#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct header  {
   double    band_width;	// bandwidth in kHz
   float     freq_0;
   float     dm;		// DM in pc/cc
   long int  mark_gap;		// marker interval in words

   long int  da_day;
   long int  da_mon;
   long int  da_year;

   long int  ti_hour;
   long int  ti_min;
   long int  ti_sec;

   char      psrname[32];           // 32 bytes
   char      datafile[32];          // 32 bytes
   char      site_name[32];         // 32 bytes; Telescope site code

   long int  n_rfch;
   long int  nbits;
   float     freq_1;
   double    band_width1;

   char      observer[32];

   long int  ti_hund;
   float     p_synch;
   float     on_soffset;
   float     freq_ref;
   float     flo0_0;
   float     flo0_1;
   float     flo_0;
   float     flo_1;
   float     fif1_0;
   float     fif1_1;
   float     fif2_0;
   float     fif2_1;

   char      dateline[32];
   char      timeline[32];
};

void get_header(const char *infile, struct header &_fheader){
   FILE *file;
   if ( (file=fopen(infile, "r")) == NULL) {
      perror (infile);
      exit(0);
   }
   char     *header = new char[2048];
   double   *dh = (double *)header;
   float    *fh = (float  *)header;
   long int *ih = (long int *)header;
   fread(header, sizeof(char), 2048, file);
   _fheader.band_width  = dh[0];
   _fheader.freq_0      = fh[2];
   _fheader.dm          = fh[3];
   _fheader.mark_gap    = ih[4];
   _fheader.da_day      = ih[5];
   _fheader.da_mon      = ih[6];
   _fheader.da_year     = ih[7];
   _fheader.ti_hour     = ih[8];
   _fheader.ti_min      = ih[9];
   _fheader.ti_sec      = ih[10];
   memcpy(_fheader.psrname, header+44, 32);
   memcpy(_fheader.datafile, header+76, 32);
   memcpy(_fheader.site_name, header+108, 32);
   _fheader.n_rfch      = ih[35];
   _fheader.nbits       = ih[36];
   _fheader.freq_1      = fh[37];
   _fheader.band_width1 = dh[19];
   memcpy(_fheader.observer, header+160, 32);
   _fheader.ti_hund     = ih[48];
   _fheader.p_synch     = fh[49];
   _fheader.on_soffset  = fh[50];
   _fheader.freq_ref    = fh[51];
   _fheader.flo0_0      = fh[52];
   _fheader.flo0_1      = fh[53];
   _fheader.flo_0       = fh[54];
   _fheader.flo_1       = fh[55];
   _fheader.fif1_0      = fh[56];
   _fheader.fif1_1      = fh[57];
   _fheader.fif2_0      = fh[58];
   _fheader.fif2_1      = fh[59];
   memcpy(_fheader.dateline, header+240, 32);
   memcpy(_fheader.timeline, header+272, 32);
}
