#include "ce.hpp"   

/*--------------------------------------------------------------------------------------
 *                               M   A   I   N
 * -------------------------------------------------------------------------------------*/

int main (int argc, char *argv[]) {
 if (argc == 1) {
  printf ("Usage: %s <f1, f2, ...>\n", argv[0]);
  exit (0);
 }

 int in; // file descriptor
 struct stat info;
 if (stat(argv[1], &info) == -1) { perror("stat"); exit(1); }
 // "1" - because of type of GP
 off_t filesize = (info.st_size - mjd_header - 1) / sizeof(float);

 float *mass;
 mass = new float[filesize];
 if (!mass) { perror("new"); exit (1); }
 memset (mass, 0, filesize*sizeof(float));

 char *head; 
 head = new char[mjd_header];
 if (!head) { perror("new"); exit (1); }

 printf ("# name  aver sigma level max xmax lowedge upedge w90 weff energy ||| max_jy  weff_mcs  energy_jymcs *** hh:mm:ss.ssssssssss   MJD   type\n");

 for (int i=1; i<argc; ++i) {

  memset (head, 0, mjd_header);
  memset (mass, 0, filesize*sizeof(float));

  in = open (argv[i], O_RDONLY);
  if (in == -1) { perror("open"); exit (1); }
  /* read header */ read (in, head, mjd_header);
  /* read GP type */ char type; read (in, &type, 1);
  read (in, mass, filesize*sizeof(float));
  close (in);

  xmax = getmax (mass, filesize, ymax);
  // initialize the header
  header.init (head, type, xmax, tres);

  get_energy (mass, filesize, argv[i]);
 }
       
  delete (head);
  delete (mass);
  return 0;
}

