#include "op.hpp"   

// returns max value
off_t getmax (float *m, off_t s, double& ym) {
 off_t xm = 0;
 ym = m[0];
 for (off_t i=1; i<s; ++i) {
  if (m[i] > ym) { ym = m[i]; xm = i; }
 }
 return xm;
}

// returns min value
off_t getmin (float *m, off_t s, double& ym) {
 off_t xm = 0;
 ym = m[0];
 for (off_t i=1; i<s; ++i) {
  if (m[i] < ym) { ym = m[i]; xm = i; }
 }
 return xm;
}

// calculates energy 
void get_energy (float *m, off_t size, char *name) {
 double aver, aver2, sigma, level;
 double sum = 0., sum2 = 0.;
 off_t nleft, nwin;
 off_t noise_shift = 100;
 double percent_thres = 87.;
 off_t search_win = 16;

 if (xmax > size - xmax) {
  nleft = 0;
  nwin = xmax - noise_shift; 
 }
 else {
  nleft = xmax + noise_shift;
  nwin = size - xmax - noise_shift;
 }

 for (off_t i=nleft; i<nleft+nwin; ++i) {
  sum  += ((double)m[i]);
  sum2 += ((double)m[i])*((double)m[i]);
 }

  aver  = (double)(sum/((double)size));
  aver2 = (double)(sum2/((double)size));
  sigma = sqrt( aver2 - aver*aver );
  level = (ymax - aver)/sigma;
  double max_jy = level * sefd;

  double energy = 0.;
  for (off_t i=xmax-search_win; i<xmax+search_win; ++i) {
   energy += ( (double)m[i] - aver );
  }
  double tempenergy = energy;
  off_t upedge, lowedge;
  for (off_t i=xmax+search_win-1; i>=xmax-search_win; --i) {
   tempenergy -= ( (double)m[i] - aver );
   if ((tempenergy*100.)/energy >= percent_thres) continue; else { upedge = i+1; break; } 
  }
  tempenergy = energy;
  for (off_t i=xmax-search_win; i<xmax+search_win; ++i) {
   tempenergy -= ( (double)m[i] - aver );
   if ((tempenergy*100.)/energy >= percent_thres) continue; else { lowedge = i-1; break; } 
  }
  off_t w90 = upedge - lowedge;
  energy = 0.;
  double energy_jymcs = 0.; 
  for (off_t i=lowedge; i<=upedge; ++i) {
   energy += ( (double)m[i] - aver );
   energy_jymcs += ( ((((double)m[i] - aver)/sigma)*sefd) * (tres / 1000.) );
  }
  double weff = energy / ( ymax - aver );
  double weff_mcs = energy_jymcs / max_jy;
  int hh, mm;
  double ss;
  header.getTime(hh, mm, ss);
  printf ("%s %lf\t%lf\t%lf\t%lf\t%ld\t%ld\t%ld\t%ld\t%.3f\t%.f ||| %.3lf\t%.3lf\t%.3lf *** %02d:%02d:%s%.10lf\t%s\t%cP\n", name, aver, sigma, level, ymax, (unsigned long)xmax, (unsigned long)lowedge, (unsigned long)upedge, (unsigned long)w90, weff, energy, max_jy, weff_mcs, energy_jymcs, hh, mm, (int)floor(ss) < 10 ? "0" : "", ss, header.get_mjd(), header.getType());
}
