#ifndef _DISP_HPP
#define _DISP_HPP

#include <string.h>
#include <math.h>
#include <stdlib.h>

#include <fftw3.h>

#include "constant.hpp"
#include "obsconf.hpp"

/* calculate phase due to dispersion */ 
double get_disp_phase (double f);

/* compute dedispersion matrix */
fftwf_complex* get_matrix (fftwf_complex *matrix, off_t size);

/* ship FFT data out in two complex arrays */
/* part1 originally has packed completely, part2 is empty */
void ship_out2complex (fftwf_complex *part1, fftwf_complex *part2, off_t size);

/* ship FFT data from the GBT to arrange in total band */
/* dest is 4*n size, part1 & part is n size */
fftwf_complex* ship_out2gbt_total (fftwf_complex *dest, fftwf_complex *part1, fftwf_complex *part2, off_t size);

/* making the dedispersion */
fftwf_complex* dedispersion (fftwf_complex *ampl_sp, fftwf_complex *matrix, float *band, fftwf_plan plan, off_t size, bool do_zero = true);

/* get ACF0 value */
double get_acf0 (fftwf_complex *x, off_t size);

/*get ACF0 value calculating the ACF itself */
double get_acf (fftwf_complex *x, off_t size);

#endif //#ifndef _DISP_HPP
