#ifndef _BITSTAT_HPP
#define _BITSTAT_HPP

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "inverf.hpp"

/* get recovered value */
float recovered_value (signed char value, double part);

/* correct for bit-statistics */
/*
 * usually we set the number equal to number spoiling points due to cycling convolution
 * during correction for dispersion. Spoiling points for direct band (when we setting the values
 * to lowest frequency) are in the beginning of the array. 
 * It's ease to correct values in the beginning of the array with the same statistics -- anyway
 * we have to ignore these values after the dedispersion!!! But if the spoiling points are in the
 * end of the array, we have to change slithly this code !!!
 */
void bits_correction (signed char *x, float *y, off_t size, long number);

#endif //#ifndef _BITSTAT_HPP
