#include "wisdom.hpp"

/* initialize the wisdom to speed up FFT calculations */
int initialize_wisdom () {
  /* If calling for the first time, read the wisdom file */

  /* First try to import the system wisdom if available */
  fprintf(stderr, "\nAttempting to read the system wisdom file (float) ...\n");
  if (!fftwf_import_system_wisdom())
    fprintf(stderr, "  failed.  The file probably does not exist.\n\n");

    fprintf (stderr, "\nImporting wisdom from /etc/fftw/fftw_wisdom.txt (float) ...\n");
    FILE *wisdomfile;
    wisdomfile = fopen("/etc/fftw/fftw_wisdom.txt", "r");
    if (wisdomfile != NULL) {
     if (!fftwf_import_wisdom_from_file(wisdomfile)) {
        fprintf(stderr, "Error importing FFTW wisdom.\n");
        fclose(wisdomfile);
//        fprintf(stderr, "Exiting.\n");
//        return 1;
     }
     else { fprintf (stderr, "Ok.\n"); fclose(wisdomfile); return 0; }
    }
    fprintf (stderr, "  failed.\n");
    fprintf (stderr, "\nImporting wisdom from /etc/fftw/wisdom (float) ...\n");
    wisdomfile = fopen("/etc/fftw/wisdom", "r");
    if (wisdomfile != NULL) {
     if (!fftwf_import_wisdom_from_file(wisdomfile)) {
        fprintf(stderr, "Error importing FFTW wisdom.\n");
        fclose(wisdomfile);
//        fprintf(stderr, "Exiting.\n");
//        return 1;
     }
     else { fprintf (stderr, "Ok.\n"); fclose(wisdomfile); return 0; }
    }
    fprintf (stderr, "  failed.\n");
//    fprintf (stderr, "Exiting.\n");
    return 1;
}
