// Print the phase in grad for Pcal harmonics
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <math.h>
#include <sys/stat.h>

int main (int argc, char *argv[]) {
 int in;
 struct stat info;
 long sz;
 float *data;

 if (argc == 1) { printf("Usage: %s <file with phase in the whole 64-MHz band>\n", argv[0]); exit (0); }
 if ( stat(argv[1], &info) != 0) { perror("stat"); exit(1); }
 sz = info.st_size / sizeof (float); 

 data = new float[sz];
 if (!data) { perror("new"); exit(1); }

 in = open (argv[1], O_RDONLY);
 lseek (in , 0, SEEK_SET);
 read (in, data, info.st_size);
 close (in);

 // the whole bandwidth is 64 MHz, so step = 1 MHz
 long step = sz/64;
//  printf ("Pcal:\n---------------\n");
 for (int i=0; i<sz; i+=step) {
//  printf ("%d:\t\tgrad= %f rad= %f  rot= %f\n", i, data[i], data[i]*(M_PI/180.), data[i] / 360.);
//  printf ("%d %.3f %.3f %.3f\n", i/step, data[i], data[i-1], data[i+1]);
  printf ("%d %.3f\n", 2052 + i/step, data[i]);
 }

 delete (data);
 return 0;
}
