#ifndef __HEADER_HPP
#define __HEADER_HPP

#include <string>
#include <stdlib.h>

using namespace std;

class Header {
  // the size of the mjd string
  static const int mjd_string_size = 26;
  // the number of digits before implicit radix point
  static const int first_digits = 5;

  // the string with MJD
  string start_mjd;
  // position of the GP in counts
  off_t pos;
  // time resolution
  double res;
  // the string with mjd of GP
  string mjd;
  // type of the GP: M - main pulse, I - interpulse
  char pulse_type;
 

  public:
    Header () {}
    Header (char *m, char type, off_t p, double t);
    virtual ~Header () {}

    // initialize
    void init (char *m, char type, off_t p, double t);

    // return start mjd in usual format like 53528.4567...
    char* get_start_mjd (char *m);
    const char* get_start_mjd ();
    // get mjd of the GP
    char* get_mjd (char *m);
    const char* get_mjd ();
    // get hour, min and sec of GP
    void getTime (int& hour, int& min, double& sec);
    // get type of the GP
    char getType () { return pulse_type; }
};

#endif //#ifndef __HEADER_HPP
