#include "op.hpp"

// returns max value
off_t getmax (float *m, off_t s, double& ym) {
 off_t xm = 0;
 ym = m[0];
 for (off_t i=1; i<s; ++i) {
  if (m[i] > ym) { ym = m[i]; xm = i; }
 }
 return xm;
}

// returns min value
off_t getmin (float *m, off_t s, double& ym) {
 off_t xm = 0;
 ym = m[0];
 for (off_t i=1; i<s; ++i) {
  if (m[i] < ym) { ym = m[i]; xm = i; }
 }
 return xm;
}

// returns aver & sigma values, updates y1, ymax & ymin 
void getavsig (float *m, off_t s, double& aver, double& sigma, float *n, off_t w, off_t xmax, double& ymax, double& ymin, double& ymaxs) {
 double sum = 0., sum2 = 0.;
 double aver2;
 off_t otstup = 100; // shift from the max value

 if (xmax > s - xmax) {
  for (off_t i=0; i<xmax - otstup; ++i) {
   sum += m[i];
   sum2 += m[i] * m[i];
  }
  aver = sum / (xmax - otstup);
  aver2 = sum2 / (xmax - otstup);
  sigma = sqrt (aver2 - aver * aver);
 } else {
  for (off_t i=xmax + otstup; i<s; ++i) {
   sum += m[i];
   sum2 += m[i] * m[i];
  }
  aver = sum / (s - xmax - otstup);
  aver2 = sum2 / (s - xmax - otstup);
  sigma = sqrt (aver2 - aver * aver);
 }
 ymaxs = (ymax - aver) / sigma;
 for (off_t i=0; i<w; ++i) { n[i] = ((n[i] - aver) / sigma) * sefd; }
 ymax = ((ymax - aver) / sigma) * sefd;
 ymin = ((ymin - aver) / sigma) * sefd;
} 

// returns aver & sigma values, without updating y-array
void getavsig (float *m, off_t s, double& aver, double& sigma, off_t xmax) {
 double sum = 0., sum2 = 0.;
 double aver2;
 off_t otstup = 100; // shift from the max value

 if (xmax > s - xmax) {
  for (off_t i=0; i<xmax - otstup; ++i) {
   sum += m[i];
   sum2 += m[i] * m[i];
  }
  aver = sum / (xmax - otstup);
  aver2 = sum2 / (xmax - otstup);
  sigma = sqrt (aver2 - aver * aver);
 } else {
  for (off_t i=xmax + otstup; i<s; ++i) {
   sum += m[i];
   sum2 += m[i] * m[i];
  }
  aver = sum / (s - xmax - otstup);
  aver2 = sum2 / (s - xmax - otstup);
  sigma = sqrt (aver2 - aver * aver);
 }
} 
