#ifndef _PLOT_HPP
#define _PLOT_HPP

#include "cpgplot.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "header.hpp"

#define MaxString 255

extern double tres; // time resolution in ns
extern double sefd; // sefd in Jy
extern off_t window; // window to show in counts
extern off_t ledge; // position of maximum from left edge
extern double shift; // shift between files in Jy
extern double dataoffset; // data offset in Jy between plot and axis
extern char xlabel[MaxString]; // x-label
extern char ylabel[MaxString]; // y-label

extern char pgplot_dev[MaxString]; // device for pgplot
extern float char_size; // character size

extern Header header; // the header

/* graphics part */
//void plotting (float *y1, float *y2, float *x, char *name, double aver1, double sigma1, double ymin1, double ymax1, double ymaxs1, double aver2, double sigma2, double ymin2, double ymax2, double ymaxs2);
void plotting (float *yI, float *yV, float *yP, float *yA, float *x, char *name, double ymin, double ymax);

// returns disp in character size
double getdisp (double max, double min, double value, double offset, double chsize);

// get y tics major interval
long getytics (double min, double max);

#endif //#ifndef _PLOT_HPP
