#ifndef __HEADER_HPP
#define __HEADER_HPP

#include <string>
#include <stdlib.h>

using namespace std;

class Header {
  // the size of the mjd string
  int mjd_string_size;
  // the number of digits before implicit radix point
  int first_digits;

  // the string with MJD
  string mjd;

  public:
    Header () {}
    Header (char *m, int mlen);

    // initialize
    void init (char *m, int mlen);
    // update
    void update (unsigned long shift, double tres);

    // return mjd in usual format like 53528.4567...
    char* get_mjd (char *m);
    const char* get_mjd ();
    // get hour, min and sec of GP
    void getTime (int& hour, int& min, double& sec);
};

#endif //#ifndef __HEADER_HPP
