#ifndef _HLOP_HPP
#define _HLOP_HPP

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <math.h>

#include <fftw3.h>

#include <sys/resource.h>

#include "io.hpp"
#include "obsconf.hpp"
#include "cmd.hpp"
#include "wisdom.hpp"
#include "disp.hpp"
#include "header.hpp"
#include "polyco.hpp"

#define MaxString 255

// the number of spoiled points
off_t bitstat_points = 0;

// basename for output files
char *base;
// path for output files
char *output_path;

bool is_wisdom = false; // true if wisdom file was read successfully
bool is_calc_prof = false; // true if to calculate average profile
bool is_quite = false; // true when one wants "quite" output

int mjd_header = 27; // length in bytes of MJD string
Header header; // header declaration

// desired phase for folding the average profile
double desired_phase = 0.5;

#endif //_HLOP_HPP
