#include <fcntl.h>
#include <string>

#include "bitstat.hpp"
#include "op.hpp"

/* write to file */
template <class T>
void write2file (T x, off_t size, std::string name) {
  int outdescr;
  if ((outdescr = open(name.c_str(), O_TRUNC | O_CREAT | O_WRONLY | O_LARGEFILE, 0644)) == -1) { perror("open"); exit (1); }
  lseek(outdescr, 0, SEEK_SET);
  write(outdescr, x, size*sizeof(T));
  close(outdescr);
}

/* write to file */
/* first one double value will be written */
template <class T>
void write2file (T x, char *val, int flag, off_t size, std::string name) {
  int outdescr, flags;
  if (flag == 0) flags = O_TRUNC | O_CREAT | O_WRONLY | O_LARGEFILE;
   else flags = O_APPEND | O_WRONLY | O_LARGEFILE;
  if ((outdescr = open(name.c_str(), flags, 0644)) == -1) { perror("open"); exit (1); }
  if (flag == 0) { lseek(outdescr, 0, SEEK_SET); write(outdescr, val, (int)strlen(val)); }
  write(outdescr, x, size*sizeof(T));
  close(outdescr);
}

/* write to file */
/* first one double value will be written */
/* second char will be written - type of the pulse */
template <class T>
void write2file (T x, char *val, char type, off_t size, std::string name) {
  int outdescr;
  if ((outdescr = open(name.c_str(), O_TRUNC | O_CREAT | O_WRONLY | O_LARGEFILE, 0644)) == -1) { perror("open"); exit (1); }
  lseek(outdescr, 0, SEEK_SET);
  write(outdescr, val, (int)strlen(val));
  write(outdescr, &type, 1);
  write(outdescr, x, size*sizeof(T));
  close(outdescr);
}


/* read from file */
void readfile (signed char *x, int mjd_header, off_t left, off_t size, char *name) {
 int indescr;
 if ((indescr = open (name, O_RDONLY | O_LARGEFILE)) == -1) { perror("open"); exit(1); };
 lseek (indescr, mjd_header+left, SEEK_SET);
 memset (x, 0, size);
 read (indescr, x, size);
 close (indescr);
}

/* read data from file, correct for bit statistics and fill fftwf array */
void read_correct_n_fill (signed char *x, float *y, fftwf_complex *part, int mjd_header, off_t s, off_t l, off_t cuts, off_t s4, off_t bp, off_t left, int reim, char *name) {
 memset (y, 0, s4*sizeof(float));
 readfile (x, mjd_header, l, cuts, name);
 bits_correction (x, y, cuts, bp);
 remove_level (y, cuts, get_level(y, cuts));
 for (off_t i=0, j=left; i<s; ++i, ++j) part[i][reim] = y[j];
}
