#include "mjd.hpp"
#include <string>

extern int mjd_header;

// get mjd value of the beginning of the output decoded files
// this value will be written as first 26 bytes of every output files (without decimal point)
// you have to remember that decimal point should follow after first 5 digits
char* getMJD (mpf_t in, unsigned long seconds, int mjd_len, char *mjd) {
 mpf_t temp1, temp2;
 mpf_init2 (temp1, 512); mpf_init2 (temp2, 512);
 
 mpf_set_ui (temp1, (unsigned int)seconds);
 mpf_set_str (temp2, "86400", 10);
 mpf_div (temp1, temp1, temp2);
 mpf_add (in, in, temp1);
 mpf_clear (temp1); mpf_clear (temp2);
 long exponent = mjd_len;
 char *cur;
 cur = new char[mjd_header-1];
 if (!cur) { perror("new cur"); exit (1); }
 memset (cur, 0, mjd_header-1);
 cur = mpf_get_str (cur, &exponent, 10, mjd_header-1, in); // "-1" because of no radix at this point
 std::string s = cur, s1;
 s1 = s.substr(0, mjd_len) + "." + s.substr(mjd_len, (int)strlen(cur)-mjd_len);
 memcpy (mjd, s1.c_str(), mjd_header);
 delete (cur);
 return mjd;
}
