#include "plotstat.hpp"

// draw to device
void drawing (float *x, float *y, StatInfo& bs, FrameInfo& conf, char *outname) {

 char *cur;
 cur = new char[MaxString];
 if (!cur) { perror("new"); exit (1); }
 memset (cur, 0, MaxString);

 unsigned int nlev = bs.getNlevels();
 unsigned char nchan = bs.getNchan();
 cpgeras ();
 cpgslw (2);
 if (nchan == 1) {
  cpgsch (char_size);
  cpgsvp (0.07, 0.99, 0.22, 0.97);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCNTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCNTSI", 25, 5);
  /* x-label */ cpgmtxt ("B", 2.7, 0.5, 0.5, stat_xlabel);
  /* y-label */ cpgmtxt ("L", 2.7, 0.5, 0.5, stat_ylabel);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  // cpgbin (nlev, x, y, true);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(0, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(0, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(0, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  cpgptxt (x[nlev-1]+0.4, 90., 0., 0., "W");
  cpgsch (char_size);
 } else { // nchan = 4
  cpgsch (0.9*char_size);
  cpgsvp (0.07, 0.5, 0.62, 0.97);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCNTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCNTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  // cpgbin (nlev, x, y, true);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(0, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(0, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(0, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  cpgptxt (x[nlev-1]+0.4, 90., 0., 0., "W");
  cpgsch (char_size);
  cpgsvp (0.56, 0.99, 0.62, 0.97);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCNTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCNTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(1, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(1, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(1, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  cpgptxt (x[nlev-1]+0.4, 90., 0., 0., "X");
  cpgsch (char_size);
  cpgsvp (0.07, 0.5, 0.20, 0.55);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCNTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCNTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(2, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(2, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(2, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  cpgptxt (x[nlev-1]+0.4, 90., 0., 0., "Y");
  cpgsch (char_size);
  cpgsvp (0.56, 0.99, 0.20, 0.55);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCNTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCNTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(3, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(3, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(3, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  cpgptxt (x[nlev-1]+0.4, 90., 0., 0., "Z");
  cpgsch (char_size);
  cpgsvp (0.07, 0.99, 0.20, 0.97);
  cpgsch (char_size);
  /* x-label */ cpgmtxt ("B", 2.7, 0.5, 0.5, stat_xlabel);
  /* y-label */ cpgmtxt ("L", 2.7, 0.5, 0.5, stat_ylabel);
 }

 /* labels */

 cpgsci (1);
 cpgslw (2);

 cpgmtxt ("B", 4.5, 0., 0., "Bit Statistics");
 cpgsch (char_size*0.8);
 sprintf (cur, "%sSampl. freq = %g MHz   Nchan = %d   Nbits = %d", label, conf.getSamplingFreq(), (int)nchan, (int)conf.getNbits());
 cpgmtxt ("B", 7., 0., 0., cur);
 memset (cur, 0, MaxString);
 int hh = (int)(conf.getSeconds()/3600.);
 int mm = (int)((conf.getSeconds() - hh*3600)/60.);
 int ss = conf.getSeconds() - hh*3600 - mm*60;
 sprintf (cur, "Start: %ld secs   UTC: %02d:%02d:%02d      Sample size = %d   Nframes = %d", conf.getSeconds(), hh, mm, ss, bs.getSampleSize(), bs.getNframes());
 cpgmtxt ("B", 8., 0., 0., cur);
 memset (cur, 0, MaxString);
 sprintf (cur, "File: %s", outname);
 cpgmtxt ("B", 9., 0., 0., cur);
 cpgslw (1);
 cpgiden ();

 delete (cur);
}

/* graphics part */
void plot_stat (StatInfo& bs, FrameInfo& conf, char *basename, int dev_default) {

 unsigned int nlev = bs.getNlevels();
 unsigned long *data = bs.getChanStat(0);
 float *x, *y;
 x = new float[nlev];
 y = new float[nlev];
 if (!x || !y) { perror("new"); exit (1); }
 memset (x, 0, nlev);
 memset (y, 0, nlev);

 x[0] = -3.; x[1] = -1.; x[2] = 1.; x[3] = 3.;
 for (unsigned int i=0; i<nlev; ++i) {
  y[i] = 100.*((float)data[i])/(bs.getSampleSize() * (float)bs.getNframes());
 }
	
 char *outname;
 outname = new char[MaxString];
 if (!outname) { perror("new outname"); exit (1); }
 memset (outname, 0, MaxString);
 sprintf (outname, "%s.WXYZ.stat.ps/cps", basename);

 // draw to POSTSCRIPT
 cpgopen (outname);
 drawing (x, y, bs, conf, outname);
 cpgclos ();

 // draw in XWINDOW
 cpgslct (dev_default);
 drawing (x, y, bs, conf, outname);

 delete (y);
 delete (x);
}
