#include "wisdom.hpp"

/* initialize the wisdom to speed up FFT calculations */
int initialize_wisdom () {
  /* If calling for the first time, read the wisdom file */

  /* First try to import the system wisdom if available */
  printf("\nAttempting to read the system wisdom file (float) ...\n");
  if (!fftwf_import_system_wisdom())
    printf("  failed.  The file probably does not exist.\n\n");

    printf ("\nImporting wisdom from /etc/fftw/fftw_wisdom.txt (float) ...\n");
    FILE *wisdomfile;
    wisdomfile = fopen("/etc/fftw/fftw_wisdom.txt", "r");
    if (wisdomfile != NULL) {
     if (!fftwf_import_wisdom_from_file(wisdomfile)) {
        printf("Error importing FFTW wisdom.\n");
        fclose(wisdomfile);
//        printf("Exiting.\n");
//        return 1;
     }
     else { printf ("Ok.\n"); fclose(wisdomfile); return 0; }
    }
    printf ("  failed.\n");
    printf ("\nImporting wisdom from /etc/fftw/wisdom (float) ...\n");
    wisdomfile = fopen("/etc/fftw/wisdom", "r");
    if (wisdomfile != NULL) {
     if (!fftwf_import_wisdom_from_file(wisdomfile)) {
        printf("Error importing FFTW wisdom.\n");
        fclose(wisdomfile);
//        printf("Exiting.\n");
//        return 1;
     }
     else { printf ("Ok.\n"); fclose(wisdomfile); return 0; }
    }
    printf ("  failed.\n");
//    printf ("Exiting.\n");
    return 1;
}
