/*******************************************************************/
/*                                                                 */
/*   ho|ukahpCN[ht@C libipvlbi.h              */
/*          Tv[{[hANZXȊO                           */
/*                                                                 */
/*      Version:    2003-10-12                                     */
/*                                                                 */
/*      Copyright (c) 2002,2003 T.Kondo/CRL All Right Reserved     */
/*                                                                 */
/*******************************************************************/
/*                                   
 ho|ukahpwb_[t@C  
      Tv[{[hANZXȊO   
           by T.Kondo 2001.8.26      
                      2002.5.26      
                      2002.7.06      
                      2003.6.16   hostget added
                      2003.10.12  definition of sampling frequency higher than
                                  or equal to 32MHz was added in "headerchkn"
                                  and "parsebit32n"
*/

#ifndef _LIBIPVLBI_
#define _LIBIPVLBI_

#include "chead.h"  // common header (src/chead.h)

#ifndef WIN32
#ifdef linux
  #include <sys/vfs.h>
#else
  #include <sys/param.h>
  #include <sys/mount.h>
#endif
#endif

#ifndef FILEMAXSIZE
//#define FILEMAXSIZE  2000000000   //  File maximum limit size in bytes
#define FILEMAXSIZE  200000000   //  File maximum limit size in bytes
#endif
#ifndef PIRA
#define PIRA  1.745329252E-2    // PI/180  degree to radian
#endif
#ifndef PIDE
#define PIDE  57.29577951       // 180/PI radian to degree
#endif
#ifndef TWOPI
#define TWOPI 6.283185307       // 2PI
#endif
#ifndef PI
#define PI    3.141592653
#endif

#ifndef MAXSTAR
#define MAXSTAR 1500            // Maximum star numbers in schedule file
#endif

#ifndef MAXOBS
#define MAXOBS 2000            // Maximum observation (scan) numbers in schedule file
#endif

#ifndef MAXSTAT
#define MAXSTAT 20            // Maximum station numbers in schedule file
#endif

#ifdef WIN32
typedef unsigned int    u_int32_t;
#endif

#ifdef WIN32
#define popen(_Z,_X) _popen(_Z,_X)
#endif

/*
typedef struct schedule
{
     char expcode[11];     // experiment code

     char starnam1[MAXSTAR][11];   // star name1
     char starnam2[MAXSTAR][11];   // star name2
     double ra[MAXSTAR];         // star position RA  in degree
     double dec[MAXSTAR];        //       "       DEC in degree
     double epo[MAXSTAR];        //       "       Epoch
     int    nstar;          // mu,ber of stars

     char statnam[20][11];  // station name
     double xyz[20][3];     // station position (x,y,z) in m
     char statid[20][2];       // station ID (A1)
     int nstation;          // number of stations

     double freqtab[16];    // frequency table
     int nfreq;             // number of frequency

     char obsstar[MAXOBS][11];  // Obs schedule Star name
     int starid[MAXOBS];       // Star ID  (entry at starpos table)
     int start[MAXOBS][5];     // start time   YY, DDD, HH, MM, SS
     int dura[MAXOBS];         // obs duration
     char obsid[MAXOBS][21];     // station IDs participated in this obs
     int nobs;               // Number of Observations
     
} sked_data_t;
*/

// following 2 functions uses "timeval" structure that is available only
//     on FreeBSD or linux.  So emulation is included in chead.h foe WIN32
// 
void sec2ymds(struct timeval *tv, int *year, int* month, int* mday, int* hh, int* mm, int* ss);
void getsystimef(int* year, int* month, int* mday, int* hh, int* mm, int* ss, 
                      float *fsec, float *tofset);

// following function returns valid value only in case of linux/FreeBSD
// fixed value is returned for WIN32 just to emulate the program on Win32
double GetFreeInfo(char* dirnam);


void hostget(char* hostname); // host name get using system command (same as hostnameger in libcor.h)  added on 20030616
              
long int nint(double x);
void read1line(char *line);
int leaf_year_check(int year);   // 邤N̂΂@O^[
void sec2hms(long int sec, int* hh, int* mm, int* ss);
void ddd2md(int year, int ddd, int* month, int* mday);
void md2ddd(int year, int* ddd, int month, int mday);
void timecorrect(int* year, int* month, int* mday,
                int* hh, int* mm, int* ss, int* secadd);

//void readskd(char* fname, sked_data_t *skd);
void parsebit32n(unsigned char* bit32, int* spatn, 
				int* smplbit, int* sfreq, int* numch,
				long int* seconds);

void headerchkn(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss);
void parseADdata(u_int32_t *ia, int numb, int adbit, int *xdata, int *npos);

void parseADdata_2(unsigned char *ia, int numb, int adbit, int *xdata, int *npos);
void parseADdata_3(unsigned char *ia, int numb, int adbit, int *xdata, int *npos);
void parse_dir_and_name(char *fpath, char *dir, char *fname);
//void substitute_env_in_path_name(char *path, char *fpath);


void hostget(char* hostname) // host name get using system command
{
    //char wbuf[60];
    int i;
    char str[60];
    char hname[20];
    char *cset=".";
    FILE *fp;
    if((fp=popen("hostname","r"))==NULL){
        printf("hostname: error!!\n");
        exit(-1);
    }
    fgets(str,60,fp);
    //printf("%s\n",str);
    // get host name without domain name
    sprintf(hname,"%s\0",strtok(str, cset));
    // remove extra CR/LF if existed  
    for (i=0; i<20; i++) {
        if(*(hname+i)==0x0a || *(hname+i)==0x0d ){
            *(hname+i)='\0';
            break;
        }
        if(*(hname+i)==0x00) break;
    }
    strcpy(hostname,hname);
    //for (i=0; i<20; i++) printf("%x ",*(hostname+i));
    //printf("\n");
    //printf("hostnameget: %s\n",hostname);
}

/*
void parse_dir_and_name(char *fpath, char *dir, char *fname) 
{
    int len,i,k;
    char cbuf[128];
    len=strlen(fpath);
    // converting '\' to '/' if so
    for(i=0; i<len; i++){
       if(fpath[i]=='\\'){
            cbuf[i]='/';
       } else {
            cbuf[i]=fpath[i];
       }
    }
    cbuf[len]='\0';
    k=-1;
    for (i=len-1; i>=0; i--){
        if(cbuf[i] == '/') {
            k=i;
            break;
        }
    }
    //printf("debug %d %s\n",k,cbuf);
    if(k<0){
        dir[0]='\0';
        strcpy(fname,cbuf);
    } else if (k == len-1){
        strcpy(dir,cbuf);
        fname[0]='\0';
    } else {
        strncpy(dir,cbuf,k+1);
        dir[k+1]='\0';
        strcpy(fname,cbuf+k+1);
    }
    //printf("debug %d %s\n",k,dir);
}

void substitute_env_in_path_name(char *path, char *fpath)
//   get enviroment variable from pathname
//      ex.  $ABCD/cout....  or  /ad4/$ABCD/cout....  
//            ABCD is extracted then substituted actual enviroment variable 
{
    int i,k,j,len,p1,p2;
    char env[50], tdir[80];
    env[0]='\0';
    strcpy(fpath,path);
    //found $
    len=strlen(path);
    for(i=0; i<len; i++){
        if(path[i]=='$') {
            p1=i;  //  start pointer
            break;
        }
    }
    if(i==len) goto exit1; // nothing to do
    j=0;
    for(k=i+1; k<len; k++){
        if(path[k]=='/' || path[k]=='\\') {
            p2=k;
            break;
        }
        env[j]=path[k];
        j++;
    }
    env[j]='\0';
    tdir[0]='\0';
    if(j>0){   // get environment
       if(getenv(env) != NULL){
           strcpy(tdir,getenv(env));
           printf("substitute_env_in_path_name:\n");
           printf("       \'%s\' is substituted by \'%s\'\n",env,tdir);
       } else {
           printf("substitute_env_in_path_name: Warning!!\n");
           printf("       Env variable \'%s\' has no value\n",env);
       }

    }
    //insert tdir
    strncpy(fpath,path,p1);
    fpath[p1]='\0';
    strcat(fpath,tdir);
    strcat(fpath,path+p2);
   // 
exit1:;
}
*/
/*
void get_true_path(char *path, char *dfltenv, char *fpath)
//   recover true path from pathname including any environment variable
//      
//    IN
//        path  --  path name  
//                     eg.    $ABCD/fname   or fname
//        dfltenv --  environment variable for default path when
//                     no path is accompnied by 'path'
//    RETURN
//        fpath   --  full path 
//      ex.  $ABCD/cout....  or  /ad4/$ABCD/cout....  
//            ABCD is extracted then substituted actual enviroment variable 
{
    int len;
    char dir[80],fname[80],cbuf[100];

    strcpy(fpath,path);
*/
    /* check file name is acompanied by directory or not */
/*
    parse_dir_and_name(path, dir, fname);
    if(dir[0]=='\0'){    // then no directory is accompnied
                              //  add directory
        if(getenv(dfltenv) != NULL){
            strcpy(dir,getenv(dfltenv));
        } else {
            strcpy(dir,"./");   //current directory
        } 
        len=strlen(dir);
        if(dir[len-1] != '/' && dir[len-1] != '\\'){
           dir[len]='/';
           dir[len+1]='\0';
        } 
        strcpy(fpath,dir);
        strcat(fpath,fname);
    } 
*/
    /* check file name include environment variables */
/*
    substitute_env_in_path_name(fpath, cbuf);
    if(strncmp(fpath,cbuf,strlen(cbuf))!=0){
         strcpy(fpath,cbuf);
    } 
}
*/


double GetFreeInfo(char* dirnam){     // get disk free space
	double freeb;
#ifndef WIN32
	struct statfs fs;
	if(statfs(dirnam, &fs)!=0){
		fprintf(stderr,"GetFreeInfo: Cannot get file system info for %s\n",dirnam);
		return -1.0;
	}
    //printf("f_bsize  %d\n",fs.f_bsize);
    //printf("f_blocks  %d\n",fs.f_blocks);
    //printf("f_bfree  %d\n",fs.f_bfree);
	//printf("f_bavail  %d\n",fs.f_bavail);
	freeb=(double)fs.f_bsize*(double)fs.f_bavail;
#else
    freeb=10.0e9;   // dummy return for WIN32 system
#endif
	return freeb;
}

long int nint(double x)
{
	double t;
	long int j;
	//t=x;
	t=fabs(x)+0.5;    // abs ݂̂ł͐ɂȂĂ܂̂fabsg
	//cout << "x=" << x << " t=" << t << '\n' ; // debug
    j=(long int)t;
	if( x < 0)
	   j=-j;
	return j;
}

void read1line(char *line)
{
    //char cbuf[128];
    //char *pibuf=cbuf;
    char c;
    /* PsR[h܂œǂݍ */
    while(1)
    {
         scanf("%c",&c);
         if(c=='\n' || c=='\r') goto exitread;
         //*pibuf++ =c;
         *line++ =c;
     }
     exitread: 
     //*pibuf='\0';
     //strcpy(line,cbuf);
     *line='\0';
}

void sec2hms(long int sec, int* hh, int* mm, int* ss)
{
	long int j;
	*hh=sec/3600 ;
       j=sec-*hh*(long)3600;
       *mm=(int)(j/60) ;
	*ss=(int)(j-*mm*(long)60) ;
}


int leaf_year_check(int year)   // N̂΂@O^[
{
       /* leaf year check */
      if (year-(year/4)*4 == 0) 
      { 
          if (year-(year/100)*100 == 0) 
          { 
               if (year-(year/400)*400 == 0) { return 0;}
               return -1;
           }
           return 0;
       }
       return -1;
}

void ddd2md(int year, int ddd, int* month, int* mday)
{
      int md[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
      int i,td,wd ;
       /* leaf year check */
      if (leaf_year_check(year)==0)
      {
         md[1]=29;
      }
      *month=0;
      *mday=0;
      td=ddd;
      for (i=0; i< 12; i++)
      {
         wd=td-md[i];
         if (wd <=0)
         {
           *mday=td;
           *month=i+1;
           goto exithere;
          }
         td=wd;
       }
   exithere:;
 }

void md2ddd(int year, int* ddd, int month, int mday)
{
      int md[12] = {0,31,28,31,30,31,30,31,31,30,31,30};
      int i;
       /* leaf year check */
      if (leaf_year_check(year)==0)
      {
         md[2]=29;
      }
      *ddd=0;
      for (i=0; i< month; i++)
      {
        *ddd=*ddd+md[i];
      }
      *ddd += mday;
 }

//#ifndef WIN32
 void sec2ymds(struct timeval *tv, int *year, int* month, int* mday, int* hh, int* mm, int* ss)
{
      //  tv.tv_sec  is  seconds from 1970/1/1 0h UTC
        
      int eday,edayold, secofday, secinh, yyyy, tday;
      eday = tv->tv_sec/86400  ;
      secofday=tv->tv_sec-eday*86400 ;
      *hh = secofday/3600 ;
      secinh = secofday-(*hh)*3600 ;
      *mm = secinh/60 ;
      *ss = secinh-(*mm)*60;

      yyyy=1970;
 loop1:
      edayold=eday;
      /* leaf year check */
      tday=365 ;
      if (leaf_year_check(yyyy)==0) {tday=366; }
      eday=edayold-tday;
      if (eday > 0 )
      { 
         yyyy++;
         goto loop1;
       }
       ddd2md(yyyy, edayold, &(*month), &(*mday));
       *year =yyyy;
 }
//#endif

void timecorrect(int* year, int* month, int* mday,
                int* hh, int* mm, int* ss, int* secadd)
{
	//char cbuf[60];
	int seconds, tday, yyyy, allday;
       seconds=(*hh)*3600+(*mm)*60+(*ss);
       seconds += *secadd;
       yyyy=*year;
       md2ddd(yyyy, &tday, *month, *mday);
       if (seconds >= 86400)
       {
          tday=tday+1;
          seconds=seconds-86400;
       }
       else if ( seconds < 0 )
       {
          tday=tday-1;
          seconds=seconds+86400;
       }
       yyyy=*year;
       allday=365;
       if (leaf_year_check(yyyy)==0)
       {  allday=366; }
       if (tday <=0 ) 
       {
         *year -= 1;
       }
       else if ( tday > allday)
       {
         *year += 1;
         tday=tday-allday;
       }
       sec2hms(seconds, hh, mm, ss);
       yyyy=*year;
       ddd2md(*year, tday, &(*month), &(*mday));
}


//#ifndef WIN32
 void getsystimef(int* year, int* month, int* mday, int* hh, int* mm, int* ss, 
                      float *fsec, float *tofset)
 {

       struct timeval tv;
       struct timezone tz;
       struct tm;
       int iwork;
       //float fsec, tofset ;
       float fwork;
   
       //int month,mday;
       gettimeofday(&tv,&tz);    // ̊֐AQOOON[Nł͂ȂƌȂĂ悤I
                                 // and not defined in Visual C++
       //printf("tv_sec tv_usec %d %d\n",tv.tv_sec,tv.tv_usec);
       //printf("tz_minuteswest tz_dsttime %d %d\n",tz.tz_minuteswest,tz.tz_dsttime);
       // at FreeBSD  tz_minuteswest always seems to be 0
       // at Linux    tz_miuteswest is 540 for JST and tv_sec seems to be affected by double the tz_miuteswest
#ifdef linux
       tv.tv_sec -= 2*tz.tz_minuteswest*60;
#endif
       
       
       tv.tv_sec += 86400;       // Now is after 2000, so I add 1 day (86400sec)
       *fsec=(float)(tv.tv_usec/1000000.0)+ (*tofset);   
       fwork=*fsec;
       iwork=(int)fwork;
       if (fwork < 0.0 )
       {
         iwork -= 1;
       }
       tv.tv_sec += iwork;
       *fsec=fwork-(float)iwork;
        //printf("FSEC = %f\n",*fsec);
      //sec2ymds(&tv, &(*year), &(*month), &(*mday), &(*hh), &(*mm), &(*ss));
       sec2ymds(&tv, year, month, mday, hh, mm, ss);
  }
//#endif


void parsebit32n(unsigned char* bit32, int* spatn, 
				int* smplbit, int* sfreq, int* numch,
				long int* seconds)
//  updated on 2003-10-12 to define sampling frequencies 
//  higher than or equal to 32MHz
{
    int sdat[16]={1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0};
    int fdat[16]={40,100,200,500,1000,2000,4000,8000,16000, 
                  32000,64000,128000,256000,512000,1024000,2048000}; //2003-10-12
                 //0,0,0,0,0,0,0};
    int smplbit0, sfreq0, seco, nch;
    *spatn=(int)(bit32[3] & 255);       // spatn = 139 means sync pattern
    smplbit0 = (bit32[2] >> 6) & 15;    // 6 times bit shift to right
    *smplbit = sdat[smplbit0];
    sfreq0 = ( bit32[2] >> 2) & 15 ;
    *sfreq=fdat[sfreq0];
    nch = bit32[2] & 2;
    if (nch == 2) {
       *numch = 4; 
    } else {
       *numch = 1;
    }
    seco = bit32[2] & 1;
    *seconds=seco*(long int)65536+
		(long int)(bit32[1] & 255)*(long int)256+
		(long int)(bit32[0] & 255);
}

/* headerchkn is updated on 2002-9-28 */
/* old version is rename to headerchkn_old */
// further updated on 2003-10-12 to define sampling frequencies 
//  higher than or equal to 32MHz
void headerchkn(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss)
{
    int sdat[16]={1,2,4,8,0,0,0,0,0,0,0,0,0,0,0,0};
    int fdat[16]={40,100,200,500,1000,2000,4000,8000,16000, 
                  32000,64000,128000,256000,512000,1024000,2048000}; //2003-10-12
                  //0,0,0,0,0,0,0};
  int smplbit0, sfreq0, seco, nch;
    *iok=-1;
    /* sync pattern check */
    if((bit64[0] == 0xFF) && (bit64[1] == 0xFF) && 
        (bit64[2] == 0xFF) && (bit64[3] == 0xFF) && (bit64[7] == 0x8B)){  // this is sync block (new FMT)

        *iok=0;
        /* parse sampling information and get time data */ 
        *spatn=(int)(bit64[7] & 255);       // spatn = 139 means sync pattern
        smplbit0 = (bit64[6] >> 6) & 15;    // 6 times bit shift to right
        *smplbit = sdat[smplbit0];
        sfreq0 = ( bit64[6] >> 2) & 15 ;
        *sfreq=fdat[sfreq0];
        nch = bit64[6] & 2;
        if (nch == 2) {
            *numch = 4; 
        } else {
            *numch = 1;
        }
        seco = bit64[6] & 1;
        *seconds=seco*(long int)65536+
		        (long int)(bit64[5] & 255)*(long int)256+
		        (long int)(bit64[4] & 255);
        sec2hms(*seconds,&(*hh),&(*mm),&(*ss));
    }
}

void headerchkn_old(unsigned char* bit64, int* iok, int* spatn, int* smplbit,
			   int* sfreq, int* numch, long int* seconds, int* hh,
			   int* mm, int* ss)
{
    unsigned char bit32a[4];
    unsigned char bit32b[4];
    int i;
    *iok=-1;
    for (i=0; i<4; i++){
       bit32a[i]=bit64[i];
       bit32b[i]=bit64[i+4];
    }
    if((bit32a[0] == 0xFF) && (bit32a[1] == 0xFF) && 
       (bit32a[2] == 0xFF) && (bit32a[3] == 0xFF) )   // this is sync block (new FMT)
    {
        /* sync patern check in next 2nd 32bit data */ 
        parsebit32n(bit32b,&(*spatn),&(*smplbit),&(*sfreq),&(*numch),&(*seconds));
        if (*spatn == 139)  //  this is also sync
	 {
           *iok=0;
           //sec2hms(&(*seconds),&(*hh),&(*mm),&(*ss));
           sec2hms(*seconds,&(*hh),&(*mm),&(*ss));
       }
     }
}



void parseADdata(u_int32_t *ia, int numb, int adbit, int *xdata, int *npos)
{
/*
    IP-VLBI{[hf[^A/D\ɉTvOlɕϊ
      ch͂̎_ł͊֌WȂ

      [in]
         ia  ---  sampler (IP-VLBI board) out data 
         numb --  size of ia (bytes)
         adbit -- sampler A/D resolution bits (1,2,4,8)
      [return]
         xdata -- data parsed into each sampled data
         npos  -- valid number of data in xdata array

     Relation between # of ch (numch) and each ch time siries

        chnumchƂ
        ch# mk Ԗڂ̃Tvf[^

        sdata(m,k)=xdata(k*numch+m)

        ƂȂ
        
*/
     int numb32, pat, n, i, ilast, ipos, ww;
     u_int32_t wd1,wd2;
     numb32=numb/4;
     ipos=0;
     ilast=32/adbit;
     pat=255;
     if (adbit == 1) {pat=1;}
     if (adbit == 2) {pat=3;}
     if (adbit == 4) {pat=15;}
     // if (adbit == 8) {pat=255;} 

     for( n=0; n < numb32-1; n++)
     {
        wd1=ia[n];
        wd2=ia[n+1];
        /* check sync pattern */
        //if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0xFF000000UL) )  // sync detected
        if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0x8B000000UL) )  // sync detected 02-07-17
         {      //printf("Sync detected ");   // removed  on 2002-10-3 
                goto exit1;
         }
        for(i=0; i<ilast; i++)
        {
             ww=(int)(wd1 & pat);
             xdata[ipos]=ww;
             wd1=wd1 >> adbit ; 
             ipos++;
         }
       exit1:  ;
     }
     *npos=ipos;
}


void parseADdata_2(unsigned char *ia, int numb, int adbit, int *xdata, int *npos)
{
/*
    IP-VLBI{[hf[^A/D\ɉTvOlɕϊ
      ch͂̎_ł͊֌WȂ

      [in]
         ia  ---  sampler (IP-VLBI board) out data 
         numb --  size of ia (bytes)
         adbit -- sampler A/D resolution bits (1,2,4,8)
      [return]
         xdata -- data parsed into each sampled data
         npos  -- valid number of data in xdata array

     Relation between # of ch (numch) and each ch time siries

        chnumchƂ
        ch# mk Ԗڂ̃Tvf[^

        sdata(m,k)=xdata(k*numch+m)

        ƂȂ
        
*/
     int numb8, pat, n, i, ilast, ipos, ww;
     u_int32_t wd1,wd2;
     numb8=numb;
     ipos=0;
     ilast=32/adbit;
     pat=255;
     if (adbit == 1) {pat=1;}
     if (adbit == 2) {pat=3;}
     if (adbit == 4) {pat=15;}
     /* if (adbit == 8) {pat=255;} */


     wd1=((u_int32_t)ia[3] << 24);
     wd1=(wd1 | (u_int32_t)ia[2] << 16);
     wd1=(wd1 | (u_int32_t)ia[1] <<  8);
     wd1=(wd1 | (u_int32_t)ia[0]);

     //printf("IN PARSE ia %d %d %d %d\n",(u_int32_t)ia[0],(u_int32_t)ia[1],(u_int32_t)ia[2],(u_int32_t)ia[3]);

     for( n=4; n < numb8-3; n+=4)
     {
        wd2=((u_int32_t)ia[n+3] << 24);
        wd2=(wd2 | (u_int32_t)ia[n+2] << 16);
        wd2=(wd2 | (u_int32_t)ia[n+1] <<  8);
        wd2=(wd2 | (u_int32_t)ia[n]);

        /* check sync pattern */
        //if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0xFF000000UL) )  // sync detected
        if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0x8B000000UL) )  // sync detected 02-07-17
         {      printf("Sync detected \n"); 
                goto exit1;
         }
        for(i=0; i<ilast; i++)
        {
             ww=(int)(wd1 & pat);
             //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
             xdata[ipos]=ww;
             wd1=wd1 >> adbit ; 
             ipos++;
         }
         wd1=wd2;
       exit1:  ;
     }
     for(i=0; i<ilast; i++)
     {
         ww=(int)(wd1 & pat);
         //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
         xdata[ipos]=ww;
         wd1=wd1 >> adbit ; 
         ipos++;
     }
     *npos=ipos;
}

void parseADdata_3(unsigned char *ia, int numb, int adbit, int *xdata, int *npos)
{
/*
    IP-VLBI{[hf[^A/D\ɉTvOlɕϊ
      ch͂̎_ł͊֌WȂ

      [in]
         ia  ---  sampler (IP-VLBI board) out data 
         numb --  size of ia (bytes)
         adbit -- sampler A/D resolution bits (1,2,4,8)
      [return]
         xdata -- data parsed into each sampled data
         npos  -- valid number of data in xdata array

     Relation between # of ch (numch) and each ch time siries

        chnumchƂ
        ch# mk Ԗڂ̃Tvf[^

        sdata(m,k)=xdata(k*numch+m)

        ƂȂ
        
*/
     int numb8, pat, n, i, ilast, ipos, ww;
     u_int32_t wd1,wd2;
     numb8=numb;
     ipos=0;
     ilast=32/adbit;
     pat=255;
     if (adbit == 1) {pat=1;}
     if (adbit == 2) {pat=3;}
     if (adbit == 4) {pat=15;}
     /* if (adbit == 8) {pat=255;} */


     wd1=((u_int32_t)ia[3] << 24);
     wd1=(wd1 | (u_int32_t)ia[2] << 16);
     wd1=(wd1 | (u_int32_t)ia[1] <<  8);
     wd1=(wd1 | (u_int32_t)ia[0]);

     //printf("IN PARSE ia %d %d %d %d\n",(u_int32_t)ia[0],(u_int32_t)ia[1],(u_int32_t)ia[2],(u_int32_t)ia[3]);

     for( n=4; n < numb8-3; n+=4)
     {
        wd2=((u_int32_t)ia[n+3] << 24);
        wd2=(wd2 | (u_int32_t)ia[n+2] << 16);
        wd2=(wd2 | (u_int32_t)ia[n+1] <<  8);
        wd2=(wd2 | (u_int32_t)ia[n]);

        /* check sync pattern */
        //if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0xFF000000UL) )  // sync detected
        if ( (wd1 == 0xFFFFFFFFUL) && ((wd2 & 0xFF000000UL) == 0x8B000000UL) )  // sync detected 02-07-17
         {      //printf("Sync detected \n"); 
                goto exit1;
         }
        for(i=0; i<ilast; i++)
        {
             ww=(int)(wd1 & pat);
             //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
             xdata[ipos]=ww;
             wd1=wd1 >> adbit ; 
             ipos++;
         }
         wd1=wd2;
       exit1:  ;
     }
     for(i=0; i<ilast; i++)
     {
         ww=(int)(wd1 & pat);
         //printf("ww wd1 pat %d %d %d",ww,wd1,pat); //debug
         xdata[ipos]=ww;
         wd1=wd1 >> adbit ; 
         ipos++;
     }
     *npos=ipos;
     //printf("numb8,ipos %d %d\n",numb8,ipos);
}

void tk_sleep(int msec)  // suspend msec 
{
    clock_t cst1,cst2;
    double telapsed,tsec;
    cst1 = clock();
    tsec=(double)msec/1000.0;
    while(1){
        cst2=clock();
        telapsed = (double)(cst2 - cst1) / CLOCKS_PER_SEC;
        if(telapsed >= tsec) break;
    }
}

#endif
