/******************************************************************/
/*                                                                */
/*   ho|ukahpCN[h     libipvlbi_board_dummy.h     */
/*          Tv[{[hCXg[ĂȂ}V    */
/*          vO`FbNp libipvlbi_board.h        */
/*          ̑ɎgpCN[ht@C                */
/*                                                                */
/*      Version:    2004-05-23                                    */
/*                                                                */
/*      Copyright (c) 2003-2004 T.Kondo/NICT All Right Reserved   */
/*                                                                */
/******************************************************************/
/*                                   
   2003-08-09
                    2004.5.23   LogWrite4 was added
                                sampleget was newnewed (use of structual variable as 
                                input parameter, and add log out function)
                                former sampleget was renamed as sampleget_old
   
!!@܂rI
   
*/
#ifndef _LIBIPVLBI_BOARD_DUMMY_
#define _LIBIPVLBI_BOARD_DUMMY_

//#include <sys/tdsio.h>  // IP-BOARD header file
#ifdef WIN32
#include <io.h>
#define read(_Z,_X,_Y) _read(_Z,_X,_Y)
#define write(_Z,_X,_Y) _write(_Z,_X,_Y)
#define open(_Z,_X,_Y) _open(_Z,_X,_Y)
#endif

#ifndef FILEMAXSIZE
//#define FILEMAXSIZE  2000000000   //  File maximum limit size in bytes
#define FILEMAXSIZE  200000000   //  File maximum limit size in bytes
#endif


typedef struct logval    // structural variablle for log
{            
    char logdir[60];     // logfile directory
    char hostname[20];   // host name
    char logfile[80];    //log file name
    int logfiletype;     // logfile naming type
                         //  0: exocode+station_id+"."+hostname+".log"
                         //  1: YYYY+hostname+".log"
                         //       where  YYYY is 4 digit year
                         //  -1: no log
} logval_t;

typedef struct spget   // sampleget type variable
{
    int span;
    int sfreq;
    int adbit;
    int numch;
    int f_size_mode;  // 0: no limitation on file size  
                      // 1: divided into 2GB size 
    char outfile[80];
    logval_t lg;
} spget_t;



// prototype 
int ini_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec);
int start_sampler(int *fd_in);
int stop_sampler(int *fd_in);
int ini_and_start_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec);
int sampleget(spget_t *spg);
int sampleget_old(char* outfile, int span, int sfreq, int adbit, int numch);
int sampleget2(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode);
int ip_board_time(unsigned int *day, unsigned int *sec, int *hh, int *mm, int *ss);
int toffset_get(int *yearPC, float *tofset); //added on 2003/08/21 
int LogWrite2(char* logdir, char* hostname, int time_mode, 
              float secofset, int mode, char* cbuf);  //added on 2003/06/16
void LogWrite3(char* logdir, char* hostname, char* logfile, int logfiletype,
              int time_mode,  float secofset, int mode, char* cbuf);
void LogWrite4(logval_t *lg, int time_mode,  float secofset, int mode, 
               char* cbuf);


/* Tv[{[h */
int ini_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec)
{
	unsigned int freq;
	
	printf("ini_sampler_dummy : ioctl() sampling set succeed\n");
	freq=sfreq;
	if(freq < 40) freq*=1000;
	printf("ini_sampler_dummy : sampling setting is %d kHz %d BIT %d CH\n",freq,adbit,numch);
	
	return 0;
}


/* TvOX^[g */
int start_sampler(int *fd_in)
{
	//int rv;
       
     printf("start_sampler_dummy : ioctl() start sampling succeed\n");
	return 0;
}


/* TvOXgbv */
int stop_sampler(int *fd_in)
{
	printf("stop_sampler_dummy : ioctl() stop sampling succeed\n");

       
	return 0;
}


/* Tv[{[hуf[^WgK[ */
int ini_and_start_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec)
{
	int rv;

    rv=ini_sampler(&(*fd_in),sfreq, adbit, numch, &(*bitsec));

	rv=start_sampler(&(*fd_in));
	
	return rv;
}

/*  f[^W֐
   NۂɃf[^W܂łRbII
    outfile ---- f[^o̓t@C
    span    ---- f[^Wԁ@ibj
    sfreq   ---- TvOg
                    40,100,200,500 (for kHz)
                    1,2,4,8,16 (for MHz)
    adbit   ---- `crbg
                    1,2,4,8
    numch   ---- `l
                    1, 4
    2003-11-20 no limitation on file size
*/


int sampleget_big(char* outfile, int span, int sfreq, int adbit, int numch)
{
    //char dev[] = "/dev/tds0";
    char dev[] = "dummy.dat";  // dummy data file
    //int fd_in;
    //int fd_out;
    //mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
    int k;
    int headbit=64;  // header bit number  for a new sampler board
    //int headbit=32;  // header bit number  for a old sampler board
    long int allbyte;     // TvOoCg
    long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
    long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
    long int c;
    unsigned int freq;
    // 2002-10-21
    double dallbyte, dc;
    int f_c;   // file number counter  in case of file exceeds > 2Gbyte
//    char cbuf[10];
//    char outname2[80]; // for extra output
    // ----------
    //u_int8_t sfreq_t, sbit_t, numch_t;
    //u_int8_t sampling;
    //u_int32_t buf[BUFSIZ * 2];
    unsigned long int buf[BUFSIZ * 2];
    //printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI
    
    /*
    printf(" span = %d\n",span);    // debug
    printf(" sfreq= %d\n",sfreq);   // debug
    printf(" adbit= %d\n",adbit);   // debug
    printf(" numch= %d\n",numch);   // debug
    */
    
    /* sampling duration check */
    if (span <= 0) {
        printf(" parameter span (duration in sec) should be positive!\n");
        // nothing to do
        return -1;
    }
    
    
    /* sampler open */
    //fd_in = fopen(dev, "rb");
    //fd_in = open("/dev/tds0", O_RDONLY);
    //if (fd_in == -1) {
    //    perror("device open() error ");
    //   return -1;
    //}
    
    /* output file open */
    //fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
    //if (fd_out == -1) {
    //    perror("output file open() error");
    //    goto end;
    //}
    
    /* sampling frequency set */
    
    if      (sfreq ==  40)  { /*sfreq_t =  TDS_SAMPLING_40KHZ*/; }
    else if (sfreq == 100)  { /*sfreq_t =  TDS_SAMPLING_100KHZ*/; }
    else if (sfreq == 200)  { /*sfreq_t =  TDS_SAMPLING_200KHZ*/; }
    else if (sfreq == 500)  { /*sfreq_t =  TDS_SAMPLING_500KHZ*/; }
    else if (sfreq ==   1)  { /*sfreq_t =  TDS_SAMPLING_1MHZ*/; }
    else if (sfreq ==   2)  { /*sfreq_t =  TDS_SAMPLING_2MHZ*/; }
    else if (sfreq ==   4)  { /*sfreq_t =  TDS_SAMPLING_4MHZ*/; }
    else if (sfreq ==   8)  { /*sfreq_t =  TDS_SAMPLING_8MHZ*/; }
    else if (sfreq ==  16)  { /*sfreq_t =  TDS_SAMPLING_16MHZ*/; }
    else { 
        printf(" parameter sfreq  (sampling frequency) must be either one of followings:\n");
        printf("              40,100,200,500 (for kHz)\n");
        printf("              1,2,4,8,16 (for MHz)\n");
        return -1;
    }
    
    /* AD resolution set */
    if      (adbit ==  1)  { /*sbit_t =  TDS_SAMPLING_1BIT*/; }
    else if (adbit ==  2)  { /*sbit_t =  TDS_SAMPLING_2BIT*/; }
    else if (adbit ==  4)  { /*sbit_t =  TDS_SAMPLING_4BIT*/; }
    else if (adbit ==  8)  { /*sbit_t =  TDS_SAMPLING_8BIT*/; }
    else { 
        printf(" parameter adbit (A/D resolution) must be either one of followings:\n");
        printf("              1,2,4,8\n");
        return -1;
    }
    
    /* number of channels */
    if      (numch ==  1)  { /*numch_t =  TDS_SAMPLING_1CH*/; }
    else if (numch ==  4)  { /*numch_t =  TDS_SAMPLING_4CH*/; }
    else { 
        printf(" parameter numch (number of channels) must be either one of followings:\n");
        printf("              1,4\n");
        return -1;
    }
    
    /* sampling parameters set */
    //sampling =  sfreq_t | sbit_t | numch_t;
    
    if (sfreq >= 40) { bitsec=sfreq*1000 ;}   
    else { bitsec=sfreq*1000*1000 ;}          
    
    //bitsec=bitsec*adbit*numch;   // bit number per second
    bitsec=(bitsec*adbit*numch)+headbit;   // bit number per second  !! 2002-9-15
    
    bytesec=bitsec/8;
    allbyte=bytesec*span;
    dallbyte=(double)bytesec*(double)span;   // 2002-10-21
    
    /* File maximum bytes check */
    printf(" bitsec  = %d\n",bitsec);  // debug
    printf(" bytesec = %d\n",bytesec);  // debug
    //printf(" allbyte = %d\n",allbyte);  // debug
    printf(" allbyte = %g\n",dallbyte);  // debug
    
    freq=sfreq;
    if(freq < 40) freq*=1000;
    printf("sampling setting is %d kHz %d BIT %d CH\n",freq,adbit,numch);
    
    
    printf("ioctl()_dummy FIFO clear succeed\n");
    
    /* sampling start */
    
    printf("ioctl()_dummy start sampling succeed\n");
    printf("This is new version (2002-10-21) of sampleget (dummy)\n");
    c = 0;
    dc=0.0;   // 2002-10-21
    f_c=0;    // 2002-10-21
    //while (c <=  allbyte) {
    while (1) {                   // 2002-10-21
        int nbyte = sizeof(buf);   // nbyte = 8192

        for (k=0; k<nbyte; k++){
             buf[k]=(unsigned int)rand();
        }
        //rv = read(fd_in, buf, nbyte);
        //if (rv == -1) {
        //    perror("read() failed ");
        //    goto end;
        //}
        //printf(" nbyte = %d\n",nbyte);   // debug
        //rv = write(fd_out, buf, rv);
        c= c+ nbyte;
        /* add on 2002-10-21 */
        dc+=(double)nbyte;
        if( dc > dallbyte) {   // sampling end
            goto exithere;
        }
//        if(c >  FILEMAXSIZE) { // newfile creation
//            c=0;
//            //close(fd_out);
//            f_c++;
//            // new file name creation     XXXX.datN   where N=1,2,3......
//            strcpy(outname2,outfile);
//            sprintf(cbuf,"%d\0",f_c);
//            strcat(outname2,cbuf);
//            printf("outfile %d %s\n",f_c,outname2);  //debug
//            /* output file open */
//            //fd_out = open(outname2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
//            //if (fd_out == -1) {
//            //    perror("output file open() error");
//            //    goto end;
//            //}
//        }
        
    }
    
exithere:

    tk_sleep((span+1)*1000);  // above process doesn't consume time
                              // so to simulate actual scan span 
                              // sleep  span*1000 msec here
    /* sampling stop */
    
    printf("ioctl()_dummy stop sampling succeed\n");
    
    //close(fd_out);
    
//end:
    //close(fd_in);
    
    return 0;
}
		


/*  f[^W֐
   NۂɃf[^W܂łRbII

  []
    spg->outfile ---- f[^o̓t@C
    spg->span    ---- f[^Wԁ@ibj
    spg->sfreq   ---- TvOg
                    40,100,200,500 (for kHz)
                    1,2,4,8,16 (for MHz)
    spg->adbit   ---- `crbg
                    1,2,4,8
    spg->numch   ---- `l
                    1, 4
    spg->f_size_mode ---- 0: 2GBȏ̃t@CT|[g
                          1: 2GB̃t@C쐬
    spg->lg.logdir --- Ot@CfBNg
    spg->lg.hostname -- zXg
    spg->lg.logfile ---Ot@C
    spg->lg.logfiletype -- Ot@C
                          0: exocode+station_id+"."+hostname+".log"
                          1: YYYY+hostname+".log"
                               where  YYYY is 4 digit year
                          -1: Oo͗}
    2002-10-21 2Gbytesȏ̊ϑ悤ɕύX
    2004-05-23 Oo͋@\ǉ
*/


int sampleget(spget_t *spg)
{
    //char dev[] = "/dev/tds0";
    char dev[] = "dummy.dat";  // dummy data file
    //int fd_in;
    //int fd_out;
    //mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
    int k;
    int headbit=64;  // header bit number  for a new sampler board
    //int headbit=32;  // header bit number  for a old sampler board
    long int allbyte;     // TvOoCg
    long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
    long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
    long int c;
    int sfreq, adbit, numch, span;
    int nbyte;
    char outfile[81];
    unsigned int freq;
    // 2002-10-21
    double dallbyte, dc;
    int f_c;   // file number counter  in case of file exceeds > 2Gbyte
    char cbuf[10];
    char outname2[80]; // for extra output
    // ----------
    //u_int8_t sfreq_t, sbit_t, numch_t;
    //u_int8_t sampling;
    //u_int32_t buf[BUFSIZ * 2];
    logval_t lg;
    unsigned long int buf[BUFSIZ * 2];
    //printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI

    span=spg->span;
    sfreq=spg->sfreq;
    adbit=spg->adbit;
    numch=spg->numch;
    strcpy(outfile,spg->outfile);
    lg=spg->lg;
    
    /*
    printf(" span = %d\n",span);    // debug
    printf(" sfreq= %d\n",sfreq);   // debug
    printf(" adbit= %d\n",adbit);   // debug
    printf(" numch= %d\n",numch);   // debug
    */
    
    /* sampling duration check */
    if (span <= 0) {
        printf(" parameter span (duration in sec) should be positive!\n");
        // nothing to do
        return -1;
    }
        
    /* sampler open */
    //fd_in = fopen(dev, "rb");
    //fd_in = open("/dev/tds0", O_RDONLY);
    //if (fd_in == -1) {
    //    perror("device open() error ");
    //   return -1;
    //}
    
    /* output file open */
    //fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
    //if (fd_out == -1) {
    //    perror("output file open() error");
    //    goto end;
    //}
    
    /* sampling frequency set */
    
    if      (sfreq ==  40)  { /*sfreq_t =  TDS_SAMPLING_40KHZ*/; }
    else if (sfreq == 100)  { /*sfreq_t =  TDS_SAMPLING_100KHZ*/; }
    else if (sfreq == 200)  { /*sfreq_t =  TDS_SAMPLING_200KHZ*/; }
    else if (sfreq == 500)  { /*sfreq_t =  TDS_SAMPLING_500KHZ*/; }
    else if (sfreq ==   1)  { /*sfreq_t =  TDS_SAMPLING_1MHZ*/; }
    else if (sfreq ==   2)  { /*sfreq_t =  TDS_SAMPLING_2MHZ*/; }
    else if (sfreq ==   4)  { /*sfreq_t =  TDS_SAMPLING_4MHZ*/; }
    else if (sfreq ==   8)  { /*sfreq_t =  TDS_SAMPLING_8MHZ*/; }
    else if (sfreq ==  16)  { /*sfreq_t =  TDS_SAMPLING_16MHZ*/; }
    else { 
        printf(" parameter sfreq  (sampling frequency) must be either one of followings:\n");
        printf("              40,100,200,500 (for kHz)\n");
        printf("              1,2,4,8,16 (for MHz)\n");
        return -1;
    }
    
    /* AD resolution set */
    if      (adbit ==  1)  { /*sbit_t =  TDS_SAMPLING_1BIT*/; }
    else if (adbit ==  2)  { /*sbit_t =  TDS_SAMPLING_2BIT*/; }
    else if (adbit ==  4)  { /*sbit_t =  TDS_SAMPLING_4BIT*/; }
    else if (adbit ==  8)  { /*sbit_t =  TDS_SAMPLING_8BIT*/; }
    else { 
        printf(" parameter adbit (A/D resolution) must be either one of followings:\n");
        printf("              1,2,4,8\n");
        return -1;
    }
    
    /* number of channels */
    if      (numch ==  1)  { /*numch_t =  TDS_SAMPLING_1CH*/; }
    else if (numch ==  4)  { /*numch_t =  TDS_SAMPLING_4CH*/; }
    else { 
        printf(" parameter numch (number of channels) must be either one of followings:\n");
        printf("              1,4\n");
        return -1;
    }
    
    /* sampling parameters set */
    //sampling =  sfreq_t | sbit_t | numch_t;
    
    if (sfreq >= 40) { bitsec=sfreq*1000 ;}   
    else { bitsec=sfreq*1000*1000 ;}          
    
    //bitsec=bitsec*adbit*numch;   // bit number per second
    bitsec=(bitsec*adbit*numch)+headbit;   // bit number per second  !! 2002-9-15
    
    bytesec=bitsec/8;
    allbyte=bytesec*span;
    dallbyte=(double)bytesec*(double)span;   // 2002-10-21
    
    /* File maximum bytes check */
    printf(" bitsec  = %d\n",bitsec);  // debug
    printf(" bytesec = %d\n",bytesec);  // debug
    //printf(" allbyte = %d\n",allbyte);  // debug
    printf(" allbyte = %g\n",dallbyte);  // debug
    
    freq=sfreq;
    if(freq < 40) freq*=1000;
    printf("sampling setting is %d kHz %d BIT %d CH\n",freq,adbit,numch);
        
    printf("ioctl()_dummy FIFO clear succeed\n");
    
    /* sampling start */
    
    printf("ioctl()_dummy start sampling succeed\n");
    printf("This is new version (2004-05-23) of sampleget (dummy)\n");
    LogWrite4(&lg,0,0.0,1,"sampleget error test");
    c = 0;
    dc=0.0;   // 2002-10-21
    f_c=0;    // 2002-10-21
    //while (c <=  allbyte) {
    nbyte = sizeof(buf)/sizeof(unsigned long int);   // 
    printf("debug nbyte %d\n",nbyte);
    while (1) {                   // 2002-10-21

        for (k=0; k<nbyte; k++){
             buf[k]=(unsigned int)rand();
        }
        //rv = read(fd_in, buf, nbyte);
        //if (rv == -1) {
        //    perror("read() failed ");
        //    goto end;
        //}
        //printf(" nbyte = %d\n",nbyte);   // debug
        //rv = write(fd_out, buf, rv);
        c+= nbyte;
        /* add on 2002-10-21 */
        dc+=(double)nbyte;
        if( dc > dallbyte) {   // sampling end
            goto exithere;
        }
        if(spg->f_size_mode==1 && c >  FILEMAXSIZE) { // newfile creation
            c=0;
            //close(fd_out);
            f_c++;
            // new file name creation     XXXX.datN   where N=1,2,3......
            strcpy(outname2,outfile);
            sprintf(cbuf,"%d\0",f_c);
            strcat(outname2,cbuf);
            printf("outfile %d %s\n",f_c,outname2);  //debug
            /* output file open */
            //fd_out = open(outname2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
            //if (fd_out == -1) {
            //    perror("output file open() error");
            //    goto end;
            //}
        }
        
    }
    
exithere:

    printf("debug span %d\n",span);

    tk_sleep((span+1)*1000);  // above process doesn't consume time
                              // so to simulate actual scan span 
                              // sleep  span*1000 msec here
    /* sampling stop */
    
    printf("ioctl()_dummy stop sampling succeed\n");
    
    //close(fd_out);
    
//end:
    //close(fd_in);
    
    return 0;
}
		

/*  f[^W֐
   NۂɃf[^W܂łRbII
    outfile ---- f[^o̓t@C
    span    ---- f[^Wԁ@ibj
    sfreq   ---- TvOg
                    40,100,200,500 (for kHz)
                    1,2,4,8,16 (for MHz)
    adbit   ---- `crbg
                    1,2,4,8
    numch   ---- `l
                    1, 4
    2002-10-21 2Gbytesȏ̊ϑ悤ɕύX
*/


int sampleget_old(char* outfile, int span, int sfreq, int adbit, int numch)
{
   /* former "sampleget" till 2004-05-32 */

    //char dev[] = "/dev/tds0";
    char dev[] = "dummy.dat";  // dummy data file
    //int fd_in;
    //int fd_out;
    //mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
    int k;
    int headbit=64;  // header bit number  for a new sampler board
    //int headbit=32;  // header bit number  for a old sampler board
    long int allbyte;     // TvOoCg
    long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
    long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
    long int c;
    unsigned int freq;
    // 2002-10-21
    double dallbyte, dc;
    int f_c;   // file number counter  in case of file exceeds > 2Gbyte
    char cbuf[10];
    char outname2[80]; // for extra output
    // ----------
    //u_int8_t sfreq_t, sbit_t, numch_t;
    //u_int8_t sampling;
    //u_int32_t buf[BUFSIZ * 2];
    unsigned long int buf[BUFSIZ * 2];
    //printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI
    
    /*
    printf(" span = %d\n",span);    // debug
    printf(" sfreq= %d\n",sfreq);   // debug
    printf(" adbit= %d\n",adbit);   // debug
    printf(" numch= %d\n",numch);   // debug
    */
    
    /* sampling duration check */
    if (span <= 0) {
        printf(" parameter span (duration in sec) should be positive!\n");
        // nothing to do
        return -1;
    }
    
    
    /* sampler open */
    //fd_in = fopen(dev, "rb");
    //fd_in = open("/dev/tds0", O_RDONLY);
    //if (fd_in == -1) {
    //    perror("device open() error ");
    //   return -1;
    //}
    
    /* output file open */
    //fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
    //if (fd_out == -1) {
    //    perror("output file open() error");
    //    goto end;
    //}
    
    /* sampling frequency set */
    
    if      (sfreq ==  40)  { /*sfreq_t =  TDS_SAMPLING_40KHZ*/; }
    else if (sfreq == 100)  { /*sfreq_t =  TDS_SAMPLING_100KHZ*/; }
    else if (sfreq == 200)  { /*sfreq_t =  TDS_SAMPLING_200KHZ*/; }
    else if (sfreq == 500)  { /*sfreq_t =  TDS_SAMPLING_500KHZ*/; }
    else if (sfreq ==   1)  { /*sfreq_t =  TDS_SAMPLING_1MHZ*/; }
    else if (sfreq ==   2)  { /*sfreq_t =  TDS_SAMPLING_2MHZ*/; }
    else if (sfreq ==   4)  { /*sfreq_t =  TDS_SAMPLING_4MHZ*/; }
    else if (sfreq ==   8)  { /*sfreq_t =  TDS_SAMPLING_8MHZ*/; }
    else if (sfreq ==  16)  { /*sfreq_t =  TDS_SAMPLING_16MHZ*/; }
    else { 
        printf(" parameter sfreq  (sampling frequency) must be either one of followings:\n");
        printf("              40,100,200,500 (for kHz)\n");
        printf("              1,2,4,8,16 (for MHz)\n");
        return -1;
    }
    
    /* AD resolution set */
    if      (adbit ==  1)  { /*sbit_t =  TDS_SAMPLING_1BIT*/; }
    else if (adbit ==  2)  { /*sbit_t =  TDS_SAMPLING_2BIT*/; }
    else if (adbit ==  4)  { /*sbit_t =  TDS_SAMPLING_4BIT*/; }
    else if (adbit ==  8)  { /*sbit_t =  TDS_SAMPLING_8BIT*/; }
    else { 
        printf(" parameter adbit (A/D resolution) must be either one of followings:\n");
        printf("              1,2,4,8\n");
        return -1;
    }
    
    /* number of channels */
    if      (numch ==  1)  { /*numch_t =  TDS_SAMPLING_1CH*/; }
    else if (numch ==  4)  { /*numch_t =  TDS_SAMPLING_4CH*/; }
    else { 
        printf(" parameter numch (number of channels) must be either one of followings:\n");
        printf("              1,4\n");
        return -1;
    }
    
    /* sampling parameters set */
    //sampling =  sfreq_t | sbit_t | numch_t;
    
    if (sfreq >= 40) { bitsec=sfreq*1000 ;}   
    else { bitsec=sfreq*1000*1000 ;}          
    
    //bitsec=bitsec*adbit*numch;   // bit number per second
    bitsec=(bitsec*adbit*numch)+headbit;   // bit number per second  !! 2002-9-15
    
    bytesec=bitsec/8;
    allbyte=bytesec*span;
    dallbyte=(double)bytesec*(double)span;   // 2002-10-21
    
    /* File maximum bytes check */
    printf(" bitsec  = %d\n",bitsec);  // debug
    printf(" bytesec = %d\n",bytesec);  // debug
    //printf(" allbyte = %d\n",allbyte);  // debug
    printf(" allbyte = %g\n",dallbyte);  // debug
    
    freq=sfreq;
    if(freq < 40) freq*=1000;
    printf("sampling setting is %d kHz %d BIT %d CH\n",freq,adbit,numch);
    
    
    printf("ioctl()_dummy FIFO clear succeed\n");
    
    /* sampling start */
    
    printf("ioctl()_dummy start sampling succeed\n");
    printf("This is new version (2002-10-21) of sampleget (dummy)\n");
    c = 0;
    dc=0.0;   // 2002-10-21
    f_c=0;    // 2002-10-21
    //while (c <=  allbyte) {
    while (1) {                   // 2002-10-21
        int nbyte = sizeof(buf);   // nbyte = 8192

        for (k=0; k<nbyte; k++){
             buf[k]=(unsigned int)rand();
        }
        //rv = read(fd_in, buf, nbyte);
        //if (rv == -1) {
        //    perror("read() failed ");
        //    goto end;
        //}
        //printf(" nbyte = %d\n",nbyte);   // debug
        //rv = write(fd_out, buf, rv);
        c= c+ nbyte;
        /* add on 2002-10-21 */
        dc+=(double)nbyte;
        if( dc > dallbyte) {   // sampling end
            goto exithere;
        }
        if(c >  FILEMAXSIZE) { // newfile creation
            c=0;
            //close(fd_out);
            f_c++;
            // new file name creation     XXXX.datN   where N=1,2,3......
            strcpy(outname2,outfile);
            sprintf(cbuf,"%d\0",f_c);
            strcat(outname2,cbuf);
            printf("outfile %d %s\n",f_c,outname2);  //debug
            /* output file open */
            //fd_out = open(outname2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
            //if (fd_out == -1) {
            //    perror("output file open() error");
            //    goto end;
            //}
        }
        
    }
    
exithere:

    tk_sleep((span+1)*1000);  // above process doesn't consume time
                              // so to simulate actual scan span 
                              // sleep  span*1000 msec here
    /* sampling stop */
    
    printf("ioctl()_dummy stop sampling succeed\n");
    
    //close(fd_out);
    
//end:
    //close(fd_in);
    
    return 0;
}
		
		
		
int sampleget2(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode)
{
/*
                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ݁@iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       5:  3+4  for debug purpose ꊇt@C debug.dat 쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
    //Dummy
    int rv;
    rv=0;
	return rv;
}



int sampleget3(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode)
{
/*      sampleget2@̉ǔ

                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ݁@iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       5:  3+4  for debug purpose ꊇt@C debug.dat 쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
    //Dummy
    int rv;
    rv=0;
	return rv;
}
		

int sampleget4(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode)
{
/*      sampleget3 ̉ǔ  (₦VNp^[̌osj

                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       5:  3+4  for debug purpose ꊇt@C debug.dat 쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
    //Dummy
    int rv;
    rv=0;
	return rv;
}
		
int ip_board_time(unsigned int *day, unsigned int *sec, int *hh, int *mm, int *ss)
{
     int year,month,mday,ddd;
       float fsec, tofset ;

       tofset=0.0;
   
	 //foCX玞̎擾̑ɃVXe玞擾
      getsystimef(&year, &month, &mday, hh, mm, ss, &fsec, &tofset);
       *sec=(*hh)*3600+(*mm)*60+(*ss);
       md2ddd(year, &ddd, month, mday);
       *day=ddd;
	return 0;
}

int toffset_get(int *yearPC, float *tofset) 
// get time difference between IP-BOARD time and PC time   2003-08-21
{ 
    int year,month,mday,hh,mm,ss;
    float fsec;
    //foCX玞̎擾 and display while
    *tofset=0.0;
    
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, tofset);
    printf("System Time : %04d/%02d/%02d %02d:%02d:%02d\n",year,month,mday,hh,mm,ss);
    printf("Offset (dummy) %f\n",*tofset);
    *yearPC=year;  // save year info get from PC
    //printf("yearPC  %d\n",*yearPC);
    return 0;   
}
	
int LogWrite2(char* logdir, char* hostname, int time_mode, 
              float secofset, int mode, char* cbuf)
{
/*
  [in]
     logdir  -----  logfile directory
     hostname ----  host PC name
     time_mode ---  0: time get from PC
                    1: time get from IP-VLBI board
     mode   ------  logfile separator mode
                    0:  : 
                    1:  /
                    2:  "
                    3:  ?
                    4:  #
                    5:  (space)
     cbuf           log statement
 
  ---------
       logfilename  logdir/YYYYhostname.log

       TIME(UT) get from host
       log format
            YYDDDHHMMSSXY cbuf
	where    YY   -- year (2 digits)
	         DDD  -- total day  (day of year)
	         HH   -- hour
	         MM   -- minute
	         SS   -- sec
	         X    -- separator mode
	         Y    -- time_mode   (space) for IP-Board Time
	                              p  for PC-TIME
	         cbuf -- Any comment
	
       A logfile will be opened as an append mode every time.

*/
    int i,ilen,ddd,y1,y2,imode;
    int hh,mm,ss,month,mday,year;
    unsigned int day, secnow;
    float fsec,tofset;
    int ip[7];
    char logfile[90], wbuf[30];
	char septab[][2]={":","/","\"","?","#"," "};
    FILE* flog;
    //time_t tnow;              // for getting date and time info
    //struct tm tmnow;          //        "

    // current time get
    tofset=secofset;
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
    secnow=hh*3600+mm*60+ss;
    md2ddd(year, &ddd, month, mday);
    if(time_mode == 1) {
       if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) return -1 ;
       ddd=day;
       ddd2md(year, ddd, &month, &mday);
    }           

    ip[0]=year;
    ip[1]=ddd;
    ip[2]=hh;
    ip[3]=mm;
    ip[4]=ss;
    ip[5]=month;
    ip[6]=mday;
    y1=ip[0] % 10;
    y2=ip[0] % 100;
    //printf("CURRENT TIME(UT) %s\n", asctime(&tmnow)); //debug
    //for (i=0; i<7; i++) printf("%d ",ip[i]); printf("\n"); //debug

    /* logfilename create */
    strcpy(logfile,logdir);
    ilen=strlen(logfile);
    if (logfile[ilen-1] != '/'){
        logfile[ilen]='/';
        logfile[ilen+1]='\0';
    }
    sprintf(wbuf,"%04d%s.log\0",year,hostname);
    strcat(logfile,wbuf);
    if( (flog  = fopen( logfile, "a" )) == NULL ){
        printf("LogWrite: Log File (%s) Open Error! \n",logfile);
        return -1;
    }
    //printf("LogWrite: Log File (%s) Opened! \n",logfile);  // debug
	
    imode=mode;
    if(imode <0 || imode >5) imode=5;
    if(time_mode==1){
       sprintf(wbuf,"%02d%03d%02d%02d%02d%s  \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    } else {
       sprintf(wbuf,"%02d%03d%02d%02d%02d%sp \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    }
    fprintf(flog,"%s%s\n",wbuf,cbuf);
    i=fclose(flog);
    return 0;
}
	
void LogWrite3(char* logdir, char* hostname, char* logfile, int logfiletype,
              int time_mode,  float secofset, int mode, char* cbuf)
{
/*
  [in]
     logdir  -----  logfile directory
     hostname ----  host PC name
     logfile  -----  logfile name
     logfiletype --  logfile name definitiion
                      0: logfile
                      1: logdir/YYYY+hostname+".log"
                         where  YYYY is 4 digit year
     time_mode ---  0: time get from PC
                    1: time get from IP-VLBI board
     mode   ------  logfile separator mode
                    0:  : 
                    1:  /
                    2:  "
                    3:  ?
                    4:  #
                    5:  (space)
     cbuf           log statement
 
  ---------

       TIME(UT) get from host
       log format
            YYDDDHHMMSSXY cbuf
	where    YY   -- year (2 digits)
	         DDD  -- total day  (day of year)
	         HH   -- hour
	         MM   -- minute
	         SS   -- sec
	         X    -- separator mode
	         Y    -- time_mode   (space) for IP-Board Time
	                              p  for PC-TIME
	         cbuf -- Any comment
	
       A logfile will be opened as an append mode every time.

*/
    int i,ilen,ddd,y1,y2,imode;
    int hh,mm,ss,month,mday,year;
    unsigned int day, secnow;
    float fsec,tofset;
    int ip[7];
    char wbuf[30];
	char septab[][2]={":","/","\"","?","#"," "};
    FILE* flog;
    //time_t tnow;              // for getting date and time info
    //struct tm tmnow;          //        "
    if(logfiletype < 0) goto exit_end;  // nothing to do
    // current time get
    tofset=secofset;
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
    secnow=hh*3600+mm*60+ss;
    md2ddd(year, &ddd, month, mday);
    if(time_mode == 1) {
    	if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) {
           printf("LogWrite3: IP-BOARD TIME GET ERROR! \n");
    	   goto exit_end;
    	}
       ddd=day;
       ddd2md(year, ddd, &month, &mday);
    }           

    ip[0]=year;
    ip[1]=ddd;
    ip[2]=hh;
    ip[3]=mm;
    ip[4]=ss;
    ip[5]=month;
    ip[6]=mday;
    y1=ip[0] % 10;
    y2=ip[0] % 100;
    //printf("CURRENT TIME(UT) %s\n", asctime(&tmnow)); //debug
    //for (i=0; i<7; i++) printf("%d ",ip[i]); printf("\n"); //debug

    /* logfilename create */
    if(logfiletype==1){
       strcpy(logfile,logdir);
       ilen=strlen(logfile);
       if (logfile[ilen-1] != '/'){
           logfile[ilen]='/';
           logfile[ilen+1]='\0';
       } 
       sprintf(wbuf,"%04d%s.log\0",year,hostname);
       strcat(logfile,wbuf);
    }

    /* logfile open */
    if( (flog  = fopen( logfile, "a" )) == NULL ){
        printf("LogWrite3: Log File (%s) Open Error! \n",logfile);
        goto exit_end;
    }
    //printf("LogWrite: Log File (%s) Opened! \n",logfile);  // debug
	
    imode=mode;
    if(imode <0 || imode >5) imode=5;
    if(time_mode==1){
       sprintf(wbuf,"%02d%03d%02d%02d%02d%s  \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    } else {
       sprintf(wbuf,"%02d%03d%02d%02d%02d%sp \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    }
    fprintf(flog,"%s%s\n",wbuf,cbuf);
    i=fclose(flog);
exit_end:;

}

	
void LogWrite4(logval_t *lg, int time_mode,  float secofset, int mode, char* cbuf)
{
/*
  [in]
     log->logdir  -----  logfile directory
     log->hostname ----  host PC name
     log->logfile  -----  logfile name
     log->logfiletype --  logfile name definitiion
                      0: logfile
                      1: logdir/YYYY+hostname+".log"
                         where  YYYY is 4 digit year
                     -1:  no log
     time_mode ---  0: time get from PC
                    1: time get from IP-VLBI board
     mode   ------  logfile separator mode
                    0:  : 
                    1:  /
                    2:  "
                    3:  ?
                    4:  #
                    5:  (space)
     cbuf           log statement
 
  ---------

       TIME(UT) get from host
       log format
            YYDDDHHMMSSXY cbuf
	where    YY   -- year (2 digits)
	         DDD  -- total day  (day of year)
	         HH   -- hour
	         MM   -- minute
	         SS   -- sec
	         X    -- separator mode
	         Y    -- time_mode   (space) for IP-Board Time
	                              p  for PC-TIME
	         cbuf -- Any comment
	
       A logfile will be opened as an append mode every time.

*/
    int i,ilen,ddd,y1,y2,imode;
    int hh,mm,ss,month,mday,year;
    unsigned int day, secnow;
    float fsec,tofset;
    int ip[7];
    char wbuf[30];
	char septab[][2]={":","/","\"","?","#"," "};
    FILE* flog;
    //time_t tnow;              // for getting date and time info
    //struct tm tmnow;          //        "
    if(lg->logfiletype < 0) goto exit_end;  // nothing to do
    // current time get
    tofset=secofset;
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
    secnow=hh*3600+mm*60+ss;
    md2ddd(year, &ddd, month, mday);
    if(time_mode == 1) {
    	if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) {
           printf("LogWrite4: IP-BOARD TIME GET ERROR! \n");
    	   goto exit_end;
    	}
       ddd=day;
       ddd2md(year, ddd, &month, &mday);
    }           

    ip[0]=year;
    ip[1]=ddd;
    ip[2]=hh;
    ip[3]=mm;
    ip[4]=ss;
    ip[5]=month;
    ip[6]=mday;
    y1=ip[0] % 10;
    y2=ip[0] % 100;
    //printf("CURRENT TIME(UT) %s\n", asctime(&tmnow)); //debug
    //for (i=0; i<7; i++) printf("%d ",ip[i]); printf("\n"); //debug

    /* logfilename create */
    if(lg->logfiletype==1){
       strcpy(lg->logfile,lg->logdir);
       ilen=strlen(lg->logfile);
       if (lg->logfile[ilen-1] != '/'){
           lg->logfile[ilen]='/';
           lg->logfile[ilen+1]='\0';
       } 
       sprintf(wbuf,"%04d%s.log\0",year,lg->hostname);
       strcat(lg->logfile,wbuf);
    }

    /* logfile open */
    if( (flog  = fopen( lg->logfile, "a" )) == NULL ){
        printf("LogWrite4: Log File (%s) Open Error! \n",lg->logfile);
        goto exit_end;
    }
    //printf("LogWrite: Log File (%s) Opened! \n",logfile);  // debug
	
    imode=mode;
    if(imode <0 || imode >5) imode=5;
    if(time_mode==1){
       sprintf(wbuf,"%02d%03d%02d%02d%02d%s  \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    } else {
       sprintf(wbuf,"%02d%03d%02d%02d%02d%sp \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    }
    fprintf(flog,"%s%s\n",wbuf,cbuf);
    i=fclose(flog);
exit_end:;

}


#endif
