#include "mjd.hpp"
#include <string>
#include <math.h>

// calculate MJD moment of GP
char* getMJD (char *startmjd, char *dest, unsigned long shift, unsigned long xmax, double TimeResolution, unsigned long number, double Period, unsigned long w) {

 mpf_t temp1, temp2, temp3;
 mpf_init2 (temp1, 512); mpf_init2 (temp2, 512); mpf_init2 (temp3, 512);
 
 mpf_set_d (temp1, Period);
 mpf_set_ui (temp2, number);
 mpf_mul (temp1, temp1, temp2);

 mpf_set_ui (temp2, xmax);
 mpf_set_ui (temp3, w);
 mpf_mul (temp3, temp2, temp3);

 mpf_set_ui (temp2, shift);
 mpf_add (temp2, temp2, temp3);

 mpf_set_d (temp3, TimeResolution);
 mpf_mul (temp2, temp2, temp3);
 mpf_clear (temp3);
 mpf_add (temp1, temp1, temp2);

 mpf_set_str (temp2, "1000000000.0", 10);
 mpf_div (temp1, temp1, temp2);
 mpf_set_str (temp2, "86400.0", 10);
 mpf_div (temp1, temp1, temp2);
 mpf_set_str (temp2, startmjd, 10);
 mpf_add (temp1, temp1, temp2);
 mpf_clear (temp2);

 long exponent = 5;
 char *cur;
 cur = new char[23];
 if (!cur) { perror("new cur"); exit (1); }
 memset (cur, 0, 23);
 cur = mpf_get_str (cur, &exponent, 10, 20, temp1); // no radix at this point, so it's why 20 rather than 21
 std::string s = cur, s1;
 s1 = s.substr(0, 5) + "." + s.substr(5, 15);
 memcpy (dest, s1.c_str(), 21);
 delete (cur);
 mpf_clear (temp1);
 return dest;
}
