#include "fitsio.h"  /* required by every program that uses CFITSIO  */

int main(int argc, char *argv[]) {

fitsfile *fptr;       /* pointer to the FITS file; defined in fitsio.h */
int status;
long exposure;

status = 0;         /* initialize status before calling fitsio routines */
fits_create_file(&fptr, "header.fits", &status);   /* create new file */

/* Write a keyword; must pass the ADDRESS of the value */
exposure = 1500;
fits_update_key(fptr, TLONG, "EXPOSURE", &exposure, "Total Exposure Time", &status);

fits_close_file(fptr, &status);            /* close the file */

fits_report_error(stderr, status);  /* print out any error messages */
return (status);
}
