#include "plotstat.hpp"

// draw to device
void drawing (float *x, float *y, StatInfo& bs, char *outname, char *mjd, char *startdate, char *starttime, double dur) {

 char *cur;
 cur = new char[MaxString];
 if (!cur) { perror("new"); exit (1); }
 memset (cur, 0, MaxString);

 unsigned int nlev = bs.getNlevels();
 unsigned char nchan = bs.getNchan();
 cpgeras ();
 cpgslw (2);

 /*========  Channel 0 (A) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.06, 0.27, 0.605, 0.97);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSNI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  // cpgbin (nlev, x, y, true);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(0, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(0, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(0, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[0]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);



  /*========  Channel 1 (B) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.30, 0.51, 0.605, 0.97);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  // cpgbin (nlev, x, y, true);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(1, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(1, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(1, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[1]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);


  /*========  Channel 2 (C) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.54, 0.75, 0.605, 0.97);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(2, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(2, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(2, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[2]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);


  /*========  Channel 3 (D) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.78, 0.99, 0.605, 0.97);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(3, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(3, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(3, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[3]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);


  /*========  Channel 4 (E) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.06, 0.27, 0.2, 0.565);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSNI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSNI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  // cpgbin (nlev, x, y, true);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(4, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(4, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(4, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[4]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);


  /*========  Channel 5 (F) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.30, 0.51, 0.2, 0.565);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSNI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  // cpgbin (nlev, x, y, true);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(5, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(5, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(5, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[5]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);


  /*========  Channel 6 (G) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.54, 0.75, 0.2, 0.565);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSNI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(6, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(6, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(6, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[6]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);


  /*========  Channel 7 (H) ==========*/
  cpgsch (0.9*char_size);
  cpgsvp (0.78, 0.99, 0.2, 0.565);
  cpgswin (x[0]-0.99999, x[nlev-1]+0.99999, -1., 100.);
  cpgslw (3);
  cpgbox ("BCTSNI", nlev <= 4 ? 1 : nlev/4, nlev <= 4 ? 1 : 4, "BCTSI", 25, 5);
  cpgsitf (0);
  cpgsci (2);
  cpgsfs (1);
  for (unsigned int i=0; i<nlev; ++i) {
   cpgrect (x[i]-0.5, x[i]+0.5, 0, bs.getChanStatPercent(7, i));
   if (nlev <= 4) { 
    memset (cur, 0, MaxString);
    sprintf (cur, "%.1f", bs.getChanStatPercent(7, i));
    cpgsch (0.8*char_size);
    cpgsci (1);
    cpgptxt (x[i], bs.getChanStatPercent(7, i)+2, 0., 0.5, cur);
    cpgsci (2);
    cpgsch (char_size);
   }
  }
  cpgsci (1);
  cpgsch (1.2*char_size);
  sprintf (cur, "%c", ext[7]);
  cpgptxt (x[nlev-1]+0.2, 90., 0., 0., cur);
  memset (cur, 0, MaxString);


  cpgsch (char_size);
  cpgsvp (0.07, 0.99, 0.20, 0.97);
  cpgsch (char_size);
  /* x-label */ cpgmtxt ("B", 2.7, 0.5, 0.5, stat_xlabel);
  /* y-label */ cpgmtxt ("L", 2.9, 0.5, 0.5, stat_ylabel);

 /* labels */

 cpgsci (1);
 cpgslw (2);

 cpgmtxt ("B", 4.5, 0., 0., "Bit Statistics");
 cpgsch (char_size*0.8);
 sprintf (cur, "GBT   Mark5A/VLBA   Sampl. freq = %g MHz   Nchan = %d   Nbits = %d   Sample size = %d", samp_freq, (int)bs.getNchan(), (int)bs.getNbits(), bs.getSampleSize());
 cpgmtxt ("B", 7., 0., 0., cur);
 memset (cur, 0, MaxString);
 sprintf (cur, "MJD: %s   UTC:  %s  %s   Dur: %g secs   Nframes = %d", mjd, startdate, starttime, dur * bs.getNframes(), bs.getNframes());
 cpgmtxt ("B", 8., 0., 0., cur);
 memset (cur, 0, MaxString);
 sprintf (cur, "File: %s", outname);
 cpgmtxt ("B", 9., 0., 0., cur);
 cpgslw (1);
 cpgiden ();

 delete (cur);
}

/* graphics part */
void plot_stat (StatInfo& bs, char *basename, int dev_default, char *mjd, char *startdate, char *starttime, double dur) {

 unsigned int nlev = bs.getNlevels();
 unsigned long *data = bs.getChanStat(0);
 float *x, *y;
 x = new float[nlev];
 y = new float[nlev];
 if (!x || !y) { perror("new"); exit (1); }
 memset (x, 0, nlev);
 memset (y, 0, nlev);

 x[0] = -3.; x[1] = -1.; x[2] = 1.; x[3] = 3.;
 for (unsigned int i=0; i<nlev; ++i) {
  y[i] = 100.*((float)data[i])/(bs.getSampleSize() * (float)bs.getNframes());
 }
	
 char *outname;
 outname = new char[MaxString];
 if (!outname) { perror("new outname"); exit (1); }
 memset (outname, 0, MaxString);
 sprintf (outname, "%s.stat.ps/cps", basename);

 // draw to POSTSCRIPT
 cpgopen (outname);
 drawing (x, y, bs, outname, mjd, startdate, starttime, dur);
 cpgclos ();

 // draw in XWINDOW
 cpgslct (dev_default);
 drawing (x, y, bs, outname, mjd, startdate, starttime, dur);

 delete (y);
 delete (x);
}
