#ifndef _CMD_HPP
#define _CMD_HPP

#include <stdlib.h>

/*+++ present output info +++*/
extern char bold[];
extern char ul[];
extern char none[];

extern char *outputpath;          // path to the output data
extern char *outname;             // basename for output files, default - the same as input file
extern size_t NumberOfFrames;     // number of frames to process (0 means all frames)
extern size_t BeginFrame;         // start to process from this frame
extern bool is_dummy;             // true when dummy mode is set
extern bool is_spectra;           // calculate average spectra in each channel rather than raw data
extern bool is_check;             // true when check mode is set
extern bool is_trackmap;          // true when one wants to get track map
extern bool is_quite;             // true when one wants "quite" output without changing frames number
extern bool is_spectra_show;      // show calculated spectra
extern bool swap_bytes;           // to swap bytes in input data or not
extern bool is_stat;              // true when bit statistics is calculating
extern bool is_debug;             // true if we want to get full info for every frame
                                  // if true, is_check=true and is_dummy=true as well
extern int debug_track;           // track to debug if is_debug = true
extern int fanout;                // fan-out, "4" means fan-out of 1:4
extern int aver;                  // number of points to average the spectrum
extern int skipharm;              // number of harmonics to skip in the spectrum
extern unsigned char Nchan;       // number of channels
extern int mjd_prefix;            // first 2 digits of MJD date

extern bool is_chan_extract;      // true when one wants to extract only one channel
extern int chan_extract;          // number of channel to extract

extern char *label;               // extra label in graphic plots

/* help */ 
void help (char *s);

/* parse command line */
int parse_command_line (int argc, char *argv[]);

#endif //#ifndef _CMD_HPP
