#include "op.hpp"

#include <string.h>

// get basename
char* basename (char *str) {
 char *s = str;
 int len = (int)strlen(s); 
 s += len;
 while (*(--s) != '/' && len--) ;
 return (++s);
}

// get dirname
char* dirname (char *str, char *dest) {
 int len = (int)strlen(str);
 while (str[--len] != '/' && len >= 0) ;
 if (len > 0) { strncpy (dest, str, len); dest[len] = '\0'; } else { dest[0] = '.'; dest[1] = '\0'; }
 return dest;
}

// get power of 2 size
size_t resize (size_t sz) {
 int n = 0;
 sz += 1;
 while ( (1<<(++n)) < sz) ;
 return (1<<(--n));
}

// returns max value
float getmax (float **m, unsigned char nchan, size_t size, long skipharm) {
 float ym = m[0][skipharm];
 for (unsigned char i=0; i<nchan; ++i) 
    for (off_t j=skipharm; j<size; ++j) 
        if (m[i][j] > ym) ym = m[i][j];
 return ym;
}

// returns min value
float getmin (float **m, unsigned char nchan, size_t size, long skipharm) {
 float ym = m[0][skipharm];
 for (unsigned char i=0; i<nchan; ++i) 
    for (off_t j=skipharm; j<size; ++j) 
        if (m[i][j] < ym) ym = m[i][j];
 return ym;
}

// average the array
float* average (float *m, float *dest, size_t size, long aver) {
 float sum;

 for (off_t i=0,j,k=0; i<size; i+=aver, ++k) {
  sum = 0.;
  for (j=i; j<i+aver; ++j) sum += m[j];
  dest[k] = sum / ((float)(j-i));
 }
 return dest;
}

// remove average level
void remove_level (float *x, off_t size, float level) {
 for (off_t i=0; i<size; ++i) x[i] -= level;
}
