#ifndef _STAT_HPP
#define _STAT_HPP

#include <stdio.h>

class SampleData;

/*+++++++ class to hold info about bit-statistics ++++++++++*/
class StatInfo {
	unsigned char Nchan;
	unsigned char Nbits;
	unsigned char cod;
	unsigned int Nlevels;
	size_t samplesize;
	size_t Nframes;

	// coding
	static const unsigned char coding[4];
	
	unsigned int **stat;

	unsigned char getCoding (unsigned char nbits); // return coding
  public:
	StatInfo (); // default constructor
	StatInfo (unsigned char nch, unsigned char nbits); // constructor
	virtual ~StatInfo (); // destructor
	void initialize (unsigned char nch, unsigned char nbits); // initialize array
	void update (SampleData& shot, size_t frames); // update stat array

	size_t getNframes () { return Nframes; } // return number of processed frames
	size_t getSampleSize () { return samplesize; } // return samplesize (per frame)
	unsigned char getNchan () { return Nchan; } // return number of channels
	unsigned char getNbits () { return Nbits; } // return number of bits
	unsigned int getNlevels () { return Nlevels; } // return number of levels
	unsigned int* getChanStat (int ch); // get statistics for selected channel
	float getChanStatPercent (int ch, unsigned int level); // get statistics for selected channel in %
};

#endif // _STAT_HPP
