#include "wisdom.hpp"

/* initialize the wisdom to speed up FFT calculations */
int initialize_wisdom (bool is_quite) {
  /* If calling for the first time, read the wisdom file */

  /* First try to import the system wisdom if available */
  if (!is_quite) fprintf(stderr, "\nAttempting to read the system wisdom file (float) ...\n");
  if (!fftwf_import_system_wisdom()) {
    if (!is_quite) fprintf(stderr, "  failed.  The file probably does not exist.\n\n");
   }

    if (!is_quite) fprintf (stderr, "\nImporting wisdom from /etc/fftw/fftw_wisdom.txt (float) ...\n");
    FILE *wisdomfile;
    wisdomfile = fopen("/etc/fftw/fftw_wisdom.txt", "r");
    if (wisdomfile != NULL) {
     if (!fftwf_import_wisdom_from_file(wisdomfile)) {
        if (!is_quite) fprintf(stderr, "Error importing FFTW wisdom.\n");
        fclose(wisdomfile);
//        if (!is_quite) fprintf(stderr, "Exiting.\n");
//        return 1;
     }
     else { if (!is_quite) fprintf (stderr, "Ok.\n"); fclose(wisdomfile); return 0; }
    }
    if (!is_quite) fprintf (stderr, "  failed.\n");
    if (!is_quite) fprintf (stderr, "\nImporting wisdom from /etc/fftw/wisdom (float) ...\n");
    wisdomfile = fopen("/etc/fftw/wisdom", "r");
    if (wisdomfile != NULL) {
     if (!fftwf_import_wisdom_from_file(wisdomfile)) {
        if (!is_quite) fprintf(stderr, "Error importing FFTW wisdom.\n");
        fclose(wisdomfile);
//        if (!is_quite) fprintf(stderr, "Exiting.\n");
//        return 1;
     }
     else { if (!is_quite) fprintf (stderr, "Ok.\n"); fclose(wisdomfile); return 0; }
    }
    if (!is_quite) fprintf (stderr, "  failed.\n");
//    if (!is_quite) fprintf (stderr, "Exiting.\n");
    return 1;
}
