
/*
   jeffh linux library
*/

struct EDTLIB {
  int fd;                /* open file descriptor */
  unsigned char *map;    /* memmapped  memory    */
  struct EDTNEXT next;   /* last returned data   */
  struct EDTCONFIG cfg;  /* memory configuration */
  int buflen;
  int overflow;
};

typedef struct EDTLIB EdtDev;

#define PCD_FUNCT 1

struct EDTLIB *edt_open( char *, int );
void *edt_wait_for_buffers( struct EDTLIB *, int );
int edt_done_count( struct EDTLIB *edt );
int edt_start_buffers( struct EDTLIB *, int );
int edt_stop_buffers( struct EDTLIB *edt );
int edt_ring_buffer_overrun( struct EDTLIB *edt );
int edt_reset_ring_buffers( struct EDTLIB *, int );
int edt_flush_fifo( struct EDTLIB *edt );
int edt_reg_write( struct EDTLIB *, unsigned int, unsigned int);
int edt_close( struct EDTLIB *);
int edt_perror( char *);
int edt_configure_ring_buffers( struct EDTLIB *, int, int, int, void *data[]);

