#include "bin2sm.hpp"

unsigned GetBinFileLength(char *name)
 {
  struct stat Finfo;

  if(stat(name, &Finfo)){perror(name); exit(-1);}
  return(Finfo.st_size/sizeof(BinData));
 }



void LoadBinFile(char *lfnam, ptrBinData buf, unsigned pos, unsigned size)
 {
  FILE *in;
  if((in = fopen(lfnam, "r+b")) == NULL) {perror(lfnam); exit(-1);};
  fseek(in, pos*sizeof(BinData), SEEK_SET);
  if(fread(buf, sizeof(BinData), size, in) != size) {perror(lfnam); exit(-1);}
  fclose(in);
 }


void SaveBinFile(char *sfnam, ptrBinData buf, unsigned size)
 {
  FILE *out;
  if((out = fopen(sfnam, "w+b")) == NULL) {perror(sfnam); exit(-1);}
  if(fwrite(buf, sizeof(BinData), size, out) != size) {perror(sfnam); exit(-1);}
  fclose(out);
 }


unsigned Smooth(ptrBinData Array, long size, int factor)
 {
  BinData Sum = 0, Last = Array[0];
  int i;

  for(i = 0; i < factor; i++) Sum += Array[i];
  Array[0] = Sum / factor;
  for(i = 1; i < size-factor; i++){
        Sum += (Array[i+factor-1] - Last);
        Last = Array[i];
	Array[i] = Sum / factor;
  }
  return(size - factor);
 }

unsigned Average(ptrBinData Array, long size, int factor)
 {
  BinData Sum = 0;
  unsigned i, count = 0;

  for(i = 0; i < size; i++){
    Sum += Array[i];
    if((i+1)%factor == 0){
      Array[count++] = Sum / factor;
      Sum = 0;
    }
  }

  if(size%factor != 0) Array[count++] = Sum / (size % factor);

  return(count);
 }
