#define MAIN_
#include "readme.hpp"
#include "bandid.hpp"   

int unit = 1; // when the file has N/2 + 1 harmonics

/*--- ,       ----*/

char *SelectFileName (char * str)
{
 char *s = str;
 int len = (int)strlen(s);
 s += len;
 while (*(--s) != '/' && len--) ;
 return (++s);
 }
 
/*---------     
              -----------------*/


long smoothing ( long sz )
{
 float sum = 0., tmp;
 sRes.BandSmooth = (sRes.BandSmooth > sz-1 ? sz - 1 : sRes.BandSmooth);
 if (shift < 0) shift = -1;
 if (shift > sRes.BandSmooth - 1) shift = -1;
 shift = ( shift == -1 ? (long)floor((double)((sRes.BandSmooth-1)/2.)) : shift);

  for(long r=0;r<sRes.BandSmooth;r++) sum += mass[r];
   tmp     = mass[0];
   mass[0] = sum/sRes.BandSmooth; 
  for(long t=0;t<sz-sRes.BandSmooth;t++) {
   sum = sum+mass[sRes.BandSmooth+t]-tmp;
   tmp = mass[t+1];
   mass[t+1] = sum/sRes.BandSmooth;
                                          }
 for (long t=sz-sRes.BandSmooth;t>=0;t--) mass[t+shift] = mass[t];
 for (long t=sz-sRes.BandSmooth+shift+1;t<sz;t++) mass[t] = mass[sz-sRes.BandSmooth+shift];
 for (long t=shift-1;t>=0;t--) mass[t] = mass[shift];
 
 return (sz - sRes.BandSmooth + 1);  
}


/*---- ,   (size)  ,
                    2 ------------------------*/

long resize (long sz)
 {
   long n = 0;
   sz += 1;
   while ( (1<<(++n)) < sz) ;
   return (1<<(--n));
  }

/*==========================Prompting===================================*/

void Help ( char *s )
 {
  printf("\nPROGRAMM %s\n"
         "It is used to create band correction function\n"
	 "Some options repeat the fieldnames of source file, in case when\n"
	 "some value is pointed in both source file and command line, value\n"
	 "from command line is used\n\n"
	 "[USAGE]: %s [options] <file with band>\n\n"
	 "[OPTIONS]:\n"
	 "-o, --source <filename>       - name of source file, default \"bandid.set\"\n"
	 "                                If filename = no then source file won't be used and\n"
	 "                                all parameters are inputed from command line\n"
	 "-d, --path   <path>           - path to the output file(s), default - the same\n"
	 "                                where are the source files\n"
	 "--create                      - create source file with name and destination pointed\n"
	 "                                before in -o or --source option. Otherwise, source\n"
	 "                                file \"bandid.set\" will be created in current directory\n"
	 "-s, --smooth <value>          - set number of smooth points, default = 1024\n"
	 "--shift      <value>          - set shift from left of smoothed band in total window\n"
	 "                                default = (long)(smooth points - 1)/2\n"
	 "--lgamma     <value>          - set the steepness of ideal band left edge, default = 10000.\n"
	 "--rgamma     <value>          - set the steepness of ideal band right edge, default = 60000.\n"
	 "--frleft     <value>          - set left edge of ideal band, default = 0\n"
	 "--frright    <value>          - set right edge of ideal band. If it's equal to -1 then\n"
	 "                                right edge is equal to size of spectrum minus 1, default = -1\n"
	 "--idmax      <value>          - set value of maximum of ideal band. If it's equal to -1 then\n"
	 "                                maximum is equal to maximum of real band, default = -1\n"
	 "--header     <value>          - size of header (in bytes) of file with band\n"
	 "                                default - 0\n"
	 "--timeres    <value>          - set time resolution (in nanosec), default - 400.\n"
	 "-h, --help                    - help\n\n"
	 "[SPECIAL OPTIONS]:\n"
	 "-bg, -background <color>      - set the background color of full window ignoring the\n"
	 "                                X resource file .Bandid\n"
	 "-fg, -foreground <color>      - set the foreground color in full window ignoring the\n"
	 "                                X resource file .Bandid\n"
	 "-display <display>            - set the display to show window, for example odessa:0 ,\n"
	 "                                where odessa is a hostname, 0 - display number\n"
	 "-fn, -font <font>             - set the font in full window\n"
	 "-xrm <\"resource:value\">       - this option allows to set some value for some resource.\n"
	 "                                For example, option -xrm \"Bandid.height:300\" allows to set\n"
	 "                                the height of full window to the value of 300\n\n"
	 "[KEYS]:\n"
	 "<q>             - quit without saving\n"
	 "<Enter>         - create correction function and one more time - quit with saving\n"
	 "<Space>         - zoom region\n"
	 "<Esc>           - unzoom region, or cancel build correction function and return again\n"
	 "                  to choosing ideal band, or cancel build ideal band and return again\n"
	 "                  to initial spectrum to eliminate interferences\n"
	 "<m>             - eliminate monohromatic interference\n"
	 "<p>             - define using window as polihromatic interference\n"
	 "<a>             - 1. define using region as region to calculate average value\n"
	 "                     and change values in previous polihromatic interference region\n"
	 "                     by average value\n"
	 "                  2. switch on/off of auto update of ideal band\n"
	 "<s>             - save visible binary data, filename is compound of filename with\n"
	 "                  with band + .saveN, where N is the number of eliminating interferences\n"
	 "<i>             - to build or update ideal band\n"
	 "<Tab>           - change active boundary\n"
	 "<LShift>        - switch modes between active boundaries, steepness and max-value.\n"
	 "                  PgUp/PgDn and Up/Down buttons will work only for current mode\n"
	 "<Left / Right>  - move active boundary or window to left/right\n"
	 "<+ / ->         - increase/decrease the size of window\n"
	 "<Up / Down>     - increase/decrease the value of active boundary steepness or max-value of ideal band\n"
	 "<PgUp / PgDn>   - increase/decrease the rate to move boundaries/window or rate of changing value of\n"
	 "                  steepness or max-value of ideal band\n\n"
	 "[SPECIAL KEYS]:\n"
	 "<LCtrl | RCtrl> - redraw the full window\n"
	 "<LCtrl + RCtrl> - switch on/off the mode of auto redrawing of full window\n"
	 "                  if BackingStore mode of Window Manager doesn't work\n\n"
	 "[MOUSE]:\n"
	 "<Button1>       - move window and left boundary\n"
	 "<Button3>       - increase size of window and move right boundary\n"
	 "<Button2>       - decrease size of window and update ideal band\n\n", s, s);
  exit(0);
 }

/*===================Parsing the command line===========================*/

int ParseCmdLine( int argc, char *argv[] )
 {
  int op, tm;
  struct option long_options[] = { {"help", no_argument, 0, 'h'},
				   {"source", required_argument, 0, 'o'},
				   {"smooth", required_argument, 0, 's'},
				   {"path", required_argument, 0, 'd'},
				   {"shift", required_argument, 0, 11},
				   {"timeres", required_argument, 0, 12},
				   {"lgamma", required_argument, 0, 13},
				   {"rgamma", required_argument, 0, 14},
				   {"frleft", required_argument, 0, 15},
				   {"frright", required_argument, 0, 16},
				   {"create", no_argument, 0, 17},
				   {"header", required_argument, 0, 18},
				   {"idmax", required_argument, 0, 19},
				   {0, 0, 0, 0}
                                  };

  optind = 0; optarg = 0;
  while((op = getopt_long(argc, argv, "hs:o:d:", long_options, 0)) != EOF)
    switch(op){
      case 's':
	sRes.BandSmooth = atol(optarg);
	if (sRes.BandSmooth < 1) sRes.BandSmooth = 1; 
      break;
      
      case 'o':
	memset(ResourceFileName, 0, MaxString+1);
	sprintf(ResourceFileName, "%s", optarg);
      break;
      
      case 'h':
        Help(argv[0]);
      break;
      
      case 'd':
	  if( OutputPath ) {
	    OutputPath = 0;
	    free(OutputPath);
	                          }
	  if( !( OutputPath = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutputPath, optarg, (int)strlen(optarg));
      break;
      
      case 11:
        shift = atol(optarg);
      break;

      case 12:
        sRes.TimeResolution = atof(optarg);
	if (sRes.TimeResolution <= 0.) sRes.TimeResolution = 1.;
      break;
      
      case 13:
        sRes.IdealBandSteepnessLeft = atof(optarg);
	if (sRes.IdealBandSteepnessLeft <= 0.) sRes.IdealBandSteepnessLeft = 1.;
      break;
      
      case 14:
        sRes.IdealBandSteepnessRight = atof(optarg);
	if (sRes.IdealBandSteepnessRight <= 0.) sRes.IdealBandSteepnessRight = 1.;
      break;
      
      case 15:
        sRes.IdealBandFrLeft = atol(optarg);
	if (sRes.IdealBandFrLeft < 0) sRes.IdealBandFrLeft = 0;
      break;
      
      case 16:
        sRes.IdealBandFrRight = atol(optarg);
	if (sRes.IdealBandFrRight < 1) sRes.IdealBandFrRight = -1;
      break;
      
      case 17:
        CreateSourceFile();
        exit(0);
      break;
      
      case 18:
        sRes.HeaderSize = atoi(optarg);
	if (sRes.HeaderSize < 0) sRes.HeaderSize = 0;
      break;
      
      case 19:
        sRes.IdealBandMaximum = atof(optarg);
      break;
      
      case '?':
        Help(argv[0]);
      break;
    }

  return(optind);
 }

/*--------      ---------------------*/

void ReadSrc (long l, long size, char *name)
{
  int file;
  TYPE *data;

     data = new TYPE[size];
     if (!data) { printf("Not enough memory!\n"); exit(1); }

     memset(data, 0, size*sizeof(TYPE));
     memset(mass, 0, size*sizeof(float));
       
       if ( (file = open(name, O_RDONLY)) == -1 )
         { printf("\nError:\nCouldn't open \"%s\" for reading!\n", name); exit(1);  }
	 
        if (lseek(file, sRes.HeaderSize + l*sizeof(TYPE), SEEK_SET) == -1 )
	 { printf("\nError:\nWrong execution of lseek() in file \"%s\"!\n", name); exit(1); }
	read(file, data, size*sizeof(TYPE));
        close(file);

   for (long q=0;q<size;q++) {
	
  #ifdef _FR_SUN
   #ifdef _TO_INTELPC
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
  
  #ifdef _FR_INTELPC
   #ifdef _TO_SUN
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
             mass[q] = (float)data[q];
	     
	                                  }		
    delete(data);	
 }
    
/*====================== Main Function ===================================*/
  
int main ( int argc, char *argv[] )
 {	    
   struct stat info;

   if (argc == 1) Help(argv[0]); 

   ResourceFileName   = new char[MaxString+1];
   XBaseResourcesFile = new char[MaxString+1];
   XResourceFile      = new char[MaxString+1];
   OutputPath         = new char[MaxString+1];
   if (!ResourceFileName || !XBaseResourcesFile || !XResourceFile || !OutputPath) { printf("Not enough memory!\n"); exit(1); }
   memset(ResourceFileName, 0, MaxString+1);
   memset(XBaseResourcesFile, 0, MaxString+1);
   memset(XResourceFile, 0, MaxString+1);
   memset(OutputPath, 0, MaxString+1);
   sprintf(ResourceFileName, "%s", "bandid.set");
   sprintf(XBaseResourcesFile, "%s", ".BaseGraphics");
   sprintf(XResourceFile, "%s", ".Bandid");
   sprintf(OutputPath, "%s", "\0");


   // ,     
   char *options[] = { "-d" };
   int opt_kind[] = { 1 }; //   : 1 -  , 0 -  
   CommandLineOptions clo(argc, argv, options, opt_kind, 1);
   av = clo.remove();
   ac = clo.getN();

   ReadResources(ac, av);
   clo.update(ac, av);
   av = clo.add();
   ac = clo.getN();

   ParseCmdLine(ac, av);

   if (strcmp(ResourceFileName, "no")) ReadFromRes();
   
   next = ParseCmdLine(ac, av);
   if (ac < next + 1) { printf("\nError:\nNot point the file with band!\n"); exit(1); }

   if (!strcmp(ResourceFileName, "no")) { memset(ResourceFileName, 0, MaxString+1);
                                          sprintf(ResourceFileName, "%s", "bandid.set");
                                         }
   
   if ( stat(av[next], &info) != 0 ) {
     printf("\nError:\nCouldn't open \"%s\"!\n", av[next]); exit(1); }

  Size = (info.st_size - sRes.HeaderSize)/sizeof(TYPE);
  if (Size <= 0) { printf("\nError:\nSize of header is to much!\n"); exit(1); }
  
//  if (2*(Size - 1) != resize(2*(Size - 1))) { printf("\nError:\nYour file with band doesn't contain N/2 + 1 positive harmonics!\n"); exit(1); }
  if (2*(Size - 1) != resize(2*(Size - 1))) unit = 0;
  
  mass = new float[Size];
  if (!mass) { printf("Not enough memory!\n"); exit(1); }

  ReadSrc(0, Size, av[next]);
  for (long i=0;i<Size;i++) {
   gmax = (i == 0 ? mass[i] : (mass[i] > gmax ? mass[i] : gmax));
   gmin = (i == 0 ? mass[i] : (mass[i] < gmin ? mass[i] : gmin));
  }

  Plotting();

  delete(mass);
  delete(XBaseResourcesFile);
  delete(XResourceFile);
  delete(OutputPath);
  delete(ResourceFileName);    

  return 0;
 }

