#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <getopt.h>
#include <math.h>

#define MaxString 255

#ifndef TYPE
 #define TYPE float
#endif

using namespace std;
	

struct sResStruc {     double TimeResolution,                    /*--    - --*/
			      IdealBandSteepnessLeft,		 /*--      --*/
			      IdealBandSteepnessRight,		 /*--      --*/
			      IdealBandMaximum;			 /*--     --*/
			 long BandSmooth,			 /*--     --*/
			      IdealBandFrLeft,			 /*--     --*/
			      IdealBandFrRight;			 /*--     --*/
			  int HeaderSize;			 /*--  ( )    --*/
			char *BandCorrFuncExt,			 /*--       --*/
			     *InterferencesFileExt;              /*--       --*/
                  };
		  		  
#ifdef MAIN_

#include "opt.hpp"

struct sResStruc sRes =   /*--     PSR1641-45 --*/

			{
			  400., 10000., 60000., -1.,
			  1024, 0, -1, 0,
			  ".cor", ".pom"
			 };

char *ResourceFileName = "bandid.set";   /*--    --*/

/*--      .  --*/
char * XBaseResourcesFile;

/*--        Bandid
          XBaseResourcesFile
--*/
char * XResourceFile;

char * OutputPath, **av;
int ac, next;
float *mass, gmax, gmin;
long Size, shift = -1;

/*-- util.cpp --*/

void ReadFromRes ( void );
void CreateSourceFile ( void );
TYPE nh2hn ( TYPE, int );

/*-- x.cpp --*/

void Plotting ( void );
void ReadResources (int&, char**&);

#endif

#ifdef UTIL_

extern struct sResStruc sRes;
extern char *ResourceFileName;    /*--    --*/

#endif

#ifdef XW_

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/ShellP.h>

#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

/*---   /   ---*/
#define zoom 100

typedef struct { Pixel fg, bg;
                 Font font; } wD, *twData;

// 
XtAppContext appcont;
// 
Display *DisId;

extern struct sResStruc sRes;
extern char *ResourceFileName;    /*--    --*/
extern char * XBaseResourcesFile, * XResourceFile;      /*--      --*/
extern char **av;
extern char * OutputPath;
extern float *mass, gmax, gmin;
extern long Size, shift;
extern int next;

float *id, stepMax, pmax, cur_x = 0., cur_y = 0.;
//     (),
//       
float *save;

long stepGamma, rate;
long setLeft, setRight, pl, pr;
long lo, left, window, min_okno = 2, okno;
//            
long lp[zoom + 1], wp[zoom + 1], rp[zoom + 1];
int count = 0;
//     ,  
//      rate
unsigned char mode_switch = 0;
//  /    
bool auto_update = false;
//  /    Expose
//   Backing Store
//   - 
//  LCtrl + RCtrl
//  - LCtrl  RCtrl
bool auto_expose = true;

int id_flag = 0, press = 0, corr = 0;

struct pomexInfo {  char type;                /*--  : m (-)  p (-)  --*/
                    long start_pos,           /*--    ( -)    ( -) --*/
		         end_pos,             /*--   ,          --*/
			 sigma_start_pos,     /*--       sigma --*/
			 sigma_size;          /*--     sigma --*/
                  };
		  
struct pomexInfo *pomArray;
int pomNumber = 0, PoliActive = 0;

unsigned int fow, foa, fod;

/*-- bandid.cpp --*/

void smoothing ( long );
char * SelectFileName ( char * );

/*-- util.cpp --*/

void Rec2Res ( void );

/*-- xutil.cpp --*/

void UpdateBandidXResources (char *, char *);

Dimension pw, ph;

/*---------- Borrowed from Kirill & Kazman |  Updated by me ------------------*/

#define INIT_WIDGETS_PROPS \
   wD wData; \
\
  Dimension w, h; \
  XtResource tRes[] = { \
    {XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel), XtOffset(twData, fg), XtRString, (void*)"black"}, \
    {XtNbackground, XtCBackground, XtRPixel, sizeof(Pixel), XtOffset(twData, bg), XtRString, (void*)"white"}, \
    {XtNfont, XtCFont, XtRFont, sizeof(Font), XtOffset(twData, font), XtRString, (void*)"6x10"}}; \
\
  XtGetApplicationResources(targetW, &wData, tRes, XtNumber(tRes), NULL, 0); \
\
  Display *disID = XtDisplay(targetW); \
  Window winID = XtWindow(targetW); \
  GC     grC   = XtGetGC(targetW, 0, NULL); \
  XSetForeground(disID, grC, wData.fg); \
  XSetFont(disID, grC, wData.font); \
\
  XWindowAttributes att; \
  XSetWindowAttributes  attr; \
  XGetWindowAttributes(disID, winID, &att); \
  attr.backing_store = Always; \
  XChangeWindowAttributes(disID, winID, CWBackingStore, &attr); \
  w = att.width; \
  h = att.height; 

#define UNPLUG_WIDGETS_GC XtReleaseGC(targetW, grC);

/*--------------------------------------------------------------------*/

#endif

