#define XW_
#include "bandid.hpp"

extern int unit;

/*-----      ----*/

template <class tFormat>
void Write (tFormat m, long left, long size, int razm, char *name, char *ext, int flag)
{
   int out;
   char *outfilename;
   outfilename = new char[MaxString+1];

   memset(outfilename, 0, MaxString+1);
   if (!strcmp(OutputPath, "\0")) sprintf(outfilename, "%s%s", name, ext); 
     else sprintf(outfilename, "%s/%s%s", OutputPath, SelectFileName(name), ext);
      
   tFormat tmp = m;
   tmp += left;
  
   if ( (out = open(outfilename, (flag == 1 ? O_TRUNC : O_APPEND) | O_CREAT | O_WRONLY, 0644)) == -1 )
      { printf("\nError: Couldn't open file %s for writing!\n", outfilename);
        exit(1);
       }
     else
       {
           lseek(out, 0, SEEK_SET);
	   write(out, tmp, size*razm);	                                           
           close(out);
        }
	   	
   printf("%s \"%s\" saved\n", corr == 1 ? "File with correction function" : "File", outfilename);

   delete(outfilename);
 }

/*---------      -------------*/

void IdealBuilding ( void )
{
 long sz = 2*(Size-unit);
 double freq, scale, sc, Gamma;
 double fl = (1.e9/(sRes.TimeResolution*sz)) * (double)sRes.IdealBandFrLeft;
 double fr = (1.e9/(sRes.TimeResolution*sz)) * (double)sRes.IdealBandFrRight;

 double val1, val2;
 long rubej = (long)ceil(Size/2);
 freq = (1.e9/(sRes.TimeResolution*sz)) * (double)(rubej-1);	      
 val1 = (1./ sqrt( 1. + exp( ((freq - fl) * (freq - fr))/(sRes.IdealBandSteepnessLeft * (fr - fl)) ) )) ; 
 freq = (1.e9/(sRes.TimeResolution*sz)) * (double)(rubej);	      
 val2 = (1./ sqrt( 1. + exp( ((freq - fl) * (freq - fr))/(sRes.IdealBandSteepnessRight * (fr - fl)) ) )) ;
 scale = val1/val2;

 memset(id, 0, Size);
    
 for (long i=0;i<Size;i++) {
   sc    = (i<rubej ? 1. : scale);
   Gamma = (i<rubej ? sRes.IdealBandSteepnessLeft : sRes.IdealBandSteepnessRight);
   freq = (1.e9/(sRes.TimeResolution*sz)) * (double)i;	      
   id[i] = sc*(sRes.IdealBandMaximum-gmin)*(1./ sqrt( 1. + exp( ((freq - fl) * (freq - fr))/(Gamma * (fr - fl)) ) )) + gmin;
  }
}

/*----------        -----------------*/

void PomexReportWrite ( char * base )
{
   if (pomNumber == 0) return;

   char *outfilename;
   outfilename = new char[MaxString+1];

   memset(outfilename, 0, MaxString+1);
   if (!strcmp(OutputPath, "\0")) sprintf(outfilename, "%s%s", base, sRes.InterferencesFileExt);  
     else sprintf(outfilename, "%s/%s%s", OutputPath, SelectFileName(base), sRes.InterferencesFileExt);
     
   FILE *out;
         if ( (out = fopen(outfilename, "wt")) == NULL ) {
	  printf("\nError:\nCouldn't open file \"%s\" for writing!\n", outfilename);
	  exit(1);
	 }
	 fseek(out, 0, SEEK_SET);
	 fprintf(out, "# PROGRAMM Bandid\n# Interferences Report File\n#\n# type\tstart\tend\tsigma_start\tsigma_size\n#\n");
	 for (int i=0;i<pomNumber;i++) {
	  if ((pomArray+i)->type == 'm') fprintf(out, "%c\t%ld\n", (pomArray+i)->type, (pomArray+i)->start_pos);
	  if ((pomArray+i)->type == 'p') fprintf(out, "%c\t%ld\t%ld\t%ld\t\t%ld\n", (pomArray+i)->type, (pomArray+i)->start_pos, (pomArray+i)->end_pos, (pomArray+i)->sigma_start_pos, (pomArray+i)->sigma_size);
	 }
	 fclose(out);
	 
   printf("Interference Report File \"%s\" saved\n", outfilename);

   delete(outfilename);
}

/*----------   ,   
                        --------------------------*/

void CutMono ( void )
{
  float buf, locmax = mass[lo];
  long tmax, step = 0;
  
  for(long t=lo;t<lo+okno;++t) {
   tmax = (t==lo ? t : (mass[t] > locmax ? t : tmax));
   locmax = (mass[t] > locmax ? mass[t] : locmax);
  }
  //     ?     
  buf = mass[tmax];
  mass[tmax] = (tmax == 0 ? (mass[tmax+1]+mass[tmax+2])/2  + ((mass[tmax+2]-mass[tmax+1])/2)*cos(mass[tmax]) : (tmax == Size-1 ? (mass[tmax-1]+mass[tmax-2])/2 + ((mass[tmax-1]-mass[tmax-2])/2)*cos(mass[tmax]): (mass[tmax-1]+mass[tmax+1])/2 + ((mass[tmax+1]-mass[tmax-1])/2)*cos(mass[tmax]) ));
  while (buf == mass[tmax]) {
   buf == mass[tmax];
   ++step;
   mass[tmax] = (tmax == 0 ? (mass[tmax+1]+mass[tmax+2])/2  + ((mass[tmax+2]-mass[tmax+1])/2)*cos(mass[tmax] + step) : (tmax == Size-1 ? (mass[tmax-1]+mass[tmax-2])/2 + ((mass[tmax-1]-mass[tmax-2])/2)*cos(mass[tmax] + step): (mass[tmax-1]+mass[tmax+1])/2 + ((mass[tmax+1]-mass[tmax-1])/2)*cos(mass[tmax] + step) ));
  }
  (pomArray+pomNumber)->type = 'm';
  (pomArray+pomNumber)->start_pos = tmax;
}

/*---------- ,    ,    ---------------*/

double NormRand ( void )
{
 long rn1, rn2;
 double yj, zj, pj , xi;

 do { rn1 = random(); rn2 = random();
      yj = 2.*(((double)rn1)/((double)(RAND_MAX+1.0))) - 1.;
      zj = 2.*(((double)rn2)/((double)(RAND_MAX+1.0))) - 1.;
      pj = yj*yj + zj*zj;
     } while ( pj >= 1. );

 return ( yj * sqrt ((-2.*log(pj))/pj) );
}

/*-------------      -------------*/

void CutPoli ( void )
{
 double aver, sigma, sum = 0., sum2 = 0.;
 (pomArray+pomNumber)->sigma_start_pos = lo;
 (pomArray+pomNumber)->sigma_size = okno;
 for (long t=lo;t<lo+okno;++t) { sum += mass[t]; sum2 += mass[t]*mass[t]; }
 sigma = sqrt( sum2/okno - (sum/okno)*(sum/okno) );
 aver = sum/okno;

 srandom((unsigned long)time(NULL));
 for (long t=(pomArray+pomNumber)->start_pos;t<=(pomArray+pomNumber)->end_pos;++t) {
  mass[t] = aver + sigma*NormRand ();
 }
}

/*=================================================================================


                                    


==================================================================================*/

/*--------     .  ----------------------*/

void CreateBaseGraphicsFile (char * filename) {

 FILE *cfg = fopen(filename, "wt");
             fseek(cfg, 0, SEEK_SET);	    
fprintf(cfg, "! This is a X resource file with base resources\n\n"
             ".display                      : :0\n"
             "*.borderWidth                 : 0\n"
             "*.font                        : 6x10\n"
             "*.mainBox.background          : lightblue\n"
	     "*.mainBox.foreground          : black\n\n"
	     
             "*.PlotBox.background          : #d5d5d5\n"
             "*.PlotBox.foreground          : darkgreen\n"
             "*.PlotBox.borderWidth         : 1\n\n"
	     
             "*.header.height               : 15\n"
             "*.header.background           : lightblue\n"
             "*.header.foreground           : #004800\n\n"
	     
             "*.legend.height               : 15\n"
             "*.legend.background           : lightblue\n"
             "*.legend.foreground           : #004800\n\n"
	     
             "*.hAxe.height                 : 35\n"
             "*.hAxe.background             : lightblue\n"
             "*.hAxe.foreground             : black\n"
             "*.hAxe.name                   : X-axis\n"
             "*.hAxe.scale                  : 1.\n"
             "*.hAxe.shift                  : 0.\n\n"
	     
             "*.vAxe.width                  : 80\n"
             "*.vAxe.background             : lightblue\n"
             "*.vAxe.foreground             : black\n"
             "*.vAxe.scale                  : 1.\n"
             "*.vAxe.shift                  : 0.\n\n"
	     
             "*.vTitle.width                : 1\n"
             "*.vTitle.background           : lightblue\n"
             "*.vTitle.foreground           : black\n"
             "*.vTitle.name                 : Y   a x i s\n\n"
	     
             "*.footnote.height             : 30\n"
             "*.footnote.background         : lightblue\n"
             "*.footnote.foreground         : #565600\n");

             fclose(cfg);
}

/*-----     ,   bandid -----*/

void CreateBandidXResources (char * filename) {

 FILE *cfg = fopen(filename, "wt");
             fseek(cfg, 0, SEEK_SET);	    
fprintf(cfg, "! This is a Bandid resource file\n\n"
             "#include \".BaseGraphics\"\n\n"
             "Bandid.height                    : 395\n"
             "Bandid.width                     : 491\n"
             "Bandid.minHeight                 : 180\n"
             "Bandid.minWidth                  : 300\n\n"
	     
	     "! Extra resources for footnote region\n\n"
             "*.footnote.tabbox             : #8b4513\n"
             "*.footnote.modebox            : #228b22\n\n"
	     
	     "! Extra resources for PlotBox region\n\n"
             "*.PlotBox.zoomer              : #808000\n"
             "*.PlotBox.activeBorder        : #444444\n"
             "*.PlotBox.otherBorder         : #afeeee\n"
             "*.PlotBox.idealBand           : #afeeee\n");

             fclose(cfg);
}

//           
//         
//    
//   . ,    
//     
void ReadResources (int& argc, char**& argv) {

  struct stat base_inf, inf;
  //     ,   ,  
  if ( stat(XBaseResourcesFile, &base_inf) == 0 ) ; else {
   memset(XBaseResourcesFile, 0, MaxString+1);
   sprintf(XBaseResourcesFile, "%s%s", getenv("HOME"), "/.BaseGraphics");
   if ( stat(XBaseResourcesFile, &base_inf) == 0 ) ; else CreateBaseGraphicsFile (XBaseResourcesFile);
  }
  if ( stat(XResourceFile, &inf) == 0 ) ; else {
   memset(XResourceFile, 0, MaxString+1);
   sprintf(XResourceFile, "%s%s", getenv("HOME"), "/.Bandid");
   if ( stat(XResourceFile, &inf) == 0 ) ; else CreateBandidXResources (XResourceFile);
  }
  
  UpdateBandidXResources (XResourceFile, XBaseResourcesFile);

  XtToolkitInitialize();
  //   
  appcont = XtCreateApplicationContext();

  //     . 
  DisId = XtOpenDisplay(appcont, NULL, "Bandid", "Bandid", NULL, 0, &argc, argv);

  //      ,     
  //   
  XrmDatabase args = XtDatabase(DisId);
  //    ,     
  XrmCombineFileDatabase(XResourceFile, &args, False);
}

//   
//      
//    (,   ..)
void UpdateResources ( Widget targetW ) {

 // :
 Position headerY, vTitleX;
 Dimension headerH, vTitleW, vAxeW, legendH, plotBoxBorderW, hAxeH, footnoteH, Height, Width;
 Arg tmpX, tmpY, tmpH, tmpW;
 
 //   
 XtSetArg(tmpH, XtNheight, &Height);
 XtSetArg(tmpW, XtNwidth, &Width);
 XtVaGetValues(XtParent(targetW), tmpH, tmpW, NULL);

 XtSetArg(tmpY, XtNy, &headerY);
 XtSetArg(tmpH, XtNheight, &headerH);
 XtVaGetValues(XtNameToWidget(targetW, "header"), tmpY, tmpH, NULL);

 XtSetArg(tmpX, XtNx, &vTitleX);
 XtSetArg(tmpW, XtNwidth, &vTitleW);
 XtVaGetValues(XtNameToWidget(targetW, "vTitle"), tmpX, tmpW, NULL);

 XtSetArg(tmpW, XtNwidth, &vAxeW);
 XtVaGetValues(XtNameToWidget(targetW, "vAxe"), tmpW, NULL);

 XtSetArg(tmpH, XtNheight, &legendH);
 XtVaGetValues(XtNameToWidget(targetW, "legend"), tmpH, NULL);

 XtSetArg(tmpH, XtNheight, &hAxeH);
 XtVaGetValues(XtNameToWidget(targetW, "hAxe"), tmpH, NULL);

 XtSetArg(tmpH, XtNheight, &footnoteH);
 XtVaGetValues(XtNameToWidget(targetW, "footnote"), tmpH, NULL);

 XtSetArg(tmpW, XtNborderWidth, &plotBoxBorderW);
 XtVaGetValues(XtNameToWidget(targetW, "PlotBox"), tmpW, NULL);


 //   
 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "header"), tmpX, tmpW, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, headerY + headerH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "legend"), tmpX, tmpY, tmpW, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, Height - footnoteH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "footnote"), tmpX, tmpY, tmpW, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, Height - footnoteH - hAxeH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "hAxe"), tmpX, tmpY, tmpW, NULL);

 XtSetArg(tmpY, XtNy, headerY + headerH + legendH);
 XtSetArg(tmpH, XtNheight, Height - headerH - legendH - hAxeH - footnoteH);
 XtVaSetValues(XtNameToWidget(targetW, "vTitle"), tmpY, tmpH, NULL);

 XtSetArg(tmpX, XtNx, vTitleX + vTitleW);
 XtSetArg(tmpY, XtNy, headerY + headerH + legendH);
 XtSetArg(tmpH, XtNheight, Height - headerH - legendH - hAxeH - footnoteH);
 XtVaSetValues(XtNameToWidget(targetW, "vAxe"), tmpX, tmpY, tmpH, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, headerY + headerH + legendH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW - 2*plotBoxBorderW);
 XtSetArg(tmpH, XtNheight, Height - headerH - legendH - hAxeH - footnoteH - 2*plotBoxBorderW);
 XtVaSetValues(XtNameToWidget(targetW, "PlotBox"), tmpX, tmpY, tmpW, tmpH, NULL);
}

/*=================================================================================


                                            

                                            		 		                        


==================================================================================*/


/*------------------------          --------------------------------

          

-----------------------------------------------------------------------------*/   

void WindowHeader ( Widget targetW )
{
    INIT_WIDGETS_PROPS     
     XFontStruct *cur_font = XQueryFont(disID, wData.font);
     fow = abs(cur_font->min_bounds.width);
     foa = cur_font->ascent;
     fod = cur_font->descent;
     
    XClearWindow(disID, winID);
    
    char InfoString[MaxString+1];  

    sprintf(InfoString, "Programm: %s   File: %s", av[0], av[next]);
    XDrawString(disID, winID, grC, 0, 3 + foa, InfoString, strlen(InfoString));
    UNPLUG_WIDGETS_GC
}

/*--------------------------         ---------------------------------

           (-)

-----------------------------------------------------------------------------*/

void Legend ( Widget targetW )
{
    INIT_WIDGETS_PROPS
    XClearWindow(disID, winID);
    
    char InfoString[MaxString+1];  

    sprintf(InfoString, "Help: q.Enter.Space.Esc.+.-.m.p.a.s.i.Tab.LShift.->.<-.Up.Down.PgUp.PgDn.MOUSE");
    XDrawString(disID, winID, grC, 0, 3 + foa, InfoString, strlen(InfoString));
    UNPLUG_WIDGETS_GC
}

/*---------------------         ------------------------------------

         

---------------------------------------------------------------------------*/  

void Footnote ( Widget targetW )
{
    INIT_WIDGETS_PROPS
    XClearWindow(disID, winID);

    typedef struct { Pixel tb, mb; } frame, *pFrame;
    frame fr;

    XtResource myRes[] = { {"tabbox", "Tabbox", XtRPixel, sizeof(Pixel), XtOffset(pFrame, tb), XtRString, (void*)"#8b4513"},
			   {"modebox", "Modebox", XtRPixel, sizeof(Pixel), XtOffset(pFrame, mb), XtRString, (void*)"#228b22"} };
    XtGetApplicationResources(targetW, &fr, myRes, XtNumber(myRes), NULL, 0); 
  
    char InfoString[MaxString+1], au[MaxString+1] = "";

    if (id_flag != 0 && corr != 1) sprintf(au, "          %s", auto_update ? "ON" : "OFF");
    sprintf(InfoString, "Pos: (%.5g , %.5g)%s", cur_x, cur_y, au);
    XDrawString(disID, winID, grC, 0, 3 + foa, InfoString, strlen(InfoString));
    memset(InfoString, 0, MaxString+1);
    
    if (id_flag == 0 && corr != 1) sprintf(InfoString, "Left: %8ld   Window: %8ld   Step: %8ld", lo, okno, rate);
     else { if (corr == 1) sprintf(InfoString, "%s", "");
             else { switch (mode_switch) {
	             case 0:  sprintf(InfoString, "Left: %8ld   Right: %8ld   Step: %8ld", pl, pr, rate);
		              break;
	             case 1:  sprintf(InfoString, "Left: %8ld   Right: %8ld   Steepness: %8ld   Step: %8ld", pl, pr, (id_flag == 1 ? (long)sRes.IdealBandSteepnessLeft : (long)sRes.IdealBandSteepnessRight), stepGamma);
		              XSetForeground(disID, grC, fr.mb);
	                      XDrawRectangle(disID, winID, grC, fow*35, 3 + 2 + foa + fod, fow*37, foa + 2*fod);
		              XSetForeground(disID, grC, wData.fg);
		              break;
		     case 2:  sprintf(InfoString, "Left: %8ld   Right: %8ld   Max. Level: %12.3g   Step: %12.3g", pl, pr, sRes.IdealBandMaximum, stepMax);
		              XSetForeground(disID, grC, fr.mb);
	                      XDrawRectangle(disID, winID, grC, fow*35, 3 + 2 + foa + fod, fow*46, foa + 2*fod);
		              XSetForeground(disID, grC, wData.fg);
		              break;
		     default: sprintf(InfoString, "%s", "");
		              break;
	            } // switch
		     XSetForeground(disID, grC, fr.tb);
	             XDrawRectangle(disID, winID, grC, (id_flag - 1)*fow*17, 3 + 2 + foa + fod, fow*((2-id_flag)*15 + (id_flag-1)*16), foa + 2*fod);
		     XSetForeground(disID, grC, wData.fg);
	           }
	   }
	   
    XDrawString(disID, winID, grC, fow/2, 2*(3 + foa) + fod, InfoString, strlen(InfoString));
    UNPLUG_WIDGETS_GC
}

/*----------                                ----------------------

           

-----------------------------------------------------------------------------------------*/    

void vTitle ( Widget targetW )
{
 typedef struct { char * title; } tit, *ptit;
 tit name;
  
 XtResource nameRes[] = { {"name",  "Name",  XtRString, sizeof(char *), XtOffset(ptit, title), XtRString, (void*)"Y   |   a x i s" } };
 XtGetApplicationResources(targetW, &name, nameRes, XtNumber(nameRes), NULL, 0); 
  
 INIT_WIDGETS_PROPS      
 XClearWindow(disID, winID);

 char value[MaxString+1];
 int Nsp = 0, flag = 0, j = 0, len = 0;

  while ( name.title[j] != '\0') { if (name.title[j] == ' ' && flag == 0) { Nsp++; flag = 1; } else flag = 0;
                                   ++j; }
  Nsp++; flag = 0;
  
  for (int i=0;i<Nsp;i++) {
    j = 0;
    memset(value, 0, MaxString+1);
    while ((name.title[len+j] != ' ' && name.title[len+j] != '\0') || flag == 1) { value[j] = name.title[len+j]; flag = 0; ++j; }
    if (name.title[len+j] == '\0') flag = 0; else { flag = 1; value[j] = '\0'; }
    len += strlen(value) + 1;
    XDrawString(disID, winID, grC, w - 3 - fow*strlen(value), h/2 - (Nsp*(foa+fod+1))/2 + foa + fod/2 + (foa + fod + 1)*i, value, strlen(value));
  }
    
 UNPLUG_WIDGETS_GC
}

/*----------                   ----------------------

            

----------------------------------------------------------------------*/    

void VertAxe ( Widget targetW, XtPointer tD )
{
 float * x;
 x = (float *)tD;

 typedef struct { float shift, scale; } par, *ppar;
                  
 par param;
 float def_scale = 1., def_shift = 0.;
  
 XtResource parRes[] = { {"scale", "Scale", XtRFloat,  sizeof(float),  XtOffset(ppar, scale), XtRFloat,  &def_scale },
			 {"shift", "Shift", XtRFloat,  sizeof(float),  XtOffset(ppar, shift), XtRFloat,  &def_shift } };
 XtGetApplicationResources(targetW, &param, parRes, XtNumber(parRes), NULL, 0); 

 INIT_WIDGETS_PROPS      
 XClearWindow(disID, winID);
 
 char value[MaxString+1];

 for(long t=left;t<left+window;t++) gmax = (t==left ? x[t] : (x[t] > gmax ? x[t] : gmax));
 for(long t=left;t<left+window;t++) gmin = (t==left ? x[t] : (x[t] < gmin ? x[t] : gmin));
 
 double step = (gmax - gmin)/3;
   
    sprintf(value, "%.3g", gmin*param.scale + param.shift);
    XDrawLine(disID, winID, grC, w-5, h-1, w, h-1);
    XDrawString(disID, winID, grC, w-8 - fow*(strlen(value)), h-2, value, strlen(value));
     sprintf(value, "%.3g", gmax*param.scale + param.shift);
    XDrawLine(disID, winID, grC, w-5, 0, w, 0);
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, w-2, t*(h/3/5), w, t*(h/3/5));
    XDrawString(disID, winID, grC, w-8 - fow*(strlen(value)), foa, value, strlen(value));
    
   for(int i=1;i<3;i++)
   {
    sprintf(value, "%.3g", (gmin + i*step)*param.scale + param.shift);
    XDrawLine(disID, winID, grC, w-5, h - i*(h/3), w, h - i*(h/3));
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, w-2, h - i*(h/3) + t*(h/3/5), w, h - i*(h/3) + t*(h/3/5));
    XDrawString(disID, winID, grC, w-8 - fow*(strlen(value)), h-2 - i*(h/3), value, strlen(value));
    }
    
 UNPLUG_WIDGETS_GC
}
  
/*----------                     ----------------------

            

----------------------------------------------------------------------*/

void HorizAxe ( Widget targetW )
{
 typedef struct { char * title;
                  float shift, scale; } tit, *ptit;
 tit name;
 float def_scale = 1., def_shift = 0.;
  
 XtResource nameRes[] = { {"name",  "Name",  XtRString, sizeof(char *), XtOffset(ptit, title), XtRString, (void*)"X-axis" },
                          {"scale", "Scale", XtRFloat,  sizeof(float),  XtOffset(ptit, scale), XtRFloat,  &def_scale },
			  {"shift", "Shift", XtRFloat,  sizeof(float),  XtOffset(ptit, shift), XtRFloat,  &def_shift } };
 XtGetApplicationResources(targetW, &name, nameRes, XtNumber(nameRes), NULL, 0); 
  
 INIT_WIDGETS_PROPS
 XClearWindow(disID, winID);
 
 char value[MaxString+1];
 double begin, step;

 begin = ((1.e9/(sRes.TimeResolution*2*(Size-unit))) * (double)left);
 step  = ((1.e9/(sRes.TimeResolution*2*(Size-unit))) * (double)(window-1))/4;
	  
  sprintf(value, "%.2f", begin*name.scale + name.shift);
   XDrawLine(disID, winID, grC, 0, 0, 0, 5);
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, t*(w/4/5), 0, t*(w/4/5), 1);
    XDrawString(disID, winID, grC, 0, 5+3 + foa, value, strlen(value));
  sprintf(value, "%.2f", (begin + 4.*step)*name.scale + name.shift);
   XDrawLine(disID, winID, grC, w-1, 0, w-1, 5);
    XDrawString(disID, winID, grC, w-1 - fow*(strlen(value)), 5+3 + foa, value, strlen(value));

  for (int i=1;i<4;i++)
   {
    sprintf(value, "%.2f", (begin + i*step)*name.scale + name.shift);
    XDrawLine(disID, winID, grC, i*(w/4), 0, i*(w/4), 5);
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, i*(w/4) + t*(w/4/5), 0, i*(w/4) + t*(w/4/5), 1);
    XDrawString(disID, winID, grC, i*(w/4) - (strlen(value)*fow)/2, 5+3 + foa, value, strlen(value));
    }
    
  sprintf(value, name.title);
  XDrawString(disID, winID, grC, w/2 - (strlen(value)*fow)/2, 5 + 2*(3 + foa) + fod, value, strlen(value));
  
 UNPLUG_WIDGETS_GC
}

/*------------                    --------------------

            

-----------------------------------------------------------------------*/    

void Destroy ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == DestroyNotify ||
      event->type == KeyPress || event->type == KeyRelease)
  {
    *cont = False;
    delete (XBaseResourcesFile);
    delete (XResourceFile);
    delete (ResourceFileName);    
    delete (OutputPath);
    delete (float *)tD;  
    delete (id);
    delete (save);
    delete (pomArray);    
    XtDestroyWidget (targetW);
    XtDestroyApplicationContext (XtWidgetToApplicationContext(targetW));  
    exit(0);
  }
}                                      

/*----------          ------------------*/

void PointerPos ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
 if (event->type == MotionNotify)
  {
    XWindowAttributes attr;
    XGetWindowAttributes(XtDisplay(targetW), XtWindow(targetW), &attr);

    cur_x = ((float)( left + window * ((float)(event->xmotion.x + attr.border_width)) / ((float)pw) )) * (1.e9/(sRes.TimeResolution*2*(Size-unit)));
    cur_y = gmin + (gmax-gmin) * ((float)(ph - event->xmotion.y)) / ((float)ph) ;
    Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
   }
 }                                                              

/*-----------   -    ,
            /      -------------*/ 

void Zoomer ( Widget targetW )
{
  int sh;
  
  typedef struct { Pixel fg; } frame, *pFrame;
  frame fr;

  XtResource myRes[] = { {"zoomer", "Zoomer", XtRPixel, sizeof(Pixel), XtOffset(pFrame, fg), XtRString, (void*)"black"} };
  XtGetApplicationResources(targetW, &fr, myRes, XtNumber(myRes), NULL, 0); 

  Display *disID = XtDisplay(targetW);
  Window winID   = XtWindow(targetW);
  GC grC         = XtGetGC(targetW, 0, NULL);
    
  XSetForeground(disID, grC, fr.fg);
  XSetFunction(disID, grC, GXxor);      
  XSetLineAttributes(disID, grC, 1, LineOnOffDash, CapButt, JoinRound);  

  int lg = (int)((((float)(lo-left))*((float)pw))/(float)window), 
      rg = (int)((((float)(lo-left+okno))*((float)pw))/(float)window);

  XDrawLine(disID, winID, grC, lg, 0, lg, ph);  
  if ( rg == pw) sh = 1; else sh = 0;
  if ( lg != rg - sh) XDrawLine(disID, winID, grC, rg - sh, 0, rg - sh, ph);   
  XDrawLine(disID, winID, grC, lg, ph/2, rg - sh, ph/2);

  XtReleaseGC(targetW, grC);  
}

/*-----------  (/) -    
                               --------------------------------*/

void MapBegunok ( Widget targetW )
{
  int sh, lg, rg;
  
  typedef struct { Pixel ab, vb; } frame, *pFrame;
  frame fr;

  XtResource myRes[] = { {"activeBorder", "ActiveBorder", XtRPixel, sizeof(Pixel), XtOffset(pFrame, ab), XtRString, (void*)"black"},
			 {"otherBorder", "OtherBorder", XtRPixel, sizeof(Pixel), XtOffset(pFrame, vb), XtRString, (void*)"black"} };
  XtGetApplicationResources(targetW, &fr, myRes, XtNumber(myRes), NULL, 0); 

  Display *disID = XtDisplay(targetW);
  Window winID   = XtWindow(targetW);
  GC grC         = XtGetGC(targetW, 0, NULL);
  
  XSetForeground(disID, grC, fr.ab);
  XSetLineAttributes(disID, grC, 1, LineOnOffDash, CapButt, JoinRound);
  XSetFunction(disID, grC, GXxor);

  lg = (int)((((float)setLeft)*((float)pw))/(float)Size), 
  rg = (int)((((float)setRight)*((float)pw))/(float)Size);

  XDrawLine(disID, winID, grC, lg, 0, lg, ph);  
  if ( rg == pw) sh = 1; else sh = 0;
  if ( lg != rg - sh) XDrawLine(disID, winID, grC, rg - sh, 0, rg - sh, ph);   

  XSetForeground(disID, grC, fr.vb);
  
  lg = (int)((((float)pl)*((float)pw))/(float)Size), 
  rg = (int)((((float)pr)*((float)pw))/(float)Size);

  XDrawLine(disID, winID, grC, lg, 0, lg, ph);  
  if ( rg == pw) sh = 1; else sh = 0;
  if ( lg != rg - sh) XDrawLine(disID, winID, grC, rg - sh, 0, rg - sh, ph);   

  XtReleaseGC(targetW, grC);
 }

/*--------------        ------------------*/

void PlotIdeal ( Widget targetW, XtPointer tD )
{    
  float * x;
  x = (float *)tD;

  typedef struct { Pixel id_col; } col, *pcol;
  col cvet;

  XtResource colRes[] = { {"idealBand",  "IdealBand",  XtRPixel, sizeof(Pixel), XtOffset(pcol, id_col), XtRString, (void*)"black"} };
  XtGetApplicationResources(targetW, &cvet, colRes, XtNumber(colRes), NULL, 0); 

  Boolean check;
  
  INIT_WIDGETS_PROPS
  
    XSetForeground(disID, grC, cvet.id_col);
    XSetLineAttributes(disID, grC, 1, LineSolid, CapButt, JoinRound);
    XSetFunction(disID, grC, GXxor);
           
   Position xcur, ycur, xcurPr, ycurPr, ycurPr2;
   double stpx, stpy;

  if ( press == 1 ) IdealBuilding();
  press = (press == 1 ? 0 : press);
    
      stpx = (double)w/((double)Size);
      stpy = (double)h/(double)(gmax - gmin);
      
      xcurPr  = (short int)(0 * stpx);
      ycurPr  = (short int)(h - (x[0] - gmin) * stpy);
      ycurPr2 = ycurPr;
                                       	 	 
  for (long j=1;j<Size;j++)
   {
     xcur = (short int)(j * stpx);
     ycur = (short int)(h - (x[j] - gmin) * stpy);

     check = ( (short int)( (j+1)*stpx )  != xcurPr || j+1 >= Size );
	      
     if (xcur == xcurPr) { ycurPr  = ( ycur >  ycurPr  ? ycur : ycurPr  );                                                   	              
                           ycurPr2 = ( ycur <= ycurPr2 ? ycur : ycurPr2 );                                                      	      
                                                                                                                             
                           if ( check ) { if (ycurPr != ycurPr2) XDrawLine(disID, winID, grC, xcurPr, ycurPr, xcur, ycurPr2);   	      
                                          ycurPr = ycur;                                                                        	      
                                         }                                                                                      	      
                          } else { XDrawLine(disID, winID, grC, xcurPr, ycurPr, xcur, ycur);                                    	      
                                   xcurPr  = xcur;                                                                              	      
                                   ycurPr  = ycur;                                                                              	      
                                   ycurPr2 = ycur;                                                                              	      
                                  }                                                                                             	      	             
    }                              

   MapBegunok(targetW);    
   UNPLUG_WIDGETS_GC   
}

/*-----------        (/)
                         --------------------------------------------*/

void Plotdata ( Widget targetW, XtPointer tD )
{    
  float * x;
  x = (float *)tD;  
  
  Boolean check;
  
  INIT_WIDGETS_PROPS

  pw = w;
  ph = h;

  Position xcur, ycur, xcurPr, ycurPr, ycurPr2;
  double stpx, stpy;       
	   
  XClearWindow(disID, winID);
       
  stpx = (double)w/((double)(window));
  stpy = (double)h/(double)(gmax - gmin);

  xcurPr  = (short int)(0 * stpx);      
  ycurPr  = (short int)(h - (x[left] - gmin) * stpy);
  ycurPr2 = ycurPr;
                                       	 	 
  for (long j=left+1;j<left+window;j++)
   {
     xcur = (short int)((j - left) * stpx);
     ycur = (short int)(h - (x[j] - gmin) * stpy);

     check = ( (short int)( (j+1-left)*stpx )  != xcurPr || j+1 >= left + window );
	      
     if (xcur == xcurPr) { ycurPr  = ( ycur >  ycurPr  ? ycur : ycurPr  );                                                   	              
                           ycurPr2 = ( ycur <= ycurPr2 ? ycur : ycurPr2 );                                                      	      
                                                                                                                             
                           if ( check ) { if (ycurPr != ycurPr2) XDrawLine(disID, winID, grC, xcurPr, ycurPr, xcur, ycurPr2);   	      
                                          ycurPr = ycur;                                                                        	      
                                         }                                                                                      	      
                          } else { XDrawLine(disID, winID, grC, xcurPr, ycurPr, xcur, ycur);                                    	      
                                   xcurPr  = xcur;                                                                              	      
                                   ycurPr  = ycur;                                                                              	      
                                   ycurPr2 = ycur;                                                                              	      
                                  }                                                                                             	      	             
    }                              

   UNPLUG_WIDGETS_GC
   
   if (id_flag != 0 && corr != 1) PlotIdeal(targetW, (XtPointer)(id));
   if (id_flag == 0) Zoomer(targetW); 
}

/*----------    -----------------*/
//   Widget   , .. coreW

void WindowRedraw (Widget targetW, XtPointer tD)
{
  WindowHeader (XtNameToWidget(targetW, "header"));
  Legend       (XtNameToWidget(targetW, "legend"));
  vTitle       (XtNameToWidget(targetW, "vTitle"));
  HorizAxe     (XtNameToWidget(targetW, "hAxe"));
  Footnote     (XtNameToWidget(targetW, "footnote"));
  
  if (corr == 1) {
   VertAxe      (XtNameToWidget(targetW, "vAxe"), (XtPointer)id);
   Plotdata     (XtNameToWidget(targetW, "PlotBox"), (XtPointer)id);
  }
  else { VertAxe      (XtNameToWidget(targetW, "vAxe"), tD);
         Plotdata     (XtNameToWidget(targetW, "PlotBox"), tD);
       }
}

/*----------      Expose --------------------*/
					      
void WinExpose ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == VisibilityNotify &&
      //   ,    
      event->xvisibility.state == 0 &&
      auto_expose)
   WindowRedraw(targetW, tD);
} 

/*----------        --------------------*/
					      
void WinResize ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
  if(event->type == ConfigureNotify)
  {
    *cont = False;
    Dimension Height = event->xconfigure.height;
    Dimension Width = event->xconfigure.width;
    Dimension hfoot, hxaxis;
    Widget tmpW;
    XWindowChanges values;
    XWindowAttributes attr;

    tmpW = XtNameToWidget(targetW, "header");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWWidth, &values);
    WindowHeader(tmpW);
    
    tmpW = XtNameToWidget(targetW, "legend");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWWidth, &values);
    Legend(tmpW);
    
    tmpW = XtNameToWidget(targetW, "footnote");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.y = Height - attr.height;
    values.width = Width - attr.x;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWY | CWWidth, &values);
    hfoot = attr.height;
    
    tmpW = XtNameToWidget(targetW, "hAxe");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x;
    values.y = Height - hfoot - attr.height;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWY | CWWidth, &values);
    hxaxis = attr.height;
    
    tmpW = XtNameToWidget(targetW, "vTitle");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.height = Height - hfoot - hxaxis - attr.y;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWHeight, &values);
    vTitle(tmpW);
    
    tmpW = XtNameToWidget(targetW, "vAxe");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.height = Height - hfoot - hxaxis - attr.y;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWHeight, &values);
    
    VertAxe(tmpW, corr == 1 ? (XtPointer)id : tD);
    HorizAxe(XtNameToWidget(targetW, "hAxe"));
    Footnote(XtNameToWidget(targetW, "footnote"));
            
    tmpW = XtNameToWidget(targetW, "PlotBox");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x - 2*attr.border_width;
    values.height = Height - hfoot - hxaxis - attr.y - 2*attr.border_width;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWWidth | CWHeight, &values);    
    Plotdata(tmpW, corr == 1 ? (XtPointer)id : tD);
  }
}                                             

/*----------      -  -------------------------*/

void MoveZoomer ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == MotionNotify)
   {   
     Zoomer(targetW);
   
     long Pos = (long)(((float)(event->xmotion.x)/(float)pw)*window);
     if (Pos + okno > window) Pos = window - okno;
     if (Pos < 0) Pos = 0;
     lo = left + Pos;
     
     Zoomer(targetW);
     Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
    }
 }

/*------------       -  ---------------*/
 
void ResizeZoomer( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
 {
  if(event->type == ButtonPress)
   {
     XEvent ev;
     struct timespec delay;
     delay.tv_sec  = 0;
     delay.tv_nsec = 100000000;
     
        switch(event->xbutton.button){
	        case 2: do {
                             Zoomer(targetW);
			     nanosleep(&delay, NULL);
		             if((lo-left) + okno + rate > window) ; else okno += rate;
                             Zoomer(targetW);
                             Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
			     delay.tv_sec = 0;
			     delay.tv_nsec = 50000000;
		            } while (!XCheckTypedEvent(XtDisplay(targetW), ButtonRelease, &ev));
	                break;

	        case 3: do {
                             Zoomer(targetW);
			     nanosleep(&delay, NULL);
		             if(okno - rate < min_okno) ; else okno -= rate;
                             Zoomer(targetW);
                             Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
			     delay.tv_sec = 0;
			     delay.tv_nsec = 50000000;
		            } while (!XCheckTypedEvent(XtDisplay(targetW), ButtonRelease, &ev)); 
	                break;
                                       }
    }
 }                                                           

/*----     -----*/

void updateOfIdealBand(Widget targetW) {
 if (corr != 1) {
   PlotIdeal(XtNameToWidget(targetW, "PlotBox"), (XtPointer)(id));
   sRes.IdealBandFrLeft = pl;
   sRes.IdealBandFrRight = pr;
   setLeft = pl;
   setRight = pr;					  
   press = 1;
   Footnote(XtNameToWidget(targetW, "footnote"));
   PlotIdeal(XtNameToWidget(targetW, "PlotBox"), (XtPointer)(id));
 }
}

/*------------       -  --------------------*/

void MoveLeftPointer ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == MotionNotify && id_flag != 0 && corr != 1)
   {
     id_flag = 1;
     MapBegunok(targetW);
   
     long Pos = (long)(((float)(event->xmotion.x)/(float)pw)*Size);
     if ( Pos >= pr ) Pos = pr-1;
     if ( Pos < 0 ) Pos = 0;
     pl = Pos;
     
   MapBegunok(targetW);
   Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
   if (auto_update) updateOfIdealBand(XtParent(targetW));
   }	     			
 }

/*------------       -  --------------------*/
 
void MoveRightPointer ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == MotionNotify && id_flag != 0 && corr != 1)
   {
     id_flag = 2;
     MapBegunok(targetW);
   
     long Pos = (long)(((float)(event->xmotion.x)/(float)pw)*Size);
     if ( Pos > Size-1 ) Pos = Size-1;
     if ( Pos <= pl ) Pos = pl + 1;
     pr = Pos;
     
   MapBegunok(targetW);
   Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
   if (auto_update) updateOfIdealBand(XtParent(targetW));
   }
 }

/*---------       ------------------------------*/
 
void IdBandBuilder ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == ButtonPress)
   {
   switch (event->xbutton.button) {
     case 2: if (id_flag != 0) {  PlotIdeal(XtNameToWidget(XtParent(targetW), "PlotBox"), tD);
                                  sRes.IdealBandFrLeft = pl;                               	       
                                  sRes.IdealBandFrRight = pr;                                        
                                  setLeft = pl;                                                      
                                  setRight = pr;                                                                                       					  
	      press = 1;
              PlotIdeal(XtNameToWidget(XtParent(targetW), "PlotBox"), tD);          
              Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
	      
                                }	      
              break;		   	  
    default:  break;	      
                                   }
   }
 }                                                              

/*-------------        
                 ,               ----------------------------*/
void ParseKeyboardFirst (Widget, XtPointer, XEvent *, Boolean *);


/*--------        
                    ---------------------------------------------------*/

void ParseKeyboardSecond ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
 if ( event->type == KeyPress || event->type == KeyRelease )
 {
  KeySym a = XLookupKeysym(&event->xkey, 0);
  long Pos = (id_flag == 1 ? pl : pr);
   switch (a) {
  /* "q" */
  case 0x71: Destroy(targetW, tD, event, cont);    
	     break;
  /* "Enter" */
  case 0xff0d: if (corr == 1) { Write (id, 0, Size, sizeof(float), av[next], sRes.BandCorrFuncExt, 1);
				sRes.IdealBandMaximum = (sRes.IdealBandMaximum == pmax ? -1. : sRes.IdealBandMaximum);
                                Rec2Res();
				printf("Source File \"%s\" updated\n", ResourceFileName);
                                Destroy(targetW, tD, event, cont);
                               }
	       for (long i=shift;i<=Size-1-(sRes.BandSmooth-1-shift);i++) id[i] = (id[i])/(mass[i]);
	       for (long i=0;i<shift;i++) id[i] = id[shift];
	       for (long i=Size-(sRes.BandSmooth-1-shift);i<Size;i++) id[i] = id[Size-1-(sRes.BandSmooth-1-shift)];

               pmax = gmax;
	       left = 0;
	       window = Size;
		 
	       corr = 1;
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));	        
	       VertAxe(XtNameToWidget(targetW, "vAxe"), (XtPointer)id);
	       Plotdata(XtNameToWidget(targetW, "PlotBox"), (XtPointer)id);
               break;
  /* "Enter" */
  case 0xff8d: if (corr == 1) { Write (id, 0, Size, sizeof(float), av[next], sRes.BandCorrFuncExt, 1);
				sRes.IdealBandMaximum = (sRes.IdealBandMaximum == pmax ? -1. : sRes.IdealBandMaximum);
                                Rec2Res();
				printf("Source File \"%s\" updated\n", ResourceFileName);
                                Destroy(targetW, tD, event, cont);
                               }
	       for (long i=shift;i<=Size-1-(sRes.BandSmooth-1-shift);i++) id[i] = (id[i])/(mass[i]);
	       for (long i=0;i<shift;i++) id[i] = id[shift];
	       for (long i=Size-(sRes.BandSmooth-1-shift);i<Size;i++) id[i] = id[Size-1-(sRes.BandSmooth-1-shift)];

               pmax = gmax;
	       left = 0;
	       window = Size;
		 
	       corr = 1;
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));	        
	       VertAxe(XtNameToWidget(targetW, "vAxe"), (XtPointer)id);
	       Plotdata(XtNameToWidget(targetW, "PlotBox"), (XtPointer)id);
               break;
  /* "Left" */
  case 0xff51: if (id_flag != 0 && corr != 1) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		
	        switch (id_flag) {
		 case 1: if (Pos - rate < 0) ; else Pos -= rate;
                         pl = Pos;
			 break;
	         case 2: if (Pos - rate <= pl) ; else Pos -= rate;
			 pr = Pos;
			 break;
		 default: break;	 
		                  }
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                   }
               break;
  /* "Left" */
  case 0xff96: if (id_flag != 0 && corr != 1) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		
	        switch (id_flag) {
		 case 1: if (Pos - rate < 0) ; else Pos -= rate;
                         pl = Pos;
			 break;
	         case 2: if (Pos - rate <= pl) ; else Pos -= rate;
			 pr = Pos;
			 break;
		 default: break;	 
		                  }
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                   }
               break;
  /* "Right" */
  case 0xff53: if (id_flag != 0 && corr != 1) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		 
               switch (id_flag) {
		 case 1: if (Pos + rate >= pr) ; else Pos += rate;
                         pl = Pos;
			 break;
	         case 2: if (Pos + rate > Size-1 ) ; else Pos += rate;
			 pr = Pos;
			 break;
		 default: break;	 
		                  }               
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                  }
               break;
  /* "Right" */
  case 0xff98: if (id_flag != 0 && corr != 1) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		 
               switch (id_flag) {
		 case 1: if (Pos + rate >= pr) ; else Pos += rate;
                         pl = Pos;
			 break;
	         case 2: if (Pos + rate > Size-1 ) ; else Pos += rate;
			 pr = Pos;
			 break;
		 default: break;	 
		                  }               
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                  }
               break;

  /*  "Up"  */
  case 0xff52: if (id_flag != 0 && corr != 1) {
                switch (mode_switch) {
		 case 1:  switch (id_flag) {
		           case 1: sRes.IdealBandSteepnessLeft += stepGamma;
			           break;
	                   case 2: sRes.IdealBandSteepnessRight += stepGamma;
			           break;
		           default: break;	 
		          }
			  break;
		 case 2:  if (sRes.IdealBandMaximum > gmax) ; else sRes.IdealBandMaximum += stepMax;  
		          break;
		}  
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                   }
               break;
  /*  "Up"  */
  case 0xff97: if (id_flag != 0 && corr != 1) {
                switch (mode_switch) {
		 case 1:  switch (id_flag) {
		           case 1: sRes.IdealBandSteepnessLeft += stepGamma;
			           break;
	                   case 2: sRes.IdealBandSteepnessRight += stepGamma;
			           break;
		           default: break;	 
		          }
			  break;
		 case 2:  if (sRes.IdealBandMaximum > gmax) ; else sRes.IdealBandMaximum += stepMax;  
		          break;
		}  
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                   }
               break;
  /* "Down" */
  case 0xff54: if (id_flag != 0 && corr != 1) {
                switch (mode_switch) {
		 case 1:  switch (id_flag) {
		           case 1: if (sRes.IdealBandSteepnessLeft - stepGamma <= 0) ;
		                    else sRes.IdealBandSteepnessLeft -= stepGamma;
			           break;
	                   case 2: if (sRes.IdealBandSteepnessRight - stepGamma <= 0) ;
		                    else sRes.IdealBandSteepnessRight -= stepGamma;
			           break;
		           default: break;	 
		          }
			  break;
		 case 2:  if (sRes.IdealBandMaximum - stepMax <= gmin) ; else sRes.IdealBandMaximum -= stepMax;   
		          break;
		}  
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                   }
               break;
  /* "Down" */
  case 0xff99: if (id_flag != 0 && corr != 1) {
                switch (mode_switch) {
		 case 1:  switch (id_flag) {
		           case 1: if (sRes.IdealBandSteepnessLeft - stepGamma <= 0) ;
		                    else sRes.IdealBandSteepnessLeft -= stepGamma;
			           break;
	                   case 2: if (sRes.IdealBandSteepnessRight - stepGamma <= 0) ;
		                    else sRes.IdealBandSteepnessRight -= stepGamma;
			           break;
		           default: break;	 
		          }
			  break;
		 case 2:  if (sRes.IdealBandMaximum - stepMax <= gmin) ; else sRes.IdealBandMaximum -= stepMax;   
		          break;
		}  
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       if (auto_update) updateOfIdealBand(targetW);
                                   }
               break; 
  /* "PgUp" */	       
  case 0xff55: switch (mode_switch) {
                case 0: if (rate*2 > Size/4) ; else rate *= 2;
		        break;
		case 1: stepGamma *= 2;
		        break;
		case 2: stepMax *= 2.;
		        break;
		default: break;
               }
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgUp" */	       
  case 0xff9a: switch (mode_switch) {
                case 0: if (rate*2 > Size/4) ; else rate *= 2;
		        break;
		case 1: stepGamma *= 2;
		        break;
		case 2: stepMax *= 2.;
		        break;
		default: break;
               }
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgDn" */
  case 0xff56: switch (mode_switch) {
                case 0: if (rate/2 < 1) ; else rate /= 2;
		        break;
		case 1: if (stepGamma/2 < 1) ; else stepGamma /= 2;
		        break;
		case 2: if (stepMax/2. < 1.e-6) ; else stepMax /= 2.;
		        break;
		default: break;
               }
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgDn" */
  case 0xff9b: switch (mode_switch) {
                case 0: if (rate/2 < 1) ; else rate /= 2;
		        break;
		case 1: if (stepGamma/2 < 1) ; else stepGamma /= 2;
		        break;
		case 2: if (stepMax/2. < 1.e-6) ; else stepMax /= 2.;
		        break;
		default: break;
               }
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break; 
  /* "Esc"  */
  case 0xff1b:  if (corr == 1) {
	         corr    = 0;
		 press   = 1;
		 left = 0;
		 window = Size;
		
	         Footnote(XtNameToWidget(targetW, "footnote"));
	         HorizAxe(XtNameToWidget(targetW, "hAxe"));
	         VertAxe(XtNameToWidget(targetW, "vAxe"), tD);
	         Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
	        }
		 //    
		 else {
                        XtAddEventHandler (XtNameToWidget(targetW, "PlotBox"), ButtonPressMask |
	                                                                       ButtonReleaseMask,   False, ResizeZoomer,     mass);
	                XtAddEventHandler (XtNameToWidget(targetW, "PlotBox"), Button1MotionMask,   False, MoveZoomer,       mass);
	                XtRemoveEventHandler    (XtNameToWidget(targetW, "PlotBox"), Button1MotionMask,   False, MoveLeftPointer,    id);
                        XtRemoveEventHandler    (XtNameToWidget(targetW, "PlotBox"), Button3MotionMask,   False, MoveRightPointer,   id);
                        XtRemoveEventHandler    (XtNameToWidget(targetW, "PlotBox"), ButtonPressMask,     False, IdBandBuilder,      id);

                        for (long i=0;i<Size;i++) mass[i] = save[i];

		        id_flag = 0;
                        left = lp[zoom];
	                window = wp[zoom];
	                rate = rp[zoom];

                        lp[zoom] = 0;
	                wp[zoom] = 0;
	                rp[zoom] = 0;
	       					   
	                MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	                Footnote(XtNameToWidget(targetW, "footnote"));
	                HorizAxe(XtNameToWidget(targetW, "hAxe"));
	                VertAxe(XtNameToWidget(targetW, "vAxe"), tD);
	                Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
			
                        XtAddEventHandler (targetW,   KeyPressMask, False, ParseKeyboardFirst,  (float *)tD);   
                        XtRemoveEventHandler (targetW,   KeyPressMask, False, ParseKeyboardSecond, (float *)tD);   
		 }
               break;	       
  /* "i" */
  case 0x69:   updateOfIdealBand(targetW);
               break;
  /*  "a"   */
  case 0x61:   auto_update = !auto_update;
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "Tab" */	       
  case 0xff09: id_flag = (id_flag == 1 ? 2 : 1);
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* LShift */
  case 0xffe1: mode_switch = (mode_switch = (mode_switch + 1) & 3) == 3 ? 0 : mode_switch;
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "LCtrl" */
  case 0xffe3: if (event->xkey.state == ControlMask) auto_expose = !auto_expose;
                else WindowRedraw(targetW, tD);
               break;
  /* "RCtrl" */	       
  case 0xffe4: if (event->xkey.state == ControlMask) auto_expose = !auto_expose;
                else WindowRedraw(targetW, tD);
               break;
  default:     break;
            }
      }
 }                                                

/*-------------        
        ,    ----------------------------------------*/

void ParseKeyboardFirst ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
 if ( event->type == KeyPress || event->type == KeyRelease )
 {
  KeySym a = XLookupKeysym(&event->xkey, 0);
  long Pos = lo - left;
   switch (a) {
  /* "q" */
  case 0x71: Destroy(targetW, tD, event, cont);    
	     break;
  /* "+" */
  case 0xffab: Zoomer(XtNameToWidget(targetW, "PlotBox"));
               if((lo-left) + okno + rate > window) ; else okno += rate;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "+" */            /*----------      = ------------*/
  case   0x3d: Zoomer(XtNameToWidget(targetW, "PlotBox"));
               if((lo-left) + okno + rate > window) ; else okno += rate;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "-" */
  case 0xffad: Zoomer(XtNameToWidget(targetW, "PlotBox"));
               if(okno - rate < min_okno) ; else okno -= rate;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;	       
  /* "-" */
  case   0x2d: Zoomer(XtNameToWidget(targetW, "PlotBox"));
               if(okno - rate < min_okno) ; else okno -= rate;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;	       
  /* "Left" */
  case 0xff51: Zoomer(XtNameToWidget(targetW, "PlotBox")); 		
	       Pos -= rate;
	       if (Pos < 0) Pos = 0;
	       lo = left + Pos;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));	       
               break;
  /* "Left" */
  case 0xff96: Zoomer(XtNameToWidget(targetW, "PlotBox")); 		
	       Pos -= rate;
	       if (Pos < 0) Pos = 0;
	       lo = left + Pos;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));	       
               break;
  /* "Right" */
  case 0xff53: Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Pos += rate;
	       if (Pos + okno > window) Pos = window - okno;
	       lo = left + Pos;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));	       
               break;
  /* "Right" */
  case 0xff98: Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Pos += rate;
	       if (Pos + okno > window) Pos = window - okno;
	       lo = left + Pos;
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));	       
               break;
  /* "PgUp" */	       
  case 0xff55: if (rate*2 > okno/2) ; else rate *= 2; 
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgUp" */	       
  case 0xff9a: if (rate*2 > okno/2) ; else rate *= 2; 
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgDn" */
  case 0xff56: if (rate/2 < 1) ; else rate /= 2;	       
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgDn" */
  case 0xff9b: if (rate/2 < 1) ; else rate /= 2;	       
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "Space"*/
  case 0x20:   if ( count > zoom - 1 ) ;
	        else {
		if ( window != min_okno ) {
	       lp[count] = left;
	       wp[count] = window;
	       rp[count] = rate;
	       count++;
               window = okno;
	       left = lo;
               okno = window/2 > min_okno ? window/2 : window - 1;
               rate = (window/10 < 1 ? 1 : window/10);	       
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));
	       VertAxe(XtNameToWidget(targetW, "vAxe"), tD);
               Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
		                            }
		      }
               break;
  /* "Esc"  */
  case 0xff1b: if ( count < 1 ) ;
	        else {
	       count--;	
	       lo = left;
	       okno = window;
	       left = lp[count];
	       window = wp[count];
	       rate = rp[count];
               lp[count] = 0;
	       wp[count] = 0;
	       rp[count] = 0;
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));
	       VertAxe(XtNameToWidget(targetW, "vAxe"), tD);
               Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
		       }
               break;      
  /* "i" */
  case 0x69:   PomexReportWrite(av[next]);
               XtRemoveEventHandler (XtNameToWidget(targetW, "PlotBox"), ButtonPressMask |
	                                                                 ButtonReleaseMask,   False, ResizeZoomer,     mass);
	       XtRemoveEventHandler (XtNameToWidget(targetW, "PlotBox"), Button1MotionMask,   False, MoveZoomer,       mass);
	       XtAddEventHandler    (XtNameToWidget(targetW, "PlotBox"), Button1MotionMask,   False, MoveLeftPointer,    id);
               XtAddEventHandler    (XtNameToWidget(targetW, "PlotBox"), Button3MotionMask,   False, MoveRightPointer,   id);
               XtAddEventHandler    (XtNameToWidget(targetW, "PlotBox"), ButtonPressMask,     False, IdBandBuilder,      id);

               for (long i=0;i<Size;i++) { save[i] = mass[i]; mass[i] = sqrt(mass[i]); }
	       smoothing(Size);

               lp[zoom] = left;
	       wp[zoom] = window;
	       rp[zoom] = rate;
	       
               left = 0;
               window = Size;
               rate = (window/10 < 1 ? 1 : window/10);	       
					   
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));
	       VertAxe(XtNameToWidget(targetW, "vAxe"), tD);
	       Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
	       Zoomer(XtNameToWidget(targetW, "PlotBox"));
	       id_flag = 1;
	       pl = setLeft;
	       pr = setRight;
	       sRes.IdealBandMaximum = (sRes.IdealBandMaximum == -1. || sRes.IdealBandMaximum <= gmin || sRes.IdealBandMaximum > gmax ? gmax : sRes.IdealBandMaximum );
	       //     -  10%   
	       stepMax = sRes.IdealBandMaximum/10.;
	       press = 1;
	       Footnote(XtNameToWidget(targetW, "footnote"));
               PlotIdeal(XtNameToWidget(targetW, "PlotBox"), (XtPointer)(id));
               XtRemoveEventHandler (targetW,   KeyPressMask, False, ParseKeyboardFirst,  (float *)tD);   
               XtAddEventHandler    (targetW,   KeyPressMask, False, ParseKeyboardSecond, (float *)tD);   
               break;
  /*  "s"   */
  case 0x73:   char str[MaxString+1];
               sprintf(str, "%s%d", ".save", pomNumber);
               Write (mass, left, window, sizeof(float), av[next], str, 1);
               break;
  /*  "m"   */
  case 0x6d:   CutMono();
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));
	       VertAxe(XtNameToWidget(targetW, "vAxe"), tD);
               Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
	       pomNumber++;
               break;
  /*  "p"   */
  case 0x70:   (pomArray+pomNumber)->type = 'p';
               (pomArray+pomNumber)->start_pos = lo;
               (pomArray+pomNumber)->end_pos = lo + okno - 1;
	       PoliActive = 1;
               break;
  /*  "a"   */
  case 0x61:   if (PoliActive == 1) {
               CutPoli();
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));
	       VertAxe(XtNameToWidget(targetW, "vAxe"), tD);
               Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
	       pomNumber++;
	       PoliActive = 0;
                                      }
               break;
  /* "LCtrl" */
  case 0xffe3: if (event->xkey.state == ControlMask) auto_expose = !auto_expose;
                else WindowRedraw(targetW, tD);
               break;
  /* "RCtrl" */	       
  case 0xffe4: if (event->xkey.state == ControlMask) auto_expose = !auto_expose;
                else WindowRedraw(targetW, tD);
               break;
  default:     break;
            }
      }
 }

/*---------  MAIN         ----------------------------------------*/

void Plotting () {

 sRes.IdealBandFrRight = (sRes.IdealBandFrRight >= Size || sRes.IdealBandFrRight == -1 ? Size - 1 : sRes.IdealBandFrRight);
 sRes.IdealBandFrLeft  = (sRes.IdealBandFrLeft >= sRes.IdealBandFrRight ? 0 : sRes.IdealBandFrLeft);
 setLeft  = sRes.IdealBandFrLeft;
 setRight = sRes.IdealBandFrRight;

 window = (Size >= min_okno ? Size : 0);
 if (window == 0) { printf("\nError:\nSize of file is too small!\n"); exit(1); }
 left = 0;
 lo = left;
 okno = (window/2 > min_okno ? window/2 : window - 1);
 rate = (window/10 < 1 ? 1 : window/10);

 //    -  10%      (  )
 stepGamma = (long)(sRes.IdealBandSteepnessLeft < sRes.IdealBandSteepnessRight ? sRes.IdealBandSteepnessLeft/10. : sRes.IdealBandSteepnessRight/10.);
 if (stepGamma < 1) stepGamma = 1;

 id = new float[Size];
 if (!id) { printf("Not enough memory!\n"); exit(1); }

 save = new float[Size];
 if (!save) { printf("Not enough memory!\n"); exit(1); }

 pomArray = new struct pomexInfo[Size];
 if (!pomArray) { printf("Not enough memory!\n"); exit(1); }

 Widget shellW  = XtVaAppCreateShell("Bandid", "Bandid", applicationShellWidgetClass, DisId, NULL);
 Widget coreW   = XtVaCreateManagedWidget("mainBox",  compositeWidgetClass, shellW,    NULL);
 Widget headerW = XtVaCreateManagedWidget("header",   coreWidgetClass,      coreW,     NULL); 
 Widget legendW = XtVaCreateManagedWidget("legend",   coreWidgetClass,      coreW,     NULL); 
 Widget vTitleW = XtVaCreateManagedWidget("vTitle",   coreWidgetClass,      coreW,     NULL);
 Widget vaxeW   = XtVaCreateManagedWidget("vAxe",     coreWidgetClass,      coreW,     NULL);
 Widget haxeW   = XtVaCreateManagedWidget("hAxe",     coreWidgetClass,      coreW,     NULL);
 Widget footW   = XtVaCreateManagedWidget("footnote", coreWidgetClass,      coreW,     NULL);
 Widget plotW   = XtVaCreateManagedWidget("PlotBox",  coreWidgetClass,      coreW,     NULL);

 //         
 UpdateResources(coreW);
 
 XtRealizeWidget(shellW);
 
 //    
 XWMHints wmh;
 wmh.flags = InputHint;
 wmh.input = True;
 XSetWMHints(DisId, XtWindow(shellW), &wmh);

 WindowHeader (headerW);
 Legend       (legendW);
 vTitle       (vTitleW);
 VertAxe      (vaxeW, mass);
 HorizAxe     (haxeW);
 Footnote     (footW);
 Plotdata     (plotW, mass);

 XtAddEventHandler(shellW,  StructureNotifyMask, False, Destroy,            mass);
 XtAddEventHandler(coreW,   KeyPressMask,        False, ParseKeyboardFirst, mass);   
 XtAddEventHandler(coreW,   StructureNotifyMask, False, WinResize,          mass);

 //    backing_store,      Expose
 if (!DoesBackingStore(XtScreen(shellW)))
  XtAddEventHandler(coreW, VisibilityChangeMask, False, WinExpose, mass);
   
 XtAddEventHandler(plotW,   Button1MotionMask,   False, MoveZoomer,         mass);
 XtAddEventHandler(plotW,   PointerMotionMask,   False, PointerPos,         mass);
 XtAddEventHandler(plotW,   ButtonPressMask |
                            ButtonReleaseMask,   False, ResizeZoomer,       mass);   

 XtAppMainLoop(appcont);
}

/*============================ E N D =============================================================*/

