#define MAIN_
#include "readme.hpp"
#include "ccf.hpp"
#include "fft.hpp"

float *mass, *pair;
float *mass2, *pair2;  //      (  ""  )
//float *mass4, *pair4;
float Level = 0.;
double beta = 1., Correct = 1., SumCorr = 0.; 
unsigned char CCFSource = 0, Rotate = 1, ACFNorm = 1, UseAlpha = 0, ReadAnSig = 0,
              NoFill = 0, GoToEnd = 0, NoWrite = 0, DetectLevel = 0, Weight = 0, NoTri = 0, AddZero = 0;
signed char Sort = -1;
long bl = 0, al = 0, usz = -1, Begin = 1, End = -1, Nv = 0;
int Header = 0, Pos = -1, UseZero = 1;
long Symmetry = 0;

//    {}
// 1 - , 0 -  
// i=0 - real ; i=1 - imagine ; i=2 - module ; i=3 - phase
//     real
//    {} -   
// 0 -   
// 1 -      pair
// 2 -    pair
// 3 -    mass
// 4 -    mass
unsigned char towrite[2][4] = { { 1, 0, 0, 0 }, { 0, 0, 0, 0 } };

unsigned char phase_type = 0; //    ( )
                              // 0 -   ; 1 -   ; 2 -   ; 3 -   ; 4 -  
char *OutputPath, *OneCCFile, *Delimiter, *OutName, *OutExt, *MeanName, *BeetFile;
bool Precision = false; // true if double precision in FFT
bool StraighOfPhase = false; // true if method of phase straightening is used
bool Cross_Spectrum = false; // true if we calculate the cross-spectrum rather than CCF calculation
unsigned char Halved_Size = 0;    // 1 if we use only half of size - another half plays role of zeroes
bool TimeDomain = false;          //      (true),     FFT (false)
bool NoModuleTriangle = false;    //      ( )

/*-------     (!) HOST  NETWORK   (!) 
            -------------------------------------------*/

TYPE nh2hn ( TYPE data, int razm1 ) {
  char tmp;
  const int razm = sizeof(TYPE);
  union { TYPE d;
          unsigned char uc[razm];
         } b;
  b.d = data;
  for (int i=0;i<razm/2;i++) { tmp = b.uc[i];
                               b.uc[i] = b.uc[razm-1-i];
			       b.uc[razm-1-i] = tmp;
                              }
  return b.d;           
}

/*---- ,   (size)  ,
                    2 ------------------------*/

long resize (long sz) {
  long n = 0;
  sz += 1;
  while ( (1<<(++n)) < sz) ;
  return (1<<(--n));
}

/*----------------------------------------
     
-----------------------------------------*/
void MassiveReArrangement (long left, long sz) {

  //  real -   .    pair ( )
  if (towrite[0][0] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = mass[i];
  //  imagine -      pair (   ),      mass
  if (towrite[0][1] == 1) {
   if (towrite[1][1] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = mass[i+1];
   if (towrite[1][1] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = mass[i+1];
   if (towrite[1][1] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = mass[i+1];
  }  
  //  module -      pair (   ),      mass
  if (towrite[0][2] == 1) {
   if (!NoModuleTriangle) { //     ""
    if (towrite[1][2] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1]);
    if (towrite[1][2] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1]);
    if (towrite[1][2] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1]);
   }
   else { //    ""
//    if (towrite[1][2] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]);
//    if (towrite[1][2] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]);
//    if (towrite[1][2] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]);

//    if (towrite[1][2] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = sqrt(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]);
//    if (towrite[1][2] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = sqrt(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]);
//    if (towrite[1][2] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = sqrt(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]);

//    if (towrite[1][2] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1] >=0 ? sqrt(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]) : -1*sqrt(fabs(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]));
//    if (towrite[1][2] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1] >= 0 ? sqrt(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]) : -1*sqrt(fabs(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]));
//    if (towrite[1][2] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1] >= 0 ? sqrt(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]) : -1*sqrt(fabs(mass[i]*mass[i] - mass2[i] + mass[i+1]*mass[i+1] - mass2[i+1]));

    if (towrite[1][2] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k] >=0 ? sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]) : -1*sqrt(fabs(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]));
    if (towrite[1][2] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = mass[i]*mass[i] + mass[i+1]*mass[i+1] -pair2[k] >= 0 ? sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]) : -1*sqrt(fabs(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]));
    if (towrite[1][2] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k] >= 0 ? sqrt(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]) : -1*sqrt(fabs(mass[i]*mass[i] + mass[i+1]*mass[i+1] - pair2[k]));
    
//    if (towrite[1][2] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = mass2[i];
//    if (towrite[1][2] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = mass2[i];
//    if (towrite[1][2] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = mass2[i];
//    if (towrite[1][2] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = mass[i]*mass[i] - mass2[i];
//    if (towrite[1][2] == 2) for (long i=left, k=(sz/(1<<UseZero)); i<2*sz - left; i+=2, k++) pair[k] = mass[i]*mass[i] - mass2[i];
//    if (towrite[1][2] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = mass[i]*mass[i] - mass2[i];
   }
  }  
  //  phase -      pair (  ),   mass (   )
  if (towrite[0][3] == 1) {
   double sc;
   switch (phase_type) {
    case 0: sc = 1.;
            break;
    case 1: sc = (180./M_PI);
            break;
    case 2: sc = (180./M_PI)*60.;
            break;
    case 3: sc = (180./M_PI)*60.*60.;
            break;
    case 4: sc = 1./(2*M_PI);
            break;
    default: break;
   }
   if (!StraighOfPhase) {
    if (towrite[1][3] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) pair[k] = (float)((atan2((double)mass[i+1], (double)mass[i]))*sc);
    if (towrite[1][3] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) mass[k] = (float)((atan2((double)mass[i+1], (double)mass[i]))*sc);
    if (towrite[1][3] == 4) for (long i=0, k=(sz/(1<<UseZero)); i<(sz / (1<<UseZero)); ++i, ++k) mass[k] = (float)((atan2((double)pair[k], (double)pair[i]))*sc);
   } else { //  
     double add = 0., prev = 0., cur, test;
     if (towrite[1][3] == 1) for (long i=left, k=0; i<2*sz - left; i+=2, k++) {
       cur = add + atan2((double)mass[i+1], (double)mass[i])*(180./M_PI);
       test = cur - prev;
       if (fabs(test) < 180.) ; else {
        if (test < 0.) { add += 360.; cur += 360.; } else { add -= 360.; cur -= 360.; }
       }       
       prev = cur;
       pair[k] = (float)(cur*(M_PI/180.)*sc);
     } // for
     if (towrite[1][3] == 3) for (long i=left, k=0; i<2*sz - left; i+=2, k++) {
       cur = add + atan2((double)mass[i+1], (double)mass[i])*(180./M_PI);
       test = cur - prev;
       if (fabs(test) < 180.) ; else {
        if (test < 0.) { add += 360.; cur += 360.; } else { add -= 360.; cur -= 360.; }
       }       
       prev = cur;
       mass[k] = (float)(cur*(M_PI/180.)*sc);
     }
     if (towrite[1][3] == 4) for (long i=0, k=(sz/(1<<UseZero)); i<(sz / (1<<UseZero)); ++i, ++k) {
       cur = add + atan2((double)pair[k], (double)pair[i])*(180./M_PI);
       test = cur - prev;
       if (fabs(test) < 180.) ; else {
        if (test < 0.) { add += 360.; cur += 360.; } else { add -= 360.; cur -= 360.; }
       }       
       prev = cur;
       mass[k] = (float)(cur*(M_PI/180.)*sc);
     }
   } // else //    
  }
  
}

/*---         ---*/

void LevelEliminate ( float * x, long left, long sz ) {
 if (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1)) {
  float Sum = 0.;
  for (long i=left; i<left+2*sz; i+=2) Sum += x[i];
  Sum /= sz;
  for (long i=left; i<left+2*sz; i+=2) x[i] -= Sum; 
 }
 else {
  float SumRe = 0., SumIm = 0.; 
  for (long i=left; i<left+2*sz; i+=2) { SumRe += x[i]; SumIm += x[i+1]; }
  SumRe /= sz; SumIm /= sz;
  for (long i=left; i<left+2*sz; i+=2) { x[i] -= SumRe; x[i+1] -= SumIm; }
 }
}

/*-------      N-K,    "" ----------------*/

void notriangle ( float * x, long left, long okno ) {
 for (long i=left;            i<left+2*(okno/2); i+=2) { x[i] /= ( okno/2 + 1 + (i - left)/2 );        x[i+1] /= ( okno/2 + 1 + (i - left)/2 ); }
 for (long i=left+2*(okno/2); i<left+2*(okno);   i+=2) { x[i] /= ( okno - 1 + okno/2 + (left - i)/2 ); x[i+1] /= ( okno - 1 + okno/2 + (left - i)/2 ); }
 if (UseZero == 0) for (long i=left; i<left+2*(okno); ++i) x[i] *= 2;
}

/*-----------   ,   (0) ---------------*/

float ACFCalc ( float * x, long sz ) {
		    
 if (Nv >= sz/2) Nv = 0;
 double acf = 0.;
 for (long i=0; i<2*sz; i+=2)
  acf += (x[i]*x[i] + x[i+1]*x[i+1])*cos(((double)(M_PI*(sz - Nv)*i))/((double)sz));
 acf *= (double)(2./sz);
 return (float)fabs(acf);
}

/*---------------------------------------------------------------------------------------
             
----------------------------------------------------------------------------------------*/
void CCFSquareCalculation ( long sz ) 
{
  float real, facf, sacf;
  long sz2 = 2 * sz, sz_2 = sz / 2;

  FFT(mass2, sz, 1, Precision, 1., false);
  FFT(pair2, sz, 1, Precision, 1., false);
  if (ACFNorm == 1) { facf = ACFCalc(mass2, sz); sacf = ACFCalc(pair2, sz); }

  for (long i=0; i<sz2; i+=2)
   {
    real = mass2[i];
    if (ReadAnSig == 1) { mass2[i]   = real      * pair2[i] + mass2[i+1] * pair2[i+1];
                          mass2[i+1] = mass2[i+1] * pair2[i] - real      * pair2[i+1];
    } else { mass2[i]   = i<sz ? 2 * (real      * pair2[i] + mass2[i+1] * pair2[i+1]) : 0.;
             mass2[i+1] = i<sz ? 2 * (mass2[i+1] * pair2[i] - real      * pair2[i+1]) : 0.;
            }
    }

  long left = (sz / (1<<UseZero))*((1<<UseZero) - 1);
  long trsz = sz / (1<<UseZero), trsz2 = 2 * (sz / (1<<UseZero));
  if (NoTri == 0) FFT(mass2, sz, -1, Precision, (float)(2./sz)); else FFT(mass2, sz, -1, Precision, 1., false);
  NegHarmTransPos(mass2, sz, -1);
  if (NoTri == 1) notriangle(mass2, left, trsz);
  if (ACFNorm == 1) { double fsacf = sqrt(facf*sacf); for (long i=left; i<sz2 - left; ++i) mass2[i] /= fsacf; }
   else for (long i=left; i<sz2 - left; ++i) mass2[i] /= trsz2;
}
/*
void CCFSquareCalculation2 ( long sz ) 
{
  float real, facf, sacf;
  long sz2 = 2 * sz, sz_2 = sz / 2;

  FFT(mass4, sz, 1, Precision, 1., false);
  FFT(pair4, sz, 1, Precision, 1., false);
  if (ACFNorm == 1) { facf = ACFCalc(mass4, sz); sacf = ACFCalc(pair4, sz); }

  for (long i=0; i<sz2; i+=2)
   {
    real = mass4[i];
    if (ReadAnSig == 1) { mass4[i]   = real      * pair4[i] + mass4[i+1] * pair4[i+1];
                          mass4[i+1] = mass4[i+1] * pair4[i] - real      * pair4[i+1];
    } else { mass4[i]   = i<sz ? 2 * (real      * pair4[i] + mass4[i+1] * pair4[i+1]) : 0.;
             mass4[i+1] = i<sz ? 2 * (mass4[i+1] * pair4[i] - real      * pair4[i+1]) : 0.;
            }
    }

  long left = (sz / (1<<UseZero))*((1<<UseZero) - 1);
  long trsz = sz / (1<<UseZero), trsz2 = 2 * (sz / (1<<UseZero));
  if (NoTri == 0) FFT(mass4, sz, -1, Precision, (float)(2./sz)); else FFT(mass4, sz, -1, Precision, 1., false);
  NegHarmTransPos(mass4, sz, -1);
  if (NoTri == 1) notriangle(mass4, left, trsz);
  if (ACFNorm == 1) { double fsacf = sqrt(facf*sacf); for (long i=left; i<sz2 - left; ++i) mass4[i] /= fsacf; }
   else for (long i=left; i<sz2 - left; ++i) mass4[i] /= trsz2;
}
*/
/*-----------------    -----------------------*/

void CCFProcedure ( long sz, long fi, long se )
{
  float real, facf, sacf;
  long sz2 = 2 * sz, sz_2 = sz / 2;

  if (Rotate == 1) { NegHarmTransPos(mass, sz, 1); NegHarmTransPos(pair, sz, 1); }
  if (NoModuleTriangle) for (long i=0; i<sz2; ++i) { mass2[i] = mass[i]*mass[i]; pair2[i] = pair[i]*pair[i]; }
//  if (NoModuleTriangle) for (long i=0; i<sz2; ++i) { mass4[i] = mass[i]*mass[i]*mass[i]*mass[i]; pair4[i] = pair[i]*pair[i]*pair[i]*pair[i]; }
  FFT(mass, sz, 1, Precision, 1., false);
  FFT(pair, sz, 1, Precision, 1., false);
  if (ACFNorm == 1) { facf = ACFCalc(mass, sz); sacf = ACFCalc(pair, sz); }

  for (long i=0;i<sz2;i+=2)
   {
    real = mass[i];
    if (towrite[0][2] == 0 || ReadAnSig == 1 || Cross_Spectrum) { mass[i]   = real      * pair[i] + mass[i+1] * pair[i+1];
                                                                  mass[i+1] = mass[i+1] * pair[i] - real      * pair[i+1];
    } else { mass[i]   = i<sz ? 2 * (real      * pair[i] + mass[i+1] * pair[i+1]) : 0.;
             mass[i+1] = i<sz ? 2 * (mass[i+1] * pair[i] - real      * pair[i+1]) : 0.;
            }
    }

  long left = (sz / (1<<UseZero))*((1<<UseZero) - 1);
  long trsz = sz / (1<<UseZero), trsz2 = 2 * (sz / (1<<UseZero));
  if (!Cross_Spectrum) { if (NoTri == 0) FFT(mass, sz, -1, Precision, (float)(2./sz)); else FFT(mass, sz, -1, Precision, 1., false); }
  NegHarmTransPos(mass, sz, -1);
  if (Cross_Spectrum && NoTri == 1) for (long i=left; i<sz2 - left; ++i) mass[i] *= sz_2;  
  if (NoTri == 1) notriangle(mass, left, trsz);
  if (ACFNorm == 1) { double fsacf = sqrt(facf*sacf); for (long i=left; i<sz2 - left; ++i) mass[i] /= fsacf; }
   else for (long i=left; i<sz2 - left; ++i) mass[i] /= trsz2;

  if (NoModuleTriangle) {
    CCFSquareCalculation (sz);
//    for (long i=left, k=0; i<sz2 - left; i+=2, k++) pair2[k] = sqrt(mass2[i] - mass[i]*mass[i] + mass2[i+1] - mass[i+1]*mass[i+1]);
    for (long i=left; i<sz2 - left; ++i) mass2[i] -= mass[i]*mass[i];
    notriangle(mass2, left, trsz);
    float tmp = mass2[sz-2], tmp1 = mass2[sz-1];
    for (long i=left; i<sz2-left; i+=2) { mass2[i] -= tmp; mass2[i+1] -= tmp1; }
    for (long i=left, k=0; i<sz2 - left; i+=2, k++) pair2[k] = mass2[i] + mass2[i+1];
/*
    CCFSquareCalculation2 (sz);
    for (long i=left; i<sz2 - left; ++i) mass4[i] -= mass[i]*mass[i]*mass[i]*mass[i];
    notriangle(mass4, left, trsz);
    tmp = mass4[sz-2]; tmp1 = mass4[sz-1];
    for (long i=left; i<sz2-left; i+=2) { mass4[i] -= tmp; mass4[i+1] -= tmp1; }
    for (long i=left; i<sz2-left; ++i) mass2[i] += mass4[i];
*/    
  }

  MassiveReArrangement (left, sz);
  
  //   real 
  if (towrite[0][0] == 1) {
  if (UseAlpha == 1 && strcmp(StrongFile, "\0")) {
    Correct = 1.;
    if ((stro+fi)->sn == -1. || (stro+se)->sn == -1.) printf("\n- warning! - bad value of one of the S/N ratios in file of strong pulses.\nAlpha correction didn't make for this ccf!\n");
     else { double alpha = beta * beta * (1. - ((stro+fi)->sn)*((stro+se)->sn)) * (1. - ((stro+fi)->sn)*((stro+se)->sn));
            if (alpha == 0.) printf("\n- warning! - value of alpha equals zero\nAlpha correction didn't make for this ccf!\n");
             else { for (long i=0; i<trsz; ++i) pair[i] /= (float)alpha; Correct = alpha; }
           }
                                                  }
  } // if (towrite[0][0] == 1)
}

/*---------------------------------------------------------
           
   (     halved-size)
   sz -     "" (    halved-size    2*sz)
   Cross_Spectrum   (   :))   FFT
------------------------------------------------------------*/
template <class T>
void TimeDomainCCF (long sz, long fi, long se, T not_used) {
//         
//    -  -     
//        

 long sz2 = sz/2;
 long dsz = (1<<UseZero)*sz*2; //    ;  2  ,..  
 long sh = ((1<<UseZero)-1)*sz2; //       (    )
 long mult = 1; //      
 if (ReadAnSig == 1 || (ReadAnSig == 0 && Cross_Spectrum)) mult = 2;

  //       (0),    
  float acf0;
  if (ACFNorm == 1) {
   float facf = 0., sacf = 0.;
   if (ReadAnSig == 0) {
    for (long j=0; j<sz; ++j) {
     facf += mass[2*(j+sh)] * mass[2*(j+sh)];
     sacf += pair[2*(j+sh)] * pair[2*(j+sh)];
    }
   } else {
    for (long j=0; j<sz; ++j) {
     facf += mass[2*(j+sh)] * mass[2*(j+sh)] + mass[2*(j+sh)+1] * mass[2*(j+sh)+1];
     sacf += pair[2*(j+sh)] * pair[2*(j+sh)] + pair[2*(j+sh)+1] * pair[2*(j+sh)+1];
    }
   }
   acf0 = sqrt(facf*sacf);
  } // if (ACFNorm == 1)

 T *shift;
 shift = new T[mult*sz];
 if (!shift) { printf("Not enough memory!\n"); exit(1); }
 memset(shift, 0, mult*sz*sizeof(T));

 if (ReadAnSig == 0) { //   - 
  //     (  1 ,  )
  for (long i=1; i<sz2; ++i) {
   //   
   if (!Cross_Spectrum) {
    for (long j=0; j<sz; ++j) shift[i-1] += mass[2*(j+sh)] * pair[(2*(j+sh+sz2-i))%dsz];  //   2 - ..  - 
   } else {
    for (long j=0; j<sz; ++j) shift[mult*(i-1)] += mass[2*(j+sh)] * pair[(2*(j+sh+sz2-i))%dsz];
   }
  } // for
   
  //       
  for (long i=0; i<=sz2; ++i) {
   if (!Cross_Spectrum) {
    for (long j=0; j<sz; ++j) shift[i+sz2-1] += mass[(2*(j+sh+i))%dsz] * pair[2*(j+sh)];
   } else {
    for (long j=0; j<sz; ++j) shift[mult*(i+sz2-1)] += mass[(2*(j+sh+i))%dsz] * pair[2*(j+sh)];
   }
  } // for
  
 } else { //   - 
 
  //     
  for (long i=1; i<sz2; ++i)
   //   
   for (long j=0; j<sz; ++j) {
    shift[mult*(i-1)]   += mass[2*(j+sh)] * pair[(2*(j+sh+sz2-i))%dsz] + mass[2*(j+sh)+1] * pair[((2*(j+sh+sz2-i))%dsz)+1];
    shift[mult*(i-1)+1] += mass[2*(j+sh)+1] * pair[(2*(j+sh+sz2-i))%dsz] - mass[2*(j+sh)] * pair[((2*(j+sh+sz2-i))%dsz)+1];
   }
   
  //       
  for (long i=0; i<=sz2; ++i)
   for (long j=0; j<sz; ++j) {
    shift[mult*(i+sz2-1)]   += mass[(2*(j+sh+i))%dsz] * pair[2*(j+sh)] + mass[((2*(j+sh+i))%dsz)+1] * pair[2*(j+sh)+1];
    shift[mult*(i+sz2-1)+1] += mass[((2*(j+sh+i))%dsz)+1] * pair[2*(j+sh)] - mass[(2*(j+sh+i))%dsz] * pair[2*(j+sh)+1];
   }   
 }

  /*--------------------    -------------------------*/

  if (ACFNorm == 0 && NoTri == 0) {
   if (ReadAnSig == 0) { if (!Cross_Spectrum) { for (long i=0; i<sz; ++i) shift[i] /= sz; } else { for (long i=0; i<sz; ++i) shift[mult*i] /= sz; } }
    else { for (long i=0; i<mult*sz; ++i) shift[i] /= sz; }
  }
  if (ACFNorm == 1 && NoTri == 0) {
   if (ReadAnSig == 0) { if (!Cross_Spectrum) { for (long i=0; i<sz; ++i) shift[i] /= acf0; } else { for (long i=0; i<sz; ++i) shift[mult*i] /= acf0; } }
    else { for (long i=0; i<mult*sz; ++i) shift[i] /= acf0; }
  }
  if (ACFNorm == 0 && NoTri == 1) {
   if (ReadAnSig == 0) {
    if (!Cross_Spectrum) {
     for (long i=sz2-2; i>=0; --i) shift[i] /= (sz2+1+i);
     for (long i=sz2-1; i<sz; ++i) shift[i] /= (sz+sz2-1-i);
    } else {
     for (long i=sz2-2; i>=0; --i) shift[mult*i] /= (sz2+1+i);
     for (long i=sz2-1; i<sz; ++i) shift[mult*i] /= (sz+sz2-1-i);
    }    
   } else { // if (ReadAnSig == 0)
    for (long i=sz2-2; i>=0; --i) { shift[mult*i] /= (sz2+1+i);    shift[mult*i + 1] /= (sz2+1+i); }
    for (long i=sz2-1; i<sz; ++i) { shift[mult*i] /= (sz+sz2-1-i); shift[mult*i + 1] /= (sz+sz2-1-i); }
   }
  }
  if (ACFNorm == 1 && NoTri == 1) {
   if (ReadAnSig == 0) {
    if (!Cross_Spectrum) {
     for (long i=sz2-2; i>=0; --i) shift[i] /= ((acf0/sz)*(sz2+1+i));
     for (long i=sz2-1; i<sz; ++i) shift[i] /= ((acf0/sz)*(sz+sz2-1-i));
    } else {
     for (long i=sz2-2; i>=0; --i) shift[mult*i] /= ((acf0/sz)*(sz2+1+i));
     for (long i=sz2-1; i<sz; ++i) shift[mult*i] /= ((acf0/sz)*(sz+sz2-1-i));
    }
   } else { // if (ReadAnSig == 0)
    for (long i=sz2-2; i>=0; --i) { shift[mult*i] /= ((acf0/sz)*(sz2+1+i));    shift[mult*i + 1] /= ((acf0/sz)*(sz2+1+i)); }
    for (long i=sz2-1; i<sz; ++i) { shift[mult*i] /= ((acf0/sz)*(sz+sz2-1-i)); shift[mult*i + 1] /= ((acf0/sz)*(sz+sz2-1-i)); }
   }
  }

  /*-------------------------------------------------------------------------*/
  
  //  -
  //   -      ,   
  //    ,     -,   FFT
  //     
  if (Cross_Spectrum) {
//   float* m;
//   m = new float[2*mult*sz];
//   if (!m) { printf("Not enough memory!\n"); exit(1); }
//   memset(m, 0, 2*mult*sz*sizeof(float));

   
   NegHarmTransPos(shift, sz, 1);
//   for (long i=0;i<2*sz; ++i) m[i+sz] = shift[i];
  
   FFT(shift, sz, 1, Precision, 1., false);
//   FFT(m, 2*sz, 1, Precision, 1., false);
//   for (long i=0;i<2*sz; ++i) shift[i] = m[i+sz];

//   delete(m);
  } // -

  //  real -   .    pair ( )
  if (towrite[0][0] == 1) { if (mult == 1) { for (long i=0; i<sz; ++i) pair[i] = shift[i]; } else { for (long i=0; i<sz; ++i) pair[i] = shift[mult*i]; } }
  //      
  if (mult == 2) {
  //  imagine -      pair (   ),      mass
  if (towrite[0][1] == 1) {
   if (towrite[1][1] == 1) for (long i=0; i<sz; ++i) pair[i] = shift[mult*i + 1];
   if (towrite[1][1] == 2) for (long i=0; i<sz; ++i) pair[i+sz] = shift[mult*i + 1];
   if (towrite[1][1] == 3) for (long i=0; i<sz; ++i) mass[i] = shift[mult*i + 1];
  }  
  //  module -      pair (   ),      mass
  if (towrite[0][2] == 1) {
   if (towrite[1][2] == 1) for (long i=0; i<sz; ++i) pair[i] = sqrt(shift[mult*i]*shift[mult*i] + shift[mult*i + 1]*shift[mult*i + 1]);
   if (towrite[1][2] == 2) for (long i=0; i<sz; ++i) pair[i+sz] = sqrt(shift[mult*i]*shift[mult*i] + shift[mult*i + 1]*shift[mult*i + 1]);
   if (towrite[1][2] == 3) for (long i=0; i<sz; ++i) mass[i] = sqrt(shift[mult*i]*shift[mult*i] + shift[mult*i + 1]*shift[mult*i + 1]);
  }  
  //  phase -      pair (  ),   mass (   )
  if (towrite[0][3] == 1) {
   double sc;
   switch (phase_type) {
    case 0: sc = 1.;
            break;
    case 1: sc = (180./M_PI);
            break;
    case 2: sc = (180./M_PI)*60.;
            break;
    case 3: sc = (180./M_PI)*60.*60.;
            break;
    case 4: sc = 1./(2*M_PI);
            break;
    default: break;
   }
   if (!StraighOfPhase) {
    if (towrite[1][3] == 1) for (long i=0; i<sz; ++i) pair[i] = (float)((atan2((double)shift[mult*i + 1], (double)shift[mult*i]))*sc);
    if (towrite[1][3] == 3) for (long i=0; i<sz; ++i) mass[i] = (float)((atan2((double)shift[mult*i + 1], (double)shift[mult*i]))*sc);
    if (towrite[1][3] == 4) for (long i=0; i<sz; ++i) mass[i+sz] = (float)((atan2((double)shift[mult*i + 1], (double)shift[mult*i]))*sc);
   } else { //  
     double add = 0., prev = 0., cur, test;
     if (towrite[1][3] == 1) for (long i=0; i<sz; ++i) {
       cur = add + atan2((double)shift[mult*i + 1], (double)shift[mult*i])*(180./M_PI);
       test = cur - prev;
       if (fabs(test) < 180.) ; else {
        if (test < 0.) { add += 360.; cur += 360.; } else { add -= 360.; cur -= 360.; }
       }       
       prev = cur;
       pair[i] = (float)(cur*(M_PI/180.)*sc);
     } // for
     if (towrite[1][3] == 3) for (long i=0; i<sz; ++i) {
       cur = add + atan2((double)shift[mult*i + 1], (double)shift[mult*i])*(180./M_PI);
       test = cur - prev;
       if (fabs(test) < 180.) ; else {
        if (test < 0.) { add += 360.; cur += 360.; } else { add -= 360.; cur -= 360.; }
       }       
       prev = cur;
       mass[i] = (float)(cur*(M_PI/180.)*sc);
     }
     if (towrite[1][3] == 4) for (long i=0; i<sz; ++i) {
       cur = add + atan2((double)shift[mult*i + 1], (double)shift[mult*i])*(180./M_PI);
       test = cur - prev;
       if (fabs(test) < 180.) ; else {
        if (test < 0.) { add += 360.; cur += 360.; } else { add -= 360.; cur -= 360.; }
       }       
       prev = cur;
       mass[i+sz] = (float)(cur*(M_PI/180.)*sc);
     }
   } // else //    
  }
 } // if (mult == 2)
  
  //   real 
  if (towrite[0][0] == 1) {
  if (UseAlpha == 1 && strcmp(StrongFile, "\0")) {
    Correct = 1.;
    if ((stro+fi)->sn == -1. || (stro+se)->sn == -1.) printf("\n- warning! - bad value of one of the S/N ratios in file of strong pulses.\nAlpha correction didn't make for this ccf!\n");
     else { double alpha = beta * beta * (1. - ((stro+fi)->sn)*((stro+se)->sn)) * (1. - ((stro+fi)->sn)*((stro+se)->sn));
            if (alpha == 0.) printf("\n- warning! - value of alpha equals zero\nAlpha correction didn't make for this ccf!\n");
             else { for (long i=0; i<sz; ++i) pair[i] /= (float)alpha; Correct = alpha; }
           }
                                                  }
  } // if (towrite[0][0] == 1)

  delete (shift);
}

/*----
      
 write   
  : --write 1111 (  -  ,
   -  ,  - ,  - )
  1 - , 0 -  
   --write 0000    

    : --write +r-i-m+p (+  , -  ,
   r -   (real), i -   (imagine), m -  (module), p -  (phase))
      .      --write +m,
   .
       .
----*/

bool processWriteOption (char * arg) {
  //    -   
  if (isdigit(arg[0])) {
   if (strlen(arg) != 4) return false;
   for (unsigned char i=0; i<4; ++i) if ((arg[0] != '1' && arg[0] != '0')) return false;
   for (unsigned char i=0; i<4; ++i) towrite[0][i] = (arg[i] == '1' ? 1 : 0);   
   return true;
  }
  
  //   ,  +  -
  if (arg[0] == '+' || arg[0] == '-') {
   if (strlen(arg)%2 != 0) return false;
   unsigned char sign;
   for (int i=0;i<strlen(arg);i+=2) {
    if (arg[i] == '+') sign = 1; else sign = 0;
    switch (arg[i+1]) {
     case 'r': towrite[0][0] = sign;
               break;
     case 'i': towrite[0][1] = sign;
               break;
     case 'm': towrite[0][2] = sign;
               break;
     case 'p': towrite[0][3] = sign;
               break;
     default: return false;
    } // switch
   } // for
    return true;
  }

  // 
  return false;
}

/*----------------------------------------------------------------
   ,     ,
    , ,    
------------------------------------------------------------------*/
void whereToWrite () {
  unsigned char Nwrite = 0; //   
  for (unsigned char i=0; i<4; ++i) Nwrite += towrite[0][i];
  if (Nwrite == 0) return;

  unsigned char k = 0;
  for (unsigned char i=0; i<4; ++i) {
   if (Nwrite != 2) { if (towrite[0][i] == 1) towrite[1][i] = ++k; }
    else if (towrite[0][i] == 1) { towrite[1][i] = k + 1; k += Nwrite; }
  }
}
    
/*==========================Prompting===================================*/

void Help ( char *s )
 {
  printf("\nPROGRAMM %s\n"
         "It is used to calculate cross correlation functions\n\n"
	 "[USAGE]: %s [options] <file(s) to process> [<delimiter> <file(s) to process as pair(s) to those before delimiter>]\n\n"
	 "[OPTIONS]:\n"
	 "--delimit    <string>         - set delimiter string between file(s) before delimiter and\n"
	 "                                file(s) after delimiter as pair(s) to them. The number of\n"
	 "                                files before delimiter have to equal to those after delimiter.\n"
	 "                                If delimiter doesn't set then programm calculates cross\n"
	 "                                correlation functions among selected files by way when first\n"
	 "                                file is correlated in series with second, third, etc., then\n"
	 "                                second file is correlated with third and so on.\n"
	 "                                By default, delimiter is :\n"
	 "-o, --one    <filename>       - name of file, the only file as pair to all selected files.\n"
	 "                                If delimiter and file(s) after delimiter are set then this\n"
	 "                                option is ignored\n"
	 "-s, --strong <filename>       - name of file with strong pulses\n"
	 "-d, --path   <path>           - path to the output file(s), default - the same where are the\n"
	 "                                source files\n"
	 "--header     <size>           - header in bytes of input file(s), default = 0\n"
	 "--bl         <left boundary>  - left boundary of used window for file(s) before delimiter\n"
	 "                                default = 0\n"
	 "--al         <left boundary>  - left boundary of used window for file(s) after delimiter\n"
	 "                                default = 0\n"
	 "-w, --size   <size of window> - size of used window for file(s) both before and after delimiter\n"
	 "                                default - equal to size of file\n"
	 "--pos        <value>          - set position of first digit in digit group in filename(s)\n"
	 "                                from begin of filename starting with 0. For example, filename\n"
	 "                                is \"pulse237.real\", then you may set position of digit 2 in\n"
	 "                                digit group 237 of this filename. This position is 5 from begin\n"
	 "                                of filename. If this option is set then this number (237) will\n"
	 "                                be used to calculate the shift between the files. By default,\n"
	 "                                this option is unset\n"
	 "--sort       <value>          - sort input files by pulse number only if option --pos is given.\n"
	 "                                If value = 0 then sort files both before delimiter and after\n"
	 "                                delimiter, value = 1 - sort only files before delimiter,\n"
	 "                                value = 2 - sort only files after delimiter, value = -1 or\n"
	 "                                other values - no sorting, default - no sorting\n"
	 "--as                          - input file(s) is the analytical signal, i.e. with the\n"
	 "                                interchange of real and imaginary parts\n"
	 "--nofill                      - don't use the imaginary part of analytical signal\n"
	 "                                default - use (if option --as is set up)\n"
	 "--alpha                       - use correction of ccfs by value of alpha (real parts only), default - no\n"
	 "--beta       <value>          - set value of beta to calculate alpha-value, default = 1.\n"
	 "--weights                     - set mode when average ccfs is divided by sum of weights where\n"
	 "                                weight is inverse value of alpha. By default, average ccfs is\n"
	 "                                divided by number of ccfs\n"
	 "--nv         <value>          - value in ACF used to normalize the CCF. If value = 0 (default)\n"
	 "                                value of ACF(0) will be used to normalize CCF, if value = 1 then\n"
	 "                                ACF(1) will be used, etc. The maximum value is N/2 - 1, otherwise\n"
	 "                                value will be changed to 0\n"
	 "--noacf                       - don't normalize ccfs by values of acfs in zero, default - yes\n"
	 "--notriangle                  - set mode to normalize ccf(s) by N-K, default - by N\n"
	 "--norotate                    - don't rotate harmonics in input data before FFT, default - rotate\n"
	 "-b, --begin  <value>          - set the begin shift between numbers of files to create ccfs,\n"
	 "                                default = 1. This value can be 0 then acfs will be created,\n"
	 "                                can be < 0 if number of first file less then number of second\n"
	 "                                file. This option is active only if option --pos is given\n"
	 "-e, --end    <value>          - set the end shift between numbers of files to create ccfs,\n"
	 "                                default - max possible shift. The same as option --begin,\n"
	 "                                this value can be = 0, < 0 and is active only if option --pos\n"
	 "                                is given\n"
	 "--ext        <string>         - extension of output file(s), default - .shift%%05ld . This option\n"
	 "                                is active only if option --pos is given, otherwise filename\n"
	 "                                for output data is <filename1> + glue + <filename2> + <suffix>, where\n"
	 "                                glue is string given by option --glue and served to connect filename\n"
	 "                                strings, and <suffix> is .real for real part of CCF, .imagine - for\n"
	 "                                imagine part, .module - for module, and .phase - for phase\n"
	 "                                Symbol %% define shift between files numbers extension will be non-predicted\n"
	 "--name       <string>         - base name of output file(s), default - ccf%%ld-%%ld . Symbols %%\n"
	 "                                define numbers of first and second files. This option is active\n"
	 "                                only if option --pos is given, otherwise see instruction to\n"
	 "                                option --ext above. If option --pos is given then output filename\n"
	 "                                is base name + extension (option --ext)\n"
         "--glue       <string>         - this option is active only if option --pos isn't given and serves\n"
         "                                to connect filenames of input files to form output filename.\n"
	 "                                By default, <string> = -with- . For more information see\n"
	 "                                instruction to option --ext above.\n"
         "--mean       <string>         - name of file with average ccf(s) (real parts only). If this option isn't\n"
	 "                                given then average ccfs won't be calculated. You can use in name of\n"
	 "                                file one %% symbol if option --pos is given. Then this %% symbol\n"
	 "                                is shift value. Otherwise, result of filename is non-predicted\n"
	 "--nowrite                     - don't write single ccfs, default - write\n"
	 "--level      <value>          - set average level to subtract, default - 0.\n"
	 "--detectlevel                 - if this option is pointed then option --level will be ignored and\n"
	 "                                programm itself will detect level on size of window\n"
	 "--use-zero   <value>          - set possibility to use additional zeroes in input arrays to compute FFT.\n"
	 "                                If value = 0 then no zeroes are in arrays, so this is the case of\n"
	 "                                cycle convolution. If value = 1 (default) then number of zeroes is equal\n"
	 "                                to size of input array, etc. This option is critical to system resources\n"
	 "--add-zero                    - adds additional zeroes in input arrays in order that size of arrays\n"
	 "                                will be the nearest (upwards) power of 2. Default, programm finds\n"
	 "                                the nearest power of 2 !!!downwards!!!\n"
         "--write      <format>         - set kind of output file(s) to be written.\n"
         "                                There are two forms of format argumnent. The first one\n"
         "                                is digit form. You need to write 4 digits, each of them\n"
         "                                has to be 1 or 0. 1 means to write this kind of file, and 0 - not.\n"
         "                                The first digit sets the real part of CCF, the second - the imagine part,\n"
         "                                the third - the module, and the fourth - the phase of CCF.\n"     
         "                                For example, one can write format as 0111.\n"
         "                                This means that real part of CCF won't be written, and imagine part,\n"
         "                                the module and the phase of CCF will be written. Default, the real part\n"
	 "                                of CCF will be written.\n"
         "                                The second form is symbol form. The true symbols are +,-,r,i,m,p.\n"
         "                                + - to write this kind of file, - - not to write, r - real part,\n"
         "                                i - imagine part, m - module, p - phase.\n"
         "                                So, one can write format as +m-p-r+i or simply +m.\n"
         "                                The +m record sets module to be written and other kinds are ignored.\n"
	 "--phase      <type>           - to write also the phase of CCF and sets the kind of phase to write.\n"
	 "                                If type = rad , then phase is in radians, type = rot - phase in\n"
	 "                                rotation cycles, type = deg - phase in degrees, type = min - phase in\n"
	 "                                minutes, and type = sec - phase in seconds. Default - in radians.\n"
	 "                                This option is identical to --write +p , but also sets the type of phase.\n"
	 "--module                      - use this option if you want to get CCF as a modul of complex value.\n"
	 "                                This option is identical to --write +m\n"
	 "--imagine                     - to write also the imaginary part of CCF. This option is identical to --write +i\n"
	 "--precisely                   - use double precision in FFT. Often not necessarily.\n"
	 "--phase_straightening         - use method of phase straightening to compute and write phase\n"
	 "--cross-spectrum              - calculate cross-spectrum rather than CCF calculation\n"
	 "--symmetry   <shift>          - this option serve to set the layout of input array among the zeroes if they are\n"
	 "                                added. If shift = 0, then input array is in the middle of zeroes. If shift > 0 then\n"
	 "                                input array move to the end of full array and vice versa. The maximum value of\n"
	 "                                shift is the halve of size of input array if the number of zeroes is equal the\n"
	 "                                the size of input array (--use-zero 1) or correspondingly larger in case of larger\n"
	 "                                values in --use-zero option. Default, shift = 0\n"
	 "--halved-size                 - to use only the half of array, another one plays role of zeroes. Automatically,\n"
	 "                                option --use-zero sets to 0\n"
	 "--time-domain                 - to calculate CCF in time domain rather than by means of FFT\n"
	 "--no-module-triangle          - to exclude triangle-shape from CCF module\n"
	 "-h, --help                    - help\n\n", s, s);
  exit(0);
}
 
/*===================Parsing the command line===========================*/

int ParseCmdLine( int argc, char *argv[] )
 {
  int op;
  struct option long_options[] = { {"help", no_argument, 0, 'h'},
				   {"one", required_argument, 0, 'o'},
				   {"strong", required_argument, 0, 's'},
				   {"path", required_argument, 0, 'd'},
				   {"size", required_argument, 0, 'w'},
				   {"begin", required_argument, 0, 'b'},
				   {"end", required_argument, 0, 'e'},
				   {"delimit", required_argument, 0, 10},
				   {"header", required_argument, 0, 11},
				   {"pos", required_argument, 0, 12},
				   {"sort", required_argument, 0, 13},
                                   {"alpha", no_argument, 0, 14},
				   {"beta", required_argument, 0, 15},
                                   {"noacf", no_argument, 0, 16},
                                   {"norotate", no_argument, 0, 17},
                                   {"as", no_argument, 0, 18},
				   {"nofill", no_argument, 0, 19},
				   {"bl", required_argument, 0, 20},
				   {"al", required_argument, 0, 21},
				   {"name", required_argument, 0, 22},
				   {"ext", required_argument, 0, 23},
				   {"mean", required_argument, 0, 24},
				   {"glue", required_argument, 0, 25},
				   {"nowrite", no_argument, 0, 26},
				   {"level", required_argument, 0, 27},
                                   {"detectlevel", no_argument, 0, 28},
                                   {"weights", no_argument, 0, 29},
                                   {"notriangle", no_argument, 0, 30},
				   {"nv", required_argument, 0, 31},
				   {"use-zero", required_argument, 0, 32},
                                   {"add-zero", no_argument, 0, 33},
				   {"phase", required_argument, 0, 34},
				   {"write", required_argument, 0, 35},
                                   {"module", no_argument, 0, 36},
                                   {"imagine", no_argument, 0, 37},
                                   {"precisely", no_argument, 0, 38},
                                   {"phase_straightening", no_argument, 0, 39},
                                   {"cross-spectrum", no_argument, 0, 40},
				   {"symmetry", required_argument, 0, 41},
				   {"halved-size", no_argument, 0, 42},
				   {"time-domain", no_argument, 0, 43},
				   {"no-module-triangle", no_argument, 0, 44},
				   {0, 0, 0, 0}
                                  };

  while((op = getopt_long(argc, argv, "ho:s:d:w:b:e:", long_options, 0)) != EOF)
    switch(op){
      case 'h':
        Help(argv[0]);
      break;
      
      case 'o':
          CCFSource = 1;
	  if( OneCCFile ) {
	    OneCCFile = 0;
	    free(OneCCFile);
	                 }
	  if( !( OneCCFile = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OneCCFile, optarg, (int)strlen(optarg));
      break;
      
      case 'd':
	  if( OutputPath ) {
	    OutputPath = 0;
	    free(OutputPath);
	                          }
	  if( !( OutputPath = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutputPath, optarg, (int)strlen(optarg));
      break;
      
      case 's':
	  if( StrongFile ) {
	    StrongFile = 0;
	    free(StrongFile);
	                 }
	  if( !( StrongFile = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(StrongFile, optarg, (int)strlen(optarg));
      break;
            
      case 'w':
        usz = atol(optarg);
	if (usz < 1) usz = -1;
      break;
      
      case 'b':
        Begin = atol(optarg);
      break;
      
      case 'e':
        End = atol(optarg);
	GoToEnd = 1;
      break;
            
      case 10:
	  if( Delimiter ) {
	    Delimiter = 0;
	    free(Delimiter);
	                 }
	  if( !( Delimiter = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(Delimiter, optarg, (int)strlen(optarg));
      break;
      
      case 11:
       Header = atoi(optarg);
       if (Header < 0) Header = 0;
      break;
      
      case 12:
       Pos = atoi(optarg);
       if (Pos < 0) Pos = -1;
      break;
      
      case 13:
       Sort = atoi(optarg);
       if (Sort < 0 || Sort > 2) Sort = -1;
      break;
      
      case 14:
       UseAlpha = 1;
      break;
      
      case 15:
       beta = atof(optarg);
       if (beta <= 0. || beta > 1.) beta = 1.;
      break;
      
      case 16:
       ACFNorm = 0;
      break;
      
      case 17:
       Rotate = 0;
      break;
      
      case 18:
       ReadAnSig = 1;
      break;
      
      case 19:
       NoFill = 1;
      break;
      
      case 20:
        bl = atol(optarg);
	if (bl < 0) bl = 0;
      break;
      
      case 21:
        al = atol(optarg);
	if (al < 0) al = 0;
      break;
      
      case 22:
	  if( OutName ) {
	    OutName = 0;
	    free(OutName);
	                 }
	  if( !( OutName = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutName, optarg, (int)strlen(optarg));
      break;
      
      case 23:
	  if( OutExt ) {
	    OutExt = 0;
	    free(OutExt);
	                 }
	  if( !( OutExt = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutExt, optarg, (int)strlen(optarg));
      break;
      
      case 24:
	  if( MeanName ) {
	    MeanName = 0;
	    free(MeanName);
	                 }
	  if( !( MeanName = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(MeanName, optarg, (int)strlen(optarg));
      break;
      
      case 25:
	  if( BeetFile ) {
	    BeetFile = 0;
	    free(BeetFile);
	                 }
	  if( !( BeetFile = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(BeetFile, optarg, (int)strlen(optarg));
      break;
      
      case 26:
       NoWrite = 1;
      break;
      
      case 27:
        Level = (float)atof(optarg);
      break;
      
      case 28:
       DetectLevel = 1;
      break;
      
      case 29:
       Weight = 1;
      break;
      
      case 30:
       NoTri = 1;
      break;
      
      case 31:
       Nv = atol(optarg);
       if (Nv < 0) Nv = 0;
      break;
      
      case 32:
       UseZero = atoi(optarg);
       if (UseZero < 0) {
        printf("Error:\nWrong value %d in option --add-zero %s !\n", UseZero, optarg);
	exit(1);
       }
      break;
      
      case 33:
       AddZero = 1;
      break;
      
      case 34:
       if (!strcmp(optarg, "rad")) phase_type = 0;
        else if (!strcmp(optarg, "deg")) phase_type = 1;
	      else if (!strcmp(optarg, "min")) phase_type = 2;
  	            else if (!strcmp(optarg, "sec")) phase_type = 3;
  	                  else if (!strcmp(optarg, "rot")) phase_type = 4;
		                else { printf("Error:\nWrong value %s in option --phase !\n", optarg);
			               exit(1);
			              }
       towrite[0][3] = 1;				
      break;
      
      case 35:
       if (!processWriteOption(optarg)) {
        printf("Error:\nBad argument %s in option --write !\n", optarg);
        exit(1);
       }
      break;
      
      case 36:
	towrite[0][2] = 1;
      break;
      
      case 37:
	towrite[0][1] = 1;
      break;
      
      case 38:
	Precision = true;
      break;
      
      case 39:
	StraighOfPhase = true;
      break;
      
      case 40:
	Cross_Spectrum = true;
      break;
      
      case 41:
        Symmetry = atol(optarg);
      break;
      
      case 42:
        Halved_Size = 1;
	UseZero = 1; //   1,     (     )
      break;
      
      case 43:
        TimeDomain = true;
      break;
      
      case 44:
        NoModuleTriangle = true;
      break;
      
      case '?':
        Help(argv[0]);
      break;
    }
  return(optind);
 }

/*--- ,       ----*/

char *SelectFileName ( char * str )
{
 char *s = str;
 int len = (int)strlen(s);
 s += len;
 while (*(--s) != '/' && len--) ;
 return (++s);
 }

/*-------       -----------*/

long PosWrite ( char * str )
{
 if (Pos == -1) return -1;
 char *s = str;
 int len = (int)strlen(s);
 if (Pos > len-1) { Pos = -1; return -1; }
 s += Pos;
 if (!isdigit(*s)) { Pos = -1; return -1; }
 char *tmp = s;
 int num = 1;
 while (isdigit(*(++s))) num++;
 char *dest;
       dest = (char *)calloc(num+1, sizeof(char *));
       if (!dest) { printf("Not enough memory!\n"); exit(1); }
       memcpy(dest, tmp, num);
       strcat(dest, "\0");
 return atol(dest);       
}

/*-----     ----*/

template <class tFormat>
void Write (tFormat m, long size, int razm, char *name1, char *name2, int aver, long shift, int flag, char *suffix)
{
   int out;
   char *outfilename, *base;
   outfilename = new char[MaxString+1];
          base = new char[MaxString+1]; 

   memset(outfilename, 0, MaxString+1);
   memset(base, 0, MaxString+1);

   if (!strcmp(OutputPath, "\0")) {
     if (aver == 0) { if (Pos == -1) sprintf(outfilename, "%s%s%s%s", SelectFileName(name1), BeetFile, SelectFileName(name2), suffix);
                       else { sprintf(outfilename, OutName, PosWrite(SelectFileName(name1)), PosWrite(SelectFileName(name2)));
			      sprintf(base, OutExt, shift);
			      strcat(outfilename, base);
			      strcat(outfilename, suffix);
			     }
                     } else sprintf(outfilename, MeanName, shift);
    } else { if (aver == 0) { if (Pos == -1) sprintf(outfilename, "%s/%s%s%s%s", OutputPath, SelectFileName(name1), BeetFile, SelectFileName(name2), suffix);
                               else { sprintf(outfilename, "%s/", OutputPath);
			              sprintf(base, OutName, PosWrite(SelectFileName(name1)), PosWrite(SelectFileName(name2)));
				      strcat(outfilename, base);
				      memset(base, 0, MaxString+1);
			              sprintf(base, OutExt, shift);
			              strcat(outfilename, base);
                                      strcat(outfilename, suffix);
				     }
                             } else { sprintf(outfilename, "%s/", OutputPath);
			              sprintf(base, MeanName, shift);
				      strcat(outfilename, base);
			             }
            }

   printf("writing... [%s] - ", outfilename);
   fflush(NULL);

#ifdef LARGEFILE   
   if ( (out = open(outfilename, (flag == 1 ? O_TRUNC : O_APPEND) | O_CREAT | O_WRONLY | O_LARGEFILE, 0644)) == -1 )
#else
   if ( (out = open(outfilename, (flag == 1 ? O_TRUNC : O_APPEND) | O_CREAT | O_WRONLY, 0644)) == -1 )
#endif
      { printf("\nError: Couldn't open file %s for writing!\n", outfilename);
        exit(1);
       }
     else
       {
           lseek(out, 0, SEEK_SET);
	   write(out, m, size*razm);	                                           
           close(out);
        }
	
   memset(m, 0, razm*size);
   	
   delete(outfilename);
   delete(base);
 }

/*---------------------------------------------------------
  ,        
    Write
-----------------------------------------------------------*/
void writing (long size, int razm, char *name1, char *name2, long shift) {

  //  real
  if (towrite[0][0] == 1) Write(pair, size, razm, name1, name2, 0, shift, 1, ".real");

  if (ReadAnSig == 1 || (ReadAnSig == 0 && !TimeDomain) || (ReadAnSig == 0 && TimeDomain && Cross_Spectrum)) {
  //  imagine
  if (towrite[0][1] == 1) {
   if (towrite[1][1] == 2) for (long i=0; i<size; ++i) pair[i] = pair[i+size];
   if (towrite[1][1] == 1 || towrite[1][1] == 2) Write(pair, size, razm, name1, name2, 0, shift, 1, ".imagine");
   if (towrite[1][1] == 3) Write(mass, size, razm, name1, name2, 0, shift, 1, ".imagine");
  }
  
  //  module
  if (towrite[0][2] == 1) {
   if (towrite[1][2] == 2) for (long i=0; i<size; ++i) pair[i] = pair[i+size];
   if (towrite[1][2] == 1 || towrite[1][2] == 2) Write(pair, size, razm, name1, name2, 0, shift, 1, ".module");
   if (towrite[1][2] == 3) Write(mass, size, razm, name1, name2, 0, shift, 1, ".module");
  }
  
  //  phase
  if (towrite[0][3] == 1) {
   if (towrite[1][3] == 4) for (long i=0; i<size; ++i) mass[i] = mass[i+size];
   if (towrite[1][3] == 1) Write(pair, size, razm, name1, name2, 0, shift, 1, ".phase");
   if (towrite[1][3] == 3 || towrite[1][3] == 4) Write(mass, size, razm, name1, name2, 0, shift, 1, ".phase");
  }
 } // if (ReadAnSig == 1 || (ReadAnSig == 0 && !TimeDomain) || (ReadAnSig == 0 && TimeDomain && Cross_Spectrum)) 
}

/*-----------      -----------------------*/

void ReadSrc (float * x, long si, long l, long size, char *name)
{
  int file;
  TYPE *data;

     data = new TYPE[(ReadAnSig == 0 ? 1 : 2)*size];
     if (!data) { printf("Not enough memory!\n"); exit(1); }

     memset(data, 0, (ReadAnSig == 0 ? 1 : 2)*size*sizeof(TYPE));
     memset(x, 0, (1<<UseZero)*2*si*sizeof(float));

#ifdef LARGEFILE       
       if ( (file = open(name, O_RDONLY | O_LARGEFILE)) == -1 )
#else
       if ( (file = open(name, O_RDONLY)) == -1 )
#endif
         { printf("\nError:\nCouldn't open \"%s\" for reading!\n", name); exit(1);  }
	 
       if (lseek(file, Header + (ReadAnSig == 0 ? 1 : 2)*l*sizeof(TYPE), SEEK_SET) == -1 )
	 { printf("\nError:\nWrong execution of lseek() in file \"%s\"!\n", name); exit(1); }
	read(file, data, (ReadAnSig == 0 ? 1 : 2)*size*sizeof(TYPE));
        close(file);

   for (long q=0, k=0;q<(ReadAnSig == 0 ? 1 : 2)*size;q++, k+=(ReadAnSig == 0 ? 2 : 1)) {
	
  #ifdef _FR_SUN
   #ifdef _TO_INTELPC
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
  
  #ifdef _FR_INTELPC
   #ifdef _TO_SUN
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
         x[k+((1<<UseZero-Halved_Size)-1)*si+2*Symmetry] = ( k%2 == 0 || (k%2 == 1 && NoFill == 0) ? (float)(data[q]) - (DetectLevel == 1 ? 0 : Level) : 0 );
	                                  }
  delete(data);	
}

/*--------------    inNames ------------------*/

void FillStructNames ( long beg, long sz, char *argv[], int start )
{
 int l;
 for (long i=beg;i<beg+sz;i++) {
   (sinN+i)->pos  = PosWrite(SelectFileName(argv[i+start-beg]));
   l = (int)strlen(argv[i+start-beg]);
   if( (sinN+i)->name ) {
       (sinN+i)->name = 0;
       free((sinN+i)->name);
	                           }
   if( !( (sinN+i)->name = (char *)calloc(l, sizeof(char *)) ) ) { printf("Not enough memory!\n"), exit(1); }
   memcpy((sinN+i)->name, argv[i+start-beg], l);
 }
}

/*---------------        
                                  inNames -----------------------------------*/

void sorting ( long beg, long sz )
{
 long tm;
 char *temp;
   if( !( temp = (char *)calloc(MaxString+1, sizeof(char *)) ) ) { printf("Not enough memory!\n"), exit(1); }
   for (long z=0;z<sz;z++)
    for (long w=beg;w<beg+sz-1;w++) {
      if ((sinN+w+1)->pos < (sinN+w)->pos) { tm = (sinN+w)->pos; (sinN+w)->pos = (sinN+w+1)->pos; (sinN+w+1)->pos = tm;
                                             memset(temp, 0, MaxString+1); memcpy(temp, (sinN+w)->name, (int)strlen((sinN+w)->name));
                                             memset((sinN+w)->name, 0, (int)strlen((sinN+w)->name)); memcpy((sinN+w)->name, (sinN+w+1)->name, (int)strlen((sinN+w+1)->name));
                                             memset((sinN+w+1)->name, 0, (int)strlen((sinN+w+1)->name)); memcpy((sinN+w+1)->name, temp, (int)strlen(temp));
					    }
                                     }
  free(temp);				     
}

/*---------    ,       ;
	    .   ,  
	    strongInfo,  -1    ------------------------------------------*/

int RequestForStrong ( char * name )
{
  for (long i=0;i<NumbOfStrong;i++) if (!strncmp(name, (stro+i)->pulse, strlen((stro+i)->pulse))) return i;
 return -1;
}

/*---------       
                   inNames -----------------------------*/

long MaxPosition ( long beg, long sz )
{
 long max;
 for (long i=beg;i<beg+sz;i++) max = (i == beg ? (sinN+i)->pos : ((sinN+i)->pos > max ? (sinN+i)->pos : max));
 return max;
}

/*--------         ----------------*/

int SplitterSearch ( int argc, char *argv[], int next, char *Delimiter )
{
  for(int i=next;i<argc;i++) if (!strcmp(argv[i], Delimiter)) return i;
  return -1;
}
     
/*====================== Main Function ===================================*/
  
int main ( int argc, char *argv[] )
 {
   struct stat info;
   int next, spl;
   long Size, fi, se, fftsz, Count;
   float *meanCCF;

   if (argc == 1) Help(argv[0]);
   
   OutputPath = new char[MaxString+1];
   StrongFile = new char[MaxString+1];
   Delimiter  = new char[MaxString+1];
   OutName    = new char[MaxString+1];
   OutExt     = new char[MaxString+1];
   MeanName   = new char[MaxString+1];
   BeetFile   = new char[MaxString+1];
   if (!OutputPath || !StrongFile || !Delimiter || !OutName || !OutExt ||
       !MeanName || !BeetFile) { printf("Not enough memory!\n"); exit(1); }
   memset(OutputPath, 0, MaxString+1);
   memset(StrongFile, 0, MaxString+1);
   memset(Delimiter, 0, MaxString+1);
   memset(OutName, 0, MaxString+1);
   memset(OutExt, 0, MaxString+1);
   memset(MeanName, 0, MaxString+1);
   memset(BeetFile, 0, MaxString+1);
   sprintf(OutputPath, "%s", "\0");
   sprintf(StrongFile, "%s", "\0");
   sprintf(Delimiter, "%s", ":");
   sprintf(OutName, "%s", "ccf%ld-%ld");
   sprintf(OutExt, "%s", ".shift%05ld");
   sprintf(MeanName, "%s", "\0");
   sprintf(BeetFile, "%s", "-with-");

   next = ParseCmdLine(argc, argv);
   if (argc < next + 1) { printf("\nError:\nNot point the file(s) to process!\n"); exit(1); }

   spl = SplitterSearch(argc, argv, next, Delimiter);
   if (spl == next) { printf("\nError:\nWrong using of delimiter!\nYou must point file(s) after delimier as pair(s) to those before delimiter!\n"); exit(1); }
   if (spl == -1) spl = argc; else { if (spl - next != argc - 1 - spl) { printf("\nError:\nNumber of files before delimiter doesn't equal\nto those after delimiter !\n"); exit(1); }
                                     CCFSource = 2;
                                    }

   sinN = new struct inNames[(spl-next)*(CCFSource != 2 ? 1 : 2)];
   if (!sinN) { printf("Not enough memory!\n"); exit(1); }
   FillStructNames(0, spl-next, argv, next);
   if (CCFSource == 2) FillStructNames(spl-next, spl-next, argv, spl+1); 

   Sort = (Sort == -1 || Sort == 1 ? Sort : (Sort == 2 ? (CCFSource != 2 ? -1 : Sort) : (CCFSource != 2 ? 1 : Sort)));
   if (Sort == 0 || Sort == 1) sorting(0, spl-next);
   if (Sort == 0 || Sort == 2) sorting(spl-next, spl-next);

   if ( stat(sinN->name, &info) != 0 ) {
     printf("\nError:\nCouldn't open \"%s\"!\n", sinN->name); exit(1); }
   
   Size = (info.st_size - Header)/((ReadAnSig == 0 ? 1 : 2) * sizeof(TYPE));
   if (Size <= 0) { printf("\nError:\nSize of header is to much!\n"); exit(1); }

   if (bl >= Size) bl = 0;
   if (usz == -1 || usz > Size) usz = Size;
   if (bl + usz > Size) usz -= (bl + usz - Size);

    if (CCFSource != 0) {
     if ( stat((CCFSource == 1 ? OneCCFile : (sinN+spl-next)->name), &info) != 0 ) {
       printf("\nError:\nCouldn't open \"%s\"!\n", (CCFSource == 1 ? OneCCFile : (sinN+spl-next)->name)); exit(1); }
     
     Size = (info.st_size - Header)/((ReadAnSig == 0 ? 1 : 2) * sizeof(TYPE));
     if (Size <= 0) { printf("\nError:\nSize of header is to much!\n"); exit(1); }
   
     if (al >= Size) al = 0;
     if (usz == -1 || usz > Size) usz = Size;
     if (al + usz > Size) usz -= (al + usz - Size);
   } else al = bl;

   if (usz != resize(usz)) {
     if (AddZero == 1) fftsz = 2*resize(usz);
      else { usz = resize(usz);
             fftsz = usz;
             printf("\n- warning! -\nSize of selected window doesn't equal to N, where N is power of 2 !\nUsing size is the nearest power of 2 now (%d)...\n", usz);
            }
   } else fftsz = usz;

   //  -    ""  ,  warning
   if (NoModuleTriangle && Cross_Spectrum) {
    NoModuleTriangle = false;
    printf("\n- warning! -\nIt's no need to correct cross-spectrum for triangle shape of its module!\n");
   }
   //    ,      
   if (towrite[0][2] == 0) NoModuleTriangle = false;

   //  Halved_Size = 1  
   if (Halved_Size == 1) { fftsz /= 2; UseZero = 1; }

   //    ,    
   whereToWrite();

   //  Symmetry ,  
   Symmetry = (labs(Symmetry) > ((1<<UseZero-Halved_Size)-1)*(fftsz/2) ? (Symmetry > 0 ? ((1<<UseZero-Halved_Size)-1)*(fftsz/2) : -1*((1<<UseZero-Halved_Size)-1)*(fftsz/2)) : Symmetry);


   mass = new float[(1<<UseZero)*2*fftsz];
   pair = new float[(1<<UseZero)*2*fftsz];   
   if (!mass || !pair) { printf("Not enough memory!\n"); exit(1); }

   if (NoModuleTriangle) {
    mass2 = new float[(1<<UseZero)*2*fftsz];
    pair2 = new float[(1<<UseZero)*2*fftsz];   
    if (!mass2 || !pair2) { printf("Not enough memory!\n"); exit(1); }
   }
/*   
   if (NoModuleTriangle) {
    mass4 = new float[(1<<UseZero)*2*fftsz];
    pair4 = new float[(1<<UseZero)*2*fftsz];   
    if (!mass4 || !pair4) { printf("Not enough memory!\n"); exit(1); }
   }
*/
   if (strcmp(MeanName, "\0") && towrite[0][0] == 1) { meanCCF = new float[fftsz];
                                                       if (!meanCCF) { printf("Not enough memory!\n"); exit(1); }
   }

     if (strcmp(StrongFile, "\0")) StrongFileRead();

     if (GoToEnd == 0) End = MaxPosition(0, (spl - next)*(spl == argc ? 1 : 2));
  
printf("\nProcessing...\n");


 for (long shift=(Pos == -1 ? 0 : Begin);shift<=(Pos == -1 ? 0 : End);shift++) {

 Count = 0;
 if (strcmp(MeanName, "\0") && towrite[0][0] == 1) memset(meanCCF, 0, fftsz*sizeof(float)); 
 
 if (Pos != -1) printf("\n [SHIFT]: %4d\n\n", shift);

 if (CCFSource == 0) { for (long i=next;i<spl-1;i++) {

  if (strcmp(StrongFile, "\0")) {
  fi = RequestForStrong(SelectFileName((sinN+i-next)->name));
  if ( fi == -1 ) continue;      }
			  
  for (long j=i+1;j<spl;j++) {
  
    if (strcmp(StrongFile, "\0")) {
    se = RequestForStrong(SelectFileName((sinN+j-next)->name));
    if ( se == -1 ) continue;      }
    
    if (Pos != -1) if ( (sinN+j-next)->pos - (sinN+i-next)->pos != shift) continue;

    Count++;			  
    printf(" [%3d]\t%s ... %s ... ", Count-1, (sinN+i-next)->name, (sinN+j-next)->name);
    fflush(NULL);


    ReadSrc(mass, fftsz, bl, usz, (sinN+i-next)->name);    
    ReadSrc(pair, fftsz, al, usz, (sinN+j-next)->name);
    if (DetectLevel == 1) { LevelEliminate(mass, ((1<<UseZero-Halved_Size)-1)*fftsz, usz < (1<<Halved_Size)*fftsz ? usz : (1<<Halved_Size)*fftsz);
			    LevelEliminate(pair, ((1<<UseZero-Halved_Size)-1)*fftsz, usz < (1<<Halved_Size)*fftsz ? usz : (1<<Halved_Size)*fftsz);
                           }
    if (TimeDomain) { if (Precision) { double temp; TimeDomainCCF(fftsz, fi, se, temp); } else { float temp; TimeDomainCCF(fftsz, fi, se, temp); } }
     else CCFProcedure((1<<UseZero)*fftsz, fi, se);
    if (strcmp(MeanName, "\0") && towrite[0][0] == 1) { for (long h=0; h<fftsz; ++h) meanCCF[h] += (Weight == 0 ? 1 : Correct)*pair[h];
                                                        if (Weight == 1) SumCorr += Correct;
						       }
    if (NoWrite == 0) writing(fftsz, sizeof(float), (sinN+i-next)->name, (sinN+j-next)->name, shift);

    printf("done\n");	 
			      }
                                                      }    						      
                      }

 if (CCFSource != 0) { for (long i=next;i<spl;i++) {

  if (strcmp(StrongFile, "\0")) {
   fi = RequestForStrong(SelectFileName((sinN+i-next)->name));
   se = RequestForStrong(SelectFileName(CCFSource == 1 ? OneCCFile : (sinN+spl-next+i-next)->name));
   if ( fi == -1 || se == -1 ) continue;
 }
  if (Pos != -1) if ((CCFSource == 1 ? PosWrite(SelectFileName(OneCCFile)) : (sinN+spl-next+i-next)->pos) - (sinN+i-next)->pos != shift) continue;

 Count++;  
 printf(" [%3d]\t%s ... %s ... ", Count-1, (sinN+i-next)->name, ( CCFSource == 1 ? OneCCFile : (sinN+spl-next+i-next)->name));
 fflush(NULL);

    ReadSrc(mass, fftsz, bl, usz, (sinN+i-next)->name);    
    ReadSrc(pair, fftsz, al, usz, (CCFSource == 1 ? OneCCFile : (sinN+spl-next+i-next)->name) );
    if (DetectLevel == 1) { LevelEliminate(mass, ((1<<UseZero-Halved_Size)-1)*fftsz, usz < (1<<Halved_Size)*fftsz ? usz : (1<<Halved_Size)*fftsz);
			    LevelEliminate(pair, ((1<<UseZero-Halved_Size)-1)*fftsz, usz < (1<<Halved_Size)*fftsz ? usz : (1<<Halved_Size)*fftsz);
                           }			   
    if (TimeDomain) { if (Precision) { double temp; TimeDomainCCF(fftsz, fi, se, temp); } else { float temp; TimeDomainCCF(fftsz, fi, se, temp); } }
     else CCFProcedure((1<<UseZero)*fftsz, fi, se);
    if (strcmp(MeanName, "\0") && towrite[0][0] == 1) { for (long h=0; h<fftsz; ++h) meanCCF[h] += (Weight == 0 ? 1 : Correct)*pair[h];
                                                        if (Weight == 1) SumCorr += Correct;
						       }
    if (NoWrite == 0) writing(fftsz, sizeof(float), (sinN+i-next)->name, (CCFSource == 1 ? OneCCFile : (sinN+spl-next+i-next)->name), shift);

 printf("done\n");	
                                                    }
                      }

    if (strcmp(MeanName, "\0") && towrite[0][0] == 1 && Count != 0) {
     for (long h=0; h<fftsz; ++h) meanCCF[h] /= (Weight == 0 ? Count : SumCorr);
     if (Weight == 1) SumCorr = 0.;
     printf("\n Average CCF "); fflush(NULL);
     Write(meanCCF, fftsz, sizeof(float), "", "", 1, shift, 1, "");
     printf("done\n");
    }
 }
 
  if (strcmp(MeanName, "\0") && towrite[0][0] == 1) delete(meanCCF);
  delete(mass);
  delete(pair);
  if (NoModuleTriangle) { delete(mass2); delete(pair2); }
//  if (NoModuleTriangle) { delete(mass4); delete(pair4); }
  delete(StrongFile);
  delete(OutputPath);
  if (CCFSource == 1) free(OneCCFile);
  delete(Delimiter);
  delete(OutName);
  delete(OutExt);
  delete(MeanName);
  delete(BeetFile);
  delete(sinN);
  delete(stro);

  return 0;
 }
 
