#define UTIL_
#include "ccf.hpp"

/*-------    
                 ,  ,
              strongInfo   ---------------------*/
 
int StrongNumber ( void )
 {
  int n = 0;
  FILE * st;
    if ( (st = fopen(StrongFile, "rt")) == NULL ) { 
      printf("\nError:\nCouldn't open file with strong pulses \"%s\" !\n", StrongFile);
      exit(1);
	                                                       }
                fseek(st, 0, SEEK_SET);
		
  char *p, curline[MaxString+1];

  while( fgets(curline, MaxString+1, st)  ) {  
	p = curline;
	curline[(int)strlen(curline) -1] = 0;
	while(*p && isascii(*p) && isspace(*p)) ++p;
	if(!*p || *p == '#') continue;
	n++;
	                                      }
      fclose(st);
  return n;    
 }

/*------       ---------*/

char * GetNumber( char * dest, char * p )
{
  int n = 0;
  char *p1 = p;
  while(*p1 && isascii(*p1) && !isspace(*p1)) { p1++; n++; }
  strncat(dest, p, n);
  return dest;
}

/*--------       ---------*/

char *NameSave ( char * str, char * dest )
{
  int len = (int)strlen(str);          
   if( dest ) { dest = 0;
	        free(dest);
	       }
  if( !( dest = (char *)calloc(len, sizeof(char *)) ) ) { printf("Not enough memory!\n"), exit(1); }
  memcpy(dest, str, len);
  return dest;
}

/*------------     ----------------*/

void AnalyzeLine( char *p, struct strongInfo *tmp )
 {
   void *entry[] = { &tmp->pulse, &tmp->sn };
   char *dest, *p1 = p;
         dest = new char[MaxString+1];
	 if (!dest) { printf("Not enough memory!\n"); exit(1); }

   *(double *)entry[1] = -1.;	 
       for (int k=0;k<2;k++) {
	if (*p) { memset(dest, 0, MaxString+1);
	          dest = GetNumber(dest, p);
                  if (k == 0) *(char **)entry[k] = NameSave(dest, *(char **)entry[k]); 			       
	          if (k == 1) *(double *)entry[k] = atof(dest);
	          p += (int)strlen(dest);
	         } else if (k==0) { printf("\nError:\nBad line in file with strong pulses \"%s\" : not full - %s !\n", StrongFile, p1); exit(1); }
        while(*p && isascii(*p) && isspace(*p)) p++;
                               }
    if (*(double *)entry[1] <= 0.) *(double *)entry[1] = -1.;
    delete(dest);	  
 }

/*----------------       ------------*/
 
void StrongFileRead ( void )
 {
  NumbOfStrong = StrongNumber();

  FILE * st;
         if ( (st = fopen(StrongFile, "rt")) == NULL ) {
	    printf("\nError:\nCouldn't open file with strong pulses \"%s\" !\n", StrongFile);
	    exit(1);
	                                                            }
                     fseek(st, 0, SEEK_SET);
		     
  stro = new struct strongInfo[NumbOfStrong];
  if (!stro) { printf("Not enough memory!\n"); exit(1); }
		    
  char *p, curline[MaxString+1];
  struct strongInfo *tmp = stro;

  while( fgets(curline, MaxString+1, st)  ) {
	p = curline;
	curline[(int)strlen(curline) -1] = 0;
	while(*p && isascii(*p) && isspace(*p)) ++p;
	if(!*p || *p == '#') continue;
	AnalyzeLine(p, tmp);
	tmp++;
	                                      }
      fclose(st);						       
 }

