#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <math.h>
#include <string.h>
#include <sys/stat.h>

#define MaxString 255

int av = 2, sm = 1;

float Max (unsigned short *src, int r, int amount, long size)
{ float Sum = 0.;
  int number = 0;

   for (long i=amount*r;i<amount*(r+1);i++) {
    if (i >= size ) break;
     number++;
     int tmp = src[i] - 2048;
     Sum += tmp*tmp;
}
 return Sum/number;
}

long SM (long size, float *a, float *b, int Points)
{ float sum = 0.;
  for (int r=0;r<Points;r++) sum += a[r];
  b[0] = sum/Points;
   for (long t=0;t<size-Points;t++)
    { sum = sum+a[Points+t]-a[t];
      b[t+1] = sum/Points;
     }
  return (size-Points+1);
 }

void Help( void )
{
 printf("\nProgramm ch1det: simple detector.\n"
        "Usage: ch1det [options] <input file>\n"
        " [options]: -a N -- calculate power of 2 for each count and\n"
        "                    averaging with N points, default N = 2\n"
        "            -s N -- after averaging smothing will be making\n"
        "                    with N points, default N = 1\n"
        "If one points both -a and -s first averaging will be making\n"
        "Output data are kept in file \"inputfilename.av\" or \"inputfilename.av.sm\"\n\n");
 exit(0);
}

int ParseCmdLine(int argc, char *argv[])
{
char op;
char *endptr;

while ( (op=getopt(argc, argv, "ha:s:")) != EOF)
 { switch (op) {
     case 'a': av = strtol(optarg, &endptr, 10);
               if (strcmp(optarg, "\0") && strcmp(endptr, "\0"))
                { printf("\nError: Wrong average key -a\n");
                  Help();
                }
                if (av <=2) av = 2;  
       break;
     case 's': sm = strtol(optarg, &endptr, 10);
               if (strcmp(optarg, "\0") && strcmp (endptr, "\0"))
                { printf("\nError: Wrong smooth key -s\n");
                  Help();
                 }
                if (sm < 1) sm = 1;
       break;
     case 'h': Help();
       break;
     case '?': printf("\nError: Wrong using parameters!\n");
               Help();
       break;
                }
  }
 return(optind);
}

void Save(float *mas, long size, char *ext, char *name)
{
int f;
char *filename;
      filename = new char[MaxString+1];
      if (!filename) printf("Not enough memory!\n"), exit(1);
memset(filename, 0, SEEK_SET);
strcpy(filename, name);
strcat(filename, ext);
printf("Saving...   %s\n", filename);
    f = open(filename, O_TRUNC | O_CREAT | O_WRONLY, 0644);
        lseek(f, 0, SEEK_SET);
        write(f, mas, size*sizeof(float));
        close(f);

delete(filename);
}

void Operate (unsigned short *src, long size, char *name)
{ 
  int ostatok;

 if (size%av == 0) ostatok = 0; else ostatok = 1;
 if (size/av + ostatok < 2) av = size/2;
 if (size%av == 0) ostatok = 0; else ostatok = 1;
 if (sm > (size/av)+ostatok-1) sm = (size/av)+ostatok-1;

 float *avdata;
        avdata = new float[size/av + ostatok];
        if (!avdata) printf("Not enough memory!\n"), exit(1);

  for (long i=0, r=0;i<size;i+=av,r++) avdata[r] = Max(src, (int)r, av, size);
   if (sm == 1) {
     Save(avdata, size/av +ostatok, ".av", name);
     delete(avdata);
                 } else
                     {
   float *smdata;
          smdata = new float[size/av +ostatok-sm+1];
          if (!smdata) printf("Not enough memory!\n"), exit(1); 

   SM(size/av +ostatok, avdata, smdata, sm);
   delete(avdata);
   Save(smdata, size/av +ostatok-sm+1, ".av.sm", name);
   delete(smdata);
                      }
 }

int main (int argc, char *argv[])
{
  int next;
  int file;
  struct stat info;
  long size;

  next = ParseCmdLine(argc, argv);
  if (argc <= next)
   {
     printf("\nError: Not point the file!\n");
     Help();
    }
  for (int i=next;i<argc;i++) {
  if (stat(argv[i], &info) != 0) {printf("\nError: Couldn't open file \"%s!\"", argv[i]); exit(1);}
  
  size = (long)(info.st_size/sizeof(unsigned short));

  if (av > size) av = size;

  unsigned short *src;
   src = new unsigned short[size];
   if (!src) printf("Not enough memory!\n"), exit(1);

  file = open(argv[i], O_RDONLY);
         lseek(file, 0, SEEK_SET);
         read(file, src, size*sizeof(unsigned short));
         close(file);

   Operate(src, size, argv[i]);

   delete(src);
 }

  return 0;
 }
