#define MAIN_
#include "readme.hpp"
#include "dt.hpp"   

float *mass;
unsigned long *sigmastat;
float Level = 0., mult, add;
unsigned char ReadAnSig = 0, YesNorm = 0, Sp2 = 0, RealPart = 2, NoSp = 0, NoFill = 0, YesRoot = 0, Det = 0;
unsigned char YesSquare = 0, YesMult = 0, YesAdd = 0, YesInfo = 0, CutZero = 0, Rotate = 1, DetectLevel = 0;
unsigned char YesStat = 0;
long wsize = 0, wleft = 0, sz, left = 0, truesize = -1, rsize, block = -1;
long Aver = 1, Smooth = 1;
int Header = 0;
char *AuxExt, *OutFile, *OutputPath, *StatString;


/*-------     (!) HOST  NETWORK   (!) 
            -------------------------------------------*/

TYPE nh2hn ( TYPE data, int razm1 )
{
  char tmp;
  const int razm = sizeof(TYPE);
  union { TYPE d;
          unsigned char uc[razm];
         } b;
  b.d = data;
  for (int i=0;i<razm/2;i++) { tmp = b.uc[i];
                               b.uc[i] = b.uc[razm-1-i];
			       b.uc[razm-1-i] = tmp;
                              }
  return b.d;           
 }

/*----------          
                                ------------------------------------------*/

int ParseString ( char * in, int sign )
{
 char *p = in, *dest, *p1;
 int numCom = 0, n;
 while (*p) { if (*p == ',') numCom++;
              p++;
             }
 if (numCom == 0) { printf("\nError:\nWrong argument in option --stat ! - %s\n", in); exit(1); }
 if (sign == 0) return (numCom+1);
	     
 dest   = new char[MaxString+1];
 if (!dest) { printf("Not enough memory!\n"); exit(1); }
 
 p = in;
 numCom = -1;
  while (*p) {  p1 = p; n = 0;
                memset(dest, 0, MaxString+1);
                while(*p1 && *p1 != ',') { if (!isdigit(*p1)) { printf("\nError:\nBad symbols in option --stat ! - %s\n", in); exit(1); }
		                            else { p1++; n++; }
					  }
                strncat(dest, p, n);
		numCom++;
		sigmastat[numCom] = (unsigned long)atol(dest);
		p += ((int)strlen(dest) + 1);
              }

 delete(dest);
 return 0;
}

/*------         -----------*/

void Stat ( long lb, long sz )
{
 float aver, aver2, sigma;
 float sum = 0., sum2 = 0.;
 long val;
 int N, Nn;
 
 for (long i=0; i<sz; i++) { sum  += mass[i];  sum2 += mass[i]*mass[i];
                            }
			    
  aver  = (float)(sum/((float)sz));
  aver2 = (float)(sum2/((float)sz));
  sigma = sqrt( aver2 - aver*aver );

  N  = ParseString (StatString, 0);
  Nn = 2 * ((long)ceil((double)N/2.));
  if (Nn < 4) Nn = 4;
  
  sigmastat = new unsigned long[Nn];
  if (!sigmastat) { printf("Not enough memory!\n"); exit(1); }
  memset(sigmastat, 0, Nn * sizeof(unsigned long));

  ParseString (StatString, 1);

  if (sigmastat[0] == 0) sigmastat[0] = 1;
  if (sigmastat[1] <= sigmastat[0]) sigmastat[1] = sigmastat[0] + 1;

  unsigned long *sN;
  sN = new unsigned long[sigmastat[1]-sigmastat[0]];
  if (!sN) { printf("Not enough memory!\n"); exit(1); }
  memset(sN, 0, (sigmastat[1]-sigmastat[0]) * sizeof(unsigned long));

   for (long w=0;w<(Nn-2)/2;w++) {
    if (sigmastat[2+w*2+1] > sz || sigmastat[2+w*2+1] == 0) sigmastat[2+w*2+1] = sz;
    if (sigmastat[2+w*2] < lb || sigmastat[2+w*2] >= lb+sz) sigmastat[2+w*2] = lb;
    if (sigmastat[2+w*2] + sigmastat[2+w*2+1] > sz) sigmastat[2+w*2+1] = sz - sigmastat[2+w*2];
   }

 for (long w=0;w<(Nn-2)/2;w++) {	  
   for (long j=0;j<sigmastat[2+w*2+1];j++) {
    val = (long)((mass[sigmastat[2+w*2]-lb+j]-aver)/sigma);
    if (val >= sigmastat[0] && val < sigmastat[1]) sN[val-sigmastat[0]]++;
   } }

  printf("\n\n"
         "Statistic information:\n"
	 "[sigma] [events]\n\n");
   for(long k=sigmastat[0];k<sigmastat[1];k++)
    printf("%6ld >   %-ld\n", k, sN[k-sigmastat[0]]);
    printf("\n");
	  
  delete(sN);
  delete(sigmastat);
}
 
/*------          () -----------*/

void Info ( long sz )
{
 float max, min;
 float aver, aver2, sigma, level;
 float sum = 0., sum2 = 0.;
 long xmax, xmin;
 
 for (long i=0; i<sz; i++) {
   xmax = (i==0 || mass[i] > max ? i : xmax);
   xmin = (i==0 || mass[i] < min ? i : xmin);
   max  = (i==0 ? mass[i] : (mass[i] > max ? mass[i] : max));
   min  = (i==0 ? mass[i] : (mass[i] < min ? mass[i] : min));
   sum  += mass[i];
   sum2 += mass[i]*mass[i];
                            }
  aver  = (float)(sum/((float)sz));
  aver2 = (float)(sum2/((float)sz));
  sigma = sqrt( aver2 - aver*aver );
  level = (max - aver)/sigma;
  printf("\n\n   Info:        <x>  =  % -g\n"
         "              <x^2>  =  % -g\n"
	 "              sigma  =  % -g\n"
	 "              level  =  % -g\n"
	 "               xmax  =  % -ld\n"
	 "                max  =  % -g\n"
	 "               xmin  =  % -ld\n"
	 "                min  =  % -g    ...", aver, aver2, sigma, level, xmax, max, xmin, min);
  fflush(NULL);	 
}

/*-------    ,   FFT -------------*/

long Spectrum ( long sz )
{    
  if (Rotate == 1) NegHarmTransPos(mass, (Sp2 != 3 ? 1 : 2)*sz, 1);  
  if (Sp2 != 0) FFT(mass, (Sp2 != 3 ? 1 : 2)*sz, (Sp2 == 4 ? -1 : 1), 1.);

//  if (Sp2 == 1 || Sp2 == 0 || Sp2 == 4) for (long i=2*wleft, k=0;i< 2*(wleft+wsize);i+=(RealPart == 2 ? 1 : 2), k++)
//                                         mass[k] = (RealPart == 1 ? mass[i] : ( RealPart == 0 ? mass[i+1] : ( k%2 == 0 ? mass[i] : mass[i+1] ) ) );
  if (Sp2 == 1 || Sp2 == 0 || Sp2 == 4) for (long i=2*wleft, k=0;i< 2*(wleft+wsize);i+=(RealPart == 2 ? 1 : 2), k++)
                                         mass[k] = (RealPart == 1 ? mass[i] : ( RealPart == 0 ? mass[i+1] : mass[i] ) );
  
  if (Sp2 == 2) for (long i=2*wleft, k=0;i< 2*(wleft+wsize);i+=2, k++)
                  mass[k] = mass[i] * mass[i] + mass[i+1] * mass[i+1] ;
		  
  if (Sp2 == 3) { for (long i=0;i< 2*2*sz;i+=2) {
                    mass[i] = mass[i] * mass[i] + mass[i+1] * mass[i+1] ;
		    mass[i+1] = 0.;            }
		    
                   FFT(mass, 2*sz, -1, (float)(1./sz));

		   for (long i=sz+2*sz;i<4*sz;i++) mass[i-2*sz] = mass[i];
                   for (long i=2*wleft, k=0;i<2*(wleft+wsize);i+=2, k++)
                    mass[k] = mass[i];
                 }

  unsigned char check = (RealPart == 2 && (Sp2 == 1 || Sp2 == 0 || Sp2 == 4) ? 2 : 1);
  
  if (wsize == sz) { if (CutZero == 1) for (long h=0;h<check;h++) mass[h] = (mass[check+h] + mass[check*(sz-1)+h])/2.;
                     if (check != 2) {
		     float temp0, temp1;
                     for (long t=sz/2+1;t<sz;t++) { temp0 = mass[t]; mass[t] = mass[t-sz/2-1];
                                                    mass[t-sz/2-1] = temp0; }
                        temp0 = mass[sz/2-1]; temp1 = mass[sz/2]; 
		     for (long t=sz/2+1;t<sz;t++) mass[t-2] = mass[t];		                                 		                                
		        mass[sz-2] = temp0; 
		        mass[sz-1] = temp1;
		                      } else NegHarmTransPos(mass, sz, -1);
                    }  else { if (CutZero == 1 && wsize == sz/2 + 1) for (long h=0;h<check;h++) mass[h] = mass[check+h]; }
    return (check*wsize);		    
}

/*------    ---------------*/

void norm ( long sz )
{
 float max;
 for (long i=0; i<sz; i++) max = (i==0 ? fabs(mass[i]) : (fabs(mass[i]) > max ? fabs(mass[i]) : max));
 if (max != 0.) for (long i=0; i<sz; i++) mass[i] /= max;
  else { printf(" ! no normilizing <divide by zero> ! "); fflush(NULL); }
}

/*------       -------------*/

void multiply ( long sz )
{
 for (long i=0; i<sz; i++) mass[i] *= mult;
}

/*--------       ------------*/

void adding ( long sz )
{
 for (long i=0; i<sz; i++) mass[i] += add;
}

/*-------      ----------------------*/

void squaring ( long sz )
{
 for (long i=0; i<sz; i++) mass[i] = mass[i]*mass[i];
}

/*-------       ----------------------*/

void rooting ( long sz )
{
 for (long i=0; i<sz; i++) mass[i] = (float)sqrt(mass[i]);
}

/*-------    ----------------------*/

long detection ( long sz )
{
 for (long i=0; i<sz; i+=2) mass[i/2] = mass[i]*mass[i] + mass[i+1]*mass[i+1];
 return sz/2;
}

/*---------    ----------------*/
     
long average ( long sz )
{
 float sum;
 int ostatok = (sz%Aver == 0 ? 0 : 1);

for (long i=0, j, k=0;i<sz;i+=Aver, k++) {
 sum = 0.;
 for (j=i;j<(i+Aver >= sz ? sz : i+Aver);j++) sum += mass[j];
 mass[k] = sum / ((float)(j-i));
                                          }
 return (sz/Aver + ostatok);    
}

/*---------    -----------------*/

long smoothing ( long sz )
{
 float sum = 0., tmp; 
 Smooth = (Smooth > sz ? sz : Smooth);

  for(long r=0;r<Smooth;r++) sum += mass[r];
   tmp     = mass[0];
   mass[0] = sum/Smooth; 
  for(long t=0;t<sz-Smooth;t++) {
   sum = sum+mass[Smooth+t]-tmp;
   tmp = mass[t+1];
   mass[t+1] = sum/Smooth;
                                   }
 return (sz - Smooth + 1);  
}


/*---      ---*/

float NoiseLevel ( float * Massive, long left, long sz, int num )
 {   
  float Sum = 0.;
    for (long i=left;i<left+num*sz;i+=num) Sum += Massive[i];
    return Sum/sz;
  }

/*-----      -----------*/

void LevelEliminate ( float * Massive, float level, long left, long sz, int num )
{
    for (long i=left;i<left+num*sz;i+=num) Massive[i] -= level; 
}


/*---- ,   (size)  ,
                    2 ------------------------*/

long resize (long sz)
 {
   long n = 0;
   sz += 1;
   while ( (1<<(++n)) < sz) ;
   return (1<<(--n));
  }


   
/*==========================Prompting===================================*/

void Help ( char *s )
 {
  printf("\nPROGRAMM %s\n"
         "It is used to make different digital transforms\n\n"
	 "[USAGE]: %s [options] <file(s) to process>\n\n"
	 "[OPTIONS]:\n"
	 "-i, --info                    - show information about input file(s):\n"
	 "                                average, average square, sigma, level, xmax, max, xmin, min\n"
	 "--stat <b,e [,l,w,l1,...]>    - gives statistic information.\n"
	 "                                The argument is at least 2 integer numbers,separated by commas without\n"
	 "                                spaces. These numbers are: b - the begin sigma value, e - the end\n"
	 "                                sigma value, l (l1,l2,...) - left boundary of window to get information,\n"
	 "                                w (w1,w2,...) - size of window. Programm will count the quantity of counts,\n"
	 "                                which values lie in sigma interval\n"
	 "--sp                          - calculate amplitude spectrum\n"
	 "--rev                         - Reverse Fourier Transform\n"
	 "--sp2                         - calculate power spectrum\n"
	 "--acf                         - calculate acf\n\n"
	 "    Default programm cuts only positive harmonics of input file(s)\n\n"
	 "--real                        - write only real part if it has sense\n"
	 "                                default - both real and imagine (if options --sp, --rev is given)\n"
	 "--imagine                       write only imaginary part if it has sense\n"
	 "                                default - both real and imagine (if options --sp, --rev is given)\n"	 
	 "--negative                    - write to the output file(s) only negativ harmonics\n"
	 "                                default - positive\n"
	 "--both                        - write to the output file(s) both positive and\n"
	 "                                negativ harmonics, default - positive\n"
	 "--norm                        - to normilize output data, default - no\n"
	 "--zero                        - cut the zero harmonic, i.e. substitution by\n"
	 "                                average value of adjacent harmonics if\n"
	 "                                option --both is pointed or take value of\n"
	 "                                next positive harmonic if option --negative\n"
	 "                                isn't pointed\n"
	 "--norotate                    - don't rotate harmonics before Fourier Transform\n"
	 "                                default - rotate\n"
	 "--nosp                        - key for the non-spectra actions\n"
	 "--level      <value>          - set average level to subtract, default - 0.\n"
	 "--detectlevel                 - if this option is pointed then option --level will be\n"
	 "                                ignored and programm itself will detect level on size\n"
	 "                                of window\n"
	 "--as                          - input file is the analytical signal, i.e. with the\n"
	 "                                interchange of real and imaginary parts\n"
	 "--nofill                      - don't use the imaginary part of analytical signal\n"
	 "                                default - use (if option --as is set up)\n"
	 "-d, --path   <path>           - path to the output file(s), default - the same\n"
	 "                                where are the source files\n"
	 "--ext        <string>         - auxiliary filename extension given to the output\n"	 
	 "                                file(s), default - .out\n"
	 "--out        <filename>       - name of file for output data. If --ext is given\n"
	 "                                then full name is filename + extension\n"
	 "                                default - input file + .out\n"
	 "--header     <size>           - header in bytes of input file(s), default = 0\n"
	 "-l, --left   <left boundary>  - left boundary of used window, default = 0\n"
	 "-w, --slice  <size of window> - size of used window, default - equal to size of\n"
	 "                                file (in points) for non-spectra actions or finds\n"
	 "                                downwards the nearest power of 2 (if size of file\n"
	 "                                don't equal to power of 2) for spectra actions\n"
	 "-m, --mult   <value>          - multiply output data to the value, default - no\n"
	 "-p, --add    <value>          - add to the output data the value, default - no\n"
	 "                                if option -m is pointed then multiplied before,\n"
	 "                                if option --norm is pointed then normilized befor,\n"
	 "                                then multiplied and then adding\n"
	 "--square                      - to square the data, default - no\n"
	 "--root                        - to square root the data, default - no\n"
	 "--det                         - to detect the data, that is to square counts and add\n"
	 "                                real and imaginary of these. This option has effect only\n"
	 "                                with --as option or with complex massive after spectra operations\n"
	 "                                default - no.\n"
	 "-a, --aver   <value>          - average procedure with number of points = value\n"
	 "                                default - no\n"
	 "-s, --smooth <value>          - smooth procedure with number of points = value\n"
	 "                                default - no\n"
	 "-b, --block  <size of block>  - size of block to record in case of large files.\n"
	 "                                If it's pointed then dest file(s) are forming by\n"
	 "                                appending consecutively the blocks of selected size;\n"
	 "                                default - equal to size of file (in points).\n"
	 "                                This option is effective only for non-spectra operations\n"
	 "-v, --version                 - print version information\n"	 
	 "-h, --help                    - help\n\n"
	 "[OPERATIONS  ORDER]:\n"
	 " 1 - level removing (--level) and/or level detection (--detectlevel) and removing\n"
	 " 2 - operations in spectra domain (if being, without --nosp) with cutting zero harmonic (--zero)\n"
	 "     (--sp, --sp2, --acf, --rev with additional options --real, --imagine, --both, --negative,\n"
	 "      --norotate)\n"
	 " 3 - normalizing (--norm)\n"
	 " 4 - multiplication (--mult)\n"
	 " 5 - adding some value (--add)\n"
	 " 6 - to square the data (--square)\n"
	 " 7 - root extraction (--root)\n"
	 " 8 - detection (--det)\n"
	 " 9 - averaging (--aver)\n"
	 "10 - smoothing (--smooth)\n"
	 "11 - to get information (--info, [--stat])\n\n", s, s);
  exit(0);
 }

/*===================Parsing the command line===========================*/

int ParseCmdLine( int argc, char *argv[] )
 {
  int op;
  struct option long_options[] = { {"help", no_argument, 0, 'h'},
                                   {"version", no_argument, 0, 'v'},
				   {"left", required_argument, 0, 'l'},
				   {"slice", required_argument, 0, 'w'},
                                   {"info", no_argument, 0, 'i'},
				   {"add", required_argument, 0, 'p'},
				   {"mult", required_argument, 0, 'm'},
				   {"aver", required_argument, 0, 'a'},
				   {"smooth", required_argument, 0, 's'},
				   {"path", required_argument, 0, 'd'},
				   {"block", required_argument, 0, 'b'},
				   {"level", required_argument, 0, 20},
				   {"negative", no_argument, 0, 21},
				   {"both", no_argument, 0, 22},
				   {"ext", required_argument, 0, 23},
                                   {"as", no_argument, 0, 24},
				   {"norm", no_argument, 0, 25},
				   {"sp", no_argument, 0, 26},
				   {"sp2", no_argument, 0, 27},
				   {"real", no_argument, 0, 28},
				   {"imagine", no_argument, 0, 29},
				   {"acf", no_argument, 0, 30},
				   {"nosp", no_argument, 0, 31},
				   {"header", required_argument, 0, 32},
				   {"zero", no_argument, 0, 33},
				   {"out", required_argument, 0, 34},
				   {"rev", no_argument, 0, 35},
				   {"norotate", no_argument, 0, 36},
                                   {"detectlevel", no_argument, 0, 37},
				   {"square", no_argument, 0, 38},
				   {"root", no_argument, 0, 40},
				   {"det", no_argument, 0, 41},
				   {"nofill", no_argument, 0, 39},
				   {"stat", required_argument, 0, 42},
				   {0, 0, 0, 0}
                                  };

  while((op = getopt_long(argc, argv, "hvl:w:ip:m:a:s:d:b:", long_options, 0)) != EOF)
    switch(op){
      case 'h':
        Help(argv[0]);
      break;
      
      case 'v':
        printf("%s - ASC Pulsar Group - %s\n", argv[0], VERSION);
        exit(0);
      break;

      case 'l':
        left = atol(optarg);
	if (left < 0) left = 0;
      break;
      
      case 'w':
        truesize = atol(optarg);
	if (truesize <= 0) truesize = -1;
      break;
      
      case 'i':
        NoSp = 1;
	YesInfo = 1;
      break;
      
      case 'p':
        YesAdd = 1;
        add = (float)atof(optarg);
      break;
      
      case 'm':
        YesMult = 1;
        mult = (float)atof(optarg);
      break;
      
      case 'a':
        Aver = atol(optarg);
	if (Aver < 1) Aver = 1;
      break;
      
      case 's':
        Smooth = atol(optarg);
	if (Smooth < 1) Smooth = 1;
      break;
      
      case 'd':
	  if( OutputPath ) {
	    OutputPath = 0;
	    free(OutputPath);
	                          }
	  if( !( OutputPath = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutputPath, optarg, (int)strlen(optarg));
      break;
      
      case 'b':
        block = atol(optarg);
	if (block <= 0) block = -1;
      break;
      
      case 20:
        Level = (float)atof(optarg);
      break;

      case 21:
        wleft = 1;
	wsize = 1;
      break;
      
      case 22:
        wleft = 2;
	wsize = 2;
      break;

      case 23:
	  if( AuxExt ) {
	    AuxExt = 0;
	    free(AuxExt);
	                 }
	  if( !( AuxExt = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(AuxExt, optarg, (int)strlen(optarg));
      break;
      
      case 24:
       ReadAnSig = 1;
      break;
      
      case 25:
       YesNorm = 1;
      break;
      
      case 26:
       Sp2 = 1;
      break;
      
      case 27:
       Sp2 = 2;
      break;
      
      case 28:
       RealPart = 1;
      break;
      
      case 29:
       RealPart = 0;
      break;
      
      case 30:
       Sp2 = 3;
      break;
      
      case 31:
       NoSp = 1;
      break;
      
      case 32:
       Header = atoi(optarg);
       if (Header < 0) Header = 0;
      break;
      
      case 33:
       CutZero = 1;
      break;
      
      case 34:
	  if( OutFile ) {
	    OutFile = 0;
	    free(OutFile);
	                 }
	  if( !( OutFile = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutFile, optarg, (int)strlen(optarg));
      break;
      
      case 35:
       Sp2 = 4;
      break;
      
      case 36:
       Rotate = 0;
      break;
      
      case 37:
       DetectLevel = 1;
      break;
      
      case 38:
       YesSquare = 1;
      break;
      
      case 39:
       NoFill = 1;
      break;
      
      case 40:
       YesRoot = 1;
      break;
      
      case 41:
       Det = 1;
      break;
      
      case 42:
       NoSp = 1;
       YesStat = 1;
       
	  if( StatString ) {
	    StatString = 0;
	    free(StatString);
	                          }
	  if( !( StatString = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(StatString, optarg, (int)strlen(optarg));
      break;
      
      case '?':
        Help(argv[0]);
      break;
    }
  return(optind);
 }

/*--- ,       ----*/

char *SelectFileName (char * str)
{
 char *s = str;
 int len = (int)strlen(s);
 s += len;
 while (*(--s) != '/' && len--) ;
 return (++s);
 }

/*-----     ----*/

template <class tFormat>
void Write (tFormat m, long size, int razm, char *name, char *ext, int flag, int wri)
{
   int out;
   char *outfilename;
   outfilename = new char[MaxString+1];

   memset(outfilename, 0, MaxString+1);

   if (!strcmp(OutputPath, "\0")) { if (strcmp(OutFile, "\0") && !strcmp(ext, ".out")) sprintf(outfilename, "%s", OutFile);
    else sprintf(outfilename, "%s%s", (!strcmp(OutFile, "\0") ? name : OutFile), ext);
    } else {
    if (strcmp(OutFile, "\0") && !strcmp(ext, ".out")) sprintf(outfilename, "%s/%s", OutputPath, OutFile);
    else sprintf(outfilename, "%s/%s%s", OutputPath, (!strcmp(OutFile, "\0") ? SelectFileName(name) : OutFile), ext);
    }

   if (wri == 1) { printf(" writing... [%s]", outfilename); fflush(NULL); }
   
   if ( (out = open(outfilename, (flag == 1 ? O_TRUNC : O_APPEND) | O_CREAT | O_WRONLY | O_LARGEFILE, 0644)) == -1 )
      { printf("\nError: Couldn't open file %s for writing!\n", outfilename);
        exit(1);
       }
     else
       {
           lseek(out, 0, SEEK_SET);
	   write(out, m, size*razm);	                                           
           close(out);
        }
	
   memset(m, 0, razm*size);
   	
   delete(outfilename);
 }

void ReadSrc (long l, long size, char *name)
{
  int file;
  TYPE *data;

     data = new TYPE[size];
     if (!data) { printf("Not enough memory!\n"); exit(1); }

     memset(data, 0, size*sizeof(TYPE));
     memset(mass, 0, (ReadAnSig != 0 ? 1 : (NoSp == 0 ? (Sp2 != 3 ? 2 : 4) : 1) )*size*sizeof(float));
       
       if ( (file = open(name, O_RDONLY | O_LARGEFILE)) == -1 )
         { printf("\nError:\nCouldn't open \"%s\" for reading!\n", name); exit(1);  }
	 
       if (lseek(file, Header + l*sizeof(TYPE), SEEK_SET) == -1 )
	 { printf("\nError:\nWrong execution of lseek() in file \"%s\"!\n", name); exit(1); }
	read(file, data, size*sizeof(TYPE));
        close(file);

   for (long q=0, k=0;q<size;q++, k+=(ReadAnSig != 0 || NoSp == 1 ? 1 : 2)) {
	
  #ifdef _FR_SUN
   #ifdef _TO_INTELPC
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
  
  #ifdef _FR_INTELPC
   #ifdef _TO_SUN
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
         mass[k+(Sp2 == 3 && NoSp == 0 ? (ReadAnSig != 0 ? size/2 : size) : 0)] = ( k%2 == 0 || (k%2 == 1 && NoFill == 0) ? (float)(data[q]) - (DetectLevel == 1 ? 0 : Level) : 0 );
	     
	                                  }		
    delete(data);	
 }
     
/*====================== Main Function ===================================*/
  
int main ( int argc, char *argv[] )
 {
   struct stat info;
   int next;
   long Size, iter, le, win;

   if (argc == 1) Help(argv[0]);
   
   AuxExt = new char[MaxString+1];
   OutFile = new char[MaxString+1];
   OutputPath = new char[MaxString+1];
   StatString = new char[MaxString+1];
   if (!AuxExt || !OutFile || !OutputPath || !StatString) { printf("Not enough memory!\n"); exit(1); }
   memset(AuxExt, 0, MaxString+1);
   memset(OutFile, 0, MaxString+1);
   memset(OutputPath, 0, MaxString+1);
   memset(StatString, 0, MaxString+1);
   sprintf(AuxExt, "%s", ".out");
   sprintf(OutFile, "%s", "\0");
   sprintf(OutputPath, "%s", "\0");
   sprintf(StatString, "%s", "\0");
   
   next = ParseCmdLine(argc, argv);
   if (argc < next + 1) { printf("\nError:\nNot point the file(s) to process!\n"); exit(1); }
   
   if ( stat(argv[next], &info) != 0 ) {
     printf("\nError:\nCouldn't open \"%s\"!\n", argv[next]); exit(1); }

   Size = (info.st_size - Header)/((ReadAnSig == 0 ? 1 : 2) * sizeof(TYPE));
   if (Size <= 0) { printf("\nError:\nSize of header is to much!\n"); exit(1); }
   printf("\nSize of file(s)\t= %ld\n", Size);
   
   if (truesize == -1 || truesize > Size) truesize = Size;
   if (left >= Size) left = 0;
   if (left + truesize > Size) truesize = Size - left;
   sz = (NoSp == 0 ? resize(truesize) : truesize);
   
   printf("Left\t\t= %ld\nWindow\t\t= %ld\n", left, sz);

   if (block == -1 || block > sz || NoSp == 0) block = sz;
   if (NoSp == 1 && Aver != 1) Aver = (Aver > sz ? sz : Aver);
   if (NoSp == 1 && Aver != 1) block = (block <= Aver ? (Aver <= sz ? Aver : sz) : (block%Aver != 0 ? Aver * (long)(block/Aver) : block));
   if (NoSp == 1 && Smooth != 1) Smooth = (Smooth > (long)(block/Aver) ? (long)(block/Aver) : Smooth);
   iter = ( sz == block ? 1 : ((sz-Aver*(NoSp == 1 && Smooth != 1 ? Smooth - 1: 0))%(block-Aver*(NoSp == 1 && Smooth != 1 ? Smooth - 1: 0)) == 0 ? (sz-Aver*(NoSp == 1 && Smooth != 1 ? Smooth - 1: 0))/(block-Aver*(NoSp == 1 && Smooth != 1 ? Smooth - 1: 0)) : (sz-Aver*(NoSp == 1 && Smooth != 1 ? Smooth - 1: 0))/(block-Aver*(NoSp == 1 && Smooth != 1 ? Smooth - 1: 0)) + 1) );

   printf("\nBlock size\t= %ld\n", block);
   printf("Iterations\t= %ld\n", iter);
   printf("\nOperations\t- %s %s\n", NoSp == 1 ? "non-spectra" : (Sp2 == 1 ? "FFT" : (Sp2 == 2 ? "Power spectrum" : (Sp2 == 3 ? "ACF" : (Sp2 == 4 ? "Reverse FFT" : "Spectra domain")))),
                                     (NoSp == 1 ? "" : (Sp2 == 1 || Sp2 == 4 || Sp2 == 0 ? (RealPart == 0 ? "(imagine)" : (RealPart == 1 ? "(real)" : "(complex)")) : "")) );
   if (NoSp == 0) printf("Harmonics\t- %s\n", (wleft == 0 && wsize == 0 ? "positive" : (wleft == 1 && wsize == 1 ? "negative" : "both")) );
   if (NoSp == 0) printf("CutZero\t\t- %s\n", CutZero == 1 ? "yes" : "no");
   printf("\nNormalizing\t- %s\n", YesNorm == 1 ? "yes" : "no");
   printf("Multiplication\t%s", YesMult == 1 ? "* " : "- no"); fflush(NULL);
   if (YesMult == 1) printf("%g\n", mult); else printf("\n");
   printf("Addition\t%s", YesAdd == 1 ? "+ " : "- no"); fflush(NULL);
   if (YesAdd == 1) printf("%g\n", add); else printf("\n");
   printf("to Square\t- %s\n", YesSquare == 1 ? "yes" : "no");
   printf("Root extraction\t- %s\n", YesRoot == 1 ? "yes" : "no");
   printf("Detection\t- %s\n", Det == 1 && ((NoSp == 1 && ReadAnSig == 1) || (NoSp == 0 && RealPart == 2 && (Sp2 == 1 || Sp2 == 0 || Sp2 == 4))) ? "yes" : "no");
   printf("Averaging\t%s", Aver != 1 ? "= " : "- no"); fflush(NULL);
   if (Aver != 1) printf("%ld\n", Aver); else printf("\n");
   printf("Smoothing\t%s", Smooth != 1 ? "= " : "- no"); fflush(NULL);
   if (Smooth != 1) printf("%ld\n", Smooth); else printf("\n");
   printf("Information\t- %s\n", YesInfo == 1 ? "yes" : "no");
   printf("Statistics\t- %s\n\n", YesStat == 1 ? "yes" : "no");
   
   wleft = (NoSp == 1 ? 0 : (wleft == 1 ? block/2 + 1 : 0) );
   wsize = (NoSp == 1 ? block : (wsize == 0 ? block/2 + 1 : (wsize == 1 ? block/2 - 1 : block) ) );

   mass = new float[(ReadAnSig != 0 ? 2*block : (NoSp == 0 ? (Sp2 != 3 ? 2*block : 2*2*block) : block) )];
   if (!mass) { printf("Not enough memory!\n"); exit(1); }

printf("\nProcessing...\n");

    for (int i=next;i<argc;i++)
     {

 printf(" [%3d]\t%s ... ", i-next, argv[i]);
 fflush(NULL);
  
 for (long t=0; t<iter; t++) {

    printf(".%5d", t+1); fflush(NULL);   

    le = (block-Aver*(NoSp == 1 && Smooth != 1 ? Smooth - 1: 0))*t;
    win = (le + block > sz ? sz - le : block);
    ReadSrc((ReadAnSig == 0 ? 1 : 2)*(left + le), (ReadAnSig == 0 ? win : 2*win), argv[i]);   
    if (DetectLevel == 1) { if (t == 0) Level = NoiseLevel(mass, (Sp2 == 3 && NoSp == 0 ? win : 0), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? win : 2*win), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? (NoSp == 0 ? 2 : (ReadAnSig == 0 ? 1 : 2)) : 1) );
                            LevelEliminate(mass, Level, (Sp2 == 3 && NoSp == 0 ? win : 0), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? win : 2*win), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? (NoSp == 0 ? 2 : (ReadAnSig == 0 ? 1 : 2)) : 1) );
                           }			   
    if (NoSp      == 0) rsize = Spectrum(win); else rsize = win*(ReadAnSig == 0 ? 1 : 2);

    if (YesNorm   == 1) norm(rsize);
    if (YesMult   == 1) multiply(rsize);
    if (YesAdd    == 1) adding(rsize);
    if (YesSquare == 1) squaring(rsize);
    if (YesRoot   == 1) rooting(rsize);
    if (Det       == 1) if ((NoSp == 1 && ReadAnSig == 1) ||
                            (NoSp == 0 && RealPart == 2 && (Sp2 == 1 || Sp2 == 0 || Sp2 == 4))) rsize = detection(rsize);
    if (Aver      != 1) rsize = average(rsize);
    if (Smooth    != 1) rsize = smoothing(rsize);
    
    printf("\b\b\b\b\b"); fflush(NULL);
    
    if (YesInfo   == 1) Info(rsize);
    if (YesStat   == 1) Stat((ReadAnSig == 0 ? 1 : 2)*(left + le), rsize);
    if (YesInfo   != 1 && YesStat != 1) Write (mass, rsize, sizeof(float), argv[i], AuxExt, t+1, iter-t);
 }
 
 printf(" - done\n");
	
       }
       
  delete(mass);
  delete(AuxExt);
  delete(OutFile);
  delete(OutputPath);
  delete(StatString);

  return 0;
 }

