#define UTIL_
#include "readme.hpp"
#include "fav.hpp"

/*---------         ( ) ----------------------*/

void CreateBitFile ( void )
{
  struct stat inf; 

  if ( stat(BitFile, &inf) == 0 ) {
      printf("\nWarning!\nSource file \"%s\" already exists!\n", BitFile); exit(1); }
	
  FILE * resource;
  if ( (resource = fopen(BitFile, "wt")) == NULL ) {
	printf("\nError:\nCouldn't open source file \"%s\" for writing!\n", BitFile);
	exit(1);
	                                                    }
                   fseek(resource, 0, SEEK_SET);
		    
  fprintf(resource, "#\n"
                    "# PROGRAMM fav (Fast AVerage s2tci-files)  Bit-Info File\n"
		    "#   You can read some information by:  fav --help\n"
		    "#\n\n"
		    "# Only one type of string is possible, beginning with in: \n"
		    "#  with information about bits placement in input words.\n"
		    "#  Then follows groups of symbols dividing by spaces, tabs, etc.\n"
		    "#  Each group carrying info about solely bit how it places in word.\n"
		    "#  If bit is unusable then write letter \"x\" in group, otherwise\n"
		    "#  view of group approximately is:  1s4 or 1a3\n"
		    "#  Here, 1 is number of channel, 4 or 3 - time account, s - sign bit, \n"
		    "#  a - amplitude bit. Below is the string for Kalyazin data:\n\n"
                    "#     in: 2a4 2a2 2a3 2a1 2s4 2s2 2s3 2s1 1a4 1a2 1a3 1a1 1s4 1s2 1s3 1s1\n\n");	       

  fclose(resource);     
}

/*------        ---------*/

char * GetNumber ( char * dest, char * p )
{
  int n = 0;
  char *p1 = p;
  while(*p1 && isascii(*p1) && !isspace(*p1)) { p1++; n++; }
  strncat(dest, p, n);
  return dest;
}

/*--------     -------------------*/

void CheckBit ( char *str, struct inStruc *tmp )
{
 char *dest;
       dest = new char[MaxString+1];
       if (!dest) { printf("Not enough memory!\n"); exit(1); }
       memset(dest, 0, MaxString+1);
       
 char *p = str, *o;
 int n = 0;
 if (*p == 'x') { tmp->bit = 'x'; delete(dest); return; }
 if (!isdigit(*p)) { printf("\nError:\nWrong bit type - %s !\n", str); exit(1); }
 ++p; ++n;
 while (*p && isascii(*p) && isdigit(*p)) { p++; n++; }
 strncat(dest, str, n);
 tmp->channel = (unsigned char)atoi(dest);
 memset(dest, 0, MaxString+1);
 if (*p != 's' && *p != 'a') { printf("\nError:\nWrong bit type - %s !", str); exit(1); }
 tmp->bit = *p;
 ++p; n = 0; o = p;
 if (!isdigit(*p)) { printf("\nError:\nWrong bit type - %s !\n", str); exit(1); }
 ++p; ++n;
 while (*p && isascii(*p) && isdigit(*p)) { p++; n++; }
 strncat(dest, o, n);
 tmp->time = (unsigned char)atoi(dest);
 inNumber++;

 delete(dest);
}

/*--------        -------------------*/

void Exchange ( struct inStruc *tmp, int k )
{
 unsigned char temp;
 char tm;
 
       temp = (tmp+k+1)->time; (tmp+k+1)->time = (tmp+k)->time; (tmp+k)->time = temp;
       temp = (tmp+k+1)->channel; (tmp+k+1)->channel = (tmp+k)->channel; (tmp+k)->channel = temp;
       temp = (tmp+k+1)->place; (tmp+k+1)->place = (tmp+k)->place; (tmp+k)->place = temp;
       tm = (tmp+k+1)->bit; (tmp+k+1)->bit = (tmp+k)->bit; (tmp+k)->bit = tm; 
}

/*--------       , 
                 ,  -  ---------------------------*/

void sortBits ( struct inStruc *tmp )
{
 for (int i=0;i<entryNumber;i++) 
  for (int j=0;j<entryNumber-1;j++) {
   if ((tmp+j)->bit == 'x' && (tmp+j+1)->bit != 'x') Exchange(tmp, j); 
   if ((tmp+j+1)->time < (tmp+j)->time && (tmp+j+1)->bit != 'x' && (tmp+j)->bit != 'x') Exchange(tmp, j); 
   if ((tmp+j+1)->time == (tmp+j)->time && (tmp+j+1)->bit != 'x' && (tmp+j)->bit != 'x') { 
    if ((tmp+j+1)->channel < (tmp+j)->channel) Exchange(tmp, j); 
    if ((tmp+j+1)->channel == (tmp+j)->channel) { 
      if ((tmp+j+1)->bit == 's' && (tmp+j)->bit == 'a') Exchange(tmp, j); 
                                                 }
                                                                                          }
  }
}

/*----------------         ------------*/
 
void BitPlacementRead ( void )
 {
  entryNumber = 8*sizeof(TYPE);           /*      
                                                  ,   8 (-   ). */
 
  FILE * bi;
         if ( (bi = fopen(BitFile, "rt")) == NULL ) {
	    printf("\nError:\nCouldn't open file \"%s\" !\n", BitFile);
	    exit(1);
	                                                            }
                     fseek(bi, 0, SEEK_SET);
		     
  sIn = new struct inStruc[entryNumber];
  if (!sIn) { printf("Not enough memory!\n"); exit(1); }
		    
  char *p, curline[MaxString+1], *dest;
  struct inStruc *tmp = sIn;

  dest = new char[MaxString+1];
  if (!dest) { printf("Not enough memory!\n"); exit(1); }
  
  while( fgets(curline, MaxString+1, bi)  ) {
	p = curline;
	curline[(int)strlen(curline) -1] = 0;
	while(*p && isascii(*p) && isspace(*p)) ++p;
	if(!*p || *p == '#') continue;

        memset(dest, 0, MaxString+1);
	dest = GetNumber(dest, p);
	p += (int)strlen(dest);
        if (!strcmp(dest, "in:")) {
	 Flag = 1;
	 for (int k=0;k<entryNumber;k++) { while(*p && isascii(*p) && isspace(*p)) p++;
                                           if (*p) { memset(dest, 0, MaxString+1);
	                                             dest = GetNumber(dest, p);
					             CheckBit(dest, tmp);
						     tmp->place = (unsigned char)k;
	                                             p += (int)strlen(dest);
						     tmp++;
	                                            } else { printf("\nError:\nBad line in \"%s\" : not full ! -> %s\n", BitFile, curline);
							     exit(1);
							    }
		                          } break; } }

  if (Flag == 0) { printf("\nError:\nFile %s doesn't contain information about input word, beginning with \"in:\" !\n", BitFile); exit(1); }
  if (inNumber == 0) { printf("\nError:\nThere are no significant bits in input word!\n"); exit(1); }
  sortBits(sIn);

      delete(dest);
      fclose(bi);
 }
 
/*-------     (!) HOST  NETWORK   (!) 
            -------------------------------------------*/
       
TYPE nh2hn ( TYPE data )
{
  char tmp;
  const int razm = sizeof(TYPE);
  union { TYPE d;
          unsigned char uc[razm];
         } b;
  b.d = data;
  for (int i=0;i<razm/2;i++) { tmp = b.uc[i];
                               b.uc[i] = b.uc[razm-1-i];
			       b.uc[razm-1-i] = tmp;
                              }  
  return b.d;           
 }
 
/*----      HOST (  i80x86 ,
    Least Significant Byte first -     )  
     NETWORK (  Internet,  SUN SPARC; Most Significant Byte first -
        )     unsigned long. 
     ,       (htonl, htons)  
     SUN-       .    
    NETWORK  HOST  i80x86  (ntohl, ntohs),     
      -------*/

unsigned long h2nl( unsigned long hostlong )
{
  union{ unsigned long ul;
         unsigned char uc[4];
        } b;
  b.ul = hostlong;
  char tmp = b.uc[0]; b.uc[0] = b.uc[3]; b.uc[3] = tmp;
  tmp = b.uc[1]; b.uc[1] = b.uc[2]; b.uc[2] = tmp; 
 return b.ul;
}


/*----      
       unsigned short ------*/

unsigned short h2ns( unsigned short hostshort )
{
  union{ unsigned short us;
         unsigned char uc[2];
        } b;
  b.us = hostshort;
  char tmp = b.uc[0]; b.uc[0] = b.uc[1]; b.uc[1] = tmp;
 return b.us;
}

