#include "cmd.hpp"

/* help */ 
void help (char *s) {
 printf("\nPROGRAMM %s\n"
	"To plot pulsar time series: profiles, pulses, etc.\n"
        "[USAGE]: %s [options] <det-file> [label1 label2 .. labelN]\n\n"
        "[OPTIONS]:\n"
	"-w, --window <size>   - _size_ number of samples to plot around the maximum, default - 300\n"
	"-p, --device <device> - device to plot, default - /xwindow\n"
	"-h, --help            - help\n\n", s, s);
 exit(0);
}

/* parse command line */
int parse_command_line (int argc, char *argv[]) {
  int op, tm;
  struct option long_options[] = { {"help", no_argument, 0, 'h'},
  	                           {"window", required_argument, 0, 'w'},
  	                           {"device", required_argument, 0, 'p'},
				   {0, 0, 0, 0}
                                  };

  optind = 0; optarg = 0;
  while((op = getopt_long(argc, argv, "w:p:h", long_options, 0)) != EOF)
    switch(op){
      
      case 'h':
        help (argv[0]);
      break;

      case 'w':
	if (atol(optarg) >=3) window = atol (optarg);
      break;
      
      case 'p':
	memset (pgplot_dev, 0, MaxString);
	sprintf (pgplot_dev, "%s", optarg);
      break;

      case '?':
        help (argv[0]);
      break;
    }
  return(optind);
}
