#include "gpview.hpp"

/*--------------------------------------------------------------------------------------
 *                               M   A   I   N
 * -------------------------------------------------------------------------------------*/

int main (int argc, char *argv[]) {

 if (argc == 1) help (argv[0]);

 int next = parse_command_line (argc, argv);
 if (argc < next+1) { printf ("Not file to plot!\n"); exit (1); }

 ledge = window/2;

 struct stat info;
 if (stat(argv[next], &info) == -1) { perror("stat"); exit(1); }
 // "1" - because of type of GP
 off_t filesize = (info.st_size) / sizeof(float);

 float *data, *x, *y;
 data = new float[filesize];
 x    = new float[window];
 y    = new float[window];
 if (!data || !x || !y) { perror("new"); exit(1); }
 memset (data, 0, filesize * sizeof(float));
 memset (x, 0, window * sizeof(float));
 memset (y, 0, window * sizeof(float));

 // read the input file with LCP
 int in; // file descriptor
 in = open (argv[next], O_RDONLY | O_LARGEFILE);
 if (in == -1) { perror("open"); exit (1); }
 read (in, data, filesize*sizeof(float));
 close (in);

 double ymax;
 off_t xmax = getmax (data, filesize, ymax);

 off_t beg, end;
 beg = (xmax - ledge >= 0 ? xmax - ledge : 0); 
 end = (xmax - ledge >= 0 ? xmax - ledge + window : window);

 // setting the x- and y-array
 for (off_t i=beg, j=0; i<end; ++i, ++j) { 
  x[j] = (float)(i-xmax);
  y[j] = data[i];
 }
 double ymin;
 off_t xmin = getmin (y, window, ymin);
 double aver, sigma, ymaxs;
 getavsig (data, filesize, aver, sigma, y, window, xmax, ymax, ymin, ymaxs);

 /* graphics part */
 plotting (y, x, next, argc, argv, aver, sigma, ymin, ymax, ymaxs);
 
 delete (data);
 delete (x);
 delete (y);
 return 0;
}
