#include "plot.hpp"
#include "io.hpp"

/* graphics part */
void plotting (float *y, float *x, int next, int ac, char *av[], double aver, double sigma, double ymin, double ymax, double ymaxs) {

 xdataoffset = window * 0.02;
 ydataoffset = (ymax - ymin) * 0.04;
 long y_major_tic = getytics(ymin - ydataoffset, ymax + ydataoffset);
 long x_major_tic = getytics(-xdataoffset, window + xdataoffset);

 cpgopen (pgplot_dev);
 cpgsch (char_size);
 cpgsvp (0.07, 0.99, 0.12, 0.97);
 cpgswin (x[0] - xdataoffset, x[window-1] + xdataoffset, ymin - ydataoffset, ymax + ydataoffset);
 cpgslw (2);
 cpgbox ("BCNTS", x_major_tic, 5, "BCNTS", y_major_tic, 5);
 /* x-label */ cpgmtxt ("B", 2.4, 0.5, 0.5, xlabel);
 /* y-label */ cpgmtxt ("L", 2.7, 0.5, 0.5, ylabel);
 cpgslw (2);
 cpgline (window, x, y);
 cpgslw (1);
 /* labels */
 cpgsch (char_size*0.8);

 char *cur;
 cur = new char[MaxString];
 if (!cur) { perror("new"); exit (1); }
 memset (cur, 0, MaxString);
 for (int i=next+1; i<ac; ++i) {
  if (i==next+1) sprintf (cur, "%s", av[i]);
   else sprintf (cur, "%s %s", cur, av[i]);
 }
 cpgmtxt ("B", 4.4, 0., 0., cur);

 cpgsch (char_size*0.6);
 memset (cur, 0, MaxString);
 sprintf (cur, "%s", av[next]);
 cpgmtxt ("B", 7., 0., 0., cur);

 memset (cur, 0, MaxString);
 sprintf (cur, "Plot file: %s", pgplot_dev);
 cpgmtxt ("B", 7., 1., 1., cur);

 cpgclos();

 delete (cur);
}

// returns disp in character size
double getdisp (double max, double min, double value, double offset, double chsize) {
 return ( -1. * ((value - min + offset) * 38./chsize) / (max - min + 2*offset));
}

// get y tics major interval
long getytics (double min, double max) {
 long beg = (long)floor((max - min)/7.);
 long end = (long)floor((max - min)/5.);
 int mult[] = { 10000, 5000, 4000, 2500, 2000, 1000, 500, 250, 200, 150, 100, 50, 25, 10, 5, 4, 2, 1 };
 for (int j=0; j<18; ++j)
  for (long i=beg; i<=end; ++i) {
   if (((long)((float)i/(float)mult[j]))*mult[j] == i) return i;
  }
 return end;
}

