#define MAIN_
#include "readme.hpp"
#include "logas.hpp"   

/*-------     (!) HOST  NETWORK   (!) 
            -------------------------------------------*/

TYPE nh2hn ( TYPE data, int razm1 ) {
  char tmp;
  const int razm = sizeof(TYPE);
  union { TYPE d;
          unsigned char uc[razm];
         } b;
  b.d = data;
  for (int i=0;i<razm/2;i++) { tmp = b.uc[i];
                               b.uc[i] = b.uc[razm-1-i];
			       b.uc[razm-1-i] = tmp;
                              }
  return b.d;           
}

/*--- ,       ----*/

char *SelectFileName (char * str) {
 char *s = str;
 int len = (int)strlen(s);
 s += len;
 while (*(--s) != '/' && len--) ;
 return (++s);
}

/*---------  ""   ----------------*/
//   ,     ,  
// ,   
     
long logaverage (long sz) {
 long delt;   //   
 double sum;
 long p,      //   
      p_shift = 0;   //   symm != 0   .   0
 long d_index = -1;

if (symm > 0) {
 p = symm - shift + 1;
 
 for (long i=symm-shift, j=i; j>=0; ) {
  delt = (long)ceil(((double)(symm-j))*Q);
  if (delt == 0) delt = 1;
  if (i-j == (long)floor(((double)(delt-1))/2.)) {
   if (i-delt+1 < 0) break;
   sum = 0;
   for (long k=i; k>i-delt; --k) sum += mass[k];
   if (!dummy) mass[--p] = sum/((double)delt);
    else {
     ++d_index;
     dI[d_index].dummy_lag = --p;
     dI[d_index].center_lag = j-symm;
     dI[d_index].range_left = i-symm-delt+1;
     dI[d_index].range_right = i-symm;
     dI[d_index].range_width = delt;
     dI[d_index].value = sum/((double)delt);
     dI[d_index].is_skipped = false;
    }    
   i -= delt;
   j = i;
  } else { --j; }
 }
 if (!dummy) { for (long i=symm-1; i>=(symm-shift+1 < 0 ? 0 : symm-shift+1); --i) mass[i] = mass[symm-shift]; }
  else {
   for (long i=symm-1; i>=(symm-shift+1 < 0 ? 0 : symm-shift+1); --i) {
    ++d_index;
    dI[d_index].dummy_lag = i;
    dI[d_index].is_skipped = true;
   }
  } // else
 
 p_shift = p;
 p_number = symm - p_shift;  //    ,    shift

} // if (symm > 0)
 
 p = symm + shift - 1;

 for (long i=symm+shift, j=i; j<sz; ) {
  delt = (long)ceil(((double)(j-symm))*Q);
  if (delt == 0) delt = 1;
  if (j-i == (long)floor(((double)(delt-1))/2.)) {
   if (i+delt >= sz) break;
   sum = 0;
   for (long k=i; k<i+delt; ++k) sum += mass[k];
   if (!dummy) mass[++p] = sum/((double)delt);
    else {
     ++d_index;
     dI[d_index].dummy_lag = ++p;
     dI[d_index].center_lag = j-symm;
     dI[d_index].range_left = i-symm;
     dI[d_index].range_right = i+delt-1-symm;
     dI[d_index].range_width = delt;
     dI[d_index].value = sum/((double)delt);
     dI[d_index].is_skipped = false;
    }    
   i += delt;
   j = i;
  } else { ++j; }
 }
 if (!dummy) { for (long i=symm; i<(symm+shift >= sz ? sz : symm+shift); ++i) mass[i] = mass[symm+shift]; }
  else {
   for (long i=symm; i<(symm+shift >= sz ? sz : symm+shift); ++i) {
    ++d_index;
    dI[d_index].dummy_lag = i;
    dI[d_index].is_skipped = true;
   }
  } // else

 p_number += p - symm + 1;
 //     p_shift;
 if (p_shift != 0) {
  if (!dummy) { for (long i=0; i<p_number; ++i) mass[i] = mass[i+p_shift]; }
   else { for (long i=0; i<p_number; ++i) dI[i].dummy_lag -= p_shift; }
 }

 return p_number;
}

/*---------  ""   ----------------*/
//   ,     ,  
// ,   
     
long logsmoothing (long sz) {
 long delt;   //   
 double sum;
 long p,      //   
      p_shift = 0;   //   symm != 0   .   0
 long d_index = -1;

if (symm > 0) {
 p = symm - shift + 1;
 
 for (long j=symm-shift, i; j>=0; --j) {
  delt = (long)ceil(((double)(symm-j))*Q);
  if (delt == 0) delt = 1;
  i = j + (long)floor(((double)(delt-1))/2.);
  if (i <= symm - shift) {  
   if (i-delt+1 < 0) break;
   sum = 0;
   for (long k=i; k>i-delt; --k) sum += mass[k];
   if (!dummy) mass[--p] = sum/((double)delt);
    else {
     ++d_index;
     dI[d_index].dummy_lag = --p;
     dI[d_index].center_lag = j-symm;
     dI[d_index].range_left = i-symm-delt+1;
     dI[d_index].range_right = i-symm;
     dI[d_index].range_width = delt;
     dI[d_index].value = sum/((double)delt);
     dI[d_index].is_skipped = false;
    }    
  }
 } // for
 if (!dummy) { for (long i=symm-1; i>=(symm-shift+1 < 0 ? 0 : symm-shift+1); --i) mass[i] = mass[symm-shift]; }
  else {
   for (long i=symm-1; i>=(symm-shift+1 < 0 ? 0 : symm-shift+1); --i) {
    ++d_index;
    dI[d_index].dummy_lag = i;
    dI[d_index].is_skipped = true;
   }
  } // else
 
 p_shift = p;
 p_number = symm - p_shift;  //    ,    shift

} // if (symm > 0)

 p = symm + shift - 1;

 for (long j=symm+shift, i; j<sz; ++j) {
  delt = (long)ceil(((double)(j-symm))*Q);
  if (delt == 0) delt = 1;
  i = j - (long)floor(((double)(delt-1))/2.);
  if (i >= symm + shift) {
   if (i+delt >= sz) break;
   sum = 0;
   for (long k=i; k<i+delt; ++k) sum += mass[k];
   if (!dummy) mass[++p] = sum/((double)delt);
    else {
     ++d_index;
     dI[d_index].dummy_lag = ++p;
     dI[d_index].center_lag = j-symm;
     dI[d_index].range_left = i-symm;
     dI[d_index].range_right = i+delt-1-symm;
     dI[d_index].range_width = delt;
     dI[d_index].value = sum/((double)delt);
     dI[d_index].is_skipped = false;
    }    
  }
 } // for
 if (!dummy) { for (long i=symm; i<(symm+shift >= sz ? sz : symm+shift); ++i) mass[i] = mass[symm+shift]; }
  else {
   for (long i=symm; i<(symm+shift >= sz ? sz : symm+shift); ++i) {
    ++d_index;
    dI[d_index].dummy_lag = i;
    dI[d_index].is_skipped = true;
   }
  } // else

 p_number += p - symm + 1;
 //     p_shift;
 if (p_shift != 0) {
  if (!dummy) { for (long i=0; i<p_number; ++i) mass[i] = mass[i+p_shift]; }
   else { for (long i=0; i<p_number; ++i) dI[i].dummy_lag -= p_shift; }
 }

 return p_number;
}

// -----------------------------
//  dummy 
// -----------------------------
void dummy_output () {
 printf ("\n\n");
 printf ("#Dummy lag    Center lag         Range                Width                Value\n");
 printf ("-------------------------------------------------------------------------------------\n");
 for (long i=0; i<p_number; ++i) {
  if (dI[i].is_skipped) printf ("%ld\t - skipped -\n", dI[i].dummy_lag);
   else printf ("%ld\t\t%ld\t\t%ld - %ld  \t\t%ld\t\t%g\n", dI[i].dummy_lag, dI[i].center_lag, dI[i].range_left, dI[i].range_right, dI[i].range_width, dI[i].value);
 }
}

// ------------------------
//  
// ------------------------
void Calc_Constant () {
 if (is_rm) Q = 1. - (1./((1.+ band/reffreq)*(1.+ band/reffreq)*(1.+ band/reffreq)));
  else Q = band/(band + reffreq);
}

/*==========================Prompting===================================*/

void Help ( char *s )
 {
  printf("\nPROGRAMM %s\n"
         "It is used to make logarithnic averaging and smoothing\n\n"
	 "[USAGE]: %s [options] <file(s) to process>\n\n"
	 "[OPTIONS]:\n"
	 "-d, --path   <path>           - path to the output file(s), default - the same\n"
	 "                                where are the source files\n"
	 "--ext        <string>         - auxiliary filename extension given to the output\n"	 
	 "                                file(s), default - .out\n"
	 "--out        <filename>       - name of file for output data. If --ext is given\n"
	 "                                then full name is filename + extension\n"
	 "                                default - input file + .out\n"
	 "-l, --left   <left boundary>  - left boundary of used window, default = 0\n"
	 "-w, --win    <size of window> - size of used window, default - equal to size of\n"
	 "                                file (in points)\n"
	 "-a, --aver                    - make logarithmic average procedure\n"
	 "-s, --smooth                  - make logarithmic smooth procedure\n"
	 "--const      <value>          - set value for logarithmic smooth/average procedure,\n"
	 "                                `value` must be > 0 and <= 1, default = 1.\n"
	 "--reffreq    <value>          - set reference frequency in MHz to calculate `value` in\n"
	 "                                --const option. Must be used together with options --band\n"
	 "                                and --rm or --fdm\n"
	 "--band       <value>          - set bandwidth in MHz to calculate `value` in --const option.\n"
	 "                                Must be used together with options --reffreq and --rm or --fdm\n"
	 "--rm                          - set type of Faraday delay as cubed time dependency.\n"
	 "                                Must be used together with options --reffreq and --band\n"
	 "--fdm                         - set type of Faraday delay as first power of time dependency.\n"
	 "                                Must be used together with options --reffreq and --band\n"
	 "--symm       <value>          - set center of symmetry, default - 0\n"
	 "--shift      <value>          - skip `value` points from beginning, default - 0\n"
	 "--dummy                       - set dummy mode, so data won't be modified and there\n"
	 "                                full info about averaging/smoothing will be printing\n"
	 "-h, --help                    - help\n\n", s, s);
  exit(0);
 }

/*===================Parsing the command line===========================*/

int ParseCmdLine( int argc, char *argv[] )
 {
  int op;
  struct option long_options[] = { {"help", no_argument, 0, 'h'},
				   {"left", required_argument, 0, 'l'},
				   {"win", required_argument, 0, 'w'},
				   {"aver", no_argument, 0, 'a'},
				   {"smooth", no_argument, 0, 's'},
				   {"path", required_argument, 0, 'd'},
				   {"ext", required_argument, 0, 10},
				   {"out", required_argument, 0, 11},
				   {"shift", required_argument, 0, 12},
				   {"dummy", no_argument, 0, 13},				   
				   {"symm", required_argument, 0, 14},
				   {"const", required_argument, 0, 15},				   
				   {"reffreq", required_argument, 0, 16},				   
				   {"band", required_argument, 0, 17},				   
				   {"rm", no_argument, 0, 18},
				   {"fdm", no_argument, 0, 19},
				   {0, 0, 0, 0}
                                  };

  while((op = getopt_long(argc, argv, "hl:w:asd:", long_options, 0)) != EOF)
    switch(op){
      case 'h':
        Help(argv[0]);
      break;
      
      case 'l':
        left = atol(optarg);
	if (left < 0) left = 0;
      break;
      
      case 'w':
        sz = atol(optarg);
	if (sz <= 0) sz = -1;
      break;
            
      case 'a':
        aver = true;
      break;
      
      case 's':
        smooth = true;
      break;
      
      case 'd':
	  if( OutputPath ) {
	    OutputPath = 0;
	    free(OutputPath);
	                          }
	  if( !( OutputPath = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutputPath, optarg, (int)strlen(optarg));
      break;
      
      case 10:
	  if( AuxExt ) {
	    AuxExt = 0;
	    free(AuxExt);
	                 }
	  if( !( AuxExt = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(AuxExt, optarg, (int)strlen(optarg));
      break;
            
      case 11:
	  if( OutFile ) {
	    OutFile = 0;
	    free(OutFile);
	                 }
	  if( !( OutFile = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(OutFile, optarg, (int)strlen(optarg));
      break;
      
      case 12:
        shift = atol(optarg);
	if (shift < 0) shift = 0;
      break;
      
      case 13:
        dummy = true;
      break;
      
      case 14:
        symm = atol(optarg);
	if (symm < 0) symm = 0;
      break;
      
      case 15:
        is_const = true;
	Q = atof(optarg);
	if (Q <=0. || Q > 1.) { printf("\nError: value in --const option is out of range!\n"); exit(1); }
      break;
      
      case 16:
        is_reffreq = true;
	reffreq = atof(optarg);
	if (reffreq <=0.) { printf("\nError: wrong frequency in --reffreq option!\n"); exit(1); }
      break;
      
      case 17:
        is_band = true;
	band = atof(optarg);
	if (band <=0.) { printf("\nError: wrong frequency in --band option!\n"); exit(1); }
      break;
      
      case 18:
        is_rm = true;
      break;
      
      case 19:
        is_fdm = true;
      break;
      
      case '?':
        Help(argv[0]);
      break;
    }
  return(optind);
 }

/*-----     ----*/

template <class tFormat>
void Write (tFormat m, long size, int razm, char *name, char *ext, int flag, int wri)
{
   int out;
   char *outfilename;
   outfilename = new char[MaxString+1];

   memset(outfilename, 0, MaxString+1);

   if (!strcmp(OutputPath, "\0")) { if (strcmp(OutFile, "\0") && !strcmp(ext, ".out")) sprintf(outfilename, "%s", OutFile);
    else sprintf(outfilename, "%s%s", (!strcmp(OutFile, "\0") ? name : OutFile), ext);
    } else {
    if (strcmp(OutFile, "\0") && !strcmp(ext, ".out")) sprintf(outfilename, "%s/%s", OutputPath, OutFile);
    else sprintf(outfilename, "%s/%s%s", OutputPath, (!strcmp(OutFile, "\0") ? SelectFileName(name) : OutFile), ext);
    }

   if (wri == 1) { printf(" writing... [%s]", outfilename); fflush(NULL); }
   
   if ( (out = open(outfilename, (flag == 1 ? O_TRUNC : O_APPEND) | O_CREAT | O_WRONLY | O_LARGEFILE, 0644)) == -1 )
      { printf("\nError: Couldn't open file %s for writing!\n", outfilename);
        exit(1);
       }
     else
       {
           lseek(out, 0, SEEK_SET);
	   write(out, m, size*razm);	                                           
           close(out);
        }
	
   memset(m, 0, razm*size);
   	
   delete(outfilename);
}

/*----------    ------------------*/

void ReadSrc (long l, long size, char *name)
{
  int file;
  TYPE *data;

     data = new TYPE[size];
     if (!data) { printf("Not enough memory!\n"); exit(1); }

     memset(data, 0, size*sizeof(TYPE));
     memset(mass, 0, size*sizeof(double));
       
       if ( (file = open(name, O_RDONLY | O_LARGEFILE)) == -1 )
         { printf("\nError:\nCouldn't open \"%s\" for reading!\n", name); exit(1);  }
	 
       if (lseek(file, l*sizeof(TYPE), SEEK_SET) == -1 )
	 { printf("\nError:\nWrong execution of lseek() in file \"%s\"!\n", name); exit(1); }
	read(file, data, size*sizeof(TYPE));
        close(file);

   for (long q=0, k=0; q<size; q++) {
	
  #ifdef _FR_SUN
   #ifdef _TO_INTELPC
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
  
  #ifdef _FR_INTELPC
   #ifdef _TO_SUN
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
         mass[q] = (double)data[q];	     
	                                  }		
  delete(data);	
}
     
/*====================== Main Function ===================================*/
  
int main ( int argc, char *argv[] )
 {
   struct stat info;
   int next;
   long Size, rsize;

   if (argc == 1) Help(argv[0]);
   
   AuxExt = new char[MaxString+1];
   OutFile = new char[MaxString+1];
   OutputPath = new char[MaxString+1];
   if (!AuxExt || !OutFile || !OutputPath) { printf("Not enough memory!\n"); exit(1); }
   memset(AuxExt, 0, MaxString+1);
   memset(OutFile, 0, MaxString+1);
   memset(OutputPath, 0, MaxString+1);
   sprintf(AuxExt, "%s", ".out");
   sprintf(OutFile, "%s", "\0");
   sprintf(OutputPath, "%s", "\0");
   
   next = ParseCmdLine(argc, argv);
   if (argc < next + 1) { printf("\nError:\nNot point the file(s) to process!\n"); exit(1); }

   if (!aver && !smooth) { printf("You must necessarily use one of the options -a or -s!\n"); exit(1); }
   if (aver && smooth) { printf("You must use only one of the options -a or -s!\n"); exit(1); }

   if ( stat(argv[next], &info) != 0 ) {
     printf("\nError:\nCouldn't open \"%s\"!\n", argv[next]); exit(1); }

   Size = info.st_size/sizeof(TYPE);
   if (Size == 0) { printf("\nError:\nSize of file is zero!\n"); exit(1); }
   
   if (sz == -1 || sz > Size) sz = Size;
   if (left >= Size) left = 0;
   if (left + sz > Size) sz = Size - left;
   rsize = sz;
   if (symm >= sz) symm = 0;
   if (symm + shift >= sz && symm - shift < 0) shift = 0;

   //  ,        
   //       
   if (!is_const && is_reffreq && is_band && (is_rm || is_fdm)) {
    printf ("Ref Frequency\t= %g\nBandwidth\t= %g\nFaraday type\t- %s\n", reffreq, band, is_rm ? "RM" : "FDM");
    Calc_Constant();
   }
   printf ("Constant Value\t= %g\n", Q);
    
   mass = new double[sz];
   if (!mass) { printf("Not enough memory!\n"); exit(1); }

   if (dummy) {
    dI = new struct dummyInfo[sz];
    if (!dI) { printf("Not enough memory!\n"); exit(1); }
   }

printf("\nProcessing...\n");

    for (int i=next; i<argc; i++)
     {

 printf(" [%3d]\t%s ... ", i-next, argv[i]);
 fflush(NULL);
  
    ReadSrc(left, sz, argv[i]);   

    if (aver) rsize = logaverage (rsize);
    if (smooth) rsize = logsmoothing (rsize);
    if (!dummy) Write (mass, rsize, sizeof(double), argv[i], AuxExt, 1, 1);
     else dummy_output();
    
 if (!dummy) printf(" - done\n");	
     }
       
  delete(mass);
  delete(AuxExt);
  delete(OutFile);
  delete(OutputPath);
  if (dummy) delete (dI);

  return 0;
}

