#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_BL_SZ 10485760l
#define SE_SZ 1050

void Error(const char* msg)
{
        perror(msg);
        exit(0);
}


int main(int ac, char **av)
{
	if (ac == 1) {  printf("\nPROGRAMM %s\n\n"
                               "USAGE: %s [OPTIONS] <file(s) to process>\n\n"
			       "[OPTIONS]:\n"
                               "-check        - check the correct work of splitting\n"
                               "-d <path>     - path for the output file(s)\n"
                               "                default - the same that for the source file(s)\n\n", av[0], av[0]);
			exit(0);
                      }  
	char check = 0;
	int nf = 1;
	char *path = (char *)malloc(255);
	if(path == NULL) Error("Raw malloc: ");
	memset(path, 0, 255);
	sprintf(path, ".");
	if (ac > 2) {
	if(!strcmp(av[1],"-d"))
	{
	         ++nf;
	         sprintf(path, "%s", av[2]);
		 ++nf;
	} 
	if(!strcmp(av[2],"-d"))
	{
	         ++nf;
	         sprintf(path, "%s", av[3]);
		 ++nf;
	}
	if(!strcmp(av[1],"-check") || !strcmp(av[3],"-check"))
	{
		printf("\nChecking enabled\n\n");
		check = 1;
		 ++nf;
	}
	  }
    for(; nf < ac; nf++)
    {
	printf("Spliting %s into ", av[nf]);

	int datF = open(av[nf], O_RDONLY);
	if(datF == -1) Error("File open");

	struct stat * info = new struct stat;
	if(!info) Error("mem1");
	if(fstat(datF, info)) Error("Stat");
	unsigned long datsz = info->st_size;
	delete info;

	unsigned short * bu = new unsigned short[SE_SZ];
	if(!bu) Error("mem2");
	if(read(datF, bu, 2*SE_SZ) == -1) Error("Reading test data");
	short numch;
	for(unsigned i = 1020, ma = 0, mi = 7; i < SE_SZ; i++)
	{
		char ch = bu[i] & 0x0f;
		if(ch < mi) mi = ch;
		if(ch > ma) ma = ch;
		numch = ma - mi + 1;
	}
char chNu = bu[1029] & 0x0f;
	delete bu;
	printf("%02hu chanels ...", numch);
	fflush(NULL);

	int *resF = new int[numch];
	unsigned long *resSZ = new unsigned long[numch];
	unsigned short **chbi = new unsigned short *[numch];
	
	lseek(datF, 2*1029, SEEK_SET);
	datsz -= 1029*2;
	unsigned long bs;
	if(datsz > MAX_BL_SZ){
		bs = MAX_BL_SZ;
	}else{
		bs = datsz;
	}

	bu  = new unsigned short [bs];

	for(char ch = 0; ch < numch; ch++)
	{
		char rr[128];
		sprintf(rr, "%s/%s.ch%02d", path, av[nf], (bu[1029] & 0x0f) + ch);
		resF[ch] = open(rr, O_CREAT|O_WRONLY|O_TRUNC, S_IREAD|S_IWRITE);
		chbi[ch] = new unsigned short [((unsigned)(bs/numch))+1];
	}
unsigned long kkk = 0;
while(kkk = read(datF, bu, bs)){
printf("\nBS = %lu, READ = %lu\n", bs, kkk);
	for(char ch = 0; ch < numch; ch++)
	{
		resSZ[ch] = 0;
	}
	unsigned long i = 0, w = 0;
	if(check)
	{
		while(i < kkk/2)
		{
			for(int j = 0; ((j < numch)&&
				(i < kkk/2)); j++,i++)
			{
				if((bu[i]&0x0f) != chNu++)
				{
					char f[80];
					sprintf(f, "Chanel numbering mismatch\n"
						"address: %u\n", i+1029);
					printf(f);
				}
				chbi[j][w] = (bu[i] >> 4) & 0x0fff;
				++resSZ[j];
			}
			chNu -= numch;
			++w;
		}
	}else{
		while(i < kkk/2)
		{
			for(int j = 0; ((j < numch)&&
				(i < kkk/2)); j++,i++)
			{
				chbi[j][w] = (bu[i] >> 4) & 0x0fff;
				++resSZ[j];
			}
			++w;
		}
	}
	printf(" Done\n");
	for(char ch = 0; ch < numch; ch++)
	{
		printf("Writing %s/%s.ch%02d ...", path, av[nf], (bu[1029] & 0x0f) + ch);
		fflush(NULL);
		write(resF[ch], chbi[ch], 2 * resSZ[ch]);
		printf(" %lu done\n", resSZ[ch]);
		fflush(NULL);
	}
}

	for(char ch = 0; ch < numch; ch++){
		delete chbi[ch];
		close(resF[ch]);
	}
	delete chbi;
	delete resF;
	delete resSZ;
	delete bu;
	close(datF);
    }
  free(path);  

  return 0;
}
