#define POMEH_
#include "totundisp.hpp"

/*--------------

         ,  
   (   sRes.InterferencesFile). Sigma   . 
 ,            
 (     ),      
   FFT.          
  FFT.
 
            ----------------------*/



/*-------    
               ,  ,
              pomexInfo   ---------------------*/


 
int PomexNumber ( void )
 {
  int n = 0;
  FILE * pom;
    if ( (pom = fopen(sRes.InterferencesFile, "rt")) == NULL ) { 
      printf("\nError:\nCouldn't open interference file \"%s\" !\n", sRes.InterferencesFile);
      exit(1);
	                                                       }
                fseek(pom, 0, SEEK_SET);
		
  char *p, curline[MaxString+1];

  while( fgets(curline, MaxString+1, pom)  ) {  
	p = curline;
	curline[(int)strlen(curline) -1] = 0;
	while(*p && isascii(*p) && isspace(*p)) ++p;
	if(!*p || *p == '#') continue;
	n++;
	                                      }
      fclose(pom);
  return n;    
 }


/*------       ---------*/

char * GetNumber( char * dest, char * p )
{
  int n = 0;
  char *p1 = p;
  while(*p1 && isascii(*p1) && !isspace(*p1)) { p1++; n++; }
  strncat(dest, p, n);
  return dest;
}

/*------------     ----------------*/

void AnalyzeLine( char *p, struct pomexInfo *tmp )
 {
   int l = 1, num;
   void *entry[] = { &tmp->start_pos, &tmp->end_pos, &tmp->sigma_start_pos, &tmp->sigma_size };
   char *dest;
         dest = new char[MaxString+1];
	 if (!dest) { printf("Not enough memory!\n"); exit(1); }
   if ( !strncasecmp(p, "m", l) || !strncasecmp(p, "p", l) )
    {
      tmp->type = *p;
      p += l;
      num = (tmp->type == 'm' || tmp->type == 'M' ? 1 : 4);
       for (int k=0;k<num;k++) {
        while(*p && isascii(*p) && isspace(*p)) p++;
	if (*p) { memset(dest, 0, MaxString+1);
	          dest = GetNumber(dest, p);
	          *(long *)entry[k] = atol(dest);
	          p += (int)strlen(dest);
	         } else { printf("\nError:\nBad line in interference file \"%s\" : not full !\n", sRes.InterferencesFile);
		          exit(1);
		         }
                                }      
     }
    else { printf("\nError:\nBad line in interference file \"%s\" : %s !\n", sRes.InterferencesFile, p);
           exit(1);
          }
    delete(dest);	  
 }

/*----------------     ------------*/
 
void PomexFileRead( void )
 {
  pomNumber = PomexNumber();

  FILE * pom;
         if ( (pom = fopen(sRes.InterferencesFile, "rt")) == NULL ) {
	    printf("\nError:\nCouldn't open interference file \"%s\" !\n", sRes.InterferencesFile);
	    exit(1);
	                                                            }
                     fseek(pom, 0, SEEK_SET);
		     
  pomArray = new struct pomexInfo[pomNumber];
  if (!pomArray) { printf("Not enough memory!\n"); exit(1); }
		    
  char *p, curline[MaxString+1];
  struct pomexInfo *tmp = pomArray;

  while( fgets(curline, MaxString+1, pom)  ) {
	p = curline;
	curline[(int)strlen(curline) -1] = 0;
	while(*p && isascii(*p) && isspace(*p)) ++p;
	if(!*p || *p == '#') continue;
	AnalyzeLine(p, tmp);
	tmp++;
	                                      }
      fclose(pom);						       
 }


/*------     long-  pomexInfo   --------*/

void pomexLocChangeFF ( struct pomexInfo *tmp, long index )
{
  void *entry[] = { &tmp->start_pos, &tmp->end_pos, &tmp->sigma_start_pos, &tmp->sigma_size };
  int num = (tmp->type == 'm' ? 1 : 4);
  
  for (int k=0;k<num;k++) *(long *)entry[k] *= index;	           
}

void pomexLocChangeRV ( struct pomexInfo *tmp, long index )
{
  void *entry[] = { &tmp->start_pos, &tmp->end_pos, &tmp->sigma_start_pos, &tmp->sigma_size };
  int num = (tmp->type == 'm' ? 1 : 4);
  
  for (int k=0;k<num;k++) *(long *)entry[k] = (long)ceil((double)((*(long *)entry[k])/index));	           
}

/*----       --------*/


void PomexFileCorrect ( off_t rsize, off_t nsize )
{
  int index = ( rsize < nsize ? (nsize-1)/(rsize-1) : (rsize-1)/(nsize-1) );
  char dir = (rsize < nsize ? 1 : 0);

  struct pomexInfo *tmp = pomArray;

  switch (dir) {
   case 1:  for (int i=0;i<pomNumber;i++, tmp++) pomexLocChangeFF(tmp, index);
            break;
   case 0:  for (int i=0;i<pomNumber;i++, tmp++) pomexLocChangeRV(tmp, index);
            break;
   default: break;	    
                }
}

/*---------- ,    ,    ---------------*/

void NormRand ( fftwf_complex * x, off_t q, float rs, float is )
{
 long rn1, rn2;
 double yj, zj, pj , xi;

 do { rn1 = random(); rn2 = random();
      yj = 2.*(((double)rn1)/((double)(RAND_MAX+1.0))) - 1.;
      zj = 2.*(((double)rn2)/((double)(RAND_MAX+1.0))) - 1.;
      pj = yj*yj + zj*zj;
     } while ( pj >= 1. );

 x[q][0] = rs * yj * sqrt ((-2.*log(pj))/pj);
 x[q][1] = is * zj * sqrt ((-2.*log(pj))/pj);
}

void PomexCorrectionFunc ( fftwf_complex * x, off_t size )
{
  if (pomNumber == 0) return;
   struct pomexInfo *tmp = pomArray;
   off_t ind, s1, si, beg, end;
   float sum_r, sum_i, sum2_r, sum2_i, sigma_r, sigma_i;  
   
   for (int i=0;i<pomNumber;i++, tmp++) {
   
   char tip = (tmp->type == 'm' || tmp->type == 'M' ? 1 : 4);
   void *entry[] = { &tmp->start_pos, &tmp->end_pos, &tmp->sigma_start_pos, &tmp->sigma_size };
   for (char j=0;j<tip;j++) {
    if ( *(long *)entry[j] < 0 || *(long *)entry[j] > size - 1 ) {
     printf("\n- warning !.. - interference N%d has bad value and will be ignored!\n\n", i);
     tip = 10;
     break;
    }
   }
     srandom((unsigned long)time(NULL));
     switch (tip) {
       case 1:  ind = tmp->start_pos;
                x[ind][0] = (ind == 0 ? (x[ind+2][0]-x[ind+1][0])/2 : (ind == size-1 ? (x[ind-2][0]-x[ind-1][0])/2 : (x[ind+1][0]-x[ind-1][0])/2 )) * cos(x[ind][0]);
                x[ind][1] = (ind == 0 ? (x[ind+2][1]-x[ind+1][1])/2 : (ind == size-1 ? (x[ind-2][1]-x[ind-1][1])/2 : (x[ind+1][1]-x[ind-1][1])/2 )) * sin(x[ind][1]);
                break;
       case 4:  s1 = tmp->sigma_start_pos; si = tmp->sigma_size;
                sum_r = 0.; sum_i = 0.; sum2_r = 0.; sum2_i = 0.; sigma_r; sigma_i;
		for (long w=s1;w<s1+si;w++) {
		 sum_r += x[w][0]; sum2_r += x[w][0]*x[w][0];
		 sum_i += x[w][1]; sum2_i += x[w][1]*x[w][1];
		}
		sum_r /= si; sum_i /= si;
		sum2_r /= si; sum2_i /= si;
		sigma_r = sqrt(sum2_r - sum_r*sum_r);
		sigma_i = sqrt(sum2_i - sum_i*sum_i);
		beg = tmp->start_pos; end = tmp->end_pos;
		for (off_t q=beg;q<=end;q++) NormRand (x, q, sigma_r, sigma_i);
                break;
       case 10: break;		
       default: break;		
     }
   }
}

/*---------------    ------------------*/

void BandInterpolation ( float * x, off_t rsize, off_t nsize )
{
  if ( 2*(rsize-1) != resize(2*(rsize-1)) ) {
   printf("\nError:\nSize of file \"%s\" is expected to be equal to N/2 + 1 harmonics,\nwhere N is power if 2 !\n", sRes.BandCorrFunc);
   exit(1);
  }
  if (rsize < 2) {
   printf("\nError\nSize of file \"%s\" must be more then 1 harmonica!\n");
   exit(1);
  }
  
  int index = ( rsize < nsize ? (nsize-1)/(rsize-1) : (rsize-1)/(nsize-1) );
  char dir = (rsize < nsize ? 1 : 0);
  
  switch (dir) {
   case 1:  for (off_t i=rsize-1;i>0;i--) {
             x[i*index] = x[i];
	     for (int j=1;j<index;j++)
	      x[i*index-j] = x[i] + (x[i-1] - x[i])*((float)(j/index));  
                                          }
            break;
   case 0:  for (off_t i=1;i<nsize;i++) {
             for (int j=1;j<index;j++) x[i] += x[i+j];
	      x[i] /= index;
                                       }
            break;
   default: break;	    
                }
}


/*-----    sigma    
                ----------------*/

double SpectrumSigmaCalc ( fftwf_complex * x,  off_t size )
{
  int number = 64;                          /*----     sigma ------*/
  off_t left = (off_t)ceil(size/16);          /*----  16, ..       -----*/
  off_t right = size - (off_t)ceil(size/4);   /*----  4, ..       ----*/
  off_t part = (off_t)ceil((right - left)/number);
  if (part < 2) { printf("\nwarning ! - there are very few number of points\n"
                         "            in amplitude spectrum for soft black spotter mode.\n"
			 "            Soft Black Spotter mode set off !\n");
                  sigma = -1.;
		  SigLevel = -1.;
		  return sigma;
  }
  double s, min = -1., pmin, sum2;

   for (off_t i=left, j; i<right; i+=part) {
    sum2 = 0.;
      for (j=i;j<(i+part >= right ? right : i+part); ++j) sum2 += x[j][0]*x[j][0] + x[j][1]*x[j][1];
    if (j-i < 2) break;
    s = sqrt( sum2 / ((float)(j-i)) );
    if (min == -1.) { min = s; pmin = s; }
    if (s < pmin && s > min) pmin = s;
    if (s < min) { pmin = min; min = s; }
                                               }
 return pmin;
}


/*-----    ,   SigLevel*sigma
                                        -------------*/

void SoftBlackSpotter ( fftwf_complex * x, off_t size )
{
  for (off_t i=0; i<size; ++i) {
    x[i][0] = (x[i][0] > SigLevel*sigma ? SigLevel*sigma*cos(x[i][0]) : (x[i][0] < (-1.)*SigLevel*sigma ? (-1.)*SigLevel*sigma*cos(x[i][0]) : x[i][0]) );
    x[i][1] = (x[i][1] > SigLevel*sigma ? SigLevel*sigma*sin(x[i][1]) : (x[i][1] < (-1.)*SigLevel*sigma ? (-1.)*SigLevel*sigma*sin(x[i][1]) : x[i][1]) );
  }
}

