#define MAIN_
#include "readme.hpp"
#include "totundisp.hpp"   

float *matrix;
float *mass_out, **mass_in;
fftwf_complex *x, *y, *z;
fftwf_plan pfor, prev;
float *tru;
off_t iter = -1, sz = -1, bl = 0, br = -1, wsize = -1, Cut = -1;
unsigned char NoDisp = 0, NoScale = 0, ReadAnSig = 0, DetectLevel = 0, NoFill = 0, UseRM = 0;
double SigLevel = -1., sigma = -1., ToSigma, Extra_Phi = 0., Linear_Phi = 0.;
bool tos = false, UseBadpoints = false;
double TimeDelay = 0.;
long Nch = 4;
bool is_quite = false;

/*------------------------------------------------------------------------
td -   
source - ,      
    
     :
23.12 ns
      mcs
      ms
      sec
      min
      hrs
      days
---------------------------------------------------------------------------*/
char* TimeDelayPresentation (double td, char* source) {
 double time = td * sRes.TimeResolution;  /*    */
 
 const char* tk[] = { "ns", "mcs", "ms", "sec", "min", "hrs", "days" };
 const unsigned short dv[] = { 1000, 1000, 1000, 60, 60, 24 };
 int i = 0;
 
 for (i=0; i<6; ++i) {
  if (time < (double)dv[i]) { sprintf(source, "%g %s", time, tk[i]); break; }
  time /= (double)dv[i];
 }
 if (i == 6) sprintf(source, "%g %s", time, tk[i]);
 return source;
}

/*---------------------------------------------------------------------------
    --time-delay
   -    
      , 
  :
12.34n  - 
     c  - 
     m  - 
     S  - 
     M  - 
     H  - 
     D  -   
------------------------------------------------------------------------------*/
double TimeDelayParsing (char* str) {
 double td;
 //    
 if (isdigit(str[strlen(str)-1]) != 0 || str[strlen(str)-1] == '.') {
   td = atof(str);
   return td;
 }
 char* dest;
 dest = new char[MaxString+1];
 if (!dest) { printf("Not enough memory!\n"); exit(1); }
 memset(dest, 0, MaxString+1);
 strncpy(dest, str, strlen(str)-1);
 td = atof(dest);
 delete(dest);
 
 switch (str[strlen(str)-1]) {
  case 'D': td *= 24;
  case 'H': td *= 60;
  case 'M': td *= 60;
  case 'S': td *= 1000.;
  case 'm': td *= 1000.;
  case 'c': td *= 1000.;
  case 'n': break;
  default: printf("Error:\nWrong character %c in argument %s of --time-delay option!\n", str[strlen(str)-1], str);
           exit(1);
 } // switch  
 td /= sRes.TimeResolution;  //  TimeDelay  
 return td;
}

/*-------------------------------------------------------------------------
   RM  FDM   DM   
--------------------------------------------------------------------------*/
void FaradayCalc () {

 double tbad, f, f1;

 f  = sRes.CenterFrequency - sRes.BandWidth/2.;
 f1 = sRes.CenterFrequency + sRes.BandWidth/2.;
 
 /* --      ,                      -----
 -----           DM,  RM,  FDM --*/
 switch (UseRM) {
  /*    */
  case 0: sRes.DM = fabs( TimeDelay / ( (((ALPHA2/(sRes.TimeResolution * 1000.))/f)/f) - (((ALPHA2/(sRes.TimeResolution * 1000.))/f1)/f1)) );  
          break;
  /*    */
  case 1: sRes.RM = (TimeDelay * 1.e6 ) / ( ((((BETA2/(sRes.TimeResolution * 1000.))/f)/f)/f) - ((((BETA2/(sRes.TimeResolution * 1000.))/f1)/f1)/f1) );
          break;
  /*  FDM */	  
  case 2: sRes.FDM = ( 2. * M_PI * TimeDelay * sRes.TimeResolution ) / ( 1000./f - 1000./f1 );
          break;
  default: break;	  
 } // switch
}

/*------- DeDispersion Procedure Functions --------------*/

// Full Dispersion --- flag = 0
// Spolied Points at the beginning  --- flag = 1
// Spoiled Points at the end  --- flag = -1
unsigned long ShowDispersion (signed char flag) {

double tbad, f, f1;

 //      ,      
 if (UseBadpoints) return (unsigned long)ceil(fabs(TimeDelay));

 switch (flag) {
  case  0:  f  = sRes.CenterFrequency - sRes.BandWidth/2.;
            f1 = sRes.CenterFrequency + sRes.BandWidth/2.;
	    break;
  case  1:  f = sRes.RefFrequency;
            f1 = sRes.CenterFrequency + sRes.BandWidth/2.;
	    break;
  case -1:  f = sRes.CenterFrequency - sRes.BandWidth/2.;
            f1 = sRes.RefFrequency;
	    break;
  default: break;
 }

 switch (UseRM) {
  /*     */
  case 0:
          tbad = sRes.DM * ALPHA2 * ( 1./(f * f) - 1./(f1 * f1) );
          TimeDelay = (tbad * 0.001)/sRes.TimeResolution;
          break;
  /*     */
  case 1:
          tbad = sRes.RM * BETA2 * ( 1./(f * f * f) - 1./(f1 * f1 * f1) );
          TimeDelay = (tbad * 1.e-9)/sRes.TimeResolution;
          break;
  /*   FDM */	  
  case 2:
          tbad = (sRes.FDM / (2.*M_PI)) * ( 1./f - 1./f1 );
          TimeDelay = (tbad * 1000.)/sRes.TimeResolution;
          break;
  default: break;	  
 }

 //  , .. RM  FDM   
 return (unsigned long)ceil(fabs(TimeDelay));
}

/* Show Dispersion in Individual Channel */
unsigned long ShowDispersionInd (signed char flag) {

double tbad, f, f1;

 //      ,      
 if (UseBadpoints) return (unsigned long)ceil(fabs(TimeDelay));

 switch (flag) {
  case  0:  f  = sRes.CenterFrequency - sRes.BandWidth/4.;
            f1 = sRes.CenterFrequency - sRes.BandWidth/2.;
	    break;
  case  1:  f = sRes.RefFrequency;
            /*f1 = sRes.CenterFrequency + sRes.BandWidth/2.;*/
            f1 = sRes.CenterFrequency - sRes.BandWidth/4.;
	    break;
  case -1:  f = sRes.CenterFrequency - sRes.BandWidth/2.;
            f1 = sRes.RefFrequency;
	    break;
  default: break;
 }

 switch (UseRM) {
  /*     */
  case 0:
          tbad = sRes.DM * ALPHA2 * ( 1./(f * f) - 1./(f1 * f1) );
          TimeDelay = (tbad * 0.001)/sRes.TimeResolution;
          break;
  /*     */
  case 1:
          tbad = sRes.RM * BETA2 * ( 1./(f * f * f) - 1./(f1 * f1 * f1) );
          TimeDelay = (tbad * 1.e-9)/sRes.TimeResolution;
          break;
  /*   FDM */	  
  case 2:
          tbad = (sRes.FDM / (2.*M_PI)) * ( 1./f - 1./f1 );
          TimeDelay = (tbad * 1000.)/sRes.TimeResolution;
          break;
  default: break;	  
 }

 //  , .. RM  FDM   
 return (unsigned long)ceil(fabs(TimeDelay));
}

/******************** Calculate Phase Correction Value **********************/

double Calc (double f) {
double z, index, freq;

freq = sRes.RefFrequency;
index = 1.e6;

 switch (UseRM) {
  /*     */
  case 0:
	  z = ( ( ALPHA1 * sRes.DM ) / f / ( freq * freq * index ) ) * ( f - freq ) * ( f - freq );
          break;
  /*     */
  case 1:
//           else z = ( ( ( ( ( ( ( BETA1 * sRes.RM ) / ( T * freq * index ) ) * ( ( ( 3. * freq * T )/((double)j) ) + 2. * (sign) ) ) / ( ( freq + (sign*((double)j))/T ) * ( freq + (sign*((double)j))/T ) ) ) / ( T * T * freq * freq * index ) ) * ((double)(j)) ) * ((double)(j)) ) * ((double)(j));
	  z = ( ( ( ( BETA1 * sRes.RM ) / ( freq * index ) ) * ( freq + 2. * f ) ) / ( f * f ) / ( freq * freq * index ) ) * ( f - freq ) * ( f - freq );
          break;
  /*   FDM */	  
  case 2:
          z = sRes.FDM;
          break;
  default: break;	  
 }

 return z;
}

/************** Compute Matrix ***************/

void ComputeMatrix ( off_t sz )
{
 double z = 0.;
 double T, freq, f0;
 
/* ----------  Band Correction ---------- */

float * band;

if (strcmp(sRes.BandCorrFunc, "no")) {

 struct stat inform; 
 int in;
 off_t bs;

   if ( stat(sRes.BandCorrFunc, &inform) != 0 ) {
      printf("\nError:\nCouldn't open file \"%s\" with band correction function !\n", sRes.BandCorrFunc); exit(1); }
      
 bs = inform.st_size/sizeof(float);
 band = new float[(bs > sz/2 + 1 ? bs : sz/2 + 1)];
 if ( !band ) { printf("Not enough memory!\n"); exit(1); }

  if ( (in = open(sRes.BandCorrFunc, O_RDONLY | O_LARGEFILE)) == -1 ) {
    printf("Error: Couldn't open %s for reading!\n", sRes.BandCorrFunc); exit(1); }
    
             lseek(in, 0, SEEK_SET);
	     read(in, band, inform.st_size);
	     close(in);
				       
 if (bs != sz/2 + 1) {
      printf("\n- Warning ! -\n"
             "Size = %lld of band correction function and size = %lld\n"
             "of dispersion matrix don't match !\n"
             "...interpolation begin...", bs, sz/2 + 1); 
      fflush(NULL);
      BandInterpolation(band, bs, sz/2 + 1);
      printf("done\n\n");
                                                }
 if (strcmp(sRes.InterferencesFile, "no")) PomexFileCorrect(bs, sz/2 + 1);
				       }
 
/*------------------------------------------------ */

  float sign;
  sign = (sRes.BandDir == 0 ? -1. : 1.);
  
 if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) {
    T = ((sRes.TimeResolution) * ((double)sz))/((double)(1.e3));
    f0 = (sRes.BandDir == 0 ? sRes.CenterFrequency - sRes.BandWidth/2. : sRes.CenterFrequency + sRes.BandWidth/2.);
    for (off_t i=0, j=0; i < 2*(sz/2 + 1); i+=2, j++)
      {
	if (NoDisp == 0) {
	 freq = f0 + (-1. * sign)*(((double)j)/T);
	 z = Calc(freq);
	}
        matrix[i] = (!strcmp(sRes.BandCorrFunc, "no") ? ((float)cos(z + Extra_Phi + Linear_Phi*((double)M_PI)*((double)j)/((double)sz) )) : ( NoDisp == 0 ? ((float)cos(z + Extra_Phi + Linear_Phi*((double)M_PI)*((double)j)/((double)sz) )) * band[j] : band[j] ) );
        matrix[i+1] = (!strcmp(sRes.BandCorrFunc, "no") ? (sign)*((float)sin(z + Extra_Phi + Linear_Phi*((double)M_PI)*((double)j)/((double)sz) )) : ( NoDisp == 0 ? (sign)*((float)sin(z + Extra_Phi + Linear_Phi*((double)M_PI)*((double)j)/((double)sz) )) * band[j] : band[j] ) );
       }
   }
       
   if (strcmp(sRes.BandCorrFunc, "no")) delete(band);
 }

/***************** D E D I S P E R S I O N ***************************/

void DeDispersionProc (off_t sz) {

 for (int f=0; f<Nch; f++) {
 for (off_t i=0; i<sz; ++i) { x[i][0] = mass_in[f][2*i]; x[i][1] = mass_in[f][2*i + 1]; }
 fftwf_execute (pfor);
 if (f == 0) { for (off_t i=0; i<sz/2 + 1; ++i) { y[i][0] = x[i][0]; y[i][1] = x[i][1]; } }
  else { for (off_t i=1; i<sz/2 + 1; ++i) { y[f*(sz/2)+i][0] = x[i][0]; y[f*(sz/2)+i][1] = x[i][1]; } }
 }

 if (Cut != -1) for (off_t i=0; i<Cut; ++i) { y[i][0] = 0.; y[i][1] = 0.; }
 if (SigLevel != -1. && sigma == -1.) sigma = SpectrumSigmaCalc(y, (Nch*sz)/2 + 1);
 if (SigLevel != -1.) SoftBlackSpotter(y, (Nch*sz)/2 + 1);

 if (strcmp(sRes.BandCorrFunc, "no") && strcmp(sRes.InterferencesFile, "no"))
   PomexCorrectionFunc(y, (Nch*sz)/2 + 1);
  
 if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) {
  for (off_t i=0; i<(Nch*sz)/2 + 1; ++i) {   
     z[i][0] = y[i][0] * matrix[2*i]   - matrix[2*i+1] * y[i][1];
     z[i][1] = y[i][0] * matrix[2*i+1] + matrix[2*i]   * y[i][1];    
   }
  }
 for (off_t i=(Nch*sz)/2 + 1; i<(Nch*sz); ++i) { z[i][0] = 0.; z[i][1] = 0.; }
 
 // reverse
 fftwf_execute (prev);
 for (off_t i=0; i<(Nch*sz); ++i) { mass_out[2*i] = y[i][0] / (Nch*sz); mass_out[2*i + 1] = y[i][1] / (Nch*sz); } 
}
     
/* ------------------------------------------- */


/*---      ---*/

float NoiseLevel ( float * Massive, off_t sz, int num )
 {   
  float Sum = 0.;
    for (off_t i=0;i<num*sz;i+=num) Sum += Massive[i];
    return Sum/sz;
  }

/*-----      -----------*/

void LevelEliminate ( float * Massive, float level, off_t sz, int num )
{
    for (off_t i=0;i<num*sz;i+=num) Massive[i] -= level; 
}

/*-------
     sigma   
         
---------*/

void CorrectionOfSigma ( float * x, off_t sz, double sig ) {
 if (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1)) {
  double s = 0., s2 = 0., cf, our_si;
  for (off_t i=0; i<2*sz; i+=2) { s += x[i]; s2 += x[i]*x[i]; }
  s /= sz; s2 /= sz;
  our_si = sqrt(s2 - s*s);
  cf = sig / our_si;
  for (off_t i=0; i<2*sz; i+=2) x[i] *= cf;
 }
 else {
  double sr = 0., si = 0., s2r = 0., s2i = 0., cfr, cfi, our_sir, our_sii;
  for (off_t i=0; i<2*sz; i+=2) { sr += x[i]; s2r += x[i]*x[i]; si += x[i+1]; s2i += x[i+1]*x[i+1]; }
  sr /= sz; s2r /= sz; si /= sz; s2i /= sz;
  our_sir = sqrt(s2r - sr*sr); our_sii = sqrt(s2i - si*si);
  cfr = sig / our_sir; cfi = sig / our_sii;
  for (off_t i=0; i<2*sz; i+=2) { x[i] *= cfr; x[i+1] *= cfi; }
 }
}

/*---- ,   (size)  ,
                    2 ------------------------*/

long resize (off_t sz)
 {
   off_t n = 0;
   sz += 1;
   while ( (1<<(++n)) < sz) ;
   return (1<<(--n));
  }

/*----
      
 write   
  : --write 111 (  -  ,
   - ,  - )
  1 - , 0 -  
   --write 000    

    : --write +d-a-r (+  , -  ,
   a - , d - , r - )
      .      --write +d,
    (   )
----*/

bool processWriteOption ( char * arg )
{
  //    -   
  if (isdigit(arg[0])) {
   if (strlen(arg) != 3) return false;
   if ((arg[0] != '1' && arg[0] != '0') ||
       (arg[1] != '1' && arg[1] != '0') ||
       (arg[2] != '1' && arg[2] != '0') ) return false;

   sRes.WriteAnalyticSignal = (arg[0] == '1' ? 1 : 0);
   sRes.WriteDetectedSignal = (arg[1] == '1' ? 1 : 0);
   sRes.WriteRealSignal = (arg[2] == '1' ? 1 : 0);
   
   return true;
  }
  
  //   ,  +  -
  if (arg[0] == '+' || arg[0] == '-') {
   if (strlen(arg)%2 != 0) return false;
   int sign;
   for (int i=0;i<strlen(arg);i+=2) {
    if (arg[i] == '+') sign = 1; else sign = 0;
    switch (arg[i+1]) {
     case 'a': sRes.WriteAnalyticSignal = sign;
               break;
     case 'd': sRes.WriteDetectedSignal = sign;
               break;	
     case 'r': sRes.WriteRealSignal = sign;
               break;
     default: return false;
    } // switch
   } // for
    return true;
  }

  // 
  return false;
}

   
/*==========================Prompting===================================*/

void Help ( char *s )
 {
  printf("\nPROGRAMM %s\n"
         "It is used to make dispersion removal technique\n"
	 "Some options repeat the fieldnames of source file, in case when\n"
	 "some value is pointed in both source file and command line, value\n"
	 "from command line is used\n\n"
	 "[USAGE]: %s [options] <file(s) to process>\n\n"
	 "[OPTIONS]:\n"
	 "-o, --source <filename>       - name of source file, default \"source.set\"\n"
	 "                                If filename = no then source file won't be used and\n"
	 "                                all parameters are inputed from command line\n"
	 "--create                      - create source file with name and destination pointed\n"
	 "                                before in -o or --source option. Otherwise, source\n"
	 "                                file \"source.set\" will be created in current directory\n"
	 "--userm      <0|1>            - to correct for rotation measure or faraday delay measure\n"
	 "                                instead of dispersion measure. 0 - to correct for RM,\n"
	 "                                1 - for faraday delay measure\n"
	 "-d, --path   <path>           - path to the output file(s), default - the same\n"
	 "                                where are the source files\n"
	 "-b, --band   <filename>       - name of file with band correction function\n"
	 "                                If filename = no then band correction won't be made\n"
	 "                                default - no\n"
	 "--pomeh      <filename>       - name of file with information of interferences\n"
	 "                                in the power spectrum of input record(s)\n"
	 "                                This file is in text format (for more information\n"
	 "                                see some example of it). If filename = no then\n"
	 "                                interference correction won't be made, default - no\n"
	 "                                Without the file of band correction this option\n"
	 "                                has no effect\n"
	 "-p, --print  <fieldname>      - Output the value of fieldname from source file\n"
	 "--header     <value>          - Size of header (in bytes) of processed files\n"
	 "                                default - 0\n"
	 "-l, --left   <left boundary>  - left boundary of used window, default - 0\n"
	 "-r, --right  <right boundary> - right boundary of used window, default - equal\n"
	 "                                to size of file (in points)\n"
	 "-s, --slice  <size of slice>  - size of slice ; default - equal to size of\n"
	 "                                file (in points) -- find downwards the nearest\n"
	 "                                power of 2 !\n"
	 "-w, --size   <size of block>  - size of block to record in case of large files.\n"
	 "                                If it's pointed then dest file(s) are forming by\n"
	 "                                appending consecutively the blocks of selected size;\n"
	 "                                default - equal to size of file (in points)\n"
	 "-i, --iter   <number of iter> - number of iterations\n"
	 "--bad        <value>          - to write or not bad points. Default, bad points are not written.\n"
	 "                                If value is 1 then bad points will be written, 0 - otherwise.\n"
	 "--write      <format>         - set kind of output file(s) to be written.\n"
	 "                                There are two forms of format argumnent. The first one\n"
	 "                                is digit form. You need to write 3 digits, each of them\n"
	 "                                has to be 1 or 0. 1 means to write this kind of file, and 0 - not.\n"
	 "                                The first digit sets the analytical signal, the second - detected\n"
	 "                                signal, and the third - the real part of analytical signal.\n"	 
	 "                                For example, one can write format as 011.\n"
	 "                                This means that analytical signal won't be written, and detected\n"
	 "                                signal and the real part of analytical signal will be written.\n"
	 "                                The second form is symbol form. The true symbols are +,-,a,d,r.\n"
	 "                                + - to write this kind of file, - - not to write, a - analytical signal,\n"
	 "                                d - detected signal, r - real part of analytical signal.\n"
	 "                                So, one can write format as +d-a-r or simply +d.\n"
	 "                                The +d record sets detected signal to be written and other kinds are\n"
	 "                                ignored, i.e. the information will be taken from configuration file.\n"
	 "--nodisp                      - not make dispersion removing, only band correction\n"
	 "                                (if option -b don't equal to no) or simply procedures\n"
	 "                                of detection, analytical signal making...\n"
	 "--timeres    <value>          - set time resolution (in nanosec), default - 31.25\n"
	 "--dm         <value>          - set pulsar DM (dispersion measure) in pc/cm^3,\n"
	 "                                default - 480.\n"
	 "--rm         <value>          - set pulsar RM (rotation measure) in rad/m^2\n"
	 "                                default - -611.\n"
	 "--fdm        <value>          - set pulsar FDM (faraday delay measure) in rad\n"
	 "                                default - 0.\n"
	 "--bw         <value>          - set receiver bandwidth (in MHz), default - 16.\n"
	 "--reffreq    <value>          - set reference frequency (in MHz), default - the same as center frequency\n"
	 "--centerfreq <value>          - set receiver band center frequency (in MHz)\n"
	 "                                default - 1642.\n"
	 "--banddir    <value>          - set band direction, 0 - direct, 1 - inverse;\n"
	 "                                default - 0\n"
	 "--level      <value>          - set ADC level, default - 2048.\n"
	 "--detectlevel                 - if this option is pointed then option --level will be\n"
	 "                                ignored and programm itself will detect level in first\n"
	 "                                iteration on size of slice and will use this level in\n"
	 "                                other iterations while process runs\n"
	 "--noscale                     - not make scaling in output file(s), i.e. don't\n"
	 "                                multiply to 2. for analytical signal and its real\n"
	 "                                part and to 4. for detected signal\n"
	 "                                default - making scaling\n"
	 "--spotter    <value>          - this option set the mode of soft black spotter,\n"
	 "                                value is number of sigma for using interference\n"
	 "                                cut level\n"
	 "--cut        <value>          - cut <value> of harmonics in amplitude spectrum, i.e.\n"
	 "                                set them to zero\n"
	 "--as                          - input file is the analytical signal, i.e. with the\n"
	 "                                interchange of real and imaginary parts\n"
	 "--nofill                      - don't use the imaginary part of analytical signal\n"
	 "                                default - use (if option --as is set up)\n"
	 "--tosigma    <value>          - to bring current sigma in each input slice to sigma\n"
	 "                                equal to stated value\n"
	 "--extra-phi  <value>          - extra phase delay in degrees during dedispersion\n"
	 "--linear-phi <value>          - extra phase delay in each harmonic determined by <value>*pi*j/N,\n"
	 "                                where j - harmonic number\n"
	 "--time-delay <value>          - set the value of time-delay within the receiver bandwidth, or\n"
	 "                                so-called the value of ``badpoints''. If <value> is presented\n"
	 "                                only by real number, then <value> is time delay in units of counts.\n"
	 "                                If <value> is real number + one of the letters 'n', 'c', 'm', 'S', 'M',\n"
	 "                                'H' or 'D', then <value> is time delay in nanoseconds, microseconds,\n"
	 "                                milliseconds, seconds, minutes, hours or days, correspondingly.\n"
	 "                                This option is used to calculate the value of DM (or RM in case of\n"
	 "                                using option --use-rm). If option --use-rm is used, then <value> can\n"
	 "                                be as positive, as negative, otherwise the absolute value of <value>\n"
	 "                                us used. The value of badpoints in counts is rounded up to the\n"
	 "                                nearest integer\n"
	 "-q, --quite                   - turn on quite output, skip printing the iteration changes\n"
	 "-h, --help                    - help\n\n", s, s);
  exit(0);
 }

/*===================Parsing the command line===========================*/

int ParseCmdLine( int argc, char *argv[] )
 {
  int op, tm;
  struct option long_options[] = { {"help", no_argument, 0, 'h'},
				   {"slice", required_argument, 0, 's'},
				   {"iter", required_argument, 0, 'i'},
				   {"source", required_argument, 0, 'o'},
				   {"path", required_argument, 0, 'd'},
				   {"band", required_argument, 0, 'b'},
				   {"left", required_argument, 0, 'l'},
				   {"right", required_argument, 0, 'r'},
				   {"print", required_argument, 0, 'p'},
				   {"size", required_argument, 0, 'w'},
                                   {"bad", required_argument, 0, 11},
                                   {"write", required_argument, 0, 12},				   
				   {"timeres", required_argument, 0, 13},
				   {"dm", required_argument, 0, 14},
				   {"bw", required_argument, 0, 15},
				   {"reffreq", required_argument, 0, 16},
				   {"centerfreq", required_argument, 0, 17},
				   {"banddir", required_argument, 0, 18},
                                   {"nodisp", no_argument, 0, 19},
				   {"level", required_argument, 0, 20},
				   {"create", no_argument, 0, 21},
				   {"header", required_argument, 0, 22},
                                   {"noscale", no_argument, 0, 23},
                                   {"as", no_argument, 0, 24},
				   {"pomeh", required_argument, 0, 25},
                                   {"detectlevel", no_argument, 0, 26},
				   {"spotter", required_argument, 0, 27},
				   {"cut", required_argument, 0, 28},
				   {"nofill", no_argument, 0, 29},
				   {"userm", required_argument, 0, 30},
				   {"rm", required_argument, 0, 31},
				   {"tosigma", required_argument, 0, 32},
				   {"extra-phi", required_argument, 0, 33},
				   {"fdm", required_argument, 0, 34},
				   {"time-delay", required_argument, 0, 35},
				   {"linear-phi", required_argument, 0, 36},
				   {"quite", no_argument, 0, 'q'},
				   {0, 0, 0, 0}
                                  };

  optind = 0; optarg = 0;
  while((op = getopt_long(argc, argv, "hs:i:o:d:b:l:r:p:w:q", long_options, 0)) != EOF)
    switch(op){
      case 's':
	sz = resize((off_t)atof(optarg));
	if (sz <= 0) sz = -1; 
      break;
      
      case 'i':
        iter = (off_t)atof(optarg);
	if (iter <= 0) iter = -1;
      break;
      
      case 'l':
        bl = (off_t)atof(optarg);
	if (bl < 0) bl = 0;
      break;
      
      case 'r':
        br = (off_t)atof(optarg);
	if (br <= 0) br = -1;
      break;
      
      case 'o':
	memset(ResourceFileName, 0, MaxString+1);
	sprintf(ResourceFileName, "%s", optarg);
      break;
      
      case 'd':
	  if( sRes.OutputPath ) {
	    sRes.OutputPath = 0;
	    free(sRes.OutputPath);
	                          }
	  if( !( sRes.OutputPath = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(sRes.OutputPath, optarg, (int)strlen(optarg));
      break;
      
      case 'b':
	  if( sRes.BandCorrFunc ) {
	    sRes.BandCorrFunc = 0;
	    free(sRes.BandCorrFunc);
	                          }
	  if( !( sRes.BandCorrFunc = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(sRes.BandCorrFunc, optarg, (int)strlen(optarg));
      break;
      
      case 'h':
        Help(argv[0]);
      break;
      
      case 'p':
        if (!PrintStrucEntry(optarg)) printf("Unknown fieldname from source file!\n");
	exit(0);
      break;
      
      case 'w':
        wsize = (off_t)atof(optarg);
	if (wsize <= 0) wsize = -1;
      break;
      
      case 11:
       tm = atoi(optarg);
       if (tm == 1 || tm == 0) sRes.BadPointsRec = tm;
      break;
      
      case 12:
       if (!processWriteOption(optarg)) {
        printf("\nError:\nBad argument in option --write !\n");
	exit(1);
       }
      break;
      
      case 13:
        sRes.TimeResolution = atof(optarg);
      break;
      
      case 14:
        sRes.DM = atof(optarg);
      break;
      
      case 15:
        sRes.BandWidth = atof(optarg);
      break;
      
      case 16:
        sRes.RefFrequency = atof(optarg);
      break;
      
      case 17:
        sRes.CenterFrequency = atof(optarg);
      break;
      
      case 18:
        sRes.BandDir = atoi(optarg);
      break;
      
      case 19:
       NoDisp = 1;
       sRes.DM = 0.;
      break;
            
      case 20:
        if (DetectLevel == 0) sRes.ADClevel = atof(optarg);
	 else sRes.ADClevel = 0.;
      break;
      
      case 21:
        CreateSourceFile();
        exit(0);
      break;
      
      case 22:
        sRes.HeaderSize = atoi(optarg);
	if (sRes.HeaderSize < 0) sRes.HeaderSize = 0;
      break;
      
      case 23:
       NoScale = 1;
      break;
      
      case 24:
       ReadAnSig = 1;
      break;
      
      case 25:
	  if( sRes.InterferencesFile ) {
	    sRes.InterferencesFile = 0;
	    free(sRes.InterferencesFile);
	                          }
	  if( !( sRes.InterferencesFile = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(sRes.InterferencesFile, optarg, (int)strlen(optarg));
      break;
      
      case 26:
       DetectLevel = 1;
       sRes.ADClevel = 0.;
      break;
      
      case 27:
        SigLevel = atof(optarg);
	if (SigLevel < 1.) SigLevel = -1.;
      break;
      
      case 28:
        Cut = (off_t)atof(optarg);
	if (Cut < 1) Cut = -1;
      break;
      
      case 29:
       NoFill = 1;
      break;
      
      case 30:
       UseRM = (unsigned char)atoi(optarg);
       if (UseRM > 1) UseRM = 0;
        else UseRM += 1;
      break;
      
      case 31:
        sRes.RM = atof(optarg);
      break;
      
      case 32:
        ToSigma = atof(optarg);
	tos = true;
      break;
      
      case 33:
        Extra_Phi = atof(optarg);
	Extra_Phi *= ((double)M_PI/(double)180.); //   
      break;
      
      case 34:
        sRes.FDM = atof(optarg);
      break;
      
      case 35:
	UseBadpoints = true;
        TimeDelay = TimeDelayParsing(optarg);
      break;
      
      case 36:
        Linear_Phi = atof(optarg);
	if (Linear_Phi < 0) Linear_Phi = 0.;
      break;

      case 'q':
       is_quite = true;
      break;
      
      case '?':
        Help(argv[0]);
      break;
    }

  return(optind);
 }

/*--- ,       ----*/

char *SelectFileName (char * str)
{
 char *s = str;
 int len = (int)strlen(s);
 s += len;
 while (*(--s) != '/' && len--) ;
 return (++s);
 }

/*-----     ----*/

template <class tFormat>
void Write (tFormat m, long size, int razm, char *name, char *ext, int flag)
{
   int out;
   char *outfilename;
   outfilename = new char[MaxString+1];

   memset(outfilename, 0, MaxString+1);
   if (!strcmp(sRes.OutputPath, "\0")) sprintf(outfilename, "%s%s", name, ext);
    else sprintf(outfilename, "%s/%s%s", sRes.OutputPath, SelectFileName(name), ext);
  
   if ( (out = open(outfilename, (flag == 1 ? O_TRUNC : O_APPEND) | O_CREAT | O_WRONLY | O_LARGEFILE, 0644)) == -1 )
      { printf("\nError: Couldn't open file %s for writing!\n", outfilename);
        exit(1);
       }
     else
       {
           lseek(out, 0, SEEK_SET);
	   write(out, m, size*razm);	                                           
           close(out);
        }
	
   memset(m, 0, razm*size);
   	
   delete(outfilename);
 }

/*---------- Read input files ------------------*/

void ReadSrc (off_t l, long size, char *argv[], int next)
{
  int file;
  TYPE *data;

     data = new TYPE[size];
     if (!data) { printf("Not enough memory!\n"); exit(1); }

  for (int f=next; f<next+4; f++) {

     memset(data, 0, size*sizeof(TYPE));
     memset(mass_in[f-next], 0, (ReadAnSig == 0 ? 2 : 1)*size*sizeof(float));
       
       if ( (file = open(argv[f], O_RDONLY | O_LARGEFILE)) == -1 )
         { printf("\nError:\nCouldn't open \"%s\" for reading!\n", argv[f]); exit(1);  }
	 
        if (lseek(file, (off_t)sRes.HeaderSize + l*sizeof(TYPE), SEEK_SET) == -1 )
	 { printf("\nError:\nWrong execution of lseek() in file \"%s\"!\n", argv[f]); exit(1); }
	read(file, data, size*sizeof(TYPE));
        close(file);

   for (long q=0, k=0;q<size;q++, k+=(ReadAnSig == 0 ? 2 : 1)) {
	
  #ifdef _FR_SUN
   #ifdef _TO_INTELPC
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
  
  #ifdef _FR_INTELPC
   #ifdef _TO_SUN
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
             mass_in[f-next][k] = ( k%2 == 0 || (k%2 == 1 && NoFill == 0) ? (float)(data[q]) - sRes.ADClevel : 0 );
	     
	                                  }		
  } // f 

    delete(data);	
 }
     
/*====================== Main Function ===================================*/
  
int main ( int argc, char *argv[] )
 {
   struct stat info;
   int next;
   off_t Size, truesize, step, left, diff, ost;
   float *DetSig, *RealSig, level[4];

   if (argc == 1) Help(argv[0]); 

   /* Making this process to be able to create files larger than 2GB */
   struct rlimit r;
    
   r.rlim_cur = r.rlim_max = RLIM_INFINITY;
   setrlimit(RLIMIT_FSIZE,&r);
   /*------------------------------------------*/

   ResourceFileName = new char[MaxString+1];
   if (!ResourceFileName) { printf("Not enough memory!\n"); exit(1); }
   memset(ResourceFileName, 0, MaxString+1);
   sprintf(ResourceFileName, "%s", "source.set");

   ParseCmdLine(argc, argv);

   if (strcmp(ResourceFileName, "no")) ReadFromRes();   
   
   next = ParseCmdLine(argc, argv);
   if (argc < next + 1) { printf("\nError:\nNot point the file(s) to process!\n"); exit(1); }

   //    --time-delay  ,    DM,  RM,  FDM
   if (UseBadpoints) FaradayCalc();

   if (sRes.RefFrequency > sRes.CenterFrequency + sRes.BandWidth/2. || sRes.RefFrequency < sRes.CenterFrequency - sRes.BandWidth/2.)
    sRes.RefFrequency = sRes.CenterFrequency;

   if ( stat(argv[next], &info) != 0 ) {
     printf("\nError:\nCouldn't open \"%s\"!\n", argv[next]); exit(1); }

  Size = (info.st_size - (off_t)sRes.HeaderSize)/((ReadAnSig == 0 ? 1 : 2) * sizeof(TYPE));
  if (Size <= 0) { printf("\nError:\nSize of header is to much!\n"); exit(1); }
  printf("\nSize of file(s)\t= %lld\n", Size);
  
  if (br == -1 || br > Size) br = Size;
  if (bl >= br) bl = 0;
  Size = br - bl;

  printf("Left\t\t= %lld\nRight\t\t= %lld\n", bl, br);
  
  if (sz == -1 || sz > Size) sz = resize(Size);
   if (sz <= ShowDispersionInd(0) && NoDisp == 0) { printf("\nError:\nSize of FFT (%lld) is less then number of bad points (%u)!\n", sz, ShowDispersionInd(0)); exit(1); }
  
  step = sz - (off_t)ShowDispersionInd(0);
  if (iter == -1 || iter > (off_t)ceil(((double)(Size - (off_t)ShowDispersionInd(0)))/((double)(step)))) iter = (off_t)ceil(((double)(Size - (off_t)ShowDispersionInd(0)))/((double)(step)));

  truesize = (iter < (off_t)ceil(((double)(Size - (off_t)ShowDispersionInd(0)))/((double)(step))) ? iter*step+(off_t)ShowDispersionInd(0) : Size) - (sRes.BadPointsRec == 0 ? (off_t)ShowDispersionInd(0) : 0);
  printf("Size to process\t= %lld  -->\n", (sRes.BadPointsRec == 0 ? truesize + (off_t)ShowDispersionInd(0) : truesize) );

  wsize = (wsize == -1 ? truesize : (wsize >= truesize ? truesize : wsize));
  ost = truesize - ((off_t)floor((double)(truesize)/(double)(wsize)))*wsize;
  if (ost != 0) printf("  --> %lld block(s) of size = %lld + 1 block of size = %lld\n", (off_t)floor((double)(truesize)/(double)(wsize)), wsize, ost);
   else printf("  --> write %lld block(s) of size = %lld\n", truesize/wsize, wsize);

  if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) {
    matrix = new float[2*(((Nch*sz)/2) + 1)];
    if (!matrix) { printf("Not enough memory!\n"); exit(1); }
   }

  if (strcmp(sRes.BandCorrFunc, "no") && strcmp(sRes.InterferencesFile, "no")) PomexFileRead();

   char* tdp;
   tdp = new char[MaxString+1];
   if (!tdp) { printf("Not enough memory!\n"); exit(1); }
   memset(tdp, 0, MaxString+1);

   ComputeMatrix(Nch*sz);
   printf("\n%s\t= %g %s  %s    %s\n", (UseRM == 0 ? "Dispersion" : (UseRM == 1 ? "Faraday RM" : "Faraday Delay")), (UseRM == 0 ? sRes.DM : (UseRM == 1 ? sRes.RM : sRes.FDM)), (UseRM == 0 ? "pc/cm^3" : (UseRM == 1 ? "rad/m^2" : "rad")), (NoDisp == 0 ? "" : "(not consider)"), (UseBadpoints ? "[set from --time-delay]  " : ""));
   printf("%s\t= %ld [%ld + %ld] count%s  [ %s ]  - %s", (UseRM == 0 ? "BadPoints" : "Time Delay"), ShowDispersion(0), ShowDispersion(+1), ShowDispersion(-1), ShowDispersion(0) > 1 ? "s" : "", TimeDelayPresentation (TimeDelay, tdp), (sRes.BadPointsRec == 1 ? "write" : "not write"));
   if (UseBadpoints) printf("    [use --time-delay]\n\n");
    else printf("\n\n");
   printf("Center Freq.\t= %g MHz  [Ref. Frequency = %g MHz]\n", sRes.CenterFrequency, sRes.RefFrequency);
   printf("BandWidth\t= %g MHz\n", sRes.BandWidth);
   printf("Time Resolution\t= %g ns\n", sRes.TimeResolution);
   printf("\nSize of slice\t= %lld\nIterations\t= %lld\nForm of band\t- %s\n", sz, iter, (sRes.BandDir == 0 ? "direct" : "inverse"));
   printf("BandCorrection\t= %s\n", sRes.BandCorrFunc);
   printf("Interferences\t= %s\n", (strcmp(sRes.BandCorrFunc, "no") ? sRes.InterferencesFile : "no"));
   if (SigLevel == -1.) printf("Black Spotter\t= off\n"); else printf("Black Spotter\t= on (%.3g sigma)\n", SigLevel);

   if (Cut > (Nch*sz)/2 + 1) Cut = (Nch*sz)/2 + 1;
   if (Cut == -1) printf("CutHarmonics\t= no\n\n"); else printf("CutHarmonics\t= %lld, Fmax = %.3g Hz\n\n", Cut, (1.e9/(sRes.TimeResolution*sz))*Cut );

   mass_in = new float*[Nch];
   for (int i=0; i<Nch; i++) { 
     mass_in[i] = new float[2*sz]; 
     if (!mass_in[i]) { printf("Not enough memory!\n"); exit(1); }
   }

   mass_out = new float[Nch*2*sz];

   tru = new float[Nch*2*wsize];
   if (!mass_out || !tru) { printf("Not enough memory!\n"); exit(1); }

   x = (fftwf_complex *) fftwf_malloc (sizeof(fftwf_complex) * 2 * sz);
   y = (fftwf_complex *) fftwf_malloc (sizeof(fftwf_complex) * 2 * sz * Nch);
   z = (fftwf_complex *) fftwf_malloc (sizeof(fftwf_complex) * 2 * sz * Nch);
   if (!x || !y || !z) { printf("Not enough memory!\n"); exit(1); }

   pfor = fftwf_plan_dft_1d (sz, x, x, FFTW_FORWARD, FFTW_ESTIMATE);
   prev = fftwf_plan_dft_1d (Nch*sz, z, y, FFTW_BACKWARD, FFTW_ESTIMATE);

   if (sRes.WriteDetectedSignal == 1) {
           DetSig = new float[Nch*wsize];
           if (!DetSig) { printf("Not enough memory!\n"); exit(1); }
    }
    
   if (sRes.WriteRealSignal == 1) {
           RealSig = new float[Nch*wsize];
           if (!RealSig) { printf("Not enough memory!\n"); exit(1); }
    }
   
printf("Processing... \n"); fflush(NULL);

 memset(tru, 0, sizeof(float)*2*wsize*Nch);
 if (sRes.WriteDetectedSignal == 1) memset(DetSig, 0, sizeof(float)*wsize*Nch);
 if (sRes.WriteRealSignal == 1) memset(RealSig, 0, sizeof(float)*wsize*Nch);

 for(off_t t=0;t<iter;t++) {

   if (!is_quite) { printf(".%5d", t+1); fflush(NULL); }

   left = step*t;
   if (left + sz > (sRes.BadPointsRec == 1 ? truesize : truesize + (off_t)ShowDispersionInd(0))) {
     diff = left + sz - (sRes.BadPointsRec == 1 ? truesize : truesize + (off_t)ShowDispersionInd(0));
     left -= diff;
    } else diff = 0;

    ReadSrc((ReadAnSig == 0 ? bl + left : 2*(bl + left)), (ReadAnSig == 0 ? sz : 2*sz), argv, next);
    if (DetectLevel == 1) { 
     if (t == 0) { 
      for (int w=0; w<Nch; w++) level[w] = NoiseLevel(mass_in[w], (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? sz : 2*sz), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? 2 : 1));
     }
     for (int w=0; w<Nch; w++) LevelEliminate(mass_in[w], level[w], (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? sz : 2*sz), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? 2 : 1));
                           }
    if (tos) for (int w=0; w<Nch; w++) CorrectionOfSigma(mass_in[w], sz, ToSigma);
    
    DeDispersionProc(sz);

 if (sRes.WriteAnalyticSignal == 1) {
    for (off_t j=2*(sRes.BadPointsRec == 1 && t == 0 ? 0 : Nch*(off_t)ShowDispersionInd(+1)) + Nch*2*diff, l=(sRes.BadPointsRec == 1 && t != 0 ? Nch*(off_t)ShowDispersionInd(+1) : 0)+Nch*(left+diff); j<2*(sRes.BadPointsRec == 1 && t == iter-1 ? Nch*sz : Nch*(sz - (off_t)ShowDispersionInd(-1))); j+=2, l++) {
     tru[2*(l%(Nch*wsize))]    = (float)( (NoScale == 0 ? 2. : 1.) * mass_out[j] );
     tru[2*(l%(Nch*wsize)) +1] = (float)( (NoScale == 0 ? 2. : 1.) * mass_out[j+1]);
     if ((l+1)%(Nch*wsize) == 0) Write (tru, Nch*2*wsize, sizeof(float), argv[next+Nch-1], sRes.AnalyticSignalFileExtension, (l+1)/(Nch*wsize)); 
     }
  }
     
 if (sRes.WriteDetectedSignal == 1) {
    for (off_t j=2*(sRes.BadPointsRec == 1 && t == 0 ? 0 : Nch*(off_t)ShowDispersionInd(+1)) + Nch*2*diff, l=(sRes.BadPointsRec == 1 && t != 0 ? Nch*(off_t)ShowDispersionInd(+1) : 0)+Nch*(left+diff); j<2*(sRes.BadPointsRec == 1 && t == iter-1 ? Nch*sz : Nch*(sz - (off_t)ShowDispersionInd(-1))); j+=2, l++) {    
     DetSig[l%(Nch*wsize)] = (NoScale == 0 ? 4. : 1.) * (mass_out[j]*mass_out[j] + mass_out[j+1]*mass_out[j+1]);
     if ((l+1)%(Nch*wsize) == 0) Write (DetSig, Nch*wsize, sizeof(float), argv[next+Nch-1], sRes.DetectedSignalFileExtension, (l+1)/(Nch*wsize)); 
     }
  }
  
 if (sRes.WriteRealSignal == 1) {
    for (off_t j=2*(sRes.BadPointsRec == 1 && t == 0 ? 0 : Nch*(off_t)ShowDispersionInd(+1)) + Nch*2*diff, l=(sRes.BadPointsRec == 1 && t != 0 ? Nch*(off_t)ShowDispersionInd(+1) : 0)+Nch*(left+diff); j<2*(sRes.BadPointsRec == 1 && t == iter-1 ? Nch*sz : Nch*(sz - (off_t)ShowDispersionInd(-1))); j+=2, l++) {
     RealSig[l%(Nch*wsize)] = (NoScale == 0 ? 2. : 1.) * mass_out[j];
     if ((l+1)%(Nch*wsize) == 0) Write (RealSig, Nch*wsize, sizeof(float), argv[next+Nch-1], sRes.RealSignalFileExtension, (l+1)/(Nch*wsize)); 
     }
  }
    if (!is_quite) { printf("\b\b\b\b\b"); fflush(NULL); }
    
 } //    

/*----------   ()  -----------*/

  printf(" writing... ");
  fflush(NULL);
  
  if (ost != 0) {
  
  if (sRes.WriteAnalyticSignal == 1)
   Write (tru, Nch*2*ost, sizeof(float), argv[next+Nch-1], sRes.AnalyticSignalFileExtension, 2);
				      
  if (sRes.WriteDetectedSignal == 1)   
   Write (DetSig, Nch*ost, sizeof(float), argv[next+Nch-1], sRes.DetectedSignalFileExtension, 2);
				      
  if (sRes.WriteRealSignal == 1)
   Write (RealSig, Nch*ost, sizeof(float), argv[next+Nch-1], sRes.RealSignalFileExtension, 2);
                 }

  printf("done\n");
 


  delete(mass_out);
  delete [] mass_in;
  fftwf_destroy_plan (pfor);
  fftwf_destroy_plan (prev);
  fftwf_free (x);
  fftwf_free (y);
  fftwf_free (z);
  if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) delete(matrix);
  if (strcmp(sRes.BandCorrFunc, "no") && strcmp(sRes.InterferencesFile, "no")) delete(pomArray);
  delete(tru);
   if (sRes.WriteDetectedSignal == 1) delete(DetSig);
   if (sRes.WriteRealSignal == 1) delete(RealSig);
  delete(ResourceFileName);
  delete(tdp);

  return 0;
}

