#define MAIN_
#include "readme.hpp"
#include "undisp.hpp"   

float *matrix;
float *mass;
float *tru;
long iter = -1, sz = -1, bl = 0, br = -1, wsize = -1, Cut = -1;
unsigned char NoDisp = 0, NoScale = 0, ReadAnSig = 0, DetectLevel = 0, NoFill = 0, UseRM = 0;
double SigLevel = -1., sigma = -1., ToSigma, Extra_Phi = 0.;
bool tos = false, UseBadpoints = false;
double TimeDelay = 0.;

/*------------------------------------------------------------------------
td -   
source - ,      
    
     :
23.12 ns
      mcs
      ms
      sec
      min
      hrs
      days
---------------------------------------------------------------------------*/
char* TimeDelayPresentation (double td, char* source) {
 double time = td * sRes.TimeResolution;  /*    */
 
 const char* tk[] = { "ns", "mcs", "ms", "sec", "min", "hrs", "days" };
 const unsigned short dv[] = { 1000, 1000, 1000, 60, 60, 24 };
 int i = 0;
 
 for (i=0; i<6; ++i) {
  if (time < (double)dv[i]) { sprintf(source, "%g %s", time, tk[i]); break; }
  time /= (double)dv[i];
 }
 if (i == 6) sprintf(source, "%g %s", time, tk[i]);
 return source;
}

/*---------------------------------------------------------------------------
    --time-delay
   -    
      , 
  :
12.34n  - 
     c  - 
     m  - 
     S  - 
     M  - 
     H  - 
     D  -   
------------------------------------------------------------------------------*/
double TimeDelayParsing (char* str) {
 double td;
 //    
 if (isdigit(str[strlen(str)-1]) != 0 || str[strlen(str)-1] == '.') {
   td = atof(str);
   return td;
 }
 char* dest;
 dest = new char[MaxString+1];
 if (!dest) { printf("Not enough memory!\n"); exit(1); }
 memset(dest, 0, MaxString+1);
 strncpy(dest, str, strlen(str)-1);
 td = atof(dest);
 delete(dest);
 
 switch (str[strlen(str)-1]) {
  case 'D': td *= 24;
  case 'H': td *= 60;
  case 'M': td *= 60;
  case 'S': td *= 1000.;
  case 'm': td *= 1000.;
  case 'c': td *= 1000.;
  case 'n': break;
  default: printf("Error:\nWrong character %c in argument %s of --time-delay option!\n", str[strlen(str)-1], str);
           exit(1);
 } // switch  
 td /= sRes.TimeResolution;  //  TimeDelay  
 return td;
}

/*-------------------------------------------------------------------------
   RM  FDM   DM   
--------------------------------------------------------------------------*/
void FaradayCalc () {

 double tbad, f, f1;

 f  = sRes.BandDir == 0 ? (double)sRes.RefFrequency : (double)(sRes.RefFrequency - sRes.BandWidth);
 f1 = sRes.BandDir == 0 ? (double)(sRes.RefFrequency + sRes.BandWidth) : sRes.RefFrequency; 

 /* --      ,                      -----
 -----           DM,  RM,  FDM --*/
 switch (UseRM) {
  /*    */
  case 0: sRes.DM = fabs( TimeDelay / ( (((ALPHA2/(sRes.TimeResolution * 1000.))/f)/f) - (((ALPHA2/(sRes.TimeResolution * 1000.))/f1)/f1)) );  
          break;
  /*    */
  case 1: sRes.RM = (TimeDelay * 1.e6 ) / ( ((((BETA2/(sRes.TimeResolution * 1000.))/f)/f)/f) - ((((BETA2/(sRes.TimeResolution * 1000.))/f1)/f1)/f1) );
          break;
  /*  FDM */	  
  case 2: sRes.FDM = ( 2. * M_PI * TimeDelay * sRes.TimeResolution ) / ( 1000./f - 1000./f1 );
          break;
  default: break;	  
 } // switch
}

/*------- DeDispersion Procedure Functions --------------*/
unsigned long ShowDispersion () {

double tbad, f, f1;

 //      ,      
 if (UseBadpoints) return (unsigned long)ceil(fabs(TimeDelay));

 /*--   --*/
 // f = (double)(sRes.LowerFrequency);
 f  = sRes.BandDir == 0 ? (double)sRes.RefFrequency : (double)(sRes.RefFrequency - sRes.BandWidth);
 f1 = sRes.BandDir == 0 ? (double)(sRes.RefFrequency + sRes.BandWidth) : sRes.RefFrequency;

 switch (UseRM) {
  /*     */
  case 0:
          /*--   --*/
          //   tbad = sRes.DM * ALPHA2 * ( 1./(f * f) - 1./((sRes.LowerFrequency + sRes.BandWidth) * (sRes.LowerFrequency + sRes.BandWidth)) );
          tbad = sRes.DM * ALPHA2 * ( 1./(f * f) - 1./(f1 * f1) );
          TimeDelay = (tbad * 0.001)/sRes.TimeResolution;
          break;
  /*     */
  case 1:
          /*--   --*/
          // tbad = sRes.RM * BETA2 * ( 1./(f * f * f) - 1./((sRes.LowerFrequency + sRes.BandWidth) * (sRes.LowerFrequency + sRes.BandWidth) * (sRes.LowerFrequency + sRes.BandWidth)) );
          tbad = sRes.RM * BETA2 * ( 1./(f * f * f) - 1./(f1 * f1 * f1) );
          TimeDelay = (tbad * 1.e-9)/sRes.TimeResolution;
          break;
  /*   FDM */	  
  case 2:
          tbad = (sRes.FDM / (2.*M_PI)) * ( 1./f - 1./f1 );
          TimeDelay = (tbad * 1000.)/sRes.TimeResolution;
          break;
  default: break;	  
 }

 //  , .. RM  FDM   
 return (unsigned long)ceil(fabs(TimeDelay));
}

double Calc (long j) {
double z, index, sign, T, freq;

T = ((sRes.TimeResolution) * ((double)sz))/((double)(1.e3));
/*--   --*/
//freq = (sRes.BandDir == 0 ? sRes.LowerFrequency : sRes.LowerFrequency + sRes.BandWidth);
/*--   --*/
freq = sRes.RefFrequency;
sign = (sRes.BandDir == 0 ? 1. : -1.);
index = 1.e6;

/*--   --
//    
if (UseRM == 0) z = ( ( ( ( ALPHA1 * sRes.DM ) / ( freq + (sign)*(( ((double)(j)) )/T)) ) / (T * T * freq * freq * index) ) * ((double)(j)) ) * ((double)(j));
//    
 else z = ( ( ( ( ( ( ( BETA1 * sRes.RM ) / ( T * freq * index ) ) * ( ( ( 3 * freq * T )/((double)j) ) + 2*(sign) ) ) / ( ( freq + (sign*((double)j))/T ) * ( freq + (sign*((double)j))/T ) ) ) / ( T * T * freq * freq * index ) ) * ((double)(j)) ) * ((double)(j)) ) * ((double)(j));
---*/

/*---    DM ,  RM ( FDM)    ----*/
/*---         LowerFrequency ---*/
 switch (UseRM) {
  /*     */
  case 0:
          z = ( ( ( ( ALPHA1 * sRes.DM ) / ( freq + (sign)*(( ((double)(j)) )/T)) ) / (T * T * freq * freq * index) ) * ((double)(j)) ) * ((double)(j)) + ( ALPHA1 * sRes.DM * DeltaF ) / freq / (freq - DeltaF) / index;
          break;
  /*     */
  case 1:
          if (j == 0) z = 0.;
           else z = ( ( ( ( ( ( ( BETA1 * sRes.RM ) / ( T * freq * index ) ) * ( ( ( 3. * freq * T )/((double)j) ) + 2. * (sign) ) ) / ( ( freq + (sign*((double)j))/T ) * ( freq + (sign*((double)j))/T ) ) ) / ( T * T * freq * freq * index ) ) * ((double)(j)) ) * ((double)(j)) ) * ((double)(j));
          break;
  /*   FDM */	  
  case 2:
          z = sRes.FDM;
          break;
  default: break;	  
 }

 return z;
}

void ComputeMatrix ( long sz )
{
 double z;
 
/* ----------  Band Correction ---------- */

float * band;

if (strcmp(sRes.BandCorrFunc, "no")) {

 struct stat inform; 
 int in;
 long bs;

   if ( stat(sRes.BandCorrFunc, &inform) != 0 ) {
      printf("\nError:\nCouldn't open file \"%s\" with band correction function !\n", sRes.BandCorrFunc); exit(1); }
      
 bs = inform.st_size/sizeof(float);
 band = new float[(bs > sz/2 + 1 ? bs : sz/2 + 1)];
 if ( !band ) { printf("Not enough memory!\n"); exit(1); }

  if ( (in = open(sRes.BandCorrFunc, O_RDONLY)) == -1 ) {
    printf("Error: Couldn't open %s for reading!\n", sRes.BandCorrFunc); exit(1); }
    
             lseek(in, 0, SEEK_SET);
	     read(in, band, inform.st_size);
	     close(in);
				       
 if (bs != sz/2 + 1) {
      printf("\n- Warning ! -\n"
             "Size = %ld of band correction function and size = %ld\n"
             "of dispersion matrix don't match !\n"
             "...interpolation begin...", bs, sz/2 + 1); 
      fflush(NULL);
      BandInterpolation(band, bs, sz/2 + 1);
      printf("done\n\n");
                                                }
 if (strcmp(sRes.InterferencesFile, "no")) PomexFileCorrect(bs, sz/2 + 1);
				       }
 
/*------------------------------------------------ */

  float sign;
  sign = (sRes.BandDir == 0 ? -1. : 1.);
  
 if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) {
    for (long i=0, j=0; i < 2*(sz/2 + 1); i+=2, j++)
      {
        if (NoDisp == 0) z = Calc(j);
        matrix[i] = (!strcmp(sRes.BandCorrFunc, "no") ? ((float)cos(z + Extra_Phi)) : ( NoDisp == 0 ? ((float)cos(z + Extra_Phi)) * band[j] : band[j] ) );
        matrix[i+1] = (!strcmp(sRes.BandCorrFunc, "no") ? (sign)*((float)sin(z + Extra_Phi)) : ( NoDisp == 0 ? (sign)*((float)sin(z + Extra_Phi)) * band[j] : band[j] ) );
       }
   }
       
   if (strcmp(sRes.BandCorrFunc, "no")) delete(band);
 }

void DeDispersionProc ( long sz )
{

 float real;

  NegHarmTransPos(mass, sz, 1);  
  FFT(mass, sz, 1, 1.);

 if (Cut != -1) for (long i=0;i<2*Cut;i++) mass[i] = 0.;
 if (SigLevel != -1. && sigma == -1.) sigma = SpectrumSigmaCalc(mass, sz/2 + 1);
 if (SigLevel != -1.) SoftBlackSpotter(mass, sz/2 + 1);

 if (strcmp(sRes.BandCorrFunc, "no") && strcmp(sRes.InterferencesFile, "no"))
   PomexCorrectionFunc(mass, sz/2 + 1);
  
 if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) {
  for (long i=0;i<2*(sz/2 + 1);i+=2)
   {   
    real = mass[i];
    mass[i]   = real * matrix[i]   - matrix[i+1] * mass[i+1] ;
    mass[i+1] = real * matrix[i+1] + matrix[i]   * mass[i+1] ;    
    }
  }

  for (long j=2*(sz/2+1);j<2*sz;j++) mass[j] = 0.;
    
  FFT(mass, sz, -1, (float)(1./sz));  
  NegHarmTransPos(mass, sz, -1);
 
}
     
/* ------------------------------------------- */


/*---      ---*/

float NoiseLevel ( float * Massive, long sz, int num )
 {   
  float Sum = 0.;
    for (long i=0;i<num*sz;i+=num) Sum += Massive[i];
    return Sum/sz;
  }

/*-----      -----------*/

void LevelEliminate ( float * Massive, float level, long sz, int num )
{
    for (long i=0;i<num*sz;i+=num) Massive[i] -= level; 
}

/*-------
     sigma   
         
---------*/

void CorrectionOfSigma ( float * x, long sz, double sig ) {
 if (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1)) {
  double s = 0., s2 = 0., cf, our_si;
  for (long i=0; i<2*sz; i+=2) { s += x[i]; s2 += x[i]*x[i]; }
  s /= sz; s2 /= sz;
  our_si = sqrt(s2 - s*s);
  cf = sig / our_si;
  for (long i=0; i<2*sz; i+=2) x[i] *= cf;
 }
 else {
  double sr = 0., si = 0., s2r = 0., s2i = 0., cfr, cfi, our_sir, our_sii;
  for (long i=0; i<2*sz; i+=2) { sr += x[i]; s2r += x[i]*x[i]; si += x[i+1]; s2i += x[i+1]*x[i+1]; }
  sr /= sz; s2r /= sz; si /= sz; s2i /= sz;
  our_sir = sqrt(s2r - sr*sr); our_sii = sqrt(s2i - si*si);
  cfr = sig / our_sir; cfi = sig / our_sii;
  for (long i=0; i<2*sz; i+=2) { x[i] *= cfr; x[i+1] *= cfi; }
 }
}

/*---- ,   (size)  ,
                    2 ------------------------*/

long resize (long sz)
 {
   long n = 0;
   sz += 1;
   while ( (1<<(++n)) < sz) ;
   return (1<<(--n));
  }

/*----
      
 write   
  : --write 111 (  -  ,
   - ,  - )
  1 - , 0 -  
   --write 000    

    : --write +d-a-r (+  , -  ,
   a - , d - , r - )
      .      --write +d,
    (   )
----*/

bool processWriteOption ( char * arg )
{
  //    -   
  if (isdigit(arg[0])) {
   if (strlen(arg) != 3) return false;
   if ((arg[0] != '1' && arg[0] != '0') ||
       (arg[1] != '1' && arg[1] != '0') ||
       (arg[2] != '1' && arg[2] != '0') ) return false;

   sRes.WriteAnalyticSignal = (arg[0] == '1' ? 1 : 0);
   sRes.WriteDetectedSignal = (arg[1] == '1' ? 1 : 0);
   sRes.WriteRealSignal = (arg[2] == '1' ? 1 : 0);
   
   return true;
  }
  
  //   ,  +  -
  if (arg[0] == '+' || arg[0] == '-') {
   if (strlen(arg)%2 != 0) return false;
   int sign;
   for (int i=0;i<strlen(arg);i+=2) {
    if (arg[i] == '+') sign = 1; else sign = 0;
    switch (arg[i+1]) {
     case 'a': sRes.WriteAnalyticSignal = sign;
               break;
     case 'd': sRes.WriteDetectedSignal = sign;
               break;	
     case 'r': sRes.WriteRealSignal = sign;
               break;
     default: return false;
    } // switch
   } // for
    return true;
  }

  // 
  return false;
}

   
/*==========================Prompting===================================*/

void Help ( char *s )
 {
  printf("\nPROGRAMM %s\n"
         "It is used to make dispersion removal technique\n"
	 "Some options repeat the fieldnames of source file, in case when\n"
	 "some value is pointed in both source file and command line, value\n"
	 "from command line is used\n\n"
	 "[USAGE]: %s [options] <file(s) to process>\n\n"
	 "[OPTIONS]:\n"
	 "-o, --source <filename>       - name of source file, default \"source.set\"\n"
	 "                                If filename = no then source file won't be used and\n"
	 "                                all parameters are inputed from command line\n"
	 "--create                      - create source file with name and destination pointed\n"
	 "                                before in -o or --source option. Otherwise, source\n"
	 "                                file \"source.set\" will be created in current directory\n"
	 "--userm      <0|1>            - to correct for rotation measure or faraday delay measure\n"
	 "                                instead of dispersion measure. 0 - to correct for RM,\n"
	 "                                1 - for faraday delay measure\n"
	 "-d, --path   <path>           - path to the output file(s), default - the same\n"
	 "                                where are the source files\n"
	 "-b, --band   <filename>       - name of file with band correction function\n"
	 "                                If filename = no then band correction won't be made\n"
	 "                                default - no\n"
	 "--pomeh      <filename>       - name of file with information of interferences\n"
	 "                                in the power spectrum of input record(s)\n"
	 "                                This file is in text format (for more information\n"
	 "                                see some example of it). If filename = no then\n"
	 "                                interference correction won't be made, default - no\n"
	 "                                Without the file of band correction this option\n"
	 "                                has no effect\n"
	 "-p, --print  <fieldname>      - Output the value of fieldname from source file\n"
	 "--header     <value>          - Size of header (in bytes) of processed files\n"
	 "                                default - 0\n"
	 "-l, --left   <left boundary>  - left boundary of used window, default - 0\n"
	 "-r, --right  <right boundary> - right boundary of used window, default - equal\n"
	 "                                to size of file (in points)\n"
	 "-s, --slice  <size of slice>  - size of slice ; default - equal to size of\n"
	 "                                file (in points) -- find downwards the nearest\n"
	 "                                power of 2 !\n"
	 "-w, --size   <size of block>  - size of block to record in case of large files.\n"
	 "                                If it's pointed then dest file(s) are forming by\n"
	 "                                appending consecutively the blocks of selected size;\n"
	 "                                default - equal to size of file (in points)\n"
	 "-i, --iter   <number of iter> - number of iterations\n"
	 "--bad        <value>          - to write or not bad points. Default, bad points are not written.\n"
	 "                                If value is 1 then bad points will be written, 0 - otherwise.\n"
	 "--write      <format>         - set kind of output file(s) to be written.\n"
	 "                                There are two forms of format argumnent. The first one\n"
	 "                                is digit form. You need to write 3 digits, each of them\n"
	 "                                has to be 1 or 0. 1 means to write this kind of file, and 0 - not.\n"
	 "                                The first digit sets the analytical signal, the second - detected\n"
	 "                                signal, and the third - the real part of analytical signal.\n"	 
	 "                                For example, one can write format as 011.\n"
	 "                                This means that analytical signal won't be written, and detected\n"
	 "                                signal and the real part of analytical signal will be written.\n"
	 "                                The second form is symbol form. The true symbols are +,-,a,d,r.\n"
	 "                                + - to write this kind of file, - - not to write, a - analytical signal,\n"
	 "                                d - detected signal, r - real part of analytical signal.\n"
	 "                                So, one can write format as +d-a-r or simply +d.\n"
	 "                                The +d record sets detected signal to be written and other kinds are\n"
	 "                                ignored, i.e. the information will be taken from configuration file.\n"
	 "--nodisp                      - not make dispersion removing, only band correction\n"
	 "                                (if option -b don't equal to no) or simply procedures\n"
	 "                                of detection, analytical signal making...\n"
	 "--timeres    <value>          - set time resolution (in nanosec), default - 31.25\n"
	 "--dm         <value>          - set pulsar DM (dispersion measure) in pc/cm^3,\n"
	 "                                default - 480.\n"
	 "--rm         <value>          - set pulsar RM (rotation measure) in rad/m^2\n"
	 "                                default - -611.\n"
	 "--fdm        <value>          - set pulsar FDM (faraday delay measure) in rad\n"
	 "                                default - 0.\n"
	 "--bw         <value>          - set receiver bandwidth (in MHz), default - 16.\n"
	 "--reffreq    <value>          - set reference frequency (in MHz), default - 1634.\n"
	 "--lowfreq    <value>          - set receiver lower frequency (in MHz)\n"
	 "                                default - reference frequency is used for direct\n"
	 "                                band and reference frequence minus bandwidth for\n"
	 "                                inverse band\n"
	 "--banddir    <value>          - set band direction, 0 - direct, 1 - inverse;\n"
	 "                                default - 0\n"
	 "--level      <value>          - set ADC level, default - 2048.\n"
	 "--detectlevel                 - if this option is pointed then option --level will be\n"
	 "                                ignored and programm itself will detect level in first\n"
	 "                                iteration on size of slice and will use this level in\n"
	 "                                other iterations while process runs\n"
	 "--noscale                     - not make scaling in output file(s), i.e. don't\n"
	 "                                multiply to 2. for analytical signal and its real\n"
	 "                                part and to 4. for detected signal\n"
	 "                                default - making scaling\n"
	 "--spotter    <value>          - this option set the mode of soft black spotter,\n"
	 "                                value is number of sigma for using interference\n"
	 "                                cut level\n"
	 "--cut        <value>          - cut <value> of harmonics in amplitude spectrum, i.e.\n"
	 "                                set them to zero\n"
	 "--as                          - input file is the analytical signal, i.e. with the\n"
	 "                                interchange of real and imaginary parts\n"
	 "--nofill                      - don't use the imaginary part of analytical signal\n"
	 "                                default - use (if option --as is set up)\n"
	 "--tosigma    <value>          - to bring current sigma in each input slice to sigma\n"
	 "                                equal to stated value\n"
	 "--extra-phi  <value>          - extra phase delay in degrees during dedispersion\n"
	 "--time-delay <value>          - set the value of time-delay within the receiver bandwidth, or\n"
	 "                                so-called the value of ``badpoints''. If <value> is presented\n"
	 "                                only by real number, then <value> is time delay in units of counts.\n"
	 "                                If <value> is real number + one of the letters 'n', 'c', 'm', 'S', 'M',\n"
	 "                                'H' or 'D', then <value> is time delay in nanoseconds, microseconds,\n"
	 "                                milliseconds, seconds, minutes, hours or days, correspondingly.\n"
	 "                                This option is used to calculate the value of DM (or RM in case of\n"
	 "                                using option --use-rm). If option --use-rm is used, then <value> can\n"
	 "                                be as positive, as negative, otherwise the absolute value of <value>\n"
	 "                                us used. The value of badpoints in counts is rounded up to the\n"
	 "                                nearest integer\n"
	 "-v, --version                 - print version information\n"
	 "-h, --help                    - help\n\n", s, s);
  exit(0);
 }

/*===================Parsing the command line===========================*/

int ParseCmdLine( int argc, char *argv[] )
 {
  int op, tm;
  struct option long_options[] = { {"help", no_argument, 0, 'h'},
                                   {"version", no_argument, 0, 'v'},
				   {"slice", required_argument, 0, 's'},
				   {"iter", required_argument, 0, 'i'},
				   {"source", required_argument, 0, 'o'},
				   {"path", required_argument, 0, 'd'},
				   {"band", required_argument, 0, 'b'},
				   {"left", required_argument, 0, 'l'},
				   {"right", required_argument, 0, 'r'},
				   {"print", required_argument, 0, 'p'},
				   {"size", required_argument, 0, 'w'},
                                   {"bad", required_argument, 0, 11},
                                   {"write", required_argument, 0, 12},				   
				   {"timeres", required_argument, 0, 13},
				   {"dm", required_argument, 0, 14},
				   {"bw", required_argument, 0, 15},
				   {"reffreq", required_argument, 0, 16},
				   {"lowfreq", required_argument, 0, 17},
				   {"banddir", required_argument, 0, 18},
                                   {"nodisp", no_argument, 0, 19},
				   {"level", required_argument, 0, 20},
				   {"create", no_argument, 0, 21},
				   {"header", required_argument, 0, 22},
                                   {"noscale", no_argument, 0, 23},
                                   {"as", no_argument, 0, 24},
				   {"pomeh", required_argument, 0, 25},
                                   {"detectlevel", no_argument, 0, 26},
				   {"spotter", required_argument, 0, 27},
				   {"cut", required_argument, 0, 28},
				   {"nofill", no_argument, 0, 29},
				   {"userm", required_argument, 0, 30},
				   {"rm", required_argument, 0, 31},
				   {"tosigma", required_argument, 0, 32},
				   {"extra-phi", required_argument, 0, 33},
				   {"fdm", required_argument, 0, 34},
				   {"time-delay", required_argument, 0, 35},
				   {0, 0, 0, 0}
                                  };

  optind = 0; optarg = 0;
  while((op = getopt_long(argc, argv, "hvs:i:o:d:b:l:r:p:w:", long_options, 0)) != EOF)
    switch(op){
      case 's':
	sz = resize(atol(optarg));
	if (sz <= 0) sz = -1; 
      break;
      
      case 'i':
        iter = atol(optarg);
	if (iter <= 0) iter = -1;
      break;
      
      case 'l':
        bl = atol(optarg);
	if (bl < 0) bl = 0;
      break;
      
      case 'r':
        br = atol(optarg);
	if (br <= 0) br = -1;
      break;
      
      case 'o':
	memset(ResourceFileName, 0, MaxString+1);
	sprintf(ResourceFileName, "%s", optarg);
      break;
      
      case 'd':
	  if( sRes.OutputPath ) {
	    sRes.OutputPath = 0;
	    free(sRes.OutputPath);
	                          }
	  if( !( sRes.OutputPath = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(sRes.OutputPath, optarg, (int)strlen(optarg));
      break;
      
      case 'b':
	  if( sRes.BandCorrFunc ) {
	    sRes.BandCorrFunc = 0;
	    free(sRes.BandCorrFunc);
	                          }
	  if( !( sRes.BandCorrFunc = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(sRes.BandCorrFunc, optarg, (int)strlen(optarg));
      break;
      
      case 'h':
        Help(argv[0]);
      break;
      
      case 'v':
        printf("%s - ASC Pulsar Group - %s\n", argv[0], VERSION);
        exit(0);
      break;

      case 'p':
        if (!PrintStrucEntry(optarg)) printf("Unknown fieldname from source file!\n");
	exit(0);
      break;
      
      case 'w':
        wsize = atol(optarg);
	if (wsize <= 0) wsize = -1;
      break;
      
      case 11:
       tm = atoi(optarg);
       if (tm == 1 || tm == 0) sRes.BadPointsRec = tm;
      break;
      
      case 12:
       if (!processWriteOption(optarg)) {
        printf("\nError:\nBad argument in option --write !\n");
	exit(1);
       }
      break;
      
      case 13:
        sRes.TimeResolution = atof(optarg);
      break;
      
      case 14:
        sRes.DM = atof(optarg);
      break;
      
      case 15:
        sRes.BandWidth = atof(optarg);
      break;
      
      case 16:
        sRes.RefFrequency = atof(optarg);
      break;
      
      case 17:
        sRes.LowerFrequency = atof(optarg);
      break;
      
      case 18:
        sRes.BandDir = atoi(optarg);
      break;
      
      case 19:
       NoDisp = 1;
       sRes.DM = 0.;
      break;
            
      case 20:
        if (DetectLevel == 0) sRes.ADClevel = atof(optarg);
	 else sRes.ADClevel = 0.;
      break;
      
      case 21:
        CreateSourceFile();
        exit(0);
      break;
      
      case 22:
        sRes.HeaderSize = atoi(optarg);
	if (sRes.HeaderSize < 0) sRes.HeaderSize = 0;
      break;
      
      case 23:
       NoScale = 1;
      break;
      
      case 24:
       ReadAnSig = 1;
      break;
      
      case 25:
	  if( sRes.InterferencesFile ) {
	    sRes.InterferencesFile = 0;
	    free(sRes.InterferencesFile);
	                          }
	  if( !( sRes.InterferencesFile = (char *)calloc((int)strlen(optarg), sizeof(char *)) ) )
	    { printf("Not enough memory!\n"), exit(1); }
	  memcpy(sRes.InterferencesFile, optarg, (int)strlen(optarg));
      break;
      
      case 26:
       DetectLevel = 1;
       sRes.ADClevel = 0.;
      break;
      
      case 27:
        SigLevel = atof(optarg);
	if (SigLevel < 1.) SigLevel = -1.;
      break;
      
      case 28:
        Cut = atol(optarg);
	if (Cut < 1) Cut = -1;
      break;
      
      case 29:
       NoFill = 1;
      break;
      
      case 30:
       UseRM = (unsigned char)atoi(optarg);
       if (UseRM > 1) UseRM = 0;
        else UseRM += 1;
      break;
      
      case 31:
        sRes.RM = atof(optarg);
      break;
      
      case 32:
        ToSigma = atof(optarg);
	tos = true;
      break;
      
      case 33:
        Extra_Phi = atof(optarg);
	Extra_Phi *= ((double)M_PI/(double)180.); //   
      break;
      
      case 34:
        sRes.FDM = atof(optarg);
      break;
      
      case 35:
	UseBadpoints = true;
        TimeDelay = TimeDelayParsing(optarg);
      break;
      
      case '?':
        Help(argv[0]);
      break;
    }

  return(optind);
 }

/*--- ,       ----*/

char *SelectFileName (char * str)
{
 char *s = str;
 int len = (int)strlen(s);
 s += len;
 while (*(--s) != '/' && len--) ;
 return (++s);
 }

/*-----     ----*/

template <class tFormat>
void Write (tFormat m, long size, int razm, char *name, char *ext, int flag)
{
   int out;
   char *outfilename;
   outfilename = new char[MaxString+1];

   memset(outfilename, 0, MaxString+1);
   if (!strcmp(sRes.OutputPath, "\0")) sprintf(outfilename, "%s%s", name, ext);
    else sprintf(outfilename, "%s/%s%s", sRes.OutputPath, SelectFileName(name), ext);
  
   if ( (out = open(outfilename, (flag == 1 ? O_TRUNC : O_APPEND) | O_CREAT | O_WRONLY | O_LARGEFILE, 0644)) == -1 )
      { printf("\nError: Couldn't open file %s for writing!\n", outfilename);
        exit(1);
       }
     else
       {
           lseek(out, 0, SEEK_SET);
	   write(out, m, size*razm);	                                           
           close(out);
        }
	
   memset(m, 0, razm*size);
   	
   delete(outfilename);
 }

void ReadSrc (long l, long size, char *name)
{
  int file;
  TYPE *data;

     data = new TYPE[size];
     if (!data) { printf("Not enough memory!\n"); exit(1); }

     memset(data, 0, size*sizeof(TYPE));
     memset(mass, 0, (ReadAnSig == 0 ? 2 : 1)*size*sizeof(float));
       
       if ( (file = open(name, O_RDONLY | O_LARGEFILE)) == -1 )
         { printf("\nError:\nCouldn't open \"%s\" for reading!\n", name); exit(1);  }
	 
        if (lseek(file, sRes.HeaderSize + l*sizeof(TYPE), SEEK_SET) == -1 )
	 { printf("\nError:\nWrong execution of lseek() in file \"%s\"!\n", name); exit(1); }
	read(file, data, size*sizeof(TYPE));
        close(file);

   for (long q=0, k=0;q<size;q++, k+=(ReadAnSig == 0 ? 2 : 1)) {
	
  #ifdef _FR_SUN
   #ifdef _TO_INTELPC
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
  
  #ifdef _FR_INTELPC
   #ifdef _TO_SUN
    if (sizeof(TYPE) != 1) data[q] = nh2hn(data[q], sizeof(TYPE));
   #endif
  #endif
             mass[k] = ( k%2 == 0 || (k%2 == 1 && NoFill == 0) ? (float)(data[q]) - sRes.ADClevel : 0 );
	     
	                                  }		
    delete(data);	
 }
     
/*====================== Main Function ===================================*/
  
int main ( int argc, char *argv[] )
 {
   struct stat info;
   int next;
   long Size, truesize, step, left, diff, ost;
   float *DetSig, *RealSig, level;

   if (argc == 1) Help(argv[0]); 

   ResourceFileName = new char[MaxString+1];
   if (!ResourceFileName) { printf("Not enough memory!\n"); exit(1); }
   memset(ResourceFileName, 0, MaxString+1);
   sprintf(ResourceFileName, "%s", "source.set");

   ParseCmdLine(argc, argv);

   if (strcmp(ResourceFileName, "no")) ReadFromRes();   
   
   next = ParseCmdLine(argc, argv);
   if (argc < next + 1) { printf("\nError:\nNot point the file(s) to process!\n"); exit(1); }

   //    --time-delay  ,    DM,  RM,  FDM
   if (UseBadpoints) FaradayCalc();

/*--   --*/
/*
   if (sRes.LowerFrequency == -3.) sRes.LowerFrequency = (sRes.BandDir == 0 ? sRes.RefFrequency : sRes.RefFrequency - sRes.BandWidth);
    else { LowFreqFlagRec = 1;
           DeltaF = sRes.RefFrequency - sRes.LowerFrequency;
          }
*/
   if (sRes.LowerFrequency == -3.) ; 
    else DeltaF = sRes.RefFrequency - sRes.LowerFrequency;

   if ( stat(argv[next], &info) != 0 ) {
     printf("\nError:\nCouldn't open \"%s\"!\n", argv[next]); exit(1); }

  Size = (info.st_size - sRes.HeaderSize)/((ReadAnSig == 0 ? 1 : 2) * sizeof(TYPE));
  if (Size <= 0) { printf("\nError:\nSize of header is to much!\n"); exit(1); }
  printf("\nSize of file(s)\t= %ld\n", Size);
  
  if (br == -1 || br > Size) br = Size;
  if (bl >= br) bl = 0;
  Size = br - bl;

  printf("Left\t\t= %ld\nRight\t\t= %ld\n", bl, br);
  
  if (sz == -1 || sz > Size) sz = resize(Size);
   if (sz <= ShowDispersion() && NoDisp == 0) { printf("\nError:\nSize of FFT (%ld) is less then number of bad points (%u)!\n", sz, ShowDispersion()); exit(1); }
  
  step = sz - ShowDispersion();
  if (iter == -1 || iter > (long)ceil(((double)(Size - ShowDispersion()))/((double)(step)))) iter = (long)ceil(((double)(Size - ShowDispersion()))/((double)(step)));

  truesize = (iter < (long)ceil(((double)(Size - ShowDispersion()))/((double)(step))) ? iter*step+ShowDispersion() : Size) - (sRes.BadPointsRec == 0 ? ShowDispersion() : 0);
  printf("Size to process\t= %ld  -->\n", (sRes.BadPointsRec == 0 ? truesize + ShowDispersion() : truesize) );

  wsize = (wsize == -1 ? truesize : (wsize >= truesize ? truesize : wsize));
  ost = truesize - ((long)floor((double)(truesize)/(double)(wsize)))*wsize;
  if (ost != 0) printf("  --> %ld block(s) of size = %ld + 1 block of size = %ld\n", (int)floor((double)(truesize)/(double)(wsize)), wsize, ost);
   else printf("  --> write %ld block(s) of size = %ld\n", truesize/wsize, wsize);

  if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) {
    matrix = new float[2*(sz/2 + 1)];
    if (!matrix) { printf("Not enough memory!\n"); exit(1); }
   }

  if (strcmp(sRes.BandCorrFunc, "no") && strcmp(sRes.InterferencesFile, "no")) PomexFileRead();

   char* tdp;
   tdp = new char[MaxString+1];
   if (!tdp) { printf("Not enough memory!\n"); exit(1); }
   memset(tdp, 0, MaxString+1);

   ComputeMatrix(sz);
   printf("\n%s\t= %g %s  %s    %s\n", (UseRM == 0 ? "Dispersion" : (UseRM == 1 ? "Faraday RM" : "Faraday Delay")), (UseRM == 0 ? sRes.DM : (UseRM == 1 ? sRes.RM : sRes.FDM)), (UseRM == 0 ? "pc/cm^3" : (UseRM == 1 ? "rad/m^2" : "rad")), (NoDisp == 0 ? "" : "(not consider)"), (UseBadpoints ? "[set from --time-delay]  " : ""));
   printf("%s\t= %ld count%s  [ %s ]  - %s", (UseRM == 0 ? "BadPoints" : "Time Delay"), ShowDispersion(), ShowDispersion() > 1 ? "s" : "", TimeDelayPresentation (TimeDelay, tdp), (sRes.BadPointsRec == 1 ? "write" : "not write"));
   if (UseBadpoints) printf("    [use --time-delay]\n\n");
    else printf("\n\n");
   printf("Ref. Frequency\t= %g MHz\n", sRes.RefFrequency);
   printf("BandWidth\t= %g MHz\n", sRes.BandWidth);
   printf("Time Resolution\t= %g ns\n", sRes.TimeResolution);
   printf("\nSize of slice\t= %ld\nIterations\t= %ld\nForm of band\t- %s\n", sz, iter, (sRes.BandDir == 0 ? "direct" : "inverse"));
   printf("BandCorrection\t= %s\n", sRes.BandCorrFunc);
   printf("Interferences\t= %s\n", (strcmp(sRes.BandCorrFunc, "no") ? sRes.InterferencesFile : "no"));
   if (SigLevel == -1.) printf("Black Spotter\t= off\n"); else printf("Black Spotter\t= on (%.3g sigma)\n", SigLevel);

   if (Cut > sz/2 + 1) Cut = sz/2 + 1;
   if (Cut == -1) printf("CutHarmonics\t= no\n\n"); else printf("CutHarmonics\t= %ld, Fmax = %.3g Hz\n\n", Cut, (1.e9/(sRes.TimeResolution*sz))*Cut );


   mass = new float[2*sz];

   tru = new float[2*wsize];
   if (!mass || !tru) { printf("Not enough memory!\n"); exit(1); }

   if (sRes.WriteDetectedSignal == 1) {
           DetSig = new float[wsize];
           if (!DetSig) { printf("Not enough memory!\n"); exit(1); }
    }
    
   if (sRes.WriteRealSignal == 1) {
           RealSig = new float[wsize];
           if (!RealSig) { printf("Not enough memory!\n"); exit(1); }
    }
   
/*-----    ------*/

printf("Processing...\n");

    for (int i=next;i<argc;i++)
     {

 printf(" [%3d]\t%s ... ", i-next, argv[i]);
 fflush(NULL);

 memset(tru, 0, sizeof(float)*2*wsize);
 if (sRes.WriteDetectedSignal == 1) memset(DetSig, 0, sizeof(float)*wsize);
 if (sRes.WriteRealSignal == 1) memset(RealSig, 0, sizeof(float)*wsize);

 for(int t=0;t<iter;t++) {

   printf(".%5d", t+1);
   fflush(NULL);

   left = step*t;
   if (left + sz > (sRes.BadPointsRec == 1 ? truesize : truesize + ShowDispersion())) {
     diff = left + sz - (sRes.BadPointsRec == 1 ? truesize : truesize + ShowDispersion());
     left -= diff;
    } else diff = 0;

    ReadSrc((ReadAnSig == 0 ? bl + left : 2*(bl + left)), (ReadAnSig == 0 ? sz : 2*sz), argv[i]);
    if (DetectLevel == 1) { if (t == 0) level = NoiseLevel(mass, (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? sz : 2*sz), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? 2 : 1));
                            LevelEliminate(mass, level, (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? sz : 2*sz), (ReadAnSig == 0 || (ReadAnSig == 1 && NoFill == 1) ? 2 : 1));
                           }
    if (tos) CorrectionOfSigma(mass, sz, ToSigma);
    
    DeDispersionProc(sz);

 if (sRes.WriteAnalyticSignal == 1) {
    for (long j=2*(sRes.BandDir == 0 ? (sRes.BadPointsRec == 1 && t == 0 ? 0 : ShowDispersion()) : 0) + 2*diff, l=(sRes.BandDir == 0 ? (sRes.BadPointsRec == 1 && t != 0 ? ShowDispersion() : 0) : 0)+left+diff; j<2*(sRes.BandDir == 0 ? sz : (sRes.BadPointsRec == 1 && t == iter-1 ? sz : step)); j+=2, l++) {
     tru[2*(l%wsize)]    = (float)( (NoScale == 0 ? 2. : 1.) * mass[j] );
     tru[2*(l%wsize) +1] = (float)( (NoScale == 0 ? 2. : 1.) * mass[j+1]);
     if ((l+1)%wsize == 0) Write (tru, 2*wsize, sizeof(float), argv[i], sRes.AnalyticSignalFileExtension, (l+1)/wsize); 
     }
  }
     
 if (sRes.WriteDetectedSignal == 1) {
    for (long j=2*(sRes.BandDir == 0 ? (sRes.BadPointsRec == 1 && t == 0 ? 0 : ShowDispersion()) : 0) + 2*diff, l=(sRes.BandDir == 0 ? (sRes.BadPointsRec == 1 && t != 0 ? ShowDispersion() : 0) : 0)+left+diff; j<2*(sRes.BandDir == 0 ? sz : (sRes.BadPointsRec == 1 && t == iter-1 ? sz : step)); j+=2, l++) {    
     DetSig[l%wsize] = (NoScale == 0 ? 4. : 1.) * (mass[j]*mass[j] + mass[j+1]*mass[j+1]);
     if ((l+1)%wsize == 0) Write (DetSig, wsize, sizeof(float), argv[i], sRes.DetectedSignalFileExtension, (l+1)/wsize); 
     }
  }
  
 if (sRes.WriteRealSignal == 1) {
    for (long j=2*(sRes.BandDir == 0 ? (sRes.BadPointsRec == 1 && t == 0 ? 0 : ShowDispersion()) : 0) + 2*diff, l=(sRes.BandDir == 0 ? (sRes.BadPointsRec == 1 && t != 0 ? ShowDispersion() : 0) : 0)+left+diff; j<2*(sRes.BandDir == 0 ? sz : (sRes.BadPointsRec == 1 && t == iter-1 ? sz : step)); j+=2, l++) {
     RealSig[l%wsize] = (NoScale == 0 ? 2. : 1.) * mass[j];
     if ((l+1)%wsize == 0) Write (RealSig, wsize, sizeof(float), argv[i], sRes.RealSignalFileExtension, (l+1)/wsize); 
     }
  }
    printf("\b\b\b\b\b");
    fflush(NULL);
    
 } //    

/*----------   ()  -----------*/

  printf(" writing... ");
  fflush(NULL);
  
  if (ost != 0) {
  
  if (sRes.WriteAnalyticSignal == 1)
   Write (tru, 2*ost, sizeof(float), argv[i], sRes.AnalyticSignalFileExtension, 2);
				      
  if (sRes.WriteDetectedSignal == 1)   
   Write (DetSig, ost, sizeof(float), argv[i], sRes.DetectedSignalFileExtension, 2);
				      
  if (sRes.WriteRealSignal == 1)
   Write (RealSig, ost, sizeof(float), argv[i], sRes.RealSignalFileExtension, 2);
                 }

  printf("done\n");
 
/*---------------------------------------*/
	
       }    	     		         										   

  delete(mass);
  if (strcmp(sRes.BandCorrFunc, "no") || NoDisp == 0) delete(matrix);
  if (strcmp(sRes.BandCorrFunc, "no") && strcmp(sRes.InterferencesFile, "no")) delete(pomArray);
  delete(tru);
   if (sRes.WriteDetectedSignal == 1) delete(DetSig);
   if (sRes.WriteRealSignal == 1) delete(RealSig);
  delete(ResourceFileName);
  delete(tdp);

  return 0;
}

