#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <getopt.h>
#include <math.h>

#include <inttypes.h>
#include <fftw3.h>

#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#include <sys/resource.h>

#define MaxString 255

#define ALPHA1 2.607131e16
#define ALPHA2 (ALPHA1 / (2 * M_PI))

/*        */
#define BETA1 8.987554e16
#define BETA2 (BETA1 / (2 * M_PI))

#ifndef TYPE
#define TYPE unsigned char
#endif
	

struct sResStruc {     double DM,                                /*--     /^3 --*/
                              RM,				 /*--     /^2 --*/
                              FDM,				 /*-- Faraday Delay Measure    --*/
		              BandWidth,                         /*--     --*/
		              CenterFrequency,                   /*--       --*/
			      RefFrequency,			 /*--       (,    ) --*/
                              TimeResolution,                    /*--    - --*/
			      ADClevel;				 /*--   (  - 2048.) --*/
		          int BandDir,                           /*--   -  (0)   (1) --*/
		              BadPointsRec,                      /*--  (1)   (0)      --*/
			      WriteAnalyticSignal,		 /*--  (1)   (0)   --*/
			      WriteDetectedSignal,		 /*--  (1)   (0)   --*/
			      WriteRealSignal,			 /*--  (1)   (0)     --*/
			      HeaderSize;			 /*--  ( )    --*/
		         char *AnalyticSignalFileExtension,	 /*--       --*/
			      *DetectedSignalFileExtension,	 /*--       --*/
			      *RealSignalFileExtension,		 /*--         --*/
			      *OutputPath,			 /*-- ,     --*/
			      *BandCorrFunc,			 /*--       --*/
			      *InterferencesFile;                /*--       --*/
                  };		

struct pomexInfo {  char type;                /*--  : m (-)  p (-)  --*/
                    long start_pos,           /*--    ( -)    ( -) --*/
		         end_pos,             /*--   ,          --*/
			 sigma_start_pos,     /*--       sigma --*/
			 sigma_size;          /*--     sigma --*/
                  };

#ifdef MAIN_

struct sResStruc sRes =   /*--     PSR1641-45 --*/

			{
			  480.0, -611.0, 0.0, 16.0, 1642., 1642.0, 31.25, 2048.,
			  0, 0, 1, 0, 0, 0,
			  ".as", ".det", ".real", "\0", "no", "no"
			 };

char *ResourceFileName = "source.set";   /*--    --*/

unsigned long rfi_spectrumsize;               /*   ( ),     */
extern struct pomexInfo *pomArray;

/*-- util.cpp --*/

void ReadFromRes ( void );
void CreateSourceFile ( void );
void Rec2Res ( void );
int PrintStrucEntry ( char * );		     
unsigned long h2nl ( unsigned long );
unsigned short h2ns ( unsigned short );
TYPE nh2hn ( TYPE, int );

/*-- pomeh.cpp --*/

void PomexCorrectionFunc ( fftwf_complex *, off_t );
void PomexFileRead ( void );
void PomexFileCorrect ( off_t, off_t );
void BandInterpolation ( float *, off_t, off_t );
double SpectrumSigmaCalc ( fftwf_complex *, off_t );
void SoftBlackSpotter ( fftwf_complex *, off_t );

#endif

#ifdef UTIL_

extern struct sResStruc sRes;
extern char *ResourceFileName;    /*--    --*/

#endif

#ifdef POMEH_

extern struct sResStruc sRes;
extern double SigLevel, sigma;

int pomNumber;
struct pomexInfo *pomArray;
extern unsigned long rfi_spectrumsize;   /*   ( ),     */

/*-- undisp.cpp --*/

off_t resize ( off_t );

#endif
