#define XW_
#include "winsp.hpp"

/*--------        ---------------*/

float CalcLevel ( long l, long w )
{
 Level = 0.;
 for (long i=l;i<l+w;i++) Level += mass[i];
 return Level/w;
}

/*=================================================================================


                                    


==================================================================================*/

/*--------     .  ----------------------*/

void CreateBaseGraphicsFile (char * filename) {

 FILE *cfg = fopen(filename, "wt");
             fseek(cfg, 0, SEEK_SET);	    
fprintf(cfg, "! This is a X resource file with base resources\n\n"
             ".display                      : :0\n"
             "*.borderWidth                 : 0\n"
             "*.font                        : 6x10\n"
             "*.mainBox.background          : lightblue\n"
	     "*.mainBox.foreground          : black\n\n"
	     
             "*.PlotBox.background          : #d5d5d5\n"
             "*.PlotBox.foreground          : darkgreen\n"
             "*.PlotBox.borderWidth         : 1\n\n"
	     
             "*.header.height               : 15\n"
             "*.header.background           : lightblue\n"
             "*.header.foreground           : #004800\n\n"
	     
             "*.legend.height               : 15\n"
             "*.legend.background           : lightblue\n"
             "*.legend.foreground           : #004800\n\n"
	     
             "*.hAxe.height                 : 35\n"
             "*.hAxe.background             : lightblue\n"
             "*.hAxe.foreground             : black\n"
             "*.hAxe.name                   : X-axis\n"
             "*.hAxe.scale                  : 1.\n"
             "*.hAxe.shift                  : 0.\n\n"
	     
             "*.vAxe.width                  : 80\n"
             "*.vAxe.background             : lightblue\n"
             "*.vAxe.foreground             : black\n"
             "*.vAxe.scale                  : 1.\n"
             "*.vAxe.shift                  : 0.\n\n"
	     
             "*.vTitle.width                : 1\n"
             "*.vTitle.background           : lightblue\n"
             "*.vTitle.foreground           : black\n"
             "*.vTitle.name                 : Y   a x i s\n\n"
	     
             "*.footnote.height             : 30\n"
             "*.footnote.background         : lightblue\n"
             "*.footnote.foreground         : #565600\n");

             fclose(cfg);
}

/*-----     ,   winsp -----*/

void CreateWinspXResources (char * filename) {

 FILE *cfg = fopen(filename, "wt");
             fseek(cfg, 0, SEEK_SET);	    
fprintf(cfg, "! This is a Winsp resource file\n\n"
             "#include \".BaseGraphics\"\n\n"
             "Winsp.height                    : 395\n"
             "Winsp.width                     : 491\n"
             "Winsp.minHeight                 : 180\n"
             "Winsp.minWidth                  : 300\n\n"
	     
	     "! Extra resources for footnote region\n\n"
             "*.footnote.tabbox             : #8b4513\n"
	     
	     "! Extra resources for PlotBox region\n\n"
             "*.PlotBox.activeBorder        : #444444\n");

             fclose(cfg);
}

//           
//         
//    
//   . ,    
//     
void ReadResources (int& argc, char**& argv) {

  struct stat base_inf, inf;
  //     ,   ,  
  if ( stat(XBaseResourcesFile, &base_inf) == 0 ) ; else {
   memset(XBaseResourcesFile, 0, MaxString+1);
   sprintf(XBaseResourcesFile, "%s%s", getenv("HOME"), "/.BaseGraphics");
   if ( stat(XBaseResourcesFile, &base_inf) == 0 ) ; else CreateBaseGraphicsFile (XBaseResourcesFile);
  }
  if ( stat(XResourceFile, &inf) == 0 ) ; else {
   memset(XResourceFile, 0, MaxString+1);
   sprintf(XResourceFile, "%s%s", getenv("HOME"), "/.Winsp");
   if ( stat(XResourceFile, &inf) == 0 ) ; else CreateWinspXResources (XResourceFile);
  }
  
  UpdateWinspXResources (XResourceFile, XBaseResourcesFile);

  XtToolkitInitialize();
  //   
  appcont = XtCreateApplicationContext();

  //     . 
  DisId = XtOpenDisplay(appcont, NULL, "Winsp", "Winsp", NULL, 0, &argc, argv);

  //      ,     
  //   
  XrmDatabase args = XtDatabase(DisId);
  //    ,     
  XrmCombineFileDatabase(XResourceFile, &args, False);
}

//   
//      
//    (,   ..)
void UpdateResources ( Widget targetW ) {

 // :
 Position headerY, vTitleX;
 Dimension headerH, vTitleW, vAxeW, legendH, plotBoxBorderW, hAxeH, footnoteH, Height, Width;
 Arg tmpX, tmpY, tmpH, tmpW;
 
 //   
 XtSetArg(tmpH, XtNheight, &Height);
 XtSetArg(tmpW, XtNwidth, &Width);
 XtVaGetValues(XtParent(targetW), tmpH, tmpW, NULL);

 XtSetArg(tmpY, XtNy, &headerY);
 XtSetArg(tmpH, XtNheight, &headerH);
 XtVaGetValues(XtNameToWidget(targetW, "header"), tmpY, tmpH, NULL);

 XtSetArg(tmpX, XtNx, &vTitleX);
 XtSetArg(tmpW, XtNwidth, &vTitleW);
 XtVaGetValues(XtNameToWidget(targetW, "vTitle"), tmpX, tmpW, NULL);

 XtSetArg(tmpW, XtNwidth, &vAxeW);
 XtVaGetValues(XtNameToWidget(targetW, "vAxe"), tmpW, NULL);

 XtSetArg(tmpH, XtNheight, &legendH);
 XtVaGetValues(XtNameToWidget(targetW, "legend"), tmpH, NULL);

 XtSetArg(tmpH, XtNheight, &hAxeH);
 XtVaGetValues(XtNameToWidget(targetW, "hAxe"), tmpH, NULL);

 XtSetArg(tmpH, XtNheight, &footnoteH);
 XtVaGetValues(XtNameToWidget(targetW, "footnote"), tmpH, NULL);

 XtSetArg(tmpW, XtNborderWidth, &plotBoxBorderW);
 XtVaGetValues(XtNameToWidget(targetW, "PlotBox"), tmpW, NULL);


 //   
 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "header"), tmpX, tmpW, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, headerY + headerH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "legend"), tmpX, tmpY, tmpW, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, Height - footnoteH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "footnote"), tmpX, tmpY, tmpW, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, Height - footnoteH - hAxeH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW);
 XtVaSetValues(XtNameToWidget(targetW, "hAxe"), tmpX, tmpY, tmpW, NULL);

 XtSetArg(tmpY, XtNy, headerY + headerH + legendH);
 XtSetArg(tmpH, XtNheight, Height - headerH - legendH - hAxeH - footnoteH);
 XtVaSetValues(XtNameToWidget(targetW, "vTitle"), tmpY, tmpH, NULL);

 XtSetArg(tmpX, XtNx, vTitleX + vTitleW);
 XtSetArg(tmpY, XtNy, headerY + headerH + legendH);
 XtSetArg(tmpH, XtNheight, Height - headerH - legendH - hAxeH - footnoteH);
 XtVaSetValues(XtNameToWidget(targetW, "vAxe"), tmpX, tmpY, tmpH, NULL);

 XtSetArg(tmpX, XtNx, vTitleW + vAxeW);
 XtSetArg(tmpY, XtNy, headerY + headerH + legendH);
 XtSetArg(tmpW, XtNwidth, Width - vTitleW - vAxeW - 2*plotBoxBorderW);
 XtSetArg(tmpH, XtNheight, Height - headerH - legendH - hAxeH - footnoteH - 2*plotBoxBorderW);
 XtVaSetValues(XtNameToWidget(targetW, "PlotBox"), tmpX, tmpY, tmpW, tmpH, NULL);
}

/*=================================================================================


                                            

                                            		 		                        


==================================================================================*/


/*------------------------          --------------------------------

          

-----------------------------------------------------------------------------*/

void WindowHeader ( Widget targetW )
{
    INIT_WIDGETS_PROPS     
     XFontStruct *cur_font = XQueryFont(disID, wData.font);
     fow = abs(cur_font->min_bounds.width);
     foa = cur_font->ascent;
     fod = cur_font->descent;
     
    XClearWindow(disID, winID);
    
    char InfoString[MaxString+1];  

    sprintf(InfoString, "Programm: %s   File: %s", av[0], av[next]);
    XDrawString(disID, winID, grC, 0, 3 + foa, InfoString, strlen(InfoString));
    UNPLUG_WIDGETS_GC
}

/*--------------------------         ---------------------------------

           (-)

-----------------------------------------------------------------------------*/

void Legend ( Widget targetW )
{
    INIT_WIDGETS_PROPS
    XClearWindow(disID, winID);
    
    char InfoString[MaxString+1];  

    sprintf(InfoString, "Help: q.Enter.Esc.Tab.->.<-.PgUp.PgDn.a.f.MOUSE");
    XDrawString(disID, winID, grC, 0, 3 + foa, InfoString, strlen(InfoString));
    UNPLUG_WIDGETS_GC
}

/*---------------------         ------------------------------------

         

---------------------------------------------------------------------------*/  

void Footnote ( Widget targetW )
{
    INIT_WIDGETS_PROPS
    XClearWindow(disID, winID);

    typedef struct { Pixel tb; } frame, *pFrame;
    frame fr;

    XtResource myRes[] = { {"tabbox", "Tabbox", XtRPixel, sizeof(Pixel), XtOffset(pFrame, tb), XtRString, (void*)"#8b4513"} };
    XtGetApplicationResources(targetW, &fr, myRes, XtNumber(myRes), NULL, 0); 
      
    char InfoString[MaxString+1], au[MaxString+1] = "";
    
    if (choice == 0) sprintf(au, "          %s", auto_update ? "ON" : "OFF");
    sprintf(InfoString, "Pos: (%.5g , %.5g)%s", cur_x, cur_y, au);
    XDrawString(disID, winID, grC, 0, 3 + foa, InfoString, strlen(InfoString));
    memset(InfoString, 0, MaxString+1);
    
    if (choice == 0) { sprintf(InfoString, "Left: %8ld   Right: %8ld   Step: %8ld   Level: %8g", setLeft, setRight, rate, Level);
                       XSetForeground(disID, grC, fr.tb);
	               XDrawRectangle(disID, winID, grC, active*fow*17, 3 + 2 + foa + fod, fow*((1-active)*15 + active*16), foa + 2*fod);
		       XSetForeground(disID, grC, wData.fg);
     } else sprintf(InfoString, "%s", "");
     
    XDrawString(disID, winID, grC, fow/2, 2*(3 + foa) + fod, InfoString, strlen(InfoString));
    UNPLUG_WIDGETS_GC
}	  

/*----------                                ----------------------

           

-----------------------------------------------------------------------------------------*/    

void vTitle ( Widget targetW )
{
 typedef struct { char * title; } tit, *ptit;
 tit name;
  
 XtResource nameRes[] = { {"name",  "Name",  XtRString, sizeof(char *), XtOffset(ptit, title), XtRString, (void*)"Y   |   a x i s" } };
 XtGetApplicationResources(targetW, &name, nameRes, XtNumber(nameRes), NULL, 0); 
  
 INIT_WIDGETS_PROPS      
 XClearWindow(disID, winID);

 char value[MaxString+1];
 int Nsp = 0, flag = 0, j = 0, len = 0;

  while ( name.title[j] != '\0') { if (name.title[j] == ' ' && flag == 0) { Nsp++; flag = 1; } else flag = 0;
                                   ++j; }
  Nsp++; flag = 0;
  
  for (int i=0;i<Nsp;i++) {
    j = 0;
    memset(value, 0, MaxString+1);
    while ((name.title[len+j] != ' ' && name.title[len+j] != '\0') || flag == 1) { value[j] = name.title[len+j]; flag = 0; ++j; }
    if (name.title[len+j] == '\0') flag = 0; else { flag = 1; value[j] = '\0'; }
    len += strlen(value) + 1;
    XDrawString(disID, winID, grC, w - 3 - fow*strlen(value), h/2 - (Nsp*(foa+fod+1))/2 + foa + fod/2 + (foa + fod + 1)*i, value, strlen(value));
  }
    
 UNPLUG_WIDGETS_GC
}

/*----------                   ----------------------

            

----------------------------------------------------------------------*/    

void VertAxe ( Widget targetW )
{
 typedef struct { float shift, scale; } par, *ppar;
                  
 par param;
 float def_scale = 1., def_shift = 0.;
  
 XtResource parRes[] = { {"scale", "Scale", XtRFloat,  sizeof(float),  XtOffset(ppar, scale), XtRFloat,  &def_scale },
			 {"shift", "Shift", XtRFloat,  sizeof(float),  XtOffset(ppar, shift), XtRFloat,  &def_shift } };
 XtGetApplicationResources(targetW, &param, parRes, XtNumber(parRes), NULL, 0); 

 INIT_WIDGETS_PROPS      
 XClearWindow(disID, winID);
 
 char value[MaxString+1];

 double step = (gmax - gmin)/3;
   
    sprintf(value, "%.3g", gmin*param.scale + param.shift);
    XDrawLine(disID, winID, grC, w-5, h-1, w, h-1);
    XDrawString(disID, winID, grC, w-8 - fow*(strlen(value)), h-2, value, strlen(value));
     sprintf(value, "%.3g", gmax*param.scale + param.shift);
    XDrawLine(disID, winID, grC, w-5, 0, w, 0);
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, w-2, t*(h/3/5), w, t*(h/3/5));
    XDrawString(disID, winID, grC, w-8 - fow*(strlen(value)), foa, value, strlen(value));
    
   for(int i=1;i<3;i++)
   {
    sprintf(value, "%.3g", (gmin + i*step)*param.scale + param.shift);
    XDrawLine(disID, winID, grC, w-5, h - i*(h/3), w, h - i*(h/3));
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, w-2, h - i*(h/3) + t*(h/3/5), w, h - i*(h/3) + t*(h/3/5));
    XDrawString(disID, winID, grC, w-8 - fow*(strlen(value)), h-2 - i*(h/3), value, strlen(value));
    }
    
 UNPLUG_WIDGETS_GC
}

/*----------                     ----------------------

            

----------------------------------------------------------------------*/

void HorizAxe ( Widget targetW )
{
 typedef struct { char * title;
                  float shift, scale; } tit, *ptit;
 tit name;
 float def_scale = 1., def_shift = 0.;
  
 XtResource nameRes[] = { {"name",  "Name",  XtRString, sizeof(char *), XtOffset(ptit, title), XtRString, (void*)"X-axis" },
                          {"scale", "Scale", XtRFloat,  sizeof(float),  XtOffset(ptit, scale), XtRFloat,  &def_scale },
			  {"shift", "Shift", XtRFloat,  sizeof(float),  XtOffset(ptit, shift), XtRFloat,  &def_shift } };
 XtGetApplicationResources(targetW, &name, nameRes, XtNumber(nameRes), NULL, 0); 
  
 INIT_WIDGETS_PROPS
 XClearWindow(disID, winID);
 
 char value[MaxString+1];
 double begin, step;

 begin = ((1.e9/(sRes.TimeResolution*2*(Size-1))) * (double)0);
 step  = ((1.e9/(sRes.TimeResolution*2*(Size-1))) * (double)(Size-1))/4;
	  
  sprintf(value, "%.2f", begin*name.scale + name.shift);
   XDrawLine(disID, winID, grC, 0, 0, 0, 5);
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, t*(w/4/5), 0, t*(w/4/5), 1);
    XDrawString(disID, winID, grC, 0, 5+3 + foa, value, strlen(value));
  sprintf(value, "%.2f", (begin + 4.*step)*name.scale + name.shift);
   XDrawLine(disID, winID, grC, w-1, 0, w-1, 5);
    XDrawString(disID, winID, grC, w-1 - fow*(strlen(value)), 5+3 + foa, value, strlen(value));

  for (int i=1;i<4;i++)
   {
    sprintf(value, "%.2f", (begin + i*step)*name.scale + name.shift);
    XDrawLine(disID, winID, grC, i*(w/4), 0, i*(w/4), 5);
     for (int t=1;t<5;t++) XDrawLine(disID, winID, grC, i*(w/4) + t*(w/4/5), 0, i*(w/4) + t*(w/4/5), 1);
    XDrawString(disID, winID, grC, i*(w/4) - (strlen(value)*fow)/2, 5+3 + foa, value, strlen(value));
    }
    
  sprintf(value, name.title);
  XDrawString(disID, winID, grC, w/2 - (strlen(value)*fow)/2, 5 + 2*(3 + foa) + fod, value, strlen(value));
  
 UNPLUG_WIDGETS_GC
}

/*------------                    --------------------

            

-----------------------------------------------------------------------*/    

void Destroy ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == DestroyNotify ||
      event->type == KeyPress || event->type == KeyRelease)
  {
    *cont = False;
    delete (XBaseResourcesFile);
    delete (XResourceFile);
    delete (ResourceFileName);    
    delete (float *)tD;  
    delete (sub);
    XtDestroyWidget (targetW);
    XtDestroyApplicationContext (XtWidgetToApplicationContext(targetW));  
    exit(0);
  }
}                                      

/*----------          ------------------*/

void PointerPos ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
 if (event->type == MotionNotify)
  {
    XWindowAttributes attr;
    XGetWindowAttributes(XtDisplay(targetW), XtWindow(targetW), &attr);

    cur_x = ((float)( Size * ((float)(event->xmotion.x + attr.border_width)) / ((float)pw) )) * (1.e9/(sRes.TimeResolution*2*(Size-1)));
    cur_y = gmin + (gmax-gmin) * ((float)(ph - event->xmotion.y)) / ((float)ph) ;
    Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
   }
 }                                                              

/*-----------  ------------------- */                      

void MapLevel ( Widget targetW )
{
  int sh, lg, rg;
  
  typedef struct { Pixel ab; } frame, *pFrame;
  frame fr;

  XtResource myRes[] = { {"activeBorder", "ActiveBorder", XtRPixel, sizeof(Pixel), XtOffset(pFrame, ab), XtRString, (void*)"black"} };
  XtGetApplicationResources(targetW, &fr, myRes, XtNumber(myRes), NULL, 0); 

  Display *disID = XtDisplay(targetW);
  Window winID   = XtWindow(targetW);
  GC grC         = XtGetGC(targetW, 0, NULL);
    
  XSetForeground(disID, grC, fr.ab);
  XSetFunction(disID, grC, GXxor);      
  XSetLineAttributes(disID, grC, 1, LineOnOffDash, CapButt, JoinRound);
  
  lg = (int)((((float)setLeft)*((float)pw))/(float)Size);
  rg = (int)((((float)setRight)*((float)pw))/(float)Size);    
  XDrawLine(disID, winID, grC, lg, (int)((float)ph-((Level-gmin)*((float)ph))/(gmax-gmin)), rg, (int)((float)ph-((Level-gmin)*((float)ph))/(gmax-gmin)));

  XtReleaseGC(targetW, grC);  
}

/*-----------  (/) -    
                               --------------------------------*/

void MapBegunok ( Widget targetW )
{
  int sh, lg, rg;
  
  typedef struct { Pixel ab; } frame, *pFrame;
  frame fr;

  XtResource myRes[] = { {"activeBorder", "ActiveBorder", XtRPixel, sizeof(Pixel), XtOffset(pFrame, ab), XtRString, (void*)"black"} };
  XtGetApplicationResources(targetW, &fr, myRes, XtNumber(myRes), NULL, 0); 

  Display *disID = XtDisplay(targetW);
  Window winID   = XtWindow(targetW);
  GC grC         = XtGetGC(targetW, 0, NULL);
    
  XSetForeground(disID, grC, fr.ab);
  XSetFunction(disID, grC, GXxor);      
  XSetLineAttributes(disID, grC, 1, LineOnOffDash, CapButt, JoinRound);
  
  lg = (int)((((float)setLeft)*((float)pw))/(float)Size);
  rg = (int)((((float)setRight)*((float)pw))/(float)Size);
  
  XDrawLine(disID, winID, grC, lg, 0, lg, ph);  
  if (rg == pw) sh = 1; else sh = 0;
  if (lg != rg - sh) XDrawLine(disID, winID, grC, rg - sh, 0, rg - sh, ph);

  if (clean) { clean = false; MapLevel(targetW); }
   else if (auto_update) MapLevel(targetW);
  
  XtReleaseGC(targetW, grC);  
}

/*-----------       
                           -------------------------------*/

void Plotdata ( Widget targetW, XtPointer tD )
{    
  float * x;
  x = (float *)tD;  
  
  Boolean check;
  
  INIT_WIDGETS_PROPS
  
  pw = w;
  ph = h;

  Position xcur, ycur, xcurPr, ycurPr, ycurPr2;
  double stpx, stpy;       
	   
  XClearWindow(disID, winID);
       
  stpx = (double)w/((double)(Size));
  stpy = (double)h/(double)(gmax - gmin);

  xcurPr  = (short int)(0 * stpx);      
  ycurPr  = (short int)(h - (x[0] - gmin) * stpy);
  ycurPr2 = ycurPr;
                                       	 	 
  for (long j=1;j<Size;j++)
   {
     xcur = (short int)(j * stpx);
     ycur = (short int)(h - (x[j] - gmin) * stpy);

     check = ( (short int)( (j+1)*stpx )  != xcurPr || j+1 >= Size );
	      
     if (xcur == xcurPr) { ycurPr  = ( ycur >  ycurPr  ? ycur : ycurPr  );                                                   	              
                           ycurPr2 = ( ycur <= ycurPr2 ? ycur : ycurPr2 );                                                      	      
                                                                                                                             
                           if ( check ) { if (ycurPr != ycurPr2) XDrawLine(disID, winID, grC, xcurPr, ycurPr, xcur, ycurPr2);   	      
                                          ycurPr = ycur;                                                                        	      
                                         }                                                                                      	      
                          } else { XDrawLine(disID, winID, grC, xcurPr, ycurPr, xcur, ycur);                                    	      
                                   xcurPr  = xcur;                                                                              	      
                                   ycurPr  = ycur;                                                                              	      
                                   ycurPr2 = ycur;                                                                              	      
                                  }                                                                                             	      	             
    }                              

   if (choice == 0) MapBegunok(targetW);
   UNPLUG_WIDGETS_GC   
}

/*------------       -  --------------------*/

void MoveLeftPointer ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == MotionNotify && choice == 0)
   {
     active = 0;
     MapBegunok(targetW);
   
     long Pos = (long)(((float)(event->xmotion.x)/(float)pw)*Size);
     if ( Pos >= setRight ) Pos = setRight-1;
     if ( Pos < 0 ) Pos = 0;
     setLeft = Pos;

   Level = CalcLevel(setLeft, setRight-setLeft+1);
   MapBegunok(targetW);
   Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
   }	     			
 }

/*------------       -  --------------------*/
 
void MoveRightPointer ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == MotionNotify && choice == 0)
   {
     active = 1;
     MapBegunok(targetW);
   
     long Pos = (long)(((float)(event->xmotion.x)/(float)pw)*Size);
     if ( Pos > Size-1 ) Pos = Size-1;
     if ( Pos <= setLeft ) Pos = setLeft + 1;
     setRight = Pos;
     
   Level = CalcLevel(setLeft, setRight-setLeft+1);
   MapBegunok(targetW);
   Footnote(XtNameToWidget(XtParent(targetW), "footnote"));
   }
 }

/*---------         --------------------*/
 
void FreshLevel ( Widget targetW,  XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == ButtonPress)
   {
   switch (event->xbutton.button) {
     case 2: if (choice == 0)
                if (!auto_update) { MapLevel(targetW);
	                            clean = true;
		}
              break;		   	  
    default:  break;	      
                                   }
   }
 }                                                              

/*----------    -----------------*/
//   Widget   , .. coreW

void WindowRedraw (Widget targetW, XtPointer tD)
{
  WindowHeader (XtNameToWidget(targetW, "header"));
  Legend       (XtNameToWidget(targetW, "legend"));
  vTitle       (XtNameToWidget(targetW, "vTitle"));
  VertAxe      (XtNameToWidget(targetW, "vAxe"));
  HorizAxe     (XtNameToWidget(targetW, "hAxe"));
  Footnote     (XtNameToWidget(targetW, "footnote"));
  
  if (choice == 1) Plotdata(XtNameToWidget(targetW, "PlotBox"), (XtPointer)sub);
   else Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
}

/*----------      Expose --------------------*/
					      
void WinExpose ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
  if (event->type == VisibilityNotify &&
      //   ,    
      event->xvisibility.state == 0 &&
      auto_expose)
   WindowRedraw(targetW, tD);
} 

/*----------        --------------------*/

void WinResize ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
  if(event->type == ConfigureNotify)
  {
    *cont = False;
    Dimension Height = event->xconfigure.height;
    Dimension Width = event->xconfigure.width;
    Dimension hfoot, hxaxis;
    Widget tmpW;
    XWindowChanges values;
    XWindowAttributes attr;

    tmpW = XtNameToWidget(targetW, "header");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWWidth, &values);
    WindowHeader(tmpW);
    
    tmpW = XtNameToWidget(targetW, "legend");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWWidth, &values);
    Legend(tmpW);
    
    tmpW = XtNameToWidget(targetW, "footnote");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.y = Height - attr.height;
    values.width = Width - attr.x;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWY | CWWidth, &values);
    hfoot = attr.height;
    
    tmpW = XtNameToWidget(targetW, "hAxe");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x;
    values.y = Height - hfoot - attr.height;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWY | CWWidth, &values);
    hxaxis = attr.height;
    
    tmpW = XtNameToWidget(targetW, "vTitle");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.height = Height - hfoot - hxaxis - attr.y;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWHeight, &values);
    vTitle(tmpW);
    
    tmpW = XtNameToWidget(targetW, "vAxe");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.height = Height - hfoot - hxaxis - attr.y;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWHeight, &values);
    
    VertAxe(tmpW);
    HorizAxe(XtNameToWidget(targetW, "hAxe"));
    Footnote(XtNameToWidget(targetW, "footnote"));
            
    tmpW = XtNameToWidget(targetW, "PlotBox");
    XGetWindowAttributes(XtDisplay(tmpW), XtWindow(tmpW), &attr);
    values.width = Width - attr.x - 2*attr.border_width;
    values.height = Height - hfoot - hxaxis - attr.y - 2*attr.border_width;
    XConfigureWindow(XtDisplay(tmpW), XtWindow(tmpW), CWWidth | CWHeight, &values);    
    Plotdata(tmpW, tD);
  }
}                                             
					      
/*--------        
                    -----------------------------------*/

void ParseKeyboard ( Widget targetW, XtPointer tD, XEvent *event, Boolean *cont )
{
 if ( event->type == KeyPress || event->type == KeyRelease )
 {
  KeySym a = XLookupKeysym(&event->xkey, 0);
  long Pos = (active == 0 ? setLeft : setRight);
   switch (a) {
  /* "q" */
  case 0x71: Destroy(targetW, tD, event, cont);    
	     break;
  /* "Enter" */
  case 0xff0d: if (choice == 1) { Rec2Res();
				  printf("Source File \"%s\" updated\n", ResourceFileName);
                                  Destroy(targetW, tD, event, cont);
                                 }
               for (long i=0;i<Size;i++) sub[i] = (i<setLeft || i>setRight ? 0. : mass[i] - Level);
               for (long i=0;i<Size;i++) {                             
	        gmax = (i == 0 ? sub[i] : (sub[i] > gmax ? sub[i] : gmax));  
	        gmin = (i == 0 ? sub[i] : (sub[i] < gmin ? sub[i] : gmin));  
	       }                                                       

	       sRes.SpWindowLeft = setLeft;
	       sRes.SpWindowSize = setRight - setLeft + 1;
	       choice = 1;
	       clean = false;
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));	        
	       VertAxe(XtNameToWidget(targetW, "vAxe"));
	       Plotdata(XtNameToWidget(targetW, "PlotBox"), (XtPointer)sub);
               break;
  /* "Enter" */
  case 0xff8d: if (choice == 1) { Rec2Res();
				  printf("Source File \"%s\" updated\n", ResourceFileName);
                                  Destroy(targetW, tD, event, cont);
                                 }
               for (long i=0;i<Size;i++) sub[i] = (i<setLeft || i>setRight ? 0. : mass[i] - Level);
               for (long i=0;i<Size;i++) {                             
	        gmax = (i == 0 ? sub[i] : (sub[i] > gmax ? sub[i] : gmax));  
	        gmin = (i == 0 ? sub[i] : (sub[i] < gmin ? sub[i] : gmin));  
	       }                                                       

	       sRes.SpWindowLeft = setLeft;
	       sRes.SpWindowSize = setRight - setLeft + 1;
	       choice = 1;
	       clean = false;
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));	        
	       VertAxe(XtNameToWidget(targetW, "vAxe"));
	       Plotdata(XtNameToWidget(targetW, "PlotBox"), (XtPointer)sub);
               break;
  /* "Left" */
  case 0xff51: if (choice == 0) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		
	        switch (active) {
		 case 0: if (Pos - rate < 0) ; else Pos -= rate;
                         setLeft = Pos;
			 break;
	         case 1: if (Pos - rate <= setLeft) ; else Pos -= rate;
			 setRight = Pos;
			 break;
		 default: break;	 
		                  }
               Level = CalcLevel(setLeft, setRight-setLeft+1);				  
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
                                   }
               break;
  /* "Left" */
  case 0xff96: if (choice == 0) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		
	        switch (active) {
		 case 0: if (Pos - rate < 0) ; else Pos -= rate;
                         setLeft = Pos;
			 break;
	         case 1: if (Pos - rate <= setLeft) ; else Pos -= rate;
			 setRight = Pos;
			 break;
		 default: break;	 
		                  }
               Level = CalcLevel(setLeft, setRight-setLeft+1);				  
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
                                   }
               break;
  /* "Right" */
  case 0xff53: if (choice == 0) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		 
               switch (active) {
		 case 0: if (Pos + rate >= setRight) ; else Pos += rate;
                         setLeft = Pos;
			 break;
	         case 1: if (Pos + rate > Size-1 ) ; else Pos += rate;
			 setRight = Pos;
			 break;
		 default: break;	 
		                  }               
               Level = CalcLevel(setLeft, setRight-setLeft+1);				  
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
                                  }
               break;
  /* "Right" */
  case 0xff98: if (choice == 0) {
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
		 
               switch (active) {
		 case 0: if (Pos + rate >= setRight) ; else Pos += rate;
                         setLeft = Pos;
			 break;
	         case 1: if (Pos + rate > Size-1 ) ; else Pos += rate;
			 setRight = Pos;
			 break;
		 default: break;	 
		                  }               
               Level = CalcLevel(setLeft, setRight-setLeft+1);				  
               MapBegunok(XtNameToWidget(targetW, "PlotBox"));
	       Footnote(XtNameToWidget(targetW, "footnote"));
                                  }
               break;
  /* "PgUp" */	       
  case 0xff55: if (rate*2 > Size/4) ; else rate *= 2; 
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgUp" */	       
  case 0xff9a: if (rate*2 > Size/4) ; else rate *= 2; 
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgDn" */
  case 0xff56: if (rate/2 < 1) ; else rate /= 2;	       
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "PgDn" */
  case 0xff9b: if (rate/2 < 1) ; else rate /= 2;	       
	       Footnote(XtNameToWidget(targetW, "footnote"));
               break;
  /* "Esc"  */
  case 0xff1b: if (choice == 1) {
	       choice = 0;
               for (long i=0;i<Size;i++) {                                                             
                 gmax = (i == 0 ? mass[i] : (mass[i] > gmax ? mass[i] : gmax));                           
                 gmin = (i == 0 ? mass[i] : (mass[i] < gmin ? mass[i] : gmin));                           
                                          }
               Level = CalcLevel(setLeft, setRight-setLeft+1);					   
	       Footnote(XtNameToWidget(targetW, "footnote"));
	       HorizAxe(XtNameToWidget(targetW, "hAxe"));
	       VertAxe(XtNameToWidget(targetW, "vAxe"));
	       Plotdata(XtNameToWidget(targetW, "PlotBox"), tD);
	                          }
               break;	       
  /* "Tab" */	       
  case 0xff09: if (choice == 0) {
                active = (active == 0 ? 1 : 0);
	        Footnote(XtNameToWidget(targetW, "footnote"));
               }
               break;
  /*  "a"  */
  case 0x61:   if (choice == 0) {
                auto_update = !auto_update;
	        if (!clean) MapLevel(XtNameToWidget(targetW, "PlotBox"));
		 else clean = false;
	        Footnote(XtNameToWidget(targetW, "footnote"));
               }
	       break;
  /*  "f"  */
  case 0x66:   if (choice == 0)
                if (!auto_update) { MapLevel(XtNameToWidget(targetW, "PlotBox"));
	                            clean = true;
		}
	       break;
  /* "LCtrl" */
  case 0xffe3: if (event->xkey.state == ControlMask) auto_expose = !auto_expose;
                else WindowRedraw(targetW, tD);
               break;
  /* "RCtrl" */	       
  case 0xffe4: if (event->xkey.state == ControlMask) auto_expose = !auto_expose;
                else WindowRedraw(targetW, tD);
               break;
  default:     break;
            }
      }
 }                                                

/*---------  MAIN         ----------------------------------------*/

void Plotting () {

 setLeft  = sRes.SpWindowLeft;
 setRight = sRes.SpWindowLeft + sRes.SpWindowSize - 1;
 Level = CalcLevel(setLeft, setRight-setLeft+1);
 rate = (Size/10 < 1 ? 1 : Size/10);

 sub = new float[Size];
 if (!sub) { printf("Not enough memory!\n"); exit(1); }
 memset(sub, 0, Size*sizeof(float));

 Widget shellW  = XtVaAppCreateShell("Winsp", "Winsp", applicationShellWidgetClass, DisId, NULL);
 Widget coreW   = XtVaCreateManagedWidget("mainBox",  compositeWidgetClass, shellW,    NULL);
 Widget headerW = XtVaCreateManagedWidget("header",   coreWidgetClass,      coreW,     NULL); 
 Widget legendW = XtVaCreateManagedWidget("legend",   coreWidgetClass,      coreW,     NULL); 
 Widget vTitleW = XtVaCreateManagedWidget("vTitle",   coreWidgetClass,      coreW,     NULL);
 Widget vaxeW   = XtVaCreateManagedWidget("vAxe",     coreWidgetClass,      coreW,     NULL);
 Widget haxeW   = XtVaCreateManagedWidget("hAxe",     coreWidgetClass,      coreW,     NULL);
 Widget footW   = XtVaCreateManagedWidget("footnote", coreWidgetClass,      coreW,     NULL);
 Widget plotW   = XtVaCreateManagedWidget("PlotBox",  coreWidgetClass,      coreW,     NULL);
 
 //         
 UpdateResources(coreW);

 XtRealizeWidget(shellW);

 //    
 XWMHints wmh;
 wmh.flags = InputHint;
 wmh.input = True;
 XSetWMHints(DisId, XtWindow(shellW), &wmh);
 
 WindowHeader (headerW);
 Legend       (legendW);
 vTitle       (vTitleW);
 VertAxe      (vaxeW);
 HorizAxe     (haxeW);
 Footnote     (footW);
 Plotdata     (plotW, mass);

 XtAddEventHandler(shellW,  StructureNotifyMask, False, Destroy,          mass);
 XtAddEventHandler(coreW,   KeyPressMask,        False, ParseKeyboard,    mass);   
 XtAddEventHandler(coreW,   StructureNotifyMask, False, WinResize,        mass);

 //    backing_store,      Expose
 if (!DoesBackingStore(XtScreen(shellW)))
  XtAddEventHandler(coreW, VisibilityChangeMask, False, WinExpose, mass);
   
 XtAddEventHandler(plotW,   Button1MotionMask,   False, MoveLeftPointer,  mass);
 XtAddEventHandler(plotW,   Button3MotionMask,   False, MoveRightPointer, mass);
 XtAddEventHandler(plotW,   PointerMotionMask,   False, PointerPos,       mass);
 XtAddEventHandler(plotW,   ButtonPressMask,     False, FreshLevel,       mass);   

 XtAppMainLoop(appcont);
}

/*============================ E N D =============================================================*/

