#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <getopt.h>
#include <math.h>

#define MaxString 255

#ifndef TYPE
 #define TYPE float
#endif	

struct sResStruc {     double TimeResolution;                    /*--    - --*/
			 long BandSmooth,			 /*--     --*/
			      SpWindowLeft,			 /*--     --*/
			      SpWindowSize,			 /*--    --*/
			      UsedFileSize;			 /*--        --*/
			  int HeaderSize;			 /*--  ( )    --*/
                  };
		  		  
#ifdef MAIN_

using namespace std;

#include "opt.hpp"

struct sResStruc sRes =   /*--     PSR1641-45 --*/

			{
			  400., 1024, 0, -1, -1, 0
			 };

char *ResourceFileName = "winsp.set";   /*--    --*/

/*--      .  --*/
char * XBaseResourcesFile;

/*--        Winsp
          XBaseResourcesFile
--*/
char * XResourceFile;

char **av;
int ac, next;
float *mass, gmax, gmin;
long Size, shift = -1;
unsigned char UseCorrect = 0;
char *CorrectionFunc;

/*-- util.cpp --*/

void ReadFromRes ( void );
void CreateSourceFile ( void );
TYPE nh2hn ( TYPE, int );

/*-- x.cpp --*/

void Plotting ( void );
void ReadResources (int&, char**&);

#endif

#ifdef UTIL_

using namespace std;

extern struct sResStruc sRes;
extern char *ResourceFileName;    /*--    --*/

#endif

#ifdef XW_

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/ShellP.h>

typedef struct { Pixel fg, bg;
                 Font font; } wD, *twData;

// 
XtAppContext appcont;
// 
Display *DisId;

extern struct sResStruc sRes;
extern char *ResourceFileName;    /*--    --*/
extern char * XBaseResourcesFile, * XResourceFile;      /*--      --*/
extern char **av;
extern float *mass, gmax, gmin;
extern long Size;
extern int next;

long rate, setLeft, setRight;
float *sub, Level, cur_x = 0., cur_y = 0.;
unsigned char choice, active = 0;
//  /   
bool auto_update = false;
//    level  ,   auto_update
//   level 
bool clean = false;

//  /    Expose
//   Backing Store
//   - 
//  LCtrl + RCtrl
//  - LCtrl  RCtrl
bool auto_expose = true;

unsigned int fow, foa, fod;

/*-- util.cpp --*/

void Rec2Res ( void );

/*-- xutil.cpp --*/

void UpdateWinspXResources (char *, char *);

Dimension pw, ph;

/*---------- Borrowed from Kirill & Kazman |  Updated by me ------------------*/

#define INIT_WIDGETS_PROPS \
   wD wData; \
\
  Dimension w, h; \
  XtResource tRes[] = { \
    {XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel), XtOffset(twData, fg), XtRString, (void*)"black"}, \
    {XtNbackground, XtCBackground, XtRPixel, sizeof(Pixel), XtOffset(twData, bg), XtRString, (void*)"white"}, \
    {XtNfont, XtCFont, XtRFont, sizeof(Font), XtOffset(twData, font), XtRString, (void*)"6x10"}}; \
\
  XtGetApplicationResources(targetW, &wData, tRes, XtNumber(tRes), NULL, 0); \
\
  Display *disID = XtDisplay(targetW); \
  Window winID = XtWindow(targetW); \
  GC     grC   = XtGetGC(targetW, 0, NULL); \
  XSetForeground(disID, grC, wData.fg); \
  XSetFont(disID, grC, wData.font); \
\
  XWindowAttributes att; \
  XSetWindowAttributes  attr; \
  XGetWindowAttributes(disID, winID, &att); \
  attr.backing_store = Always; \
  XChangeWindowAttributes(disID, winID, CWBackingStore, &attr); \
  w = att.width; \
  h = att.height; 

#define UNPLUG_WIDGETS_GC XtReleaseGC(targetW, grC);

/*--------------------------------------------------------------------*/

#endif

