#!/usr/local/bin/perl
#
# read info from OBS_LOGS.txt file and calculates Total Data Volume
# Note: the last file in every session is not counted, because it could be smaller than 80s
# Note: if "Files" = 999 then this record is not counted
#
use Getopt::Long;

$filesize = 2.000867328; # size of every file (in GB)

# Parse command line
GetOptions ( "h" => \$is_help,      # to print the help
             "help" => \$is_help,   # to print the help
             "update" => \$is_update ); # to update OBS_LOGS.txt file

if ($is_help) {  &help($0); exit 0; }

$file = "/home/users/vkondrat/obs/drift/OBS_LOGS.txt";
# first upfate OBS_LOGS.txt file
if ($is_update) {
 system ("scp spigot2:/users/sransom/driftscan/OBS_LOGS.txt $file");
}

open (OBS, "<$file") || die "can't open file \"$file\": $!\n";
while (defined ($line = <OBS>)) {
 chomp $line;
 if ($line =~ /^#/) { next; }
 @temp = split /\s+/, $line;
 push @{ $list{"mjd"} }, $temp[0];
 push @{ $list{"who"} }, $temp[1];
 push @{ $list{"files"} }, $temp[2];
 push @{ $list{"az"} }, $temp[3];
 push @{ $list{"el"} }, $temp[4];
 push @{ $list{"bits"} }, $temp[5];
 push @{ $list{"basename"} }, $temp[6];
 push @{ $list{"disks"} }, $temp[7];
}
close (OBS);


# number of lines on OBS_LOGS.txt file
$numlines = $#{@{$list{"mjd"}}};

$total = 0;
for ($i=0; $i<=$numlines; $i++) {
 $n = ${@{$list{"files"}}}[$i];
 if ($n == 999) { next; }
 $n = ($n - 1) * $filesize;
 $total += $n;
}

print "\n";
print "##############################################\n";
print   "#                                            #\n";
printf ("# Total Data Volume: %6.0f GB (%6.2f TB)   #\n", $total, $total/1000.);
print   "#                                            #\n";
print "##############################################\n";
print "\n";


#######################################################################################
#
#
#                            R O U T I N E S
#
#

# help
sub help {
 local ($prg) = @_;
 $prg = `basename $prg`; chomp $prg;
 print "Usage: $prg [options]\n";
 print "       -update   - to download file \"OBS_LOGS.txt\" from spigot2\n";
 print "       -h, -help - print this help\n"; 
}
