#!/bin/sh
#
#
if [ $# == 0 ]; then
 echo "Usage: $0 <dir> <basename>"
 exit 0
fi

dir=$1
bname=$2
lastfile=`ls -1 $dir/$bname*.fits | tail -1`
lastnum=`basename $lastfile | awk -F _ '{print $4}' - | awk -F . '{print $1}' -` 
lastnum=$((10#$lastnum+0))
#step=45 # number of files that are about 1 hour
step=12 # every 15min
#step=4 # every 5min
bandprg="/users/vkondrat/obs/drift/rfi/bandpass.py"
nsize=10670080
spectra=5120
last=5119
curdir=`pwd`
psjoin="/users/vkondrat/obs/drift/rfi/psjoin"
psfiles=""
count=0

for (( i=1 ; i <= $lastnum; i+=$step )) ; do
 echo $i

  if [ $i -lt 10 ]; then
   ofile=$bname"_000"$i".fits"
  elif [ $i -lt 100 ]; then
   ofile=$bname"_00"$i".fits"
  else
   ofile=$bname"_0"$i".fits"
  fi
  ifile=$dir"/"$ofile
  ofile=$curdir"/"$ofile
  
  if [ ! -e $ifile ]; then
   continue
  fi 
  
  dd if=$ifile of=$ofile bs=$nsize count=1  
  pyhead.py -u SPECTRA $spectra $ofile
  pyhead.py -u FRSTSPEC 0 $ofile
  pyhead.py -u LASTSPEC $last $ofile
  pyhead.py -u NAXIS2 $spectra $ofile
  dt=`pyhead.py -p DATE-OBS $ofile | grep -v size | awk '{print $3}' -`
  tm=`pyhead.py -p TIME-OBS $ofile | grep -v size | awk '{print $3}' -`
#  fn=`pyhead.py -p FILENO $ofile | grep -v size | awk '{print $3}' -`
  object="Date:"$dt"-Time:"$tm"-#"$i"-Bandpass"
  pyhead.py -u OBJECT $object $ofile
  $bandprg `basename $ofile` 
  rm -f $ofile
  psfiles=$psfiles" "$ofile".ps"
  
  count=$(($count+1))

done

  $psjoin $psfiles > tmp.ps
  if [ $count -ge 7 ]; then
   num=8
  else 
   num=$count
  fi
  psnup "-"$num -l tmp.ps $bname".ps"
  rm -f tmp.ps
  rm -f $psfiles
