#ifndef _LAGTIMING_HPP
#define _LAGTIMING_HPP

#include <iostream>
#include <sstream>
#include <string>
#include <time.h>

using namespace std;

class LagTiming {
           time_t starttime;  // start time in seconds (since 1970)
	   time_t endtime;    // end time
	   time_t interval;
	   int days;
	   int hours;
	   int minutes;
	   int seconds;

           // string representation of the time
	   std::string timestr;
	   
	   // calculates the lag between time moments and sets up days, hours, minutes and seconds
	   void getlag () {
	    interval = endtime - starttime;
            days = (int)(interval / 86400);
            hours = (int)((interval - days * 86400) / 3600);
	    minutes = (int)((interval - days * 86400 - hours * 3600) / 60);
	    seconds = (int)(interval - days * 86400 - hours * 3600 - minutes * 60);

            std::ostringstream o;
	    if (days > 0)  o << days << "d ";
	    if (hours > 0) o << hours << "h ";
	    if (minutes > 0) o << minutes << "m ";
	    o << seconds << "s";
	    timestr = o.str();
	   }

   public:
	   LagTiming () {};
	   virtual ~LagTiming () { };

           // start the chronometer
	   void start () {
	    starttime = time (NULL);
	   };
	   // stop the chronometer
	   void stop (bool is_print = false) {
	    endtime = time (NULL);
	    getlag ();
	    if (is_print) cout << timestr << endl;
	   };
	   // return time as a string
	   const char *lag () {
	    return timestr.c_str();
	   }
};

#endif //#ifndef _LAGTIMING_HPP
