#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

#include <fftw3.h>



int main (void) {

fftwf_complex *inout;
fftwf_plan plan;
int fftlen = 1024;

printf ("begin ...\n");
inout = (fftwf_complex *) fftwf_malloc (fftlen * sizeof (fftwf_complex));
plan = fftwf_plan_dft_1d(fftlen, inout, inout, FFTW_FORWARD, FFTW_EXHAUSTIVE);
fftwf_destroy_plan (plan);
fftwf_free (inout);
printf ("done.\n");

/* Forgetting wisdom */
fftwf_forget_wisdom ();

  /* If calling for the first time, read the wisdom file */

    /* First try to import the system wisdom if available */
    printf("\nAttempting to read the system wisdom file (float) ...\n");
    if (!fftwf_import_system_wisdom())
    printf("  failed.  The file probably does not exist.\n\n");

    FILE *wisdomfile;
    wisdomfile = fopen("/etc/fftw/wisdomf", "r");
    if (wisdomfile == NULL) {
      printf("Error opening \"/etc/fftw/wisdomf\"\n");
      printf("Exiting.\n");
      exit(1);
    }
    if (!fftwf_import_wisdom_from_file(wisdomfile)) {
      printf("Error importing FFTW wisdom.\n");
      printf("Exiting.\n");
      exit(1);
    }
    else printf ("Ok.\n");
	    
    fclose(wisdomfile);

printf ("with wisdom begin ...\n");
inout = (fftwf_complex *) fftwf_malloc (fftlen * sizeof (fftwf_complex));
plan = fftwf_plan_dft_1d(fftlen, inout, inout, FFTW_FORWARD, FFTW_EXHAUSTIVE);
fftwf_destroy_plan (plan);
fftwf_free (inout);
printf ("done.\n");

    return (0);    
}
